-- Lootster
--
-- Created by Mackenz, Server: Dragonblight
--
-- Acknowledgements to the following people from whom I snaffled code or provided translations:
--
-- Sardonic, LootHog
-- CodeMoose, DepositBox
-- Morok (sargeras), French Translation

-- Constant (non-localised) Data
--
-- Scoll line count and height
LOOTSTER_ROLL_LINES			= 13;

LOOTSTER_DKP_LINES			= 12;
LOOTSTER_PLAYER_LINES		= 4;

LOOTSTER_ITEM_LINES			= 16;

LOOTSTER_RAID_LINES			= 4;
LOOTSTER_BOSS_LINES			= 4;
LOOTSTER_ATTEND_LINES		= 6;
LOOTSTER_ADJUST_LINES		= 6;

LOOTSTER_RAIDADJUST_LINES	= 4;

LOOTSTER_FRAME_HEIGHT		= 16;

-- Version
LOOTSTER_VERSION			= "2.0.Beta6";

-- Enumerated Constants
LOOTSTER_ENUM_EVENTSTATE	= { LOAD=1, LOGIN=2, ENTER=3 };

LOOTSTER_ENUM_NBG			= { NEED=1, GREED=2 };

LOOTSTER_ENUM_IDTYPE		= { RAID="R", BOSS="B", ATTEND="T", ADJUST="D", NATIVE="" };

LOOTSTER_ENUM_ATTENDED		= { FULL=1, PARTIAL=2, NOTATALL=3 };

LOOTSTER_ENUM_VIEWRAID		= { BYATTEND=1, BYADJUST=2 };		

LOOTSTER_ENUM_ROLLMODE		= { USEDKP=1, USENORM=2 };

LOOTSTER_ENUM_DKP			= { BYDKP=1, BYTIER=2, BYMODIFIED=3 };
LOOTSTER_ENUM_NORM			= { BY1001000=1, BYNEEDGREED=2 };

LOOTSTER_ENUM_AUTORAID		= { RAID=1, RAIDNBOSS=2 };

LOOTSTER_ENUM_LOOTMODE		= { UNCOMMON=2, RARE=3, EPIC=4, LEGENDARY=5 };
LOOTSTER_ENUM_LOOTMETHOD	= { FREEFORALL=1, ROUNDROBIN=2, MASTER=3, GROUP=4, NEEDBEFOREGREED=5 };

LOOTSTER_ENUM_BIND			= { UNK=1, BoE=2, BoP=3 };

-- Horde/Alliance Only Classes
LOOTSTER_CLASS_ALLIANCE		= { ["PALADIN"]=true };
LOOTSTER_CLASS_HORDE		= { ["SHAMAN"]=true };

-- Unknown Tier
LOOTSTER_TIER_UNKNOWN		= "99999";

-- Text Encoding/Decoding Strings
LOOTSTER_ENC_ORBAR_RAW		= "|";
LOOTSTER_ENC_ORBAR_ENC		= LOOTSTER_ENC_ORBAR_RAW..LOOTSTER_ENC_ORBAR_RAW;
LOOTSTER_ENC_MARKER_RAW		= "#";
LOOTSTER_ENC_MARKER_ENC		= LOOTSTER_ENC_MARKER_RAW..LOOTSTER_ENC_MARKER_RAW;
LOOTSTER_ENC_NEWLINE_RAW	= "\n";
LOOTSTER_ENC_NEWLINE_ENC	= " "..LOOTSTER_ENC_MARKER_RAW.." ";
LOOTSTER_ENC_QUOTESLASH_RAW	= "\"/";
LOOTSTER_ENC_QUOTESLASH_ENC	= "\""..LOOTSTER_ENC_MARKER_RAW.."/";

-- To/From Whisper Queue Intervals (seconds) and Initial Message Dispatch Count
LOOTSTER_TQUE_DISPATCH 		= 0.500;
LOOTSTER_TQUE_DISPATCHBIAS	= 0.050;
LOOTSTER_TQUE_DISPATCHINIT	= 4;

LOOTSTER_FQUE_CLEAR 		= 5.000;

-- Lootster Popup Frame List
LOOTSTER_POPUP_FRAME		= 
{
	"Lootster_ItemSyncFrame",
	"Lootster_RaidSyncFrame",
	"Lootster_RaidFrameRaidFrame",
	"Lootster_RaidFrameBossFrame",
	"Lootster_RaidFrameAttendFrame",
	"Lootster_RaidFrameAdjustFrame",
	"Lootster_RaidFrameReportFrame"
};

-- Server Time Zones
LOOTSTER_TZ_SERVER			=
{
	-- US East
	[ -5] =   0,	-- STD, same day
	[ -4] =  -1,	-- DST, same day
	[ 19] = -24,	-- STD, previous day
	[ 20] = -25,	-- DST, previous day

	-- US West
	[ -8] =   0,	-- STD, same day
	[ -7] =  -1,	-- DST, same day
	[ 16] = -24,	-- STD, previous day
	[ 17] = -25,	-- DST, previous day

	-- European
	[-23] =  24,	-- STD, following day
	[-22] =  23,	-- DST, following day
	[  1] =   0,	-- STD, same day
	[  2] =  -1,	-- DST, same day

	-- Oceanic
	[-13] =  24,	-- STD, following day
	[-12] =  23,	-- DST, following day
	[ 11] =   0,	-- STD, same day
	[ 12] =  -1,	-- DST, same day
};

-- Synchronise Management
LOOTSTER_SYNC_PREFIX		= "<LS>";
LOOTSTER_SYNC_PREFIXLEN		= string.len(LOOTSTER_SYNC_PREFIX);
LOOTSTER_SYNC_POSTFIXCONT	= "-";
LOOTSTER_SYNC_VERSION		= 1;
LOOTSTER_SYNC_TIMEOUT		= 8.000;
LOOTSTER_SYNC_MESSAGELEN	= 255;

LOOTSTER_SYNC_CMD_SYNCITEM	= "SYNCITEM";
LOOTSTER_SYNC_CMD_SYNCRAID	= "SYNCRAID";

LOOTSTER_SYNC_CMD_ACK		= "ACK";
LOOTSTER_SYNC_CMD_BEGIN		= "BEGIN";
LOOTSTER_SYNC_CMD_ABORT		= "ABORT";
LOOTSTER_SYNC_CMD_COMMIT	= "COMMIT";

LOOTSTER_SYNC_CMD_ITEM		= "ITEM";

LOOTSTER_SYNC_CMD_ID		= "ID";
LOOTSTER_SYNC_CMD_RAID		= "RAID";
LOOTSTER_SYNC_CMD_BOSS		= "BOSS";
LOOTSTER_SYNC_CMD_ATTEND	= "ATTEND";
LOOTSTER_SYNC_CMD_ADJUST	= "ADJUST";
LOOTSTER_SYNC_CMD_LEGACY	= "LEGACY";
LOOTSTER_SYNC_CMD_MASTER	= "MASTER";
LOOTSTER_SYNC_CMD_RUNNING	= "RUNNING";

LOOTSTER_SYNC_EXP_SYNCITEM	= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_SYNCITEM.."/%d/";
LOOTSTER_SYNC_EXP_SYNCRAID	= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_SYNCRAID.."/%d/";

LOOTSTER_SYNC_EXP_ACK		= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_ACK.."/";
LOOTSTER_SYNC_EXP_BEGIN		= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_BEGIN.."/%d/%d/";
LOOTSTER_SYNC_EXP_ABORT		= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_ABORT.."/";
LOOTSTER_SYNC_EXP_COMMIT	= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_COMMIT.."/%d/";

LOOTSTER_SYNC_EXP_ITEM		= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_ITEM.."/%s/%q/%q/";

LOOTSTER_SYNC_EXP_ID		= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_ID.."/%d/";
LOOTSTER_SYNC_EXP_RAID		= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_RAID.."/%s/%q/%s/%d/%d/%q/";
LOOTSTER_SYNC_EXP_BOSS		= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_BOSS.."/%s/%s/%q/%d/%d/%d/%d/%d/";
LOOTSTER_SYNC_EXP_ATTEND	= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_ATTEND.."/%s/%s/%s/%s/%d/";
LOOTSTER_SYNC_EXP_ADJUST	= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_ADJUST.."/%s/%s/%s/%s/%d/%d/%d/%q/%q/%q/";
LOOTSTER_SYNC_EXP_LEGACY	= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_LEGACY.."/%s/%d/%d/%q/%q/";
LOOTSTER_SYNC_EXP_MASTER	= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_MASTER.."/%s/";
LOOTSTER_SYNC_EXP_RUNNING	= LOOTSTER_SYNC_PREFIX..LOOTSTER_SYNC_CMD_RUNNING.."/%s/%s/";

LOOTSTER_SYNC_IMP_PREFIX	= "^"..LOOTSTER_SYNC_PREFIX;

LOOTSTER_SYNC_IMP_PATTERN	= "^"..LOOTSTER_SYNC_PREFIX.."(.*)$";
LOOTSTER_SYNC_IMP_COMMAND	= "^(%w+)/(.*)$";

LOOTSTER_SYNC_IMP_SYNCITEM	= "^(%d+)/$";
LOOTSTER_SYNC_IMP_SYNCRAID	= "^(%d+)/$";

LOOTSTER_SYNC_IMP_BEGIN		= "^(%d+)/(%d+)/$";
LOOTSTER_SYNC_IMP_COMMIT	= "^(%d+)/$";

LOOTSTER_SYNC_IMP_ITEM		= "^(.*)/\"(.*)\/\"(.*)\"/$";

LOOTSTER_SYNC_IMP_ID		= "^(%d+)/$";
LOOTSTER_SYNC_IMP_RAID		= "^(.*)/\"(.*)\"/(.*)/(%d+)/(-?%d+)/\"(.*)\"/$";
LOOTSTER_SYNC_IMP_BOSS		= "^(.*)/(.*)/\"(.*)\"/(%d+)/(-?%d+)/(%d)/(%d)/(%d)/$";
LOOTSTER_SYNC_IMP_ATTEND	= "^(.*)/(.*)/(.*)/(.*)/(%d)/$";
LOOTSTER_SYNC_IMP_ADJUST	= "^(.*)/(.*)/(.*)/(.*)/(%d+)/(%d)/(-?%d+)/\"(.*)\"/\"(.*)\"/\"(.*)\"/$";
LOOTSTER_SYNC_IMP_LEGACY	= "^(.*)/(-?%d+)/(%d+)/\"(.*)\"/\"(.*)\"/$";
LOOTSTER_SYNC_IMP_MASTER	= "^(.*)/$";
LOOTSTER_SYNC_IMP_RUNNING	= "^(.*)/(.*)/$";

-- CT_RaidAssist Definitions
LOOTSTER_CTRACMD_MSG		= "MS ";

-- Saved Variables
Lootster_Options			= {};

Lootster_Options_Default	=
{
	Active				= false;
	Passive				= false;
	MiniMap				= true;
	MiniMapPos			= 270;
	Suppress			= false;
	AckRoll				= true;
	AckNoCall			= true;
	AckNoRoll			= true;
	AckNoHelp			= false;
	Counter				= true;
	CounterSec			= 5;
	AutoSnoop			= true;
	DebugMsgs			= false;
	EchoRestrict		= true;
	EchoToChat			= true;
	EchoToCTRA			= true;
	EchoByClick			= true;
	EchoByGroupLoot		= true;
	RollMode			= LOOTSTER_ENUM_ROLLMODE.USENORM;
	DKPType				= LOOTSTER_ENUM_DKP.BYTIER;
	DKPPrior			= false;
	DKPFactoring		= false;
	DKPFactor			= 1;
	DKPCaps				= true;
	DKPHi				= 50;
	DKPLo				= 50;
	NormType			= LOOTSTER_ENUM_NORM.BYNEEDGREED;
	CorKRoll			= false;
	CorKOpen			= false;
	CorKClose			= false;
	TrackBy				= LOOTSTER_ENUM_AUTORAID.RAID;
	RaidIcon			= false;
	BossIcon			= false;
	AutoRaid			= false;
	LootMode			= LOOTSTER_ENUM_LOOTMODE.UNCOMMON;
	AutoDKPLoot			= false;
	AutoNonDKPLoot		= false;
	AutoLootRaid		= false;
	RepRaidSortCol		= "DateOpn";
	RepRaidSortColOrd	= true;
	RepBossSortCol		= "DateBeg";
	RepBossSortColOrd	= true;
	RepAttendSortCol	= "Player";
	RepAttendSortColOrd	= true;
	RepAdjustSortCol	= "DateAdj";
	RepAdjustSortColOrd	= true;
	RepAttend			= true;
	RepAttendDetail		= true;
	RepAdjust			= true;
	RepConsolidate		= false;
	Sound				= true;
	Updated1900			= false;
};

Lootster_Rules				= {};

Lootster_Rules_Default		=
{
	RulesDKP		= "";
	RulesNorm		= "";
};

Lootster_Id					= 1;

Lootster_Raid				= {};

Lootster_Boss				= {};

Lootster_Attend				= {};

Lootster_Adjust				= {};

Lootster_Players			= {};

Lootster_Running			= {};

Lootster_Restrict			= {};

Lootster_MasterLooted		= {};

-- Global Variables
local	Lootster_EventState									= LOOTSTER_ENUM_EVENTSTATE.LOAD;

local	Lootster_ChatFrame_OnEventCB						= nil;		-- ChatFrame_OnEvent callback function
local	Lootster_ChatFrame_OnHyperlinkShowCB				= nil;		-- ChatFrame_OnHyperlinkShow callback function
local	Lootster_ChatFrame_AddMessageGroupCB				= nil;		-- ChatFrame_AddMessageGroup callback function
local	Lootster_ChatFrame_RemoveMessageGroupCB				= nil;		-- ChatFrame_RemoveMessageGroup callback function
local	Lootster_ChatFrame_RegisterForMessagesCB			= nil;		-- ChatFrame_RegisterForMessages callback function
local	Lootster_ChatFrame_RemoveAllMessageGroupsCB			= nil;		-- ChatFrame_RemoveAllMessageGroups callback function
local	Lootster_LootFrameItem_OnClickCB					= nil;		-- LootFrameItem_OnClick callback function
local	Lootster_GroupLootFrame_OnShowCB					= nil;		-- GroupLootFrame_OnShow callback function
local	Lootster_GroupLootFrame_OnEventCB					= nil;		-- GroupLootFrame_OnEvent callback function
local	Lootster_ContainerFrameItemButton_OnClickCB			= nil;		-- ContainerFrameItemButton_OnClick callback function
local	Lootster_AllInOneInventoryFrameItemButton_OnClickCB	= nil;		-- AllInOneInventoryFrameItemButton_OnClick callback function

local   Lootster_Language									= nil;		-- Default language

local	Lootster_TZOffsetSvrUTC								= 0;		-- Server timezone offset from UTC
local	Lootster_TZOffsetSvrCur								= 0;		-- Server timezone offset from current

local   Lootster_Self										= nil;		-- Self
local   Lootster_SelfClass									= nil;		-- Self class
local   Lootster_SelfClassType								= nil;		-- Self class type

local	Lootster_SelfRoll									= 100;		-- Self roll maximum

local	Lootster_Roster										= {};		-- Current roster
local	Lootster_RosterRoll									= {};		-- Current roll roster

local	Lootster_HasDKP										= false;	-- Has DKP enabled flag

local   Lootster_DKP										= {};		-- Current DKP data
local   Lootster_DKPSort									= {};		-- Current DKP data sort
local   Lootster_DKPSortCol									= "Player";	-- Current DKP data sort column
local   Lootster_DKPSortOrd									= true;		-- Current DKP data sort order

local   Lootster_PlayerId									= nil;      -- Current player id
local	Lootster_PlayerSort									= {};		-- Current player sort

local   Lootster_RaidRec									= nil;      -- Editing raid record

local   Lootster_RaidId										= nil;      -- Current raid id
local	Lootster_RaidSort									= {};		-- Current raid sort
local	Lootster_RaidSortCol								= "DateOpn";-- Current raid sort column
local	Lootster_RaidSortOrd								= false;	-- Current raid sort order

local   Lootster_BossRec									= nil;      -- Editing boss record

local   Lootster_BossId										= nil;      -- Current boss id
local	Lootster_BossSort									= {};		-- Current boss sort
local	Lootster_BossSortCol								= "DateBeg";-- Current boss sort column
local	Lootster_BossSortOrd								= false;	-- Current boss sort order

local   Lootster_AttendRec									= nil;      -- Editing attendance record

local   Lootster_AttendId									= nil;      -- Current attendance id
local	Lootster_AttendSort									= {};		-- Current attendance sort
local	Lootster_AttendSortCol								= "Player";	-- Current attendance sort column
local	Lootster_AttendSortOrd								= true;		-- Current attendance sort order

local   Lootster_AdjustRec									= nil;      -- Editing adjustment record

local   Lootster_AdjustId									= nil;      -- Current adjustment id
local	Lootster_AdjustSort									= {};		-- Current adjustment sort
local	Lootster_AdjustSortCol								= "DateAdj";-- Current adjustment sort column
local	Lootster_AdjustSortOrd								= false;	-- Current adjustment sort order

local	Lootster_MainALT									= {};		-- Main to Alt Look-aside Table
local	Lootster_ALTMain									= {};		-- Alt to Main Look-aside Table

local	Lootster_ParkSort									= {};		-- Park player sort

local   Lootster_Rolls										= {};		-- Current rolls
local   Lootster_RollsSort									= {};		-- Current rolls sort
local   Lootster_RollsSortCol								= "Roll";	-- Current rolls sort column
local   Lootster_RollsSortOrd								= true;		-- Current rolls sort order

local   Lootster_Tiers										= {};		-- Current tiers
local   Lootster_TiersSort									= {};		-- Current tiers sort
local   Lootster_TiersPrompt								= "";		-- Current tiers prompt

local	Lootster_Grouped									= false;	-- Player is grouped
local	Lootster_RollCount									= 0;		-- Roll count
local	Lootster_PlayerCount								= 0;		-- Player count
local	Lootster_RestrictedCount							= 0;		-- Restricted class count

local	Lootster_ItemID										= nil;		-- Item ID
local	Lootster_ItemSlot									= nil;		-- Item slot
local	Lootster_ItemLink									= nil;		-- Item link
local	Lootster_ItemText									= "";		-- Item text
local	Lootster_ItemCount									= 1;		-- Item count to roll on
local	Lootster_ItemPrompt									= "";		-- Item prompt text (with appropriate item count)

local	Lootster_ItemSel									= nil;		-- Current item selected
local	Lootster_ItemSort									= {};		-- Current item sort
local	Lootster_ItemSortCol								= "Text";	-- Current item sort column
local	Lootster_ItemSortOrd								= true;		-- Current item sort order

local   Lootster_NBG										= nil;		-- Need before Greed
local   Lootster_NBG_ClassPlease							= "";		-- Need before Greed class please text
local   Lootster_NBG_ClassIgnore							= "";		-- Need before Greed class ignore text

local	Lootster_Won										= {};		-- Winner list
local	Lootster_WonItemCount								= 0;		-- Winner item count (may be different from Winner list entries)

local	Lootster_Tied										= false;	-- Tied roll
local	Lootster_TiedRolls									= {};		-- Tied rolls
local	Lootster_TiedRollsSort								= {};		-- Tied rolls sort
local	Lootster_TiedItemCount								= 0;		-- Tied item count to roll on

local	Lootster_LootMode									= LOOTSTER_ENUM_LOOTMODE.UNCOMMON;
local	Lootster_LootMethod									= LOOTSTER_ENUM_LOOTMETHOD.GROUP;
local	Lootster_LootMaster									= nil;		-- Master looter

local	Lootster_LootQuality								= {};		-- Loot colour/quality lookup

local	Lootster_InBossFight								= false;	-- In boss fight flag

local	Lootster_ClassIgnore								= {};		-- No ignore class yet

local	Lootster_ClassLower									= {};		-- Class lower/invariant lookup
local	Lootster_ClassPlural								= {};		-- Class plural/invariant lookup
local	Lootster_ClassSingular								= {};		-- Class singular/invariant lookup

local	Lootster_ClassRestricted							= false;	-- Class is restricted
local	Lootster_ClassRestrictedLock						= false;	-- Class is restricted locked

local	Lootster_ClassRestrictions							= {};		-- Class roll restrictions
local	Lootster_ClassRestrictionsMaskOrig					= 0;		-- Class roll restrictions mask (original)
local	Lootster_ClassRestrictionsMaskCurr					= 0;		-- Class roll restrictions mask (current)

local	Lootster_ToWhisperQue								= nil;		-- To Whisper queue
local	Lootster_FromWhisperQue								= nil;		-- From Whisper queue

local	Lootster_ChatMaskWhisper							= 0;		-- Chat Frames whisper mask

local	Lootster_SyncUser									= nil;		-- Synchronise player
local	Lootster_SyncType									= nil;		-- Synchronise type
local	Lootster_SyncCont									= nil;		-- Synchronise continuation record
local	Lootster_SyncAcks									= 0;		-- Synchronise acknowledgements received
local	Lootster_SyncTitle									= "";		-- Synchronise title
local	Lootster_SyncCount									= 0;		-- Synchronise record count
local	Lootster_SyncTotal									= 0;		-- Synchronise record total

local	Lootster_SyncData									= {};		-- Synchronise data table

local	Lootster_MenuGroups									= {}		-- Menu groups
local	Lootster_MenuPlayers								= {}		-- Menu players

local	Lootster_CountdownCount								= 0;		-- Roll clear counter

local	Lootster_ViewRaidType								= LOOTSTER_ENUM_VIEWRAID.BYATTEND;

local	Lootster_ReportWriterCB								= nil;		-- No inital report writer

local	Lootster_DKPFactorSave								= nil;		-- DKP factor save
local	Lootster_DKPHiSave									= nil;		-- DKP cap hi save
local	Lootster_DKPLoSave									= nil;		-- DKP cap lo save

-- Load handler
function Lootster_OnLoad()
	local   faction, ix, key, classRec, frame;

	-- hook events
	this:RegisterEvent("ADDON_LOADED")
	this:RegisterEvent("PLAYER_LOGIN")
	this:RegisterEvent("PLAYER_LOGOUT")
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("PARTY_LEADER_CHANGED");	
	this:RegisterEvent("PARTY_LOOT_METHOD_CHANGED"); 
	this:RegisterEvent("PARTY_MEMBERS_CHANGED"); 
	this:RegisterEvent("RAID_ROSTER_UPDATE");
	this:RegisterEvent("LOOT_OPENED");
	this:RegisterEvent("LOOT_CLOSED");
	this:RegisterEvent("LOOT_SLOT_CLEARED");
	this:RegisterEvent("CHAT_MSG_LOOT");
	this:RegisterEvent("CHAT_MSG_RAID");
	this:RegisterEvent("CHAT_MSG_PARTY");
	this:RegisterEvent("CHAT_MSG_RAID_LEADER");
	this:RegisterEvent("CHAT_MSG_SYSTEM");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
	this:RegisterEvent("ZONE_CHANGED");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	this:RegisterEvent("UPDATE_INSTANCE_INFO");

	-- hook command handler
	SLASH_LOOTSTER1 = "/lootster";
	SLASH_LOOTSTER2 = "/ls";

	SlashCmdList["LOOTSTER"] = Lootster_OnCommand;

	-- echo current version
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(string.format(LOOTSTER_MSG_LOAD, LOOTSTER_VERSION));
	end
	
	-- make the popups closable using Escape key
	table.insert(UISpecialFrames, "Lootster_RaidFrameRaidFrame");
	table.insert(UISpecialFrames, "Lootster_RaidFrameBossFrame");
	table.insert(UISpecialFrames, "Lootster_RaidFrameAttendFrame");
	table.insert(UISpecialFrames, "Lootster_RaidFrameAdjustFrame");
	table.insert(UISpecialFrames, "Lootster_RaidFrameReportFrame");

	-- create a dialogs for raid deletion
	StaticPopupDialogs["LOOTSTER_PROMPT_RAID_DELETE"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_RAID_DELETE),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Raid_Raid_Delete_OnAccept();
									end,
		OnCancel				=	function()
										Lootster_Raid_Raid_Delete_OnCancel();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};

	StaticPopupDialogs["LOOTSTER_PROMPT_RAID_DELETEALL"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_RAID_DELETEALL),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Raid_Raid_DeleteAll_OnAccept();
									end,
		OnCancel				=	function()
										Lootster_Raid_Raid_DeleteAll_OnCancel();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};

	-- create a dialogs for boss deletion
	StaticPopupDialogs["LOOTSTER_PROMPT_BOSS_DELETE"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_BOSS_DELETE),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Raid_Boss_Delete_OnAccept();
									end,
		OnCancel				=	function()
										Lootster_Raid_Boss_Delete_OnCancel();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};

	StaticPopupDialogs["LOOTSTER_PROMPT_BOSS_DELETEALL"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_BOSS_DELETEALL),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Raid_Boss_DeleteAll_OnAccept();
									end,
		OnCancel				=	function()
										Lootster_Raid_Boss_DeleteAll_OnCancel();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};
	
	-- create a dialogs for attendence player and attednance deletion
	StaticPopupDialogs["LOOTSTER_PROMPT_ATTEND_PLAYER"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_ATTEND_PLAYER),
		button1					= TEXT(ACCEPT),
		button2					= TEXT(CANCEL),
		hasEditBox				= 1,
		maxLetters				= 12,
		OnAccept				=	function()
										local editBox;

										-- make sure we have an attend record
										if (Lootster_AttendRec ~= nil) then
											-- get the edit box
											editBox = getglobal(this:GetParent():GetName().."EditBox");

											-- snarf the entered player - this will be the alt
											Lootster_AttendRec.Alt = editBox:GetText();

											-- get the main
											Lootster_AttendRec.Player = Lootster_GetALTMain(Lootster_AttendRec.Alt);

											-- and cause menu to update
											UIDropDownMenu_SetText(Lootster_AttendRec.Alt, Lootster_RaidFrameAttendFramePlayerDropDown);
											UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAttendFramePlayerDropDown, Lootster_AttendRec.Alt);

											-- update player if set
											if (Lootster_AttendRec.Player == "") then
												Lootster_AttendRec.Player = nil;
												Lootster_AttendRec.Alt = nil;
											end

											-- update raid attendance UI
											Lootster_RaidAttendUpdateUI();
										end
									end,
		OnShow					=	function()
										getglobal(this:GetName().."EditBox"):SetFocus();
									end,
		OnHide					=	function()
										if (ChatFrameEditBox:IsVisible()) then
											ChatFrameEditBox:SetFocus();
										end

										getglobal(this:GetName().."EditBox"):SetText("");
									end,
		EditBoxOnEnterPressed	=	function()
										local editBox;

										-- make sure we have an attend record
										if (Lootster_AttendRec ~= nil) then
											-- get the edit box
											editBox = getglobal(this:GetParent():GetName().."EditBox");

											-- snarf the entered player - this will be the alt
											Lootster_AttendRec.Alt = editBox:GetText();

											-- get the main
											Lootster_AttendRec.Player = Lootster_GetALTMain(Lootster_AttendRec.Alt);

											-- and cause menu to update
											UIDropDownMenu_SetText(Lootster_AttendRec.Alt, Lootster_RaidFrameAttendFramePlayerDropDown);
											UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAttendFramePlayerDropDown, Lootster_AttendRec.Alt);

											-- update player if set
											if (Lootster_AttendRec.Player == "") then
												Lootster_AttendRec.Player = nil;
												Lootster_AttendRec.Alt = nil;
											end

											-- update raid attendance UI
											Lootster_RaidAttendUpdateUI();

											-- thats all folks
											this:GetParent():Hide();
										end
									end,
		EditBoxOnEscapePressed	=	function()
										this:GetParent():Hide();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};

	StaticPopupDialogs["LOOTSTER_PROMPT_ATTEND_DELETE"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_ATTEND_DELETE),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Raid_Attend_Delete_OnAccept();
									end,
		OnCancel				=	function()
										Lootster_Raid_Attend_Delete_OnCancel();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};

	StaticPopupDialogs["LOOTSTER_PROMPT_ATTEND_DELETEALL"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_ATTEND_DELETEALL),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Raid_Attend_DeleteAll_OnAccept();
									end,
		OnCancel				=	function()
										Lootster_Raid_Attend_DeleteAll_OnCancel();
									end,
		timeout					= 0,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};
	
	-- create a dialogs for adjustment player and adjustment deletion
	StaticPopupDialogs["LOOTSTER_PROMPT_ADJUST_PLAYER"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_ADJUST_PLAYER),
		button1					= TEXT(ACCEPT),
		button2					= TEXT(CANCEL),
		hasEditBox				= 1,
		maxLetters				= 12,
		OnAccept				=	function()
										local editBox;

										-- make sure we have an adjust record
										if (Lootster_AdjustRec ~= nil) then
											-- get the edit box
											editBox = getglobal(this:GetParent():GetName().."EditBox");

											-- snarf the entered player - this will be the alt
											Lootster_AdjustRec.Alt = editBox:GetText();

											-- get the main
											Lootster_AdjustRec.Player = Lootster_GetALTMain(Lootster_AdjustRec.Alt);

											-- and cause menu to update
											UIDropDownMenu_SetText(Lootster_AdjustRec.Alt, Lootster_RaidFrameAdjustFramePlayerDropDown);
											UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAdjustFramePlayerDropDown, Lootster_AdjustRec.Alt);

											-- update player if set
											if (Lootster_AdjustRec.Player == "") then
												Lootster_AdjustRec.Player = nil;
												Lootster_AdjustRec.Alt = nil;
											end

											-- update raid adjust UI
											Lootster_RaidAdjustUpdateUI();
										end
									end,
		OnShow					=	function()
										getglobal(this:GetName().."EditBox"):SetFocus();
									end,
		OnHide					=	function()
										if (ChatFrameEditBox:IsVisible()) then
											ChatFrameEditBox:SetFocus();
										end

										getglobal(this:GetName().."EditBox"):SetText("");
									end,
		EditBoxOnEnterPressed	=	function()
										local editBox;

										-- make sure we have an adjust record
										if (Lootster_AdjustRec ~= nil) then
											-- get the edit box
											editBox = getglobal(this:GetParent():GetName().."EditBox");

											-- snarf the entered player - this will be the alt
											Lootster_AdjustRec.Alt = editBox:GetText();

											-- get the main
											Lootster_AdjustRec.Player = Lootster_GetALTMain(Lootster_AdjustRec.Alt);

											-- and cause menu to update
											UIDropDownMenu_SetText(Lootster_AdjustRec.Alt, Lootster_RaidFrameAdjustFramePlayerDropDown);
											UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAdjustFramePlayerDropDown, Lootster_AdjustRec.Alt);

											-- update player if set
											if (Lootster_AdjustRec.Player == "") then
												Lootster_AdjustRec.Player = nil;
												Lootster_AdjustRec.Alt = nil;
											end

											-- update raid adjust UI
											Lootster_RaidAdjustUpdateUI();

											-- thats all folks
											this:GetParent():Hide();
										end
									end,
		EditBoxOnEscapePressed	=	function()
										this:GetParent():Hide();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};
	
	StaticPopupDialogs["LOOTSTER_PROMPT_ADJUST_DELETE"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_ADJUST_DELETE),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Raid_Adjust_Delete_OnAccept();
									end,
		OnCancel				=	function()
										Lootster_Raid_Adjust_Delete_OnCancel();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};

	StaticPopupDialogs["LOOTSTER_PROMPT_ADJUST_DELETEALL"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_ADJUST_DELETEALL),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Raid_Adjust_DeleteAll_OnAccept();
									end,
		OnCancel				=	function()
										Lootster_Raid_Adjust_DeleteAll_OnCancel();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};
	
	-- create a dialog for raid synchronise player
	StaticPopupDialogs["LOOTSTER_PROMPT_RAIDSYNC_PLAYER"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_RAIDSYNC_PLAYER),
		button1					= TEXT(ACCEPT),
		button2					= TEXT(CANCEL),
		hasEditBox				= 1,
		maxLetters				= 12,
		OnAccept				=	function()
										local editBox;

										-- get the edit box
										editBox = getglobal(this:GetParent():GetName().."EditBox");

										-- snarf the entered player
										Lootster_SyncUser = editBox:GetText();

										-- and cause menu to update
										UIDropDownMenu_SetText(Lootster_SyncUser, Lootster_RaidSyncFramePlayerDropDown);
										UIDropDownMenu_SetSelectedName(Lootster_RaidSyncFramePlayerDropDown, Lootster_SyncUser);

										-- if player is blank, reset
										if (Lootster_SyncUser == "") then
											Lootster_SyncUser = nil;
										end

										-- update raid synchronise UI
										Lootster_RaidSyncUpdateUI();
									end,
		OnShow					=	function()
										getglobal(this:GetName().."EditBox"):SetFocus();
									end,
		OnHide					=	function()
										if (ChatFrameEditBox:IsVisible()) then
											ChatFrameEditBox:SetFocus();
										end

										getglobal(this:GetName().."EditBox"):SetText("");
									end,
		EditBoxOnEnterPressed	=	function()
										local editBox;

										-- get the edit box
										editBox = getglobal(this:GetParent():GetName().."EditBox");

										-- snarf the entered player
										Lootster_SyncUser = editBox:GetText();

										-- and cause menu to update
										UIDropDownMenu_SetText(Lootster_SyncUser, Lootster_RaidSyncFramePlayerDropDown);
										UIDropDownMenu_SetSelectedName(Lootster_RaidSyncFramePlayerDropDown, Lootster_SyncUser);

										-- if player is blank, reset
										if (Lootster_SyncUser == "") then
											Lootster_SyncUser = nil;
										end

										-- update raid synchronise UI
										Lootster_RaidSyncUpdateUI();

										-- thats all folks
										this:GetParent():Hide();
									end,
		EditBoxOnEscapePressed	=	function()
										this:GetParent():Hide();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};
	
	-- create a dialog for item synchronise player
	StaticPopupDialogs["LOOTSTER_PROMPT_ITEMSYNC_PLAYER"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_ITEMSYNC_PLAYER),
		button1					= TEXT(ACCEPT),
		button2					= TEXT(CANCEL),
		hasEditBox				= 1,
		maxLetters				= 12,
		OnAccept				=	function()
										local editBox;

										-- get the edit box
										editBox = getglobal(this:GetParent():GetName().."EditBox");

										-- snarf the entered player
										Lootster_SyncUser = editBox:GetText();

										-- and cause menu to update
										UIDropDownMenu_SetText(Lootster_SyncUser, Lootster_ItemSyncFramePlayerDropDown);
										UIDropDownMenu_SetSelectedName(Lootster_ItemSyncFramePlayerDropDown, Lootster_SyncUser);

										-- if player is blank, reset
										if (Lootster_SyncUser == "") then
											Lootster_SyncUser = nil;
										end

										-- update item synchronise UI
										Lootster_ItemSyncUpdateUI();
									end,
		OnShow					=	function()
										getglobal(this:GetName().."EditBox"):SetFocus();
									end,
		OnHide					=	function()
										if (ChatFrameEditBox:IsVisible()) then
											ChatFrameEditBox:SetFocus();
										end

										getglobal(this:GetName().."EditBox"):SetText("");
									end,
		EditBoxOnEnterPressed	=	function()
										local editBox;

										-- get the edit box
										editBox = getglobal(this:GetParent():GetName().."EditBox");

										-- snarf the entered player
										Lootster_SyncUser = editBox:GetText();

										-- and cause menu to update
										UIDropDownMenu_SetText(Lootster_SyncUser, Lootster_ItemSyncFramePlayerDropDown);
										UIDropDownMenu_SetSelectedName(Lootster_ItemSyncFramePlayerDropDown, Lootster_SyncUser);

										-- if player is blank, reset
										if (Lootster_SyncUser == "") then
											Lootster_SyncUser = nil;
										end

										-- update item synchronise UI
										Lootster_ItemSyncUpdateUI();

										-- thats all folks
										this:GetParent():Hide();
									end,
		EditBoxOnEscapePressed	=	function()
										this:GetParent():Hide();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};

	-- create dialogs for item and all item deletion
	StaticPopupDialogs["LOOTSTER_PROMPT_ITEM_DELETE"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_ITEM_DELETE),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Item_Delete_OnAccept();
									end,
		OnCancel				=	function()
										Lootster_Item_Delete_OnCancel();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};

	StaticPopupDialogs["LOOTSTER_PROMPT_ITEM_DELETEALL"] =
	{
		text					= TEXT(LOOTSTER_PROMPT_ITEM_DELETEALL),
		button1					= TEXT(YES),
		button2					= TEXT(CANCEL),
		OnAccept				=	function()
										Lootster_Item_DeleteAll_OnAccept();
									end,
		timeout					= 0,
		exclusive				= 1,
		whileDead				= 1,
		hideOnEscape			= 1
	};	
end

-- Event handler
function Lootster_OnEvent()
	-- determine event
	if		(event == "ADDON_LOADED") then
		Lootster_ADDON_Load(arg1);
	elseif	(event == "PLAYER_LOGIN") then
		Lootster_PLAYER_Login();
	elseif	(Lootster_EventState < LOOTSTER_ENUM_EVENTSTATE.LOGIN) then
		return;
	elseif	(event == "PLAYER_LOGOUT") then
		Lootster_PLAYER_Logout();
	elseif	(event == "PLAYER_ENTERING_WORLD") then
		Lootster_PLAYER_Enter();
	elseif	(Lootster_EventState < LOOTSTER_ENUM_EVENTSTATE.ENTER) then
		return;
	elseif	(event == "PLAYER_LEAVING_WORLD") then
		Lootster_PLAYER_Leave();
	elseif	(event == "PLAYER_REGEN_ENABLED") then
		Lootster_PLAYER_Regen(true);
	elseif	(event == "PLAYER_REGEN_DISABLED") then
		Lootster_PLAYER_Regen(false);
	elseif	(event == "PLAYER_TARGET_CHANGED") then
		Lootster_PLAYER_Target(arg1);
	elseif	(event == "PARTY_LEADER_CHANGED") then
		Lootster_PARTY_Leader();
	elseif	(event == "PARTY_LOOT_METHOD_CHANGED") then
		Lootster_PARTY_Leader();
	elseif	(event == "PARTY_MEMBERS_CHANGED") then
		Lootster_PARTY_Roster();
	elseif	(event == "RAID_ROSTER_UPDATE") then
		Lootster_PARTY_Roster();
	elseif	(event == "LOOT_OPENED") then
		Lootster_LOOT_Opened();
	elseif	(event == "LOOT_CLOSED") then
		Lootster_LOOT_Closed();
	elseif	(event == "LOOT_SLOT_CLEARED") then
		Lootster_LOOT_Slot_Cleared(arg1);
	elseif	(event == "CHAT_MSG_LOOT") then
		Lootster_MSG_Loot();
	elseif	(event == "CHAT_MSG_RAID") then
		Lootster_MSG_PartyRaid();
	elseif	(event == "CHAT_MSG_PARTY") then
		Lootster_MSG_PartyRaid();
	elseif	(event == "CHAT_MSG_SYSTEM") then
		Lootster_MSG_System();
	elseif	(event == "CHAT_MSG_WHISPER") then
		Lootster_MSG_Whisper();
	elseif	(event == "CHAT_MSG_RAID_LEADER") then
		Lootster_MSG_PartyRaid();
	elseif	(event == "CHAT_MSG_COMBAT_XP_GAIN") then
		Lootster_MSG_Death();
	elseif	(event == "CHAT_MSG_COMBAT_HOSTILE_DEATH") then
		Lootster_MSG_Death();
	elseif	(event == "ZONE_CHANGED") then
		Lootster_ZONE_Changed();
	elseif	(event == "ZONE_CHANGED_NEW_AREA") then
		Lootster_ZONE_Changed();
	elseif	(event == "UPDATE_INSTANCE_INFO") then
		Lootster_UPDATE_Instance();
	end
end

-- Timer Update handler
function Lootster_OnUpdate(elapsed)
	-- handle only if counting down
	if (elapsed ~= nil) then		
		-- is the countdown timer active?
		if (Lootster_CountdownCount > 0) then
			-- call the timer countdown handler
			Lootster_Timer_Countdown(elapsed);
		end

		-- is the to whisper queue active?
		if (Lootster_ToWhisperQue ~= nil) then
			-- call the timer to whisper handler
			Lootster_Timer_ToWhisper(elapsed);
		end

		-- is the from whisper queue active?
		if (Lootster_FromWhisperQue ~= nil) then
			-- call the timer whisper handler
			Lootster_Timer_FromWhisper(elapsed);
		end

		-- is the synchronise timeout active?
		if (this.NextSyncTimeoutTime > 0) then
			-- call the timer synchronise handler
			Lootster_Timer_SyncTimeout(elapsed);
		end
	end
end

-- Timer Countdown handler
function Lootster_Timer_Countdown(elapsed)
	-- update elapsed time
	this.LastCountdownTime = this.LastCountdownTime + elapsed;

	-- see if we passed a second since last update
	if (this.LastCountdownTime >= 1) then
		-- decrement counter
		Lootster_CountdownCount = Lootster_CountdownCount - 1;

		-- punch out tic if it has not expired
		if (Lootster_CountdownCount > 0) then
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_COUNTDOWNTIC, Lootster_CountdownCount));
		end

		-- reset last update time
		this.LastCountdownTime = 0;
	end
end

-- Timer To Whisper handler
function Lootster_Timer_ToWhisper(elapsed)
	-- update elapsed time in milliseconds
	this.LastToWhisperTime = this.LastToWhisperTime + elapsed;

	-- see if we passed a second since last update
	if (this.LastToWhisperTime >= this.NextToWhisperTime) then
		-- dispatch messages while we have them and our time marker is valid
		while((Lootster_ToWhisperQue ~= nil) and (table.getn(Lootster_ToWhisperQue) > 0) and (Lootster_ToWhisperQue[1].Time <= this.NextToWhisperTime)) do
			-- punch this message out
			SendChatMessage(Lootster_ToWhisperQue[1].Msg, "WHISPER", Lootster_Language, Lootster_ToWhisperQue[1].To);

			-- are we showing debug messages?
			if (Lootster_Options.DebugMsgs == false) then 
				-- enqueue on from whisper queue to supress the whisper echo
				Lootster_FromWhisper_Enqueue(Lootster_ToWhisperQue[1].To, Lootster_ToWhisperQue[1].Msg);
			end

			-- smoke this message
			table.remove(Lootster_ToWhisperQue, 1);

			-- and smoke queue if empty
			if (table.getn(Lootster_ToWhisperQue) == 0) then
				Lootster_ToWhisperQue = nil;
			end
		end

		-- any more messages?
		if (Lootster_ToWhisperQue ~= nil) then
			-- snarf current time as for last
			this.LastToWhisperTime = time();

			-- calculate next time to start dispatching
			this.NextToWhisperTime = this.LastToWhisperTime + LOOTSTER_TQUE_DISPATCH;
		end
	end
end

-- Timer From Whisper handler
function Lootster_Timer_FromWhisper(elapsed)
	-- update elapsed time in milliseconds
	this.LastFromWhisperTime = this.LastFromWhisperTime + elapsed;

	-- see if we passed a second since last update
	if (this.LastFromWhisperTime >= this.NextFromWhisperTime) then
		-- indeed - smoke from whisper queue as it is essentially defunct
		Lootster_FromWhisperQue = nil;
	end
end


-- Timer Synchronise Timeout handler
function Lootster_Timer_SyncTimeout(elapsed)
	-- update elapsed time in milliseconds
	this.LastSyncTimeoutTime = this.LastSyncTimeoutTime + elapsed;

	-- see if we passed a second since last update
	if (this.LastSyncTimeoutTime >= this.NextSyncTimeoutTime) then
		-- do we have a synchronise user?
		if (Lootster_SyncUser ~= nil) then
			-- abort synchronise
			Lootster_SendPrivate(Lootster_SyncUser, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- timed out operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_TIMEOUT);
		end
	end
end

-- To Whisper Enqueue handler
function Lootster_ToWhisper_Enqueue(to, msg, sync)
	local	sub;

	-- is this a Lootster message?
	if (string.find(msg, LOOTSTER_SYNC_IMP_PREFIX) ~= nil) then
		-- is this message over length?
		if (string.len(msg) > LOOTSTER_SYNC_MESSAGELEN) then
			-- chunk up the message
			repeat
				-- get sub-message
				sub = string.sub(msg, 1, (LOOTSTER_SYNC_MESSAGELEN - 1))..LOOTSTER_SYNC_POSTFIXCONT;

				-- and slice up current message
				msg = LOOTSTER_SYNC_PREFIX..string.sub(msg, LOOTSTER_SYNC_MESSAGELEN);

				-- enqueue sub-message
				Lootster_ToWhisper_Enqueue(to, sub);
			until string.len(msg) <= LOOTSTER_SYNC_MESSAGELEN;

			-- enqueue final sub-message
			Lootster_ToWhisper_Enqueue(to, msg, sync);
		end
	end

	-- first message being enqueued?
	if (Lootster_ToWhisperQue == nil) then
		-- establish current time
		Lootster_Timer.CurrToWhisperTime = time();

		-- set the next broadcast period, which is enough for initial message dispatches
		Lootster_Timer.NextToWhisperTime = Lootster_Timer.CurrToWhisperTime + LOOTSTER_TQUE_DISPATCHBIAS * LOOTSTER_TQUE_DISPATCHINIT;

		-- set last time fired
		Lootster_Timer.LastToWhisperTime = Lootster_Timer.CurrToWhisperTime;

		-- create queue
		Lootster_ToWhisperQue = {};
	else
		-- bias current time to delay message
		Lootster_Timer.CurrToWhisperTime = Lootster_Timer.CurrToWhisperTime + LOOTSTER_TQUE_DISPATCHBIAS;
	end

	-- is this a synchronous request (that is, immediate - no queuing)
	if (sync ~= true) then	
		-- enqueue this message
		table.insert(Lootster_ToWhisperQue, { Time=Lootster_Timer.CurrToWhisperTime, To=to, Msg=msg });
	else
		-- punch this message out right now
		SendChatMessage(msg, "WHISPER", Lootster_Language, to);

		-- and enqueue to be suppressed
		Lootster_FromWhisper_Enqueue(to, msg);
	end
end

-- From Whisper Enqueue handler
function Lootster_FromWhisper_Enqueue(to, msg)
	-- set last time fired
	Lootster_Timer.LastFromWhisperTime = time();
	
	-- update whisper expiry clear timer
	Lootster_Timer.NextFromWhisperTime = Lootster_Timer.LastFromWhisperTime + LOOTSTER_FQUE_CLEAR;
	
	-- have we an empty queue?
	if (Lootster_FromWhisperQue == nil) then
		-- initialise
		Lootster_FromWhisperQue = {};
	end

	-- have we an empty player queue?
	if (Lootster_FromWhisperQue[to] == nil) then
		-- initialise
		Lootster_FromWhisperQue[to] = {};
	end

	-- enqueue this from whisper
	table.insert(Lootster_FromWhisperQue[to], { Mask=0, Msg=msg });
end

-- Command handler
function Lootster_OnCommand(cmd)
	-- only command is nothing at all - toggle display
	if (cmd == "") then
		Lootster_Toggle();
	else
		-- process this as a player inquiry from ourselves
		Lootster_PlayerInquiry(Lootster_Self, cmd);
	end
end

-- ChatFrame Event handler
function Lootster_ChatFrame_OnEvent(event)
	-- manage roll and whisper suppression
	if		(event == "CHAT_MSG_SYSTEM") then
		Lootster_CHAT_System(event);
	elseif	(event == "CHAT_MSG_WHISPER") then
		Lootster_CHAT_Whisper(event);
	elseif	(event == "CHAT_MSG_WHISPER_INFORM") then
		Lootster_CHAT_Whisper_Inform(event);
	else
		-- pass to chat frame for processing
		Lootster_ChatFrame_OnEventCB(event);
	end
end

-- ChatFrame Hyperlink Show handler
function Lootster_ChatFrame_OnHyperlinkShow(link, text, button)
	-- must be an item
	if (strsub(link, 1, 4) == "item") then
		-- see if they are echoing restrictions or linking the item
		if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
			-- display restrictions of the hyperlink
			Lootster_Class_Display_OnClick(text);
			return;
		elseif	(IsShiftKeyDown() and (button == "LeftButton")) then
			-- snarf the hyperlink
			Lootster_SetHyperlink(text);
		end
	end

	-- and pass to base class
	Lootster_ChatFrame_OnHyperlinkShowCB(link, text, button);
end

-- ChatFrame Add Message Group handler
function Lootster_ChatFrame_AddMessageGroup(chatFrame, group)
	-- is this the whisper group?
	if (group == "WHISPER") then
		-- add this frame to the chat frame whisper mask
		Lootster_ChatMaskWhisper = bit.bor(Lootster_ChatMaskWhisper, bit.lshift(1, chatFrame:GetID()));
	end

	-- call base class
	Lootster_ChatFrame_AddMessageGroupCB(chatFrame, group);
end

-- ChatFrame Remove Message Group handler
function Lootster_ChatFrame_RemoveMessageGroup(chatFrame, group)
	-- call base class
	Lootster_ChatFrame_RemoveMessageGroupCB(chatFrame, group);

	-- is this the whisper group?
	if (group == "WHISPER") then
		-- remove this frame remove the chat frame whisper mask
		Lootster_ChatMaskWhisper = bit.band(Lootster_ChatMaskWhisper, bit.bnot(bit.lshift(1, chatFrame:GetID())));
	end
end

-- ChatFrame Register For Messages handler
function Lootster_ChatFrame_RegisterForMessages(...)
	local	aix;

	-- hammer through all the arguments
	for aix=1, arg.n do
		-- is this whisper?
		if (arg[aix] == "WHISPER") then
			-- add this frame to the chat frame whisper mask
			Lootster_ChatMaskWhisper = bit.bor(Lootster_ChatMaskWhisper, bit.lshift(1, this:GetID()));
			break
		end
	end

	-- call base class
	Lootster_ChatFrame_RegisterForMessagesCB(unpack(arg));
end

-- ChatFrame Remove All Message Groups handler
function Lootster_ChatFrame_RemoveAllMessageGroups(chatFrame)
	-- call base class
	Lootster_ChatFrame_RemoveAllMessageGroupsCB(chatFrame);

	-- remove this frame remove the chat frame whisper mask
	Lootster_ChatMaskWhisper = bit.band(Lootster_ChatMaskWhisper, bit.bnot(bit.lshift(1, chatFrame:GetID())));
end

-- LootFrameItem Click handler
function Lootster_LootFrameItem_OnClick(button)
	-- see if they are echoing restrictions or linking the loot
	if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
		-- display restrictions of the hyperlink if this is a loot item
		if (LootSlotIsItem(this.slot)) then
			Lootster_Class_Display_OnClick(GetLootSlotLink(this.slot));
			return;
		end
	elseif	(IsShiftKeyDown() and (button == "LeftButton")) then
		-- snarf the hyperlink if this is a loot item
		if (LootSlotIsItem(this.slot)) then
			Lootster_SetHyperlink(GetLootSlotLink(this.slot), this.slot);
		end
	end

	-- and pass to base class
	Lootster_LootFrameItem_OnClickCB(button);
end

-- GroupLootFrame Show handler
function Lootster_GroupLootFrame_OnShow()
	local	lootFrame, classIcon, classFrame;
	local	restrictions;

	-- first, pass to the callback function
	Lootster_GroupLootFrame_OnShowCB();

	-- retrieve the echo loot frame
	lootFrame = getglobal("Lootster_EchoLootFrame"..this:GetID());

	-- are we to allow class restrictions to be echoed?
	if ((Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByGroupLoot == true)) then
		-- get the item details for the roll link
		_, _, _, _, restrictions = Lootster_GetItemDetails(GetLootRollItemLink(this.rollID));

		-- see if we have class restrictions
		if (table.getn(restrictions) > 0) then
			local	class, count, ix;
			local	classes = {};
			local	icon;

			-- build an alphabetical list of restricted classes
			for ix, flag in ipairs(LOOTSTER_CLASS_SORT) do
				-- this class restricted?
				if ((Lootster_ClassIgnore[LOOTSTER_CLASS_SORT[ix]] == nil) and (restrictions[LOOTSTER_CLASS_SORT[ix]] == true)) then
					table.insert(classes, LOOTSTER_CLASS_SORT[ix]);
				end
			end

			-- now show the respective class icons
			count = table.getn(classes);

			for ix=1, count, 1 do
				-- get this class icon
				classIcon = getglobal("Lootster_EchoLootFrame"..this:GetID().."ClassFrame"..ix.."Icon");

				-- hammer in the class texture
				classIcon:SetTexture("Interface\\AddOns\\Lootster\\Images\\Class-"..classes[ix]);

				-- get this class frame
				classFrame = getglobal("Lootster_EchoLootFrame"..this:GetID().."ClassFrame"..ix);

				-- update the class frame's class
				classFrame.Class = LOOTSTER_CLASS[classes[ix]].Plural;

				-- and show
				classFrame:Show();
			end

			-- now hide the remaining class icon slots
			for ix=(count + 1), (table.getn(LOOTSTER_CLASS) - 1), 1 do
				-- get this class frame
				classFrame = getglobal("Lootster_EchoLootFrame"..this:GetID().."ClassFrame"..ix);

				-- and hide
				classFrame:Hide();
			end

			-- and show the echo loot frame
			lootFrame:Show();
		else
			-- hide the echo loot frame
			lootFrame:Hide();
		end
	else
		-- hide the echo loot frame
		lootFrame:Hide();
	end
end

-- GroupLootFrame Event handler
function Lootster_GroupLootFrame_OnEvent()
	-- first, pass to the callback function
	Lootster_GroupLootFrame_OnEventCB();

	-- is this the cancel loot roll event?
	if (event == "CANCEL_LOOT_ROLL") then
		-- make sure this is the roll we are handling
		if (arg1 == this.rollID) then
			-- hide our echo loot frame
			getglobal("Lootster_EchoLootFrame"..this:GetID()):Hide()
		end
	end
end

-- ContainerFrameItemButton Click handler
function Lootster_ContainerFrameItemButton_OnClick(button, ignoreShift)
	-- see if they are echoing restrictions or linking a bag item
	if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and not ignoreShift and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
		-- display restrictions of the hyperlink
		Lootster_Class_Display_OnClick(GetContainerItemLink(this:GetParent():GetID(), this:GetID()));
		return;
	elseif	(IsShiftKeyDown() and (button == "LeftButton") and not ignoreShift) then
		-- snarf the hyperlink
		Lootster_SetHyperlink(GetContainerItemLink(this:GetParent():GetID(), this:GetID()));
	end

	-- and pass to base class
	Lootster_ContainerFrameItemButton_OnClickCB(button, ignoreShift);
end

-- AllInOneInventoryFrameItemButton Click handler
function Lootster_AllInOneInventoryFrameItemButton_OnClick(button, ignoreShift)
	local bag, slot;
	
	-- cross check we are called correctly by inspecting the AllInOneInventory functions
	if		(Lootster_AllInOneInventoryFrameItemButton_OnClickCB == nil) then
		-- huh?
		return;
	elseif	(AllInOneInventory_GetIdAsBagSlot ~= nil) then
		-- we have expect AllInOneInventory function.  Get the bag and slot
	 	bag, slot = AllInOneInventory_GetIdAsBagSlot(this:GetID());
	
		-- see if they are echoing restrictions or linking a bag item
		if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and not ignoreShift and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
			-- display restrictions of the hyperlink
			Lootster_Class_Display_OnClick(GetContainerItemLink(bag, slot));
			return;
		elseif	(IsShiftKeyDown() and (button == "LeftButton") and not ignoreShift) then
			-- snarf the hyperlink
			Lootster_SetHyperlink(GetContainerItemLink(bag, slot));
		end
	end

	-- and pass to base class
	Lootster_AllInOneInventoryFrameItemButton_OnClickCB(button, ignoreShift);
end

-- UI Toggle handler
function Lootster_Toggle()
	-- show/hide the MiniMap button and hide/show the title
	Lootster_MiniMapButton_SwitchState(false);

	-- handle toggling of the UI
	if (Lootster_Options.MiniMap == true) then
		-- MiniMap Operation
		if (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RaidFrame:IsVisible() or Lootster_ItemFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible()) then
			if (Lootster_Options.Sound) then
				PlaySound("igMiniMapClose");
			end

			-- hide
			Lootster_TabsFrame:Hide();
			Lootster_RollFrame:Hide();
			Lootster_DataFrame:Hide();
			Lootster_RaidFrame:Hide();
			Lootster_ItemFrame:Hide();
			Lootster_RuleFrame:Hide();
			Lootster_OptionsFrame:Hide();

			Lootster_ClassFrame:Hide();

			-- hide dialogs et al
			Lootster_ItemSyncFrame:Hide();
			Lootster_RaidSyncFrame:Hide();
			Lootster_RaidFrameRaidFrame:Hide();
			Lootster_RaidFrameBossFrame:Hide();
			Lootster_RaidFrameAttendFrame:Hide();
			Lootster_RaidFrameAdjustFrame:Hide();

			Lootster_RaidFrameReportFrame:Hide();

			-- are we in Normal 100/1000 mode using auto-clear on close?
			if ((Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) and (Lootster_Options.CorKClose == true)) then
				-- clear rolls
				Lootster_Roll_ClearRolls_OnClick();
			end
		else
			if (Lootster_Options.Sound) then
				PlaySound("igMiniMapOpen");
			end

			-- if we are class restricted, we show the class dialog
			if (Lootster_ClassRestricted == true) then
				Lootster_ClassFrame:Show();
			else
				-- reset class restrictions
				Lootster_ResetClass();

				-- update the class UI
				Lootster_UpdateClassUI();

				-- update the UI
				Lootster_UpdateRollUI();
			end

			-- show
			Lootster_OptionsFrame:Show();
			Lootster_RuleFrame:Show();
			Lootster_ItemFrame:Show();
			Lootster_RaidFrame:Show();
			Lootster_DataFrame:Show();
			Lootster_RollFrame:Show();
			Lootster_TabsFrame:Show();
			Lootster_Title:Show();
		end
	else
		-- normal operation
		if (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RaidFrame:IsVisible() or Lootster_ItemFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible()) then
			if (Lootster_Options.Sound) then
				PlaySound("igMiniMapClose");
			end

			-- hide
			Lootster_TabsFrame:Hide();
			Lootster_RollFrame:Hide();
			Lootster_DataFrame:Hide();
			Lootster_RaidFrame:Hide();
			Lootster_ItemFrame:Hide();
			Lootster_RuleFrame:Hide();
			Lootster_OptionsFrame:Hide();

			Lootster_ClassFrame:Hide();

			-- hide dialogs et al
			Lootster_ItemSyncFrame:Hide();
			Lootster_RaidSyncFrame:Hide();
			Lootster_RaidFrameRaidFrame:Hide();
			Lootster_RaidFrameBossFrame:Hide();
			Lootster_RaidFrameAttendFrame:Hide();
			Lootster_RaidFrameAdjustFrame:Hide();

			Lootster_RaidFrameReportFrame:Hide();

			-- are we in Normal 100/1000 mode using auto-clear on close?
			if ((Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) and (Lootster_Options.CorKClose == true)) then
				-- clear rolls
				Lootster_Roll_ClearRolls_OnClick();
			end
		else
			if (Lootster_Options.Sound) then
				PlaySound("igMiniMapOpen");
			end

			-- if we are class restricted, we show the class dialog
			if (Lootster_ClassRestricted == true) then
				Lootster_ClassFrame:Show();
			else
				-- reset class restrictions
				Lootster_ResetClass();

				-- update the class UI
				Lootster_UpdateClassUI();

				-- update the UI
				Lootster_UpdateRollUI();
			end

			-- show
			Lootster_OptionsFrame:Show();
			Lootster_RuleFrame:Show();
			Lootster_ItemFrame:Show();
			Lootster_RaidFrame:Show();
			Lootster_DataFrame:Show();
			Lootster_RollFrame:Show();
			Lootster_TabsFrame:Show();
		end
	end
end

-- UI Raid Toggle handler
function Lootster_Raid_Toggle(zone)
	local	raidRec, wowId, dateExp;
	
	-- if we are running raind and boss and we have running boss id we are done
	if ((Lootster_Running.BossId ~= nil) and (Lootster_Options.TrackBy ~= LOOTSTER_ENUM_AUTORAID.RAID)) then
		return;
	end
	
	-- wax on or wax off?
	if (Lootster_Running.RaidId == nil) then
		-- zone supplied?
		if (zone == nil) then
			-- get the zone name (dont care if not changed)
			_, zone = Lootster_HasRaidZoneChanged();
		end		

		-- hammer zone if we are forcing an unknown zone
		if (zone == "") then
			zone = nil;
		end

		-- no zone use default
		if (zone == nil) then
			zone = LOOTSTER_RAIDRAID_ZONEUNKNOWN
		end
	
		-- determine the WoW instance id and instance reset date
		wowId, dateExp = Lootster_GetInstanceId(zone);
	
		-- instantiate a new raid record
		raidRec = Lootster_NewRaid(zone, wowId, Lootster_CalcServerTime(time()), dateExp);

		-- see if we have a valid instance id and reset date
		if (wowId ~= nil) then
			if (dateExp ~= nil) then
				dateExp = Lootster_FormatServerTime(dateExp);
			else
				dateExp = LOOTSTER_RAIDRAID_NODATEEXP;
			end
		else
			-- reset
			wowId = LOOTSTER_RAIDRAID_NOWOWID;
			dateExp = LOOTSTER_RAIDRAID_NODATEEXP;
		end

		-- let players know a raid was created
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_RAIDCREATED, raidRec.Zone, wowId, Lootster_FormatServerTime(raidRec.DateOpn), LOOTSTER_RAIDRAID_NODATEEXP));
	
		-- create raid and make our running raid
		Lootster_Running.RaidId = Lootster_CreateRaid(raidRec);
	
		-- force toggle of boss to start a default
		Lootster_Boss_Toggle();
	else
		-- end of raid
		Lootster_Running.RaidId = nil;

		-- end of boss
		Lootster_Running.BossId = nil;
	end		

	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);
	
	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- UI Boss Toggle handler
function Lootster_Boss_Toggle(boss)
	local	change, mobkey, mobRec, tbd, bossRec, name;

	-- no running raid id we are done
	if (Lootster_Running.RaidId == nil) then
		return;
	end
	
	-- wax on or wax off?
	if (Lootster_Running.BossId == nil) then
		-- boss supplied?
		if (boss == nil) then
			-- get the boss name
			change, boss = Lootster_HasRaidBossChanged();
		end

		-- hammer boss if we are forcing an TDB boss
		if (boss == LOOTSTER_RAIDBOSS_TBD) then
			boss = nil;
		end

		-- not a real boss then we need to fake one
		if (boss == nil) then
			-- use To Be Determined boss initially
			boss = LOOTSTER_RAIDBOSS_TBD;

			-- use raid zone as the partial lookup
			name = string.lower(Lootster_Raid[Lootster_Running.RaidId].Zone);

			-- hammer through mob list looking for first one with the zone name in it
			for mobkey, mobsRec in pairs(Lootster_MobsDKP) do
				-- does this mob match the passed name
				if (string.find(mobsRec.Name, name) ~= nil) then
					-- right, you'll do!
					boss = mobsRec.Name;

					break;
				end
			end

			-- boss is TBD
			tbd = true;
		else
			-- we now the dude
			tbd = false;
		end

		-- instantiate a new boss record
		bossRec = Lootster_NewBoss(boss, Lootster_CalcServerTime(time()), tbd);

		-- let players know a boss was created
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_BOSSCREATED, bossRec.Boss, Lootster_FormatServerTime(bossRec.DateBeg), LOOTSTER_RAIDBOSS_NODATEEND));
	
		-- create boss and make our running boss
		Lootster_Running.BossId = Lootster_CreateBoss(bossRec);
	
		-- insert boss into the running
		Lootster_InsertBoss(Lootster_Running.RaidId, Lootster_Running.BossId);

		-- take full attendance now
		Lootster_TakeAttendance(Lootster_Running.BossId, LOOTSTER_ENUM_ATTENDED.FULL);
	else
		-- take partial attendance now
		Lootster_TakeAttendance(Lootster_Running.BossId, LOOTSTER_ENUM_ATTENDED.PARTIAL);

		-- end of boss - update end time first
		Lootster_Boss[Lootster_Running.BossId].DateEnd = Lootster_CalcServerTime(time());

		Lootster_Running.BossId = nil;
	end	

	-- resort raid data using current sort
	Lootster_Raid_Boss_Sort(nil);
	
	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Addon Load handler
function Lootster_ADDON_Load(addon)
	local	key, value;

	-- is this Lootster?
	if (addon ~= LOOTSTER_LABEL_LOOTSTER) then
		-- not me
		return;
	end

	-- initialise session
	for key, value in pairs(Lootster_Options_Default) do
		if (Lootster_Options[key] == nil) then
			Lootster_Options[key] = value
		end
	end

	for key, value in pairs(Lootster_Rules_Default) do
		if (Lootster_Rules[key] == nil) then
			Lootster_Rules[key] = value
		end
	end

	-- transfer old DKP used toggle to new selection style
	if (Lootster_Options.DKPUsed ~= nil) then
		-- update roll mode
		if (Lootster_Options.DKPUsed == true) then
			-- DKP mode
			Lootster_Options.RollMode = LOOTSTER_ENUM_ROLLMODE.USEDKP;
		else
			-- Normal mode
			Lootster_Options.RollMode = LOOTSTER_ENUM_ROLLMODE.USENORM;
		end

		-- set default DKP type (old style)
		Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYMODIFIED;

		-- set default Normal mode
		Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BYNEEDGREED;

		-- erase old DKP used toggle
		Lootster_Options.DKPUsed = nil;
	end

	-- transfer old rules to new rules if necessary
	if (Lootster_Rules.Rules ~= nil) then
		-- update DKP rules
		Lootster_Rules.RulesDKP = Lootster_Rules.Rules;

		-- update normal rules
		Lootster_Rules.RulesNorm = Lootster_Rules.Rules;

		-- erase old rules
		Lootster_Rules.Rules = nil;
	end

	-- transfer old 100 rules to new Norm rules as necessary (name change)
	if (Lootster_Rules.Rules100 ~= nil) then
		-- update normal rules
		Lootster_Rules.RulesNorm = Lootster_Rules.Rules100;

		-- erase old 100 rules
		Lootster_Rules.Rules100 = nil;
	end

	-- ensure loot rules have a trailing break
	Lootster_Rules.RulesDKP = Lootster_AppendTrailingLineBreak(Lootster_Rules.RulesDKP);
	Lootster_Rules.RulesNorm = Lootster_AppendTrailingLineBreak(Lootster_Rules.RulesNorm);

	-- Version 1800 -> 1900 update
	--
	-- Version 1900 causes the Suppress Rolls in Chat Log to work.  Modified initial load of Lootster
	-- to flip this flag OFF to reduce surprises
	if ((Lootster_Options.Updated1900 == nil) or (Lootster_Options.Updated1900 == false)) then
		-- flip suppression off
		Lootster_Options.Suppress = false;

		-- and mark as having done so
		Lootster_Options.Updated1900 = true;
	end

	-- has DKP check
	Lootster_HasDKP = (Lootster_DateDKP ~= nil) and (Lootster_MainDKP ~= nil) and (Lootster_AltsDKP ~= nil) or
					  (Lootster_ParkDKP ~= nil) and (Lootster_MobsDKP ~= nil) and (Lootster_ItemDKP ~= nil) or
					  (Lootster_TierDKP ~= nil);

	-- if DKP is disabled, make sure we correct current states
	if (not Lootster_HasDKP) then
		-- switch off DKP
		Lootster_Options.RollMode = LOOTSTER_ENUM_ROLLMODE.USENORM;

		-- spoof empty tables so we process as normal
		Lootster_DateDKP = "";
		Lootster_MainDKP = {};
		Lootster_AltsDKP = {};
		Lootster_ParkDKP = {};
		Lootster_MobsDKP = {};
		Lootster_ItemDKP = {};
		Lootster_TierDKP = {};
	else
		-- show DKP date widgets
		Lootster_OptionsFrameVersionFrameDKPDateLabel:Show();
		Lootster_OptionsFrameVersionFrameDKPDate:Show();

		-- enable roll mode widget
		Lootster_OptionsFrameRollModeButton:Enable();
	end
	
	-- do we have zone definitions?
	if (Lootster_ZoneDKP == nil) then
		-- no zones, which is fine
		Lootster_ZoneDKP = {};
	end

	-- disable the countdown button
	Lootster_RollFrameCountdown:Disable();

	-- initialise roll tab
	Lootster_RollFrameActive:SetChecked(Lootster_Options.Active);
	Lootster_RollFramePassive:SetChecked(Lootster_Options.Passive);

	-- disable/enable passive rolling checkbox
	if (Lootster_Options.Active == true) then
		Lootster_RollFramePassive:Disable();
	else
		Lootster_RollFramePassive:Enable();
	end

	-- initialise options tab
	Lootster_OptionsFrameMiniMapButton:SetChecked(Lootster_Options.MiniMap);

	Lootster_OptionsFrameMiniMapSlider:SetValue(Lootster_Options.MiniMapPos);
	Lootster_OptionsFrameMiniMapSliderText:SetText(Lootster_Options.MiniMapPos);

	Lootster_OptionsFrameVersionFrameVersion:SetText(LOOTSTER_VERSION);
	Lootster_OptionsFrameVersionFrameDKPDate:SetText(Lootster_DateDKP);

	Lootster_OptionsFrameSuppress:SetChecked(Lootster_Options.Suppress);

	Lootster_OptionsFrameAckRoll:SetChecked(Lootster_Options.AckRoll);

	Lootster_OptionsFrameAckNoCall:SetChecked(Lootster_Options.AckNoCall);

	Lootster_OptionsFrameAckNoRoll:SetChecked(Lootster_Options.AckNoRoll);

	Lootster_OptionsFrameAckNoHelp:SetChecked(Lootster_Options.AckNoHelp);

	Lootster_OptionsFrameCounter:SetChecked(Lootster_Options.Counter);

	Lootster_OptionsFrameSeconds:SetNumber(Lootster_Options.CounterSec);

	Lootster_OptionsFrameEchoRestrict:SetChecked(Lootster_Options.EchoRestrict);
	Lootster_OptionsFrameEchoToChat:SetChecked(Lootster_Options.EchoToChat);
	Lootster_OptionsFrameEchoToCTRA:SetChecked(Lootster_Options.EchoToCTRA);
	Lootster_OptionsFrameEchoByClick:SetChecked(Lootster_Options.EchoByClick);
	Lootster_OptionsFrameEchoByGroupLoot:SetChecked(Lootster_Options.EchoByGroupLoot);

	Lootster_OptionsFrameAutoSnoop:SetChecked(Lootster_Options.AutoSnoop);

	Lootster_OptionsFrameDebugMsgs:SetChecked(Lootster_Options.DebugMsgs);

	Lootster_OptionsFrameDKPPriority:SetChecked(Lootster_Options.DKPPrior);

	Lootster_OptionsFrameDKPCaps:SetChecked(Lootster_Options.DKPCaps);

	Lootster_OptionsFrameDKPHi:SetNumber(Lootster_Options.DKPHi);
	Lootster_OptionsFrameDKPLo:SetNumber(Lootster_Options.DKPLo);

	Lootster_OptionsFrameDKPHiRO:SetText(Lootster_Options.DKPHi);
	Lootster_OptionsFrameDKPLoRO:SetText(Lootster_Options.DKPLo);

	Lootster_OptionsFrameDKPFactoring:SetChecked(Lootster_Options.DKPFactoring);

	Lootster_OptionsFrameDKPFactor:SetNumber(Lootster_Options.DKPFactor);

	Lootster_OptionsFrameDKPFactorRO:SetText(Lootster_Options.DKPFactor);

	Lootster_OptionsFrameNormCorKRoll:SetChecked(Lootster_Options.CorKRoll);
	Lootster_OptionsFrameNormCorKOpen:SetChecked(Lootster_Options.CorKOpen);
	Lootster_OptionsFrameNormCorKClose:SetChecked(Lootster_Options.CorKClose);

	Lootster_OptionFrameRaidFrameTrackRaid:SetChecked(Lootster_Options.TrackBy == LOOTSTER_ENUM_AUTORAID.RAID);
	Lootster_OptionFrameRaidFrameTrackRaidNBoss:SetChecked(Lootster_Options.TrackBy == LOOTSTER_ENUM_AUTORAID.RAIDNBOSS);

	Lootster_OptionsFrameRaidIcon:SetChecked(Lootster_Options.RaidIcon);
	Lootster_OptionsFrameBossIcon:SetChecked(Lootster_Options.BossIcon);
	Lootster_OptionsFrameAutoRaid:SetChecked(Lootster_Options.AutoRaid);

	Lootster_OptionsFrameAutoDKPLoot:SetChecked(Lootster_Options.AutoDKPLoot);
	Lootster_OptionsFrameAutoNonDKPLoot:SetChecked(Lootster_Options.AutoNonDKPLoot);
	Lootster_OptionsFrameAutoLootRaid:SetChecked(Lootster_Options.AutoLootRaid);
	
	-- initialise raid report
	Lootster_RaidFrameReportFrameAttend:SetChecked(Lootster_Options.RepAttend);
	Lootster_RaidFrameReportFrameAttendDetail:SetChecked(Lootster_Options.RepAttendDetail);
	Lootster_RaidFrameReportFrameAdjust:SetChecked(Lootster_Options.RepAdjust);
	Lootster_RaidFrameReportFrameConsolidate:SetChecked(Lootster_Options.RepConsolidate);

	-- hide the UI
	Lootster_RollFrame:Hide();
	Lootster_DataFrame:Hide();
	Lootster_RaidFrame:Hide();
	Lootster_ItemFrame:Hide();
	Lootster_RuleFrame:Hide();
	Lootster_OptionsFrame:Hide();
	Lootster_TabsFrame:Hide();
	
	-- and show/hide the MiniMap button and hide/show the title
	Lootster_MiniMapButton_SwitchState(false);

	-- reflect the position
	Lootster_MiniMapButton_UpdatePosition();

	-- setup location of main frame
	Lootster_CheckLocation();

	-- update echo UI
	Lootster_CheckEchoUse();

	-- check tabs and update mode UI
	Lootster_CheckModeUse();

	-- check raid UI
	Lootster_CheckRaidUse();
end

-- Player Login handler
function Lootster_PLAYER_Login()
	local	faction, cix;
	local	button, icon;
	local	ix;
	local	key, classRec;

	-- bump event state
	Lootster_EventState = Lootster_EventState + 1;

	-- determine language and player class to jetison
	faction = UnitFactionGroup("player");

	if		(faction == "Alliance") then
		Lootster_Language = LOOTSTER_LANG_COMMON;

		Lootster_ClassIgnore = LOOTSTER_CLASS_HORDE;
	elseif  (faction == "Horde") then
		Lootster_Language = LOOTSTER_LANG_ORCISH;

		Lootster_ClassIgnore = LOOTSTER_CLASS_ALLIANCE;
	end

	-- initialise class frame
	for cix=1, table.getn(LOOTSTER_CLASS_SORT), 1 do
		-- get the class item button
		button = getglobal("Lootster_ClassFrameClass"..cix.."Text");

		-- hammer the text into this guy
		button:SetText(LOOTSTER_CLASS[LOOTSTER_CLASS_SORT[cix]].Singular);

		-- get button for the item class header
		button = getglobal("Lootster_ItemFrameClassHeader"..cix);

		-- set the class tooltip
		button.Class = LOOTSTER_CLASS[LOOTSTER_CLASS_SORT[cix]].Plural;

		-- get class icon for the item class header
		icon = getglobal("Lootster_ItemFrameClassHeader"..cix.."Icon");

		-- and set the class icon
		icon:SetTexture("Interface\\AddOns\\Lootster\\Images\\Class-"..LOOTSTER_CLASS_SORT[cix]);
	end

	-- get default language
 	Lootster_Language = GetDefaultLanguage("player");

	-- get player name and class
	Lootster_Self = UnitName("player");
	Lootster_SelfClass, Lootster_SelfClassType = UnitClass("player");

	-- generate loot colour/quality lookup
	for ix=LOOTSTER_ENUM_LOOTMODE.UNCOMMON, LOOTSTER_ENUM_LOOTMODE.LEGENDARY do
		-- add the colour to quality
		Lootster_LootQuality[ITEM_QUALITY_COLORS[ix].hex] = ix;
	end

	-- generate the class plural and singluar class name to invariant lookups
	for key, classRec in pairs(LOOTSTER_CLASS) do
		-- add the lower to invariant
		Lootster_ClassLower[string.lower(classRec.Singular)] = key;

		-- add the plural to invariant
		Lootster_ClassPlural[classRec.Plural] = key;

		-- add the singular to invariant
		Lootster_ClassSingular[classRec.Singular] = key;
	end

	-- gather chat frame whisper mask
	Lootster_ChatMaskWhisper = Lootster_LoadChatMask("WHISPER");
	
	-- determine server time zone
	Lootster_LoadTimeZone();

	-- load data
	Lootster_LoadData();

	-- hook chat frame event and hyperlink handler
	Lootster_ChatFrame_OnEventCB = ChatFrame_OnEvent;

	ChatFrame_OnEvent = Lootster_ChatFrame_OnEvent;

	Lootster_ChatFrame_OnHyperlinkShowCB = ChatFrame_OnHyperlinkShow;

	ChatFrame_OnHyperlinkShow = Lootster_ChatFrame_OnHyperlinkShow;

	Lootster_ChatFrame_AddMessageGroupCB = ChatFrame_AddMessageGroup;

	ChatFrame_AddMessageGroup = Lootster_ChatFrame_AddMessageGroup;

	Lootster_ChatFrame_RemoveMessageGroupCB = ChatFrame_RemoveMessageGroup;

	ChatFrame_RemoveMessageGroup = Lootster_ChatFrame_RemoveMessageGroup;

	Lootster_ChatFrame_RegisterForMessagesCB = ChatFrame_RegisterForMessages;

	ChatFrame_RegisterForMessages = Lootster_ChatFrame_RegisterForMessages;

	Lootster_ChatFrame_RemoveAllMessageGroupsCB = ChatFrame_RemoveAllMessageGroups;

	ChatFrame_RemoveAllMessageGroups = Lootster_ChatFrame_RemoveAllMessageGroups;

	-- hook loot frame item click handler
	Lootster_LootFrameItem_OnClickCB = LootFrameItem_OnClick;

	LootFrameItem_OnClick = Lootster_LootFrameItem_OnClick;

	-- hook group loot frame show and event handlers
	Lootster_GroupLootFrame_OnShowCB = GroupLootFrame_OnShow;

	GroupLootFrame_OnShow = Lootster_GroupLootFrame_OnShow;
	
	Lootster_GroupLootFrame_OnEventCB = GroupLootFrame_OnEvent;

	GroupLootFrame_OnEvent = Lootster_GroupLootFrame_OnEvent;

	-- hook container frame item button click handler
	Lootster_ContainerFrameItemButton_OnClickCB = ContainerFrameItemButton_OnClick;

	ContainerFrameItemButton_OnClick = Lootster_ContainerFrameItemButton_OnClick;

	-- hook All In One Inventory item button click handler
	Lootster_AllInOneInventoryFrameItemButton_OnClickCB = AllInOneInventoryFrameItemButton_OnClick;

	AllInOneInventoryFrameItemButton_OnClick = Lootster_AllInOneInventoryFrameItemButton_OnClick;
end

-- Player Logout handler
function Lootster_PLAYER_Logout()
	-- previous event state
	Lootster_EventState = Lootster_EventState - 1;
end

-- Player Enter World handler
function Lootster_PLAYER_Enter()
	local	change, zone;
	
	-- bump event state
	Lootster_EventState = Lootster_EventState + 1;

	-- force a roster update
	Lootster_PARTY_Roster();

	-- initially select the running raid and boss, if any
	Lootster_RaidId = Lootster_Running.RaidId;
	Lootster_BossId = Lootster_Running.BossId;
	
	-- see if instance information updated
	Lootster_CheckInstanceInfo();

	-- clear rolls to force UI update
	Lootster_Roll_ClearRolls_OnClick();

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);
	
	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);
	
	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);
	
	-- resort attend data using current sort
	Lootster_Raid_Attend_Sort(nil);
	
	-- resort adjust data using current sort
	Lootster_Raid_Adjust_Sort(nil);
	
	-- resort item data using current sort
	Lootster_Item_Sort(nil);

	-- initialise raid UI
	Lootster_UpdateRaidUI();

	-- no auto-tracking bail
	if (Lootster_Options.AutoRaid ~= true) then
		return;
	end
	
	-- get zone and whether it changed
	change, zone = Lootster_HasRaidZoneChanged();
	
	-- zone change?
	if (change == true) then
		-- we already got a raid running?
		if (Lootster_Running.RaidId ~= nil) then
			-- force raid toggle to close
			Lootster_Raid_Toggle();
		end

		-- force raid toggle to open
		Lootster_Raid_Toggle();
	end	
end

-- Player Leave World handler
function Lootster_PLAYER_Leave()
	-- previous event state
	Lootster_EventState = Lootster_EventState - 1;
end

-- Player Aggro handler
function Lootster_PLAYER_Regen(regen)
	local	change, boss;
	
	-- no auto-tracking or no running boss bail
	if ((Lootster_Options.AutoRaid ~= true) or (Lootster_Running.BossId == nil)) then
		return;
	end
	
	-- whats our aggro state?
	if (regen == true) then
		-- not in a boss fight anymore, if we ever were
		Lootster_InBossFight = false;
	else
		-- is this a real boss?
		change, boss = Lootster_HasRaidBossChanged();

		-- if this is the running boss, retake attendance
		if (boss == Lootster_Boss[Lootster_Running.BossId].Boss) then
			-- take attendance
			Lootster_TakeAttendance(Lootster_Running.BossId, LOOTSTER_ENUM_ATTENDED.PARTIAL);

			-- mark as having engaged in combat
			Lootster_Boss[Lootster_Running.BossId].Combat = true;

			-- we are now in a boss fight
			Lootster_InBossFight = true;
		end
	end
end

-- Player Target Change handler
function Lootster_PLAYER_Target(val)
	local	change, boss;

	-- ignore non-player targeting (generated by Chromaggus and Eye of C'Thun)
	if ((val ~= nil) and (val ~= "player")) then
		return;
	end

	-- no auto-tracking or no running raid bail
	if ((Lootster_Options.AutoRaid ~= true) or (Lootster_Running.RaidId == nil)) then
		return;
	end

	-- is this a real boss?
	change, boss = Lootster_HasRaidBossChanged();

	-- is this a real boss?
	if (change == true) then
		-- do we have a boss running?
		if		(Lootster_Running.BossId == nil) then
			-- nope, so start one
			Lootster_Boss_Toggle();
		elseif	(Lootster_Boss[Lootster_Running.BossId].TBD == true) then
			-- we have a TBD boss at the moment, so update the boss
			Lootster_Boss[Lootster_Running.BossId].Boss = boss;

			Lootster_Boss[Lootster_Running.BossId].TBD = false;

			-- resort raid data using current sort
			Lootster_Raid_Boss_Sort(nil);
		elseif	(Lootster_Options.TrackBy == LOOTSTER_ENUM_AUTORAID.RAIDNBOSS) then
			-- force boss toggle to stop old
			Lootster_Boss_Toggle();

			-- force boss toggle to start new
			Lootster_Boss_Toggle();
		end
	else
		-- no change - see if we have a boss and not killed
		if ((Lootster_Running.BossId ~= nil) and (boss ~= nil) and (Lootster_Boss[Lootster_Running.BossId].Killed == false)) then
			-- is boss now toast?
			if (UnitIsDead("target") ~= nil) then
				-- woot!  Take attendance marking any not here at start as partials
				Lootster_TakeAttendance(Lootster_Running.BossId, LOOTSTER_ENUM_ATTENDED.PARTIAL);

				-- update date end time
				Lootster_Boss[Lootster_Running.BossId].DateEnd = Lootster_CalcServerTime(time());

				-- and mark as toasted
				Lootster_Boss[Lootster_Running.BossId].Killed = true;

				-- resort boss data using current sort
				Lootster_Raid_Boss_Sort(nil);
			end
		end
	end

	-- update raid boss UI
	Lootster_RaidBossUpdateUI();
end

-- Party/Raid Leader handler
function Lootster_PARTY_Leader()
	local	unit, pcount, player, ix, rank, leaderIx;

	-- determine if we are party or raid
	if		(GetNumRaidMembers() > 0) then
		-- get new player count
		pcount = GetNumRaidMembers()

		-- are we the leader?
		if (IsRaidLeader() ~= nil) then
			-- we are the man!
			Lootster_LootMaster = Lootster_Self;
		else
			-- no leader yet
			Lootster_LootMaster = nil;
		end

		-- get the raid attendance
		for ix=1, pcount,1 do
			-- form the unit name
			unit = "raid"..ix;

			-- get the player name
			player = UnitName(unit);

			-- no player (no information there yet) or unknown, move on
			if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
				-- get rank
				_, rank = GetRaidRosterInfo(ix);

				-- is this the leader?
				if (rank == 2) then
					-- they are the man!
					Lootster_LootMaster = player;
				end
			end
		end
	elseif	(GetNumPartyMembers() > 0) then
		-- get new player count
		pcount = GetNumPartyMembers();

		-- are we the leader?
		if (IsPartyLeader() ~= nil) then
			-- we are the man!
			Lootster_LootMaster = Lootster_Self;

			leaderIx = 0;
		else
			-- no leader yet
			Lootster_LootMaster = nil;

			-- get leader party index
			leaderIx = GetPartyLeaderIndex();
		end

		-- get the raid attendance
		for ix=1, pcount, 1 do
			-- form the unit name
			unit = "party"..ix;

			-- get the player name
			player = UnitName(unit);

			-- no player (no information there yet) or unknown, move on
			if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
				-- is this the leader?
				if (ix == leaderIx) then
					-- they are the man!
					Lootster_LootMaster = player;
				end
			end
		end
	else
		-- we are the man!
		Lootster_LootMaster = Lootster_Self;
	end

	-- get the loot mode
	Lootster_LootMode = GetLootThreshold();

	-- get the loot method
	Lootster_LootMethod = LOOTSTER_ENUM_LOOTMETHOD[string.upper(GetLootMethod())];
end

-- Party/Raid Roster handler
function Lootster_PARTY_Roster()
	local	wasGrouped, unit, pcount, player, class, classType, name, main, ix, rank, leaderIx;

	local   adj, key, mcount;
	
	local	change, zone, boss;
	
	-- snarf whether player was previously grouped
	wasGrouped = Lootster_Grouped;

	-- reset attendance list
	Lootster_Roster = {};

	if		(GetNumRaidMembers() > 0) then
		-- get new player count
		pcount = GetNumRaidMembers()

		Lootster_PlayerCount = pcount;

		-- are we the leader?
		if (IsRaidLeader() ~= nil) then
			-- we are the man!
			Lootster_LootMaster = Lootster_Self;
		else
			-- no leader yet
			Lootster_LootMaster = nil;
		end

		-- get the raid attendance
		for ix=1, pcount,1 do
			-- form the unit name
			unit = "raid"..ix;

			-- get the player name
			player = UnitName(unit);

			-- no player (no information there yet) or unknown, move on
			if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
				-- get the player class
				class, classType = UnitClass(unit);

				-- force player name to lower case for later matching
				name = string.lower(player);

				-- and bookkeep
				Lootster_Roster[player] = Lootster_NewRoster(name, class, classType);

				-- get rank
				_, rank = GetRaidRosterInfo(ix);

				-- is this the leader?
				if (rank == 2) then
					-- they are the man!
					Lootster_LootMaster = player;
				end
			else
				-- adjust the player count
				Lootster_PlayerCount = Lootster_PlayerCount - 1;
			end
		end
	elseif	(GetNumPartyMembers() > 0) then
		-- get new player count
		pcount = GetNumPartyMembers();

		Lootster_PlayerCount = pcount;

		-- are we the leader?
		if (IsPartyLeader() ~= nil) then
			-- we are the man!
			Lootster_LootMaster = Lootster_Self;

			leaderIx = 0;
		else
			-- no leader yet
			Lootster_LootMaster = nil;

			-- get leader party index
			leaderIx = GetPartyLeaderIndex();
		end

		-- get the raid attendance
		for ix=1, pcount, 1 do
			-- form the unit name
			unit = "party"..ix;

			-- get the player name
			player = UnitName(unit);

			-- no player (no information there yet) or unknown, move on
			if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
				-- get the player class
				class, classType = UnitClass(unit);

				-- force player name to lower case for later matching
				name = string.lower(player);

				-- and bookkeep
				Lootster_Roster[player] = Lootster_NewRoster(name, class, classType);

				-- is this the leader?
				if (ix == leaderIx) then
					-- they are the man!
					Lootster_LootMaster = player;
				end
			else
				-- adjust the player count
				Lootster_PlayerCount = Lootster_PlayerCount - 1;
			end
		end

		-- add us
		Lootster_PlayerCount = Lootster_PlayerCount + 1;
	else
		-- we are the man!
		Lootster_LootMaster = Lootster_Self;

		-- just us
		Lootster_PlayerCount = 1;
	end
	
	-- let Blizzard tell us if we are really really grouped
	Lootster_Grouped = UnitInParty("player") or UnitInRaid("player");

	-- force ourselves to lower case for later matching
	name = string.lower(Lootster_Self);

	Lootster_Roster[Lootster_Self] = Lootster_NewRoster(name, Lootster_SelfClass, Lootster_SelfClassType);

	-- get the loot mode
	Lootster_LootMode = GetLootThreshold();

	-- get the loot method
	Lootster_LootMethod = LOOTSTER_ENUM_LOOTMETHOD[string.upper(GetLootMethod())];

	-- iterate through roll table looking for ex-parrots
	for key, value in pairs(Lootster_Rolls) do
		-- in the roster?
		if (Lootster_Roster[key] == nil) then
			-- if this guy actually rolled, adjust the roll count
			if (value.Roll ~= nil) then
				Lootster_RollCount = Lootster_RollCount - 1;
			end

			-- remove the record
			Lootster_Rolls[key] = nil;
		end
	end

	-- iterate through tied roll table looking for ex-parrots
	for key, value in pairs(Lootster_TiedRolls) do
		-- in the roster?
		if (Lootster_Roster[key] == nil) then
			-- if this guy actually rolled, adjust the roll count
			if (value.Roll ~= nil) then
				Lootster_TiedRollCount = Lootster_TiedRollCount - 1;
			end

			-- remove the record
			Lootster_TiedRolls[key] = nil;
		end
	end

	-- reset Alt/Main and Main/Alt Look-aside Tables
	Lootster_MainALT = {};
	Lootster_ALTMain = {};

	-- create the Alt/Main and Main/Alt Look-aside Table
	for player, rosRec in pairs(Lootster_Roster) do
		-- is this guy an alt?
		if (Lootster_AltsDKP[player] ~= nil) then
			-- add this guy to the Main to Alt look-aside table
			Lootster_MainALT[Lootster_AltsDKP[player].Name] = player;

			-- add this guy to the Alt to Main look-aside table
			Lootster_ALTMain[player] = Lootster_AltsDKP[player].Name;
		end
	end
	
	-- reset added main count
	mcount = 0;

	-- anybody not in main DKP table gets a default entry
	for player, rosRec in pairs(Lootster_Roster) do
		-- get the main name for this guy (could be alt)
		main = Lootster_GetALTMain(player);

		-- this guy in the DKP table?
		if		(Lootster_DKP[main] == nil) then
			-- stuff into DKP table.  Note there is no way to know the class if this is an alt
			if (main == player) then
				Lootster_DKP[main] = Lootster_NewDKP(main, rosRec.Class, 0, 0, rosRec.Trial, rosRec.App);
			else
				Lootster_DKP[main] = Lootster_NewDKP(main, "-", 0, 0, rosRec.Trial, rosRec.App);
			end

			-- create an total adjustment entry for this guy
			Lootster_CreateAdjust(Lootster_NewAdjust(main, player, Lootster_CalcServerTime(time()), nil, LOOTSTER_MSG_ADJUSTTOTAL, ""), main);

			-- bump player count
			mcount = mcount + 1;
		elseif ((main == player) and (Lootster_DKP[main].Class == "-")) then
			-- update the class since this is the main
			Lootster_DKP[main].Class = rosRec.Class;
		end
	end

	-- are we auto-tracking?
	if (Lootster_Options.AutoRaid == true) then
		-- have we changed party status?
		if (wasGroup ~= Lootster_Grouped) then
			-- are we opening a raid?
			if (Lootster_Grouped == true) then
				-- need to create a raid, so determine if zone changed
				change, zone = Lootster_HasRaidZoneChanged();

				if (change == true) then
					-- we already got a raid running?
					if (Lootster_Running.RaidId ~= nil) then
						-- force raid toggle to close
						Lootster_Raid_Toggle();
					end

					-- force raid toggle to open
					Lootster_Raid_Toggle();
				end	
			else
				-- we already got a raid running?
				if (Lootster_Running.RaidId ~= nil) then
					-- force raid toggle to close
					Lootster_Raid_Toggle();
				end
			end
		end
	end

	-- update restricted count
	Lootster_UpdateRestricted();

	-- resort rolls
	Lootster_Roll_Sort();

	-- update the screen
	Lootster_Roll_Update();

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);
	
	-- update received roll status
	Lootster_UpdateRollUI();
end

-- Loot Opened handler
function Lootster_LOOT_Opened()
end

-- Loot Closed handler
function Lootster_LOOT_Closed()
	-- clear item link if we are using the loot item
	if (Lootster_ItemSlot ~= nil) then
		-- reset the hyperlinks
		Lootster_SetHyperlink(nil);
	end
end

-- Loot Slot Cleared handler
function Lootster_LOOT_Slot_Cleared(slot)
	-- reset our item if this was the guy that was toasted
	if (slot == Lootster_ItemSlot) then
		Lootster_LOOT_Closed();
	end
end

-- Loot Message handler
function Lootster_MSG_Loot()
	local	player, link, multi, itemID, itemText, bindingType, quality, count, ix, dkp, reason, items, isML, adjustId;
	
	-- are we bookkeeping loot?
	if ((Lootster_Options.AutoDKPLoot == false) and (Lootster_Options.AutoNonDKPLoot == false)) then
		-- not bookkeeping
		return;
	end
	
	-- no boss and we are not auto-creating bosses?
	if ((Lootster_Running.BossId == nil) and (Lootster_Options.AutoLootRaid == false)) then
		-- not bookkeeping
		return;
	end

	-- attempt to parse loot message
	_, _, player, link, multi = string.find(arg1, LOOTSTER_LOOT_PLAYER_PATTERN);

	-- player loot?
	if ((player == nil) or (link == nil)) then
		-- nope, check us
		_, _, link, multi = string.find(arg1, LOOTSTER_LOOT_SELF_PATTERN);
		
		-- a link?
		if (link == nil) then
			-- no clue
			return;
		end
		
		-- we won something
		player = Lootster_Self;
	end
	
	-- retrieve the item id and text
	itemID, itemText, _, _, _, _, bindingType = Lootster_GetItemDetails(link);
	
	-- retrieve the quality of the item
	_, _, quality = GetItemInfo(itemID);
	
	-- are we tracking this quality level?
	if (quality < Lootster_Options.LootMode) then
		-- not good enough
		return;
	end

	-- initially a single item
	count = 1;

	-- if this is BoP item, handle multiples
	if (bindingType ~= LOOTSTER_ENUM_BIND.BoP) then
		-- if we have multiple items, determine count
		if (multi ~= nil) then
			_, _, count = string.find(multi, LOOTSTER_LOOT_MULTIITEM_PATTERN);
		end
		
		-- no count means we default to one
		if (count == nil) then
			-- just one item
			count = 1;
		end
	end

	-- determine what kind of loot this is (DKP or non-DKP)
	dkp, reason, items = Lootster_GetItemDKP(itemText);

	-- is this a DKP item and tracking non-DKP loot?
	if		((items == 0) and (Lootster_Options.AutoNonDKPLoot == false)) then
		-- don't bother with non-DKP loot
		return;
	elseif	((items ~= 0) and (Lootster_Options.AutoDKPLoot == false)) then
		-- don't bother with DKP loot
		return;
	end

	-- not master looted by default
	isML = false;

	-- are we master looting and this guy is the Master Looter?
	if ((Lootster_LootMethod == LOOTSTER_ENUM_LOOTMETHOD.MASTER) and (player == Lootster_LootMaster)) then
		-- if this item is not BoP and of Master Loot quality, mark as master looted
		if ((bindingType ~= LOOTSTER_ENUM_BIND.BoP) and (quality >= Lootster_LootMode)) then
			-- this is a Master Looted item
			isML = true;

			-- reset DKP since we don't want it affecting the Master Looter
			dkp = 0;
		end
	end
	
	-- do we have a running raid?
	if		(Lootster_Running.RaidId == nil) then
		-- nope, so create a raid
		Lootster_Raid_Toggle();
	elseif	(Lootster_Running.BossId == nil) then
		-- nope, so create a boss
		Lootster_Boss_Toggle();
	end
	
	-- create an adjustment for this loot under the main for each item
	for ix=1, count do
		-- create adjustment
		adjustId = Lootster_CreateAdjust(Lootster_NewAdjust(Lootster_GetALTMain(player), player, Lootster_CalcServerTime(time()), dkp, link, reason, ""));
		
		-- update alt with looted player name
		Lootster_Adjust[adjustId].Alt = player;

		-- set master looted as appropriate
		Lootster_Adjust[adjustId].ML = isML;

		-- add this adjustment to the running boss
		Lootster_InsertAdjust(Lootster_Running.BossId, adjustId);
	end

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);
	
	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);

	-- resort adjustment data using current sort
	Lootster_Raid_Adjust_Sort(nil);

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Party/Raid Message handler
function Lootster_MSG_PartyRaid()
	local	msg		= arg1;
	local	player	= arg2;

	-- argument breakdown is as follows:
	--
	-- message, sender, language, channel, arg5, arg6, arg7, channelNumber, channelName, loops, frame = arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, loops, frame

	-- if we are here, it was not a pass/reclaim during a roll call.  Check for auto-snoop processing
	if (Lootster_Options.AutoSnoop == true) then
		local	rollMode, modeType, modeDetail, modePrior, modeCaps, modeCall, capsCapHi, capsCapLo;

		local	restrictsCap, NBGCap, specifyCap, itemCap, linkCap, usingCap, dkpCap, dkpCapVal, itemCount, restrictCap1, restrictCap2, restrictCapP, restrictCapPU, restrictCapL;

		local	restricts = {};

		local	class, tied, hashcount, hashlist;

		local	isRollMode = false;
		local	isRollCall = false;

		-- process to see if its another Lootster switching modes
		_, _, modeType, modeDetail = string.find(msg, LOOTSTER_MODE_MODE_PATTERN);

		-- process to see if its another Lootster calling for a roll
		_,_, restrictsCap, NBGCap, specifyCap = string.find(msg, LOOTSTER_NBG_ALL_PATTERN);

		-- check various message combinations
		if		((player ~= Lootster_Self) and (modeType ~= nil) and (modeDetail ~= nil)) then
			-- okay, we may have a roll mode.  Tease it apart
			if		((modeType == LOOTSTER_MODE_1001000_PATTERN) or (modeType == LOOTSTER_MODE_NEEDGREED_PATTERN)) then
				-- extract normal details 
				_,_, modeCall = string.find(modeDetail, LOOTSTER_MODE_NORMMODE_PATTERN);

				-- a normal mode.  Process roll call
				if ((modeCall == LOOTSTER_MSG_REQUIRED) or (modeCall == LOOTSTER_MSG_OPTIONAL)) then
					-- optional roll call is allowed only for 100/1000 mode
					if ((modeType == LOOTSTER_MODE_NEEDGREED_PATTERN) and (modeCall == LOOTSTER_MSG_OPTIONAL)) then
						-- spoofed roll call change
						return;
					end
				else
					-- spoofed roll call change
					return;
				end

				-- mode is Normal
				rollMode = LOOTSTER_ENUM_ROLLMODE.USENORM;

				-- at this point, we can safely say its a roll mode
				isRollMode = true;
			elseif	((modeType == LOOTSTER_MODE_DKP_PATTERN) or (modeType == LOOTSTER_MODE_TIER_PATTERN) or (modeType == LOOTSTER_MODE_MODIFIED_PATTERN)) then
				-- must have DKP handling enabled
				if (Lootster_HasDKP == false) then
					-- we cannot handle this mode
					return;
				end

				-- extract DKP details 
				_,_, modePrior, modeCaps = string.find(modeDetail, LOOTSTER_MODE_DKPMODE_PATTERN);

				-- a DKP mode.  Process priority
				if ((modePrior == LOOTSTER_MODE_PRIORNONE_PATTERN) or (modePrior == LOOTSTER_MODE_PRIORUSED_PATTERN)) then
					-- process caps				
					if (modeCaps ~= LOOTSTER_MODE_CAPSNONE_PATTERN) then
						-- retrieve the caps
						_, _, capsCapHi, capsCapLo = string.find(modeCaps, LOOTSTER_MODE_CAPSUSED_PATTERN);

						if (capsCapLo == nil) then
							-- spoofed caps change
							return;
						end

						-- convert the text
						capsCapHi = tonumber(capsCapHi);
						capsCapLo = tonumber(capsCapLo);
					end
				else
					-- spoofed priority change
					return;
				end

				-- mode is Normal
				rollMode = LOOTSTER_ENUM_ROLLMODE.USEDKP;

				-- at this point, we can safely say its a roll mode
				isRollMode = true;
			else
				-- spoofed mode change
				return;
			end
		elseif	((player ~= Lootster_Self) and ((NBGCap == LOOTSTER_NBG_NEED) or (NBGCap == LOOTSTER_NBG_GREED) or (NBGCap == LOOTSTER_NBG_1001000) or (NBGCap == LOOTSTER_NBG_TIED))) then
			-- plead spoof prevention
			if ((NBGCap == LOOTSTER_NBG_GREED) and (restrictsCap ~= LOOTSTER_MSG_PLEASE)) then
				-- spoofed greed call - ignore
				return;
			end

			-- make sure current roll mode and roll type is consistent
			if		(NBGCap == LOOTSTER_NBG_1001000) then
				-- must be in Normal 100/1000 mode
				if ((Lootster_Options.RollMode ~= LOOTSTER_ENUM_ROLLMODE.USENORM) or (Lootster_Options.NormType ~= LOOTSTER_ENUM_NORM.BY1001000)) then
					-- spoofed mode call
					return;
				end
			elseif	((NBGCap == LOOTSTER_NBG_NEED) or (NBGCap == LOOTSTER_NBG_GREED)) then
				-- cannot be in Normal 100/1000
				if ((Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000)) then
					-- spoofed mode call
					return;
				end
			end

			-- if this is not a straight plead, tease apart the restrictions
			if	(restrictsCap ~= LOOTSTER_MSG_PLEASE) then
				-- we have restrictions, depending on the type of call.  Either way, its in the same form.

				-- first, we must check for multi-restrictions first
				_, _, restrictCapP, restrictCapPU, restrictCapL = string.find(restrictsCap, LOOTSTER_NBG_RESTRICTN_PATTERN);

				if (restrictCapL == nil) then
					-- not a multi-restriction, we must check for two restrictions next
					_, _, restrictCap1, restrictCap2 = string.find(restrictsCap, LOOTSTER_NBG_RESTRICT2_PATTERN);

					if (restrictCap2 == nil) then
						-- not two restrictions, so check for a single restriction
						_, _, restrictCap1 = string.find(restrictsCap, LOOTSTER_NBG_RESTRICT1_PATTERN);
					end

					-- add restrictions as necessary
					if (restrictCap1 ~= nil) then
						-- only the one restriction
						if (Lootster_AddRestriction(NBGCap, restricts, restrictCap1) == true) then
							-- class/player spoof check - duplicate
							return;
						end
					end

					if (restrictCap2 ~= nil) then
						-- only the two restrictions
						if (Lootster_AddRestriction(NBGCap, restricts, restrictCap2) == true) then
							-- class/player spoof check - duplicate
							return;
						end
					end
				else
					-- we need to process each restriction
					for restrictCap1 in string.gfind(restrictCapP, LOOTSTER_NBG_RESTRICT1_PATTERN) do
						-- how we add this to the table depends on the NBG type
						if (Lootster_AddRestriction(NBGCap, restricts, restrictCap1) == true) then
							-- class/player spoof check - duplicate
							return;
						end
					end

					-- add penultimate and last restrictions
					if ((Lootster_AddRestriction(NBGCap, restricts, restrictCapPU) == true) or 
						(Lootster_AddRestriction(NBGCap, restricts, restrictCapL) == true)) then
						-- class/player spoof check - duplicate
						return;
					end
				end
			end

			-- class and playa spoof prevention
			if		((NBGCap == LOOTSTER_NBG_NEED) or (NBGCap == LOOTSTER_NBG_1001000)) then
				-- setup hashcount
				hashcount = table.getn(restricts);

				-- okay, validate the restricted classes
				for key, classRec in pairs(LOOTSTER_CLASS) do
					-- is he in restrictions?
					if (restricts[key] ~= nil) then
						-- class allowed
						hashcount = hashcount - 1;
					end
				end

				-- class spoofed if hashcount is not zero
				if (hashcount ~= 0) then
					return;
				end
			elseif	(NBGCap == LOOTSTER_NBG_TIED) then
				-- must be two or more players for a tied roll
				if (table.getn(restricts) <= 1) then
					-- TIED roll call spoof
					return;
				end

				-- setup hashlist
				hashlist = {};

				-- make sure players are valid
				for ix, tied in ipairs(restricts) do
					-- player must be in roster
					if (Lootster_Roster[tied] == nil) then
						-- player spoofed if not in roster
						return;
					end

					-- player cannot be duplicated
					if (hashlist[tied] ~= nil) then
						-- player spoofed if duplicate
						return;
					end

					-- add to hashlist
					hashlist[tied] = true;
				end
			end

			-- if we have a link, tease it apart
			if (specifyCap ~= "") then
				-- check for specfied item
				_,_, itemCap = string.find(specifyCap, LOOTSTER_NBG_ON_PATTERN);

				-- do we have an item?
				if (itemCap ~= nil) then
					-- okay, see if its generic
					_, _, itemCount, usingCap = string.find(itemCap, LOOTSTER_NBG_ITEMS_PATTERN);

					if		(itemCount == nil) then
						-- see if its a single real link
						_, _, linkCap, usingCap = string.find(itemCap, LOOTSTER_NBG_LINK1_PATTERN);

						-- if not a single link, check for multiple items
						if (linkCap == nil) then
							-- see if its multiple real link
							_, _, itemCount, linkCap, usingCap = string.find(itemCap, LOOTSTER_NBG_LINKN_PATTERN);
						end

						-- is the link capture nil?
						if (linkCap == nil) then
							-- it better be a TIED roll call, since if there is no link there must be a using clause
							if		(NBGCap ~= LOOTSTER_NBG_TIED) then
								-- link spoof prevention
								return;
							elseif	(specifyCap ~= LOOTSTER_NBG_USING_PATTERN) then
								-- TIED roll call spoof prevention
								return;
							end
						else
							-- link is valid, but make sure of a tied roll
							if ((NBGCap == LOOTSTER_NBG_TIED) and (usingCap ~= LOOTSTER_NBG_USING_PATTERN)) then
								-- TIED roll call spoof prevention
								return;
							else
								-- see if we have a DKP costing - only in DKP mode of course
								if ((Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) and (usingCap == "")) then
									-- spoofed roll call in DKP mode
									return;
								end

								-- see if we have a real DKP costing
								_, _, dkpCap = string.find(usingCap, LOOTSTER_NBG_COSTING_PATTERN);

								if ((dkpCap ~= nil) and (dkpCap ~= LOOTSTER_COST_DKPTBD) and (dkpCap ~= LOOTSTER_COST_DKP0TBD)) then
									-- we must have a real DKP value
									_, _, dkpCapVal = string.find(dkpCap, LOOTSTER_NBG_COSTINGDKP_PATTERN);

									if (dkpCapVal == nil) then
										-- DKP costing spoof prevention
										return;
									end
								end
							end
						end
					elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
						-- cannot have an item count in DKP mode
						return;
					end
				end

				-- cannot have zero or negative item counts
				if		(itemCount == nil) then
					-- no item count
					itemCount = 1;
				elseif	(tonumber(itemCount) > 0) then
					-- convert to number
					itemCount = tonumber(itemCount);
				else
					-- spoofed roll call
					return;
				end
			else
				-- is this a TIED roll?
				if (NBGCap == LOOTSTER_NBG_TIED) then
					-- TIED roll call spoof prevention
					return;
				end

				-- certainly no link
				linkCap = nil;

				-- default item count is 1
				itemCount = 1;
			end 

			-- at this point, we can safely say its a roll call
			isRollCall = true;
		end

		-- if we are active and this is a roll mode or roll call, make sure we are deactivated
		if ((Lootster_Options.Active == true) and ((isRollMode == true) or (isRollCall == true))) then
			-- toggle off
			Lootster_RollFrameActive:SetChecked(false);

			-- and snarf
			Lootster_Roll_ActiveButton_Toggle();
		end

		-- process the auto-snoop
		if		(isRollMode == true) then
			-- clear rolls
			Lootster_Roll_ClearRolls_OnClick();

			-- update the UI
			Lootster_UpdateRollUI();

			-- set roll mode as required
			Lootster_Options.RollMode = rollMode;

			-- set roll mode
			Lootster_Option_RollMode_OnShow();

			-- determine new roll mode
			if		(rollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
				-- set requisite DKP mode
				if		(modeType == LOOTSTER_MODE_DKP_PATTERN) then
					-- set DKP mode
					Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYDKP;
				elseif	(modeType == LOOTSTER_MODE_TIER_PATTERN) then
					-- set Tier mode
					Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYTIER;
				elseif	(modeType == LOOTSTER_MODE_MODIFIED_PATTERN) then
					-- set DKP Modified mode
					Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYMODIFIED;
				else
					-- default to Tier mode
					Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYTIER;
				end

				-- set DKP type
				Lootster_Option_RollType_OnShow();

				-- set DKP priority toggle according to priority in effect
				Lootster_Options.DKPPrior = modePrior ~= LOOTSTER_MODE_PRIORNONE_PATTERN;

				Lootster_OptionsFrameDKPPriority:SetChecked(Lootster_Options.DKPPrior);

				-- set DKP capped toggle according to caps in effect
				Lootster_Options.DKPCaps = modeCaps ~= LOOTSTER_MODE_CAPSNONE_PATTERN;

				Lootster_OptionsFrameDKPCaps:SetChecked(Lootster_Options.DKPCaps);

				-- if caps are in effect, set those as well
				if (modeCaps ~= LOOTSTER_MODE_CAPSNONE_PATTERN) then
					-- update DKP hi and lo caps
					Lootster_OptionsFrameDKPHi:SetNumber(capsCapHi); 
					Lootster_OptionsFrameDKPLo:SetNumber(capsCapLo);

					-- cause snarf of set DKP caps
					Lootster_Option_DKPHi_Entered();
					Lootster_Option_DKPLo_Entered();
				end
			elseif	(rollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
				-- set requisite Normal mode
				if		(modeType == LOOTSTER_MODE_1001000_PATTERN) then
					-- set 100/1000 mode
					Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BY1001000;
				elseif	(modeType == LOOTSTER_MODE_NEEDGREED_PATTERN) then
					-- set Need then Greed mode
					Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BYNEEDGREED;
				else
					-- default to Need then Greed mode
					Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BYNEEDGREED;
				end

				-- set DKP type
				Lootster_Option_RollType_OnShow();

				-- set 100/1000 roll call toggle according to roll call in effect
				Lootster_Options.CorKRoll = modeCall ~= LOOTSTER_MSG_REQUIRED;

				Lootster_OptionsFrameNormCorKRoll:SetChecked(Lootster_Options.CorKRoll);
			end

			-- update roll handling
			Lootster_UpdateRollHandling();

			-- snooped roll mode - done
			return;
		elseif	(isRollCall == true) then	
			-- clear rolls
			Lootster_Roll_ClearRolls_OnClick();

			-- set the number of items being rolled on
			Lootster_RollFrameItems:SetNumber(itemCount);

			-- and spoof entry to transfer and update
			Lootster_Roll_Items_Entered();

			-- set the hyperlink as appropriate
			Lootster_SetHyperlink(linkCap);

			-- is this NEED or 100/1000?
			if		((NBGCap == LOOTSTER_NBG_NEED) or (NBGCap == LOOTSTER_NBG_1001000)) then
				-- see if an item was passed and it was not class restricted
				if ((Lootster_ClassRestrictedLock == false) and (table.getn(restricts) > 0)) then
					-- dude is class restricted by roll caller
					Lootster_ClassRestricted = true;

					-- no classes
					Lootster_ClassRestrictions = {};

					-- reset the current restriction mask
					Lootster_ClassRestrictionsMaskCurr = 0;

					-- reset count
					table.setn(Lootster_ClassRestrictions, 0);

					-- all these guys are plural, so reverse lookup
					for key, classRec in pairs(LOOTSTER_CLASS) do
						-- is he in restrictions?
						if (restricts[key] ~= nil) then
							-- set class restricted
							Lootster_ClassRestrictions[key] = true;

							-- add to current mask.  Since the original mask is unchanged, we can detect if
							-- these class restrictions differ from that previously saved
							Lootster_ClassRestrictionsMaskCurr = bit.bor(Lootster_ClassRestrictionsMaskCurr, classRec.Mask);

							-- bump count
							table.setn(Lootster_ClassRestrictions, table.getn(Lootster_ClassRestrictions) + 1);
						end
					end

					-- update the class frame
					Lootster_UpdateClassUI();

					-- update restricted count
					Lootster_UpdateRestricted();

					-- show the class frame if we are visible
					if (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RaidFrame:IsVisible() or Lootster_ItemFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible()) then
						Lootster_ClassFrame:Show();
					end
				end

				-- what kind of roll?
				if		(NBGCap == LOOTSTER_NBG_NEED) then
					-- force Need roll
					Lootster_Roll_NeedRoll_OnClick();
				elseif	(NBGCap == LOOTSTER_NBG_1001000) then
					-- force 100/1000 roll
					Lootster_Roll_1001000Roll_OnClick();
				end
			elseif	(NBGCap == LOOTSTER_NBG_GREED) then
				-- force Greed roll
				Lootster_Roll_GreedRoll_OnClick();
			elseif	(NBGCap == LOOTSTER_NBG_TIED) then
				-- calculate the positions
				Lootster_CalculatePositions();

				-- okay, add the tied players, if any
				for ix, tied in ipairs(restricts) do
					-- player allowed to roll
					Lootster_AddPlayer(tied);
				end

				-- resort the rolls
				Lootster_Roll_Sort();

				-- update received roll status
				Lootster_UpdateRollUI();	

				-- update the screen
				Lootster_Roll_Update();

				-- force Tied roll
				Lootster_Roll_TiedRoll_OnClick();
			end

			-- snooped roll call - done
			return;
		end
	end

	-- see if it was a pass/reclaim
	if		(string.lower(msg) == LOOTSTER_CMD_PASS) then
		-- let the player pass their roll
		Lootster_PassRoll(player);

		-- processed
		return;
	elseif	(string.lower(msg) == LOOTSTER_CMD_RECLAIM) then
		-- let the player reclaim their roll
		Lootster_ReclaimRoll(player);

		-- processed
		return;
	end
end

-- Hostile Death Message handler
function Lootster_MSG_Death()
	local	boss;
	
	-- no auto-tracking or no running raid bail
	if ((Lootster_Options.AutoRaid ~= true) or (Lootster_Running.RaidId == nil)) then
		return;
	end

	-- extract the name of the mob
	_, _, boss = string.find(arg1, LOOTSTER_MOBDEATH_PATTERN);
	
	-- if we have a boss test for toasted
	if ((Lootster_Running.BossId ~= nil) and (Lootster_Boss[Lootster_Running.BossId].Killed == false) and (Lootster_Boss[Lootster_Running.BossId].Boss == boss)) then
		-- woot!  Take attendance marking any not here at start as partials
		Lootster_TakeAttendance(Lootster_Running.BossId, LOOTSTER_ENUM_ATTENDED.PARTIAL);

		-- update date end time
		Lootster_Boss[Lootster_Running.BossId].DateEnd = Lootster_CalcServerTime(time());

		-- and mark as toasted
		Lootster_Boss[Lootster_Running.BossId].Killed = true;

		-- resort boss data using current sort
		Lootster_Raid_Boss_Sort(nil);
	end
end

-- System Message handler
function Lootster_MSG_System()
	local player, roll, min_roll, max_roll;

	-- attempt to decode /random roll
	_, _, player, roll, minRoll, maxRoll = string.find(arg1, LOOTSTER_ROLL_PATTERN)

	-- if we have a player we have a playa
	if (player ~= nil) then
		Lootster_ProcessRoll(player, roll, minRoll, maxRoll)
	end
end

-- Whisper Message handler
function Lootster_MSG_Whisper()
	local	player	= arg2;
	local	msg		= arg1;

	-- pass to our inquiry handler
	Lootster_PlayerInquiry(player, msg);
end

-- System Chat handler
function Lootster_CHAT_System(event)
	local	player	= arg2;
	local	msg		= arg1;

	-- snarf /randoms
	if (msg == nil) or (not Lootster_Options.Suppress) or (not string.find(msg, LOOTSTER_ROLL_PATTERN)) then
		-- not a suppressed roll, so pass to callback
		Lootster_ChatFrame_OnEventCB(event)
	end
end

-- Whisper Chat Message handler
function Lootster_CHAT_Whisper(event)
	local	player	= arg2;
	local	msg		= arg1;

	-- don't echo whisper if a foreign player inquiry (don't execute!) or debug is on
	if ((msg == nil) or (player == Lootster_Self) or (Lootster_PlayerInquiry(player, msg, true) == false) or (Lootster_Options.DebugMsgs == true)) then
		-- unless debugging, suppress internal Lootster messages
		if ((Lootster_Options.DebugMsgs == true) or (string.find(msg, LOOTSTER_SYNC_IMP_PREFIX) == nil)) then  
			-- punt this out
			Lootster_ChatFrame_OnEventCB(event);
		end
	end
end

-- Whisper Inform Chat Message handler
function Lootster_CHAT_Whisper_Inform(event)
	local	player	= arg2;
	local	msg		= arg1;
	local	mask;

	-- no message, echoing debug messages or nothing in the from whisper from queue for this guy? 
	if ((msg == nil) or (Lootster_Options.DebugMsgs == true) or (Lootster_FromWhisperQue == nil) or (Lootster_FromWhisperQue[player] == nil) or (Lootster_FromWhisperQue[player][1].Msg ~= msg)) then
		-- unless debugging, suppress internal Lootster messages
		if ((Lootster_Options.DebugMsgs == true) or (string.find(msg, LOOTSTER_SYNC_IMP_PREFIX) == nil)) then  
			-- punt this out
			Lootster_ChatFrame_OnEventCB(event);
		end
	else
		-- calculate chat frame mask
		mask = bit.bor(Lootster_FromWhisperQue[player][1].Mask, bit.lshift(1, this:GetID()));

		-- is this guy been reported by all whisper chat frames?
		if (mask == Lootster_ChatMaskWhisper) then
			-- remove this message
			table.remove(Lootster_FromWhisperQue[player], 1);

			-- if we have no more from whispers, smoke the player queue
			if (table.getn(Lootster_FromWhisperQue[player]) == 0) then	
				-- smoke the player's queue entry
				Lootster_FromWhisperQue[player] = nil
			end
		else
			-- update the message's whisper chat mask
			Lootster_FromWhisperQue[player][1].Mask = mask;
		end
	end
end

-- Zone Change handler
function Lootster_ZONE_Changed()
	local	change, zone;
	
	-- determine zone
	change, zone = Lootster_HasRaidZoneChanged();

	-- has zone changed?
	if (change == true) then
		-- yes, so see if we are auto-tracking raids
		if (Lootster_Options.AutoTrack == true) then
			-- have we are running boss?
			if (Lootster_Running.BossId ~= nil) then
				-- toggle off boss
				Lootster_Boss_Toggle();
			end
	
			-- have we are running raid?
			if (Lootster_Running.RaidId ~= nil) then
				-- toggle off raid
				Lootster_Raid_Toggle();
			end

			-- toggle a new raid
			Lootster_Raid_Toggle();
		end
	end
end

-- Update Instance Information handler
function Lootster_UPDATE_Instance()
	-- update the running raid, if any
	if (Lootster_CheckInstanceInfo() == true) then
		-- resort raid data using current sort
		Lootster_Raid_Raid_Sort(nil);
	end
end

-- Check Location handler
function Lootster_CheckLocation()
	local width			= Lootster_RollFrame:GetWidth();
	local width2		= width / 2;
	local height		= Lootster_RollFrame:GetHeight();

	local tabwidth		= Lootster_TabsFrame:GetWidth();
	local tabheight		= Lootster_TabsFrame:GetHeight();

	Lootster_RollFrame:ClearAllPoints();
	Lootster_RollFrame:SetPoint("TOPLEFT", "Lootster_Title", "BOTTOM", -width2, 0);
	Lootster_RollFrame:SetPoint("TOPRIGHT", "Lootster_Title", "BOTTOM", width2, 0);

	Lootster_TabsFrame:ClearAllPoints();
	Lootster_TabsFrame:SetPoint("TOPLEFT", "Lootster_RollFrame", "BOTTOMLEFT", 0, 7);
	Lootster_TabsFrame:SetPoint("TOPRIGHT", "Lootster_RollFrame", "BOTTOMLEFT", tabwidth, 7-tabheight);

	Lootster_ClassFrame:ClearAllPoints();
	Lootster_ClassFrame:SetPoint("TOPLEFT", "Lootster_RollFrame", "TOPRIGHT", -7, 0);
end

-- Check Echo Use handler
function Lootster_CheckEchoUse()
	-- are we allowing click display of class restrictions?
	if (Lootster_Options.EchoRestrict == false) then
		-- disable echo To check boxes
		Lootster_OptionsFrameEchoToChat:Disable();
		Lootster_OptionsFrameEchoToCTRA:Disable();

		-- disable echo By check boxes
		Lootster_OptionsFrameEchoByClick:Disable();
		Lootster_OptionsFrameEchoByGroupLoot:Disable();
	else
		-- enable echo To check boxes
		Lootster_OptionsFrameEchoToChat:Enable();
		Lootster_OptionsFrameEchoToCTRA:Enable();

		-- enable echo By check boxes
		Lootster_OptionsFrameEchoByClick:Enable();
		Lootster_OptionsFrameEchoByGroupLoot:Enable();
	end
end		

-- Check Mode Use handler
function Lootster_CheckModeUse()
	-- show the mode widgets as required
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- show the data tab
		Lootster_DataTab:Show();

		-- show anchors to force repaint
		Lootster_Anchor1Tab:Show();
		Lootster_Anchor2Tab:Show();

		-- move raid tab relative to item tab
		Lootster_RaidTab:ClearAllPoints();
		Lootster_RaidTab:SetPoint("TOPLEFT", "Lootster_Anchor2Tab", "TOPLEFT", 0, 0);
		Lootster_RaidTab:SetPoint("BOTTOMRIGHT", "Lootster_Anchor2Tab", "BOTTOMRIGHT", 0, 0);

		-- and rehide anchors
		Lootster_Anchor2Tab:Hide();
		Lootster_Anchor1Tab:Hide();

		-- update 100/1000 UI
		Lootster_CheckCorKUse();

		-- show DKP and Tier heading for roll tab
		Lootster_RollFrameColumnHeader4:SetText(LOOTSTER_ROLL_DKP);
		Lootster_RollFrameColumnHeader5:SetText(LOOTSTER_ROLL_TIER);

		-- show DKP heading for raid, boss, attend and adjust tabs
		Lootster_RaidFrameRaidFrameColumnHeader7:SetText(LOOTSTER_RAID_DKP);
		Lootster_RaidFrameBossFrameColumnHeader7:SetText(LOOTSTER_RAID_DKP);
		Lootster_RaidFrameBossAttendFrameColumnHeader5:SetText(LOOTSTER_RAID_DKP);
		Lootster_RaidFrameBossAdjustFrameColumnHeader3:SetText(LOOTSTER_RAID_DKP);

		-- update rule table show rules label
		Lootster_RuleFrameRulesFrameLabel:SetText(string.format(LOOTSTER_RULE_RULE, LOOTSTER_OPTION_ROLLMODELIST[Lootster_Options.RollMode]));

		-- update rules tab with DKP rules
		Lootster_RuleFrameRulesFrameText:SetText(Lootster_Rules.RulesDKP);

		-- setup the roll type for using DKP
		Lootster_Option_RollType_OnShow();

		-- show the DKP mode option frame
		Lootster_OptionsFrameRollManageDKPFrame:Show();

		-- are we using modified DKP rolling?
		if (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
			-- show DKP factoring frame
			Lootster_OptionsFrameDKPFactorFrame:Show();
		else
			-- hide DKP factoring frame
			Lootster_OptionsFrameDKPFactorFrame:Hide();
		end

		-- hide the Normal 100/1000 mode option frame
		Lootster_OptionsFrameRollManageCorKFrame:Hide();

		-- show adjustment DKP edit box
		Lootster_RaidFrameAdjustFrameDKP:Show();
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
		-- hide the data tab
		Lootster_DataTab:Hide();

		-- show anchors to force repaint
		Lootster_Anchor1Tab:Show();
		Lootster_Anchor2Tab:Show();

		-- move item tab relative to data tab
		Lootster_RaidTab:ClearAllPoints();
		Lootster_RaidTab:SetPoint("TOPLEFT", "Lootster_Anchor1Tab", "TOPLEFT", 0, 0);
		Lootster_RaidTab:SetPoint("BOTTOMRIGHT", "Lootster_Anchor1Tab", "BOTTOMRIGHT", 0, 0);

		-- and rehide anchors
		Lootster_Anchor2Tab:Hide();
		Lootster_Anchor1Tab:Hide();

		-- update 100/1000 UI
		Lootster_CheckCorKUse();

		-- what Normal mode are we using?
		if (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			-- set DKP and Tier heading to Need or Greed
			Lootster_RollFrameColumnHeader4:SetText(LOOTSTER_ROLL_N_G);
		else
			-- erase DKP and Tier heading for roll tab
			Lootster_RollFrameColumnHeader4:SetText("");
		end

		-- erase Tier heading for roll tab
		Lootster_RollFrameColumnHeader5:SetText("");

		-- erase DKP heading for raid, boss, attend and adjust tabs
		Lootster_RaidFrameRaidFrameColumnHeader7:SetText("");
		Lootster_RaidFrameBossFrameColumnHeader7:SetText("");
		Lootster_RaidFrameBossAttendFrameColumnHeader5:SetText("");
		Lootster_RaidFrameBossAdjustFrameColumnHeader3:SetText("");

		-- update rule table show rules label
		Lootster_RuleFrameRulesFrameLabel:SetText(string.format(LOOTSTER_RULE_RULE, LOOTSTER_OPTION_ROLLMODELIST[Lootster_Options.RollMode]));

		-- update rules tab with normal rules
		Lootster_RuleFrameRulesFrameText:SetText(Lootster_Rules.RulesNorm);

		-- setup the roll type for using DKP
		Lootster_Option_RollType_OnShow();

		-- hide the DKP mode option frame
		Lootster_OptionsFrameRollManageDKPFrame:Hide();

		-- see what Normal type is in effect
		if (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			-- show the Normal 100/1000 mode option frame
			Lootster_OptionsFrameRollManageCorKFrame:Show();
		else
			-- hide the Normal 100/1000 mode option frame
			Lootster_OptionsFrameRollManageCorKFrame:Hide();
		end

		-- hide adjustment DKP edit box
		Lootster_RaidFrameAdjustFrameDKP:Hide();
	end
end

-- Check 100/1000 Use handler
function Lootster_CheckCorKUse()
	-- show the 100/1000 widgets as required
	if		((Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000)) then
		-- hide normal buttons
		Lootster_RollFrameNeedRoll:Hide();
		Lootster_RollFrameGreedRoll:Hide();

		Lootster_RollFrameRoll:Hide();

		-- show CorK buttons
		Lootster_RollFrame1001000Roll:Show();

		Lootster_RollFrameRoll100:Show();
		Lootster_RollFrameRoll1000:Show();

		-- do we allow auto-roll?
		if (Lootster_Options.CorKRoll == false) then
			-- disable other CorK options
			Lootster_OptionsFrameNormCorKOpen:Disable();
			Lootster_OptionsFrameNormCorKClose:Disable();
		else
			-- enable other CorK options
			Lootster_OptionsFrameNormCorKOpen:Enable();
			Lootster_OptionsFrameNormCorKClose:Enable();
		end
	else
		-- show normal buttons
		Lootster_RollFrameNeedRoll:Show();
		Lootster_RollFrameGreedRoll:Show();

		Lootster_RollFrameRoll:Show();

		-- hide CorK buttons
		Lootster_RollFrame1001000Roll:Hide();

		Lootster_RollFrameRoll100:Hide();
		Lootster_RollFrameRoll1000:Hide();
	end
end

-- Check Raid Use handler
function Lootster_CheckRaidUse()
	-- do we track by raid?
	if (Lootster_Options.TrackBy == LOOTSTER_ENUM_AUTORAID.RAID) then
		-- disable boss icon handling
		Lootster_OptionsFrameBossIcon:Disable();
	else
		-- enable boss icon handling
		Lootster_OptionsFrameBossIcon:Enable();
	end
end

-- Check Instance Information handler
function Lootster_CheckInstanceInfo(raidRec)
	local	zone, wowId, dateExp;

	-- do we have a passed raid record?
	if (raidRec == nil) then
		-- nope, so do we have a running raid? 
		if (Lootster_Running.RaidId ~= nil) then
			-- use this raid record
			raidRec = Lootster_Raid[Lootster_Running.RaidId];
		end
	end
	
	-- do we already have a WoWID?
	if ((raidRec == nil) or (raidRec.WoWId ~= nil)) then
		-- no raid or it already has a WoWId
		return false;
	end

	-- get the instance information
	wowId, dateExp = Lootster_GetInstanceId(raidRec.Zone);
	
	if (wowId ~= nil) then
		-- update raid information
		raidRec.WoWId = wowId;
		raidRec.DateExp = dateExp;
	end
	
	return wowId ~= nil;
end

-- Load Chat Frame Mask handler
function Lootster_LoadChatMask(group)
	local	fix, chatFrame, gix, gvalue;
	local	mask = 0;

	-- hammer through all chat frames
	for fix=1, NUM_CHAT_WINDOWS do
		-- get the chat frame
		chatFrame = getglobal("ChatFrame"..fix);

		-- hammer through all the message types for this frame
		for gix, gvalue in ipairs(chatFrame.messageTypeList) do
			-- make sure we compare apples to apples
			if (string.upper(gvalue) == string.upper(group)) then
				-- add this guy to the mask
				mask = bit.bor(mask, bit.lshift(1, fix));
				break;
			end
		end
	end

	return mask;
end

-- Load the Time Zone handler
function Lootster_LoadTimeZone()
	local   curTime, utcTime, curDiff, utcHour, svrHour;
	
	-- get current time
	curTime = time();

	-- calculate UTC time
	utcTime = time(date("!*t", curTime));
	
	-- calculate current/UTC time differential, in hours
	curDiff = (curTime - utcTime) / 3600;
	
	-- format as UTC hour
	utcHour = date("!%H", curTime);
	
	-- get the game time hour
	svrHour = GetGameTime();

	-- and calculate server difference in time against UTC
	Lootster_TZOffsetSvrUTC = svrHour - utcHour;

	-- use hack server timezone lookup table to determine correct day bias for server time
	if (LOOTSTER_TZ_SERVER[Lootster_TZOffsetSvrUTC] ~= nil) then

		-- use server's day bias against UTC
		Lootster_TZOffsetSvrUTC = Lootster_TZOffsetSvrUTC + LOOTSTER_TZ_SERVER[Lootster_TZOffsetSvrUTC];
	end
	
	-- calculate our server time offset from current time
	Lootster_TZOffsetSvrCur = Lootster_TZOffsetSvrUTC - curDiff;
end

-- Load Data handler
function Lootster_LoadData()
	local	raidIx, raidId, raidRec, bossIx, bossId, flag, player, attendIx, attendId, attendRec, adjustIx, adjustId, adjustRec, adjustSet, itemId, itemSet;
	local	resetOld, parkIx, dkpRec;

	-- reset DKP and adjust total lists
	Lootster_DKP = {};

	-- hammer through each raid, accumulating boss, attend and adjust counts
	for raidId, raidRec in pairs(Lootster_Raid) do
		-- initialise and accumulate boss count
		bossIx = 0;

		for bossId, flag in pairs(Lootster_Raid[raidId].BossSet) do
			-- initialise and accumulate attend count for this boss
			attendIx = 0;

			for player, attendId in pairs(Lootster_Boss[bossId].AttendSet) do
				-- initialise and accumulate adjust count for this attendee
				adjustIx = 0;

				for adjustId, adjustRec in pairs(Lootster_Attend[attendId].AdjustSet) do
					-- bump attend count
					adjustIx = adjustIx + 1;
				end

				-- and set adjust count for attendee
				table.setn(Lootster_Attend[attendId].AdjustSet, adjustIx);

				-- bump attend count
				attendIx = attendIx + 1;
			end

			-- and set attend count for raid
			table.setn(Lootster_Boss[bossId].AttendSet, attendIx);

			-- initialise and accumulate adjust count for this boss
			adjustIx = 0;

			for adjustId, adjustRec in pairs(Lootster_Boss[bossId].AdjustSet) do
				-- bump attend count
				adjustIx = adjustIx + 1;
			end

			-- and set adjust count for raid
			table.setn(Lootster_Boss[bossId].AdjustSet, adjustIx);

			-- bump boss count
			bossIx = bossIx + 1;
		end

		-- and set boss count for raid
		table.setn(Lootster_Raid[raidId].BossSet, bossIx);

		-- initialise and accumulate attend count for raid
		attendIx = 0;

		for attendId, attendRec in pairs(Lootster_Raid[raidId].AttendSet) do
			-- bump attend count
			attendIx = attendIx + 1;
		end

		-- and set attend count for raid
		table.setn(Lootster_Raid[raidId].AttendSet, attendIx);

		-- initialise and accumulate adjust count for raid
		adjustIx = 0;

		for adjustId, adjustRec in pairs(Lootster_Raid[raidId].AdjustSet) do
			-- bump attend count
			adjustIx = adjustIx + 1;
		end

		-- and set adjust count for raid
		table.setn(Lootster_Raid[raidId].AdjustSet, adjustIx);
	end

	-- initialise and accumlate the raid count in the master looted table
	raidIx = 0;

	for raidId, itemSet in pairs(Lootster_MasterLooted) do
		-- initialise and accumlate item count in master looted raid table
		itemIx = 0;

		for itemId, adjustSet in pairs(itemSet) do
			-- bump item count
			itemIx = itemIx + 1;
		end

		-- set count of items in master looted raid table
		table.setn(itemSet, itemIx);

		-- bump count of raids
		raidIx = raidIx + 1;
	end

	-- set count of raids in master looted table
	table.setn(Lootster_MasterLooted, raidIx);

	-- create the DKP table
	for player, dkpRec in pairs(Lootster_MainDKP) do
		-- stuff into DKP table
		Lootster_DKP[player] = Lootster_NewDKP(player, "-", dkpRec.DKP, 0, dkpRec.Trial, dkpRec.App);
	end

	-- initialise the park player indirection table
	parkIx = 0;
	Lootster_ParkSort = {};

	for player, value in pairs(Lootster_ParkDKP) do
		parkIx = parkIx + 1;
		Lootster_ParkSort[parkIx] = player;
	end

	-- resort the park players
	table.sort(Lootster_ParkSort);

	-- add park players to DKP and Adjust table
	for player, parkRec in pairs(Lootster_ParkDKP) do
		-- stuff into DKP table
		Lootster_DKP[player] = Lootster_NewDKP(player, "-", 0, 0, false, false);
	end

	-- preprocess the adjustment table, removing all translated records
	for adjustId, adjustRec in pairs(Lootster_Adjust) do
		-- if this key is a string, its one of ours
		if		(type(adjustId) == "string") then
			-- see if the key converts to a number, in which case its a converted record
			if		(tonumber(adjustId) ~= nil) then
				-- translated record - remove so we can reconvert
				Lootster_Adjust[adjustId] = nil;
			elseif	(adjustRec.DKP == nil) then
				-- this is a total record - reconstruct please
				Lootster_Adjust[adjustId] = nil;
			elseif	(Lootster_DKP[adjustRec.Player] == nil) then
				-- create player underlying this adjustment
				Lootster_DKP[adjustRec.Player] = Lootster_NewDKP(adjustRec.Player, "-", 0, 0);
			end
		elseif	(Lootster_DKP[adjustRec.Player] == nil) then
			-- create player underlying this adjustment
			Lootster_DKP[adjustRec.Player] = Lootster_NewDKP(adjustRec.Player, "-", 0, 0);
		end
	end

	-- are previous version records present?
	if (table.getn(Lootster_Adjust) > 0) then
		-- old raid reset flag
		resetOld = false;

		-- preprocess the adjustment table, translating all previous version records
		for adjustIx, adjustRec in ipairs(Lootster_Adjust) do
			-- don't bookkeep total records in boss
			if (adjustRec.DKP ~= nil) then
				-- have we created the old raid/boss yet?
				if (resetOld == false) then
					-- create special convert raid and boss to accomodate these guys.  First though
					-- clobber any existing special raid/boss
					Lootster_DeleteRaid(LOOTSTER_CONV_RAIDID);

					-- create special raid
					Lootster_CreateRaid(Lootster_NewRaid(LOOTSTER_CONV_RAID, nil, Lootster_CalcServerTime(time())), LOOTSTER_CONV_RAIDID);

					-- create special boss
					Lootster_CreateBoss(Lootster_NewBoss(LOOTSTER_CONV_BOSS, Lootster_CalcServerTime(time())), LOOTSTER_CONV_BOSSID);

					-- add the special boss to the special raid
					Lootster_InsertBoss(LOOTSTER_CONV_RAIDID, LOOTSTER_CONV_BOSSID);

					-- done
					resetOld = true;
				end

				-- create an adjustment record for this guy
				adjustId = Lootster_CreateAdjust(Lootster_NewAdjust(adjustRec.Player, adjustRec.Player, Lootster_CalcServerTime(adjustRec.Epoch), adjustRec.DKP, nil, adjustRec.Reason, adjustRec.Comment), tostring(adjustIx));

				-- add this adjustment to the special boss
				Lootster_InsertAdjust(LOOTSTER_CONV_BOSSID, adjustId);
			end
		end
	end

	-- process the adjustment table (translated records only)
	for adjustId, adjustRec in pairs(Lootster_Adjust) do
		-- process only translated records
		if (type(adjustId) == "string") then
			-- is this an alt record?
			if	(Lootster_AltsDKP[adjustRec.Player] ~= nil) then
				-- the main became the alt - remove the record from the boss
				Lootster_RemoveAdjust(Lootster_Adjust[adjustId].BossId, adjustId);

				-- transfer the adjustment record to the main
				adjustRec.Player = Lootster_AltsDKP[adjustRec.Player].Name;

				-- and insert back into the boss
				Lootster_InsertAdjust(Lootster_Adjust[adjustId].BossId, adjustId);
			else
				-- add the adjustment DKP to total player adjustment DKP
				Lootster_DKP[adjustRec.Player].DKPAdj = Lootster_DKP[adjustRec.Player].DKPAdj + adjustRec.DKP;
			end
		end
	end

	-- create adjustment totals for each player in DKP table
	for player, dkpRec in pairs(Lootster_DKP) do
		-- create an adjustment record for this guy
		Lootster_CreateAdjust(Lootster_NewAdjust(player, player, Lootster_CalcServerTime(time()), nil, LOOTSTER_MSG_ADJUSTTOTAL, ""), player);

		-- force update of DKP values
		Lootster_UpdateDKP(player);
	end
end

-- Process Restrictions handle
function Lootster_ProcessRestrictions(link, slot)
	local	itemLink, ix, field, text, classes, class, flag;

	-- reset item details
	Lootster_ItemID = nil;
	Lootster_ItemLink = nil;
	Lootster_ItemSlot = nil;
	Lootster_ItemText = "";

	-- reset class restrictions
	Lootster_ResetClass();

	-- do we have an item?
	if (link ~= nil) then
		-- wire in item link
		Lootster_ItemLink = link;

		-- do we have a slot?
		if (slot ~= nil) then
			-- wire up slot
			Lootster_ItemSlot = slot;
		end

		-- get the item details for this link
		Lootster_ItemID, 
		Lootster_ItemText, 
		Lootster_ClassRestricted, 
		Lootster_ClassRestrictedLock, 
		Lootster_ClassRestrictions, 
		Lootster_ClassRestrictionsMaskOrig = Lootster_GetItemDetails(Lootster_ItemLink);

		-- save orginal mask as current mask to dected changes
		Lootster_ClassRestrictionsMaskCurr = Lootster_ClassRestrictionsMaskOrig;
	end

	-- did we find restrictions?
	if (Lootster_ClassRestricted == true) then
		-- update the class frame
		Lootster_UpdateClassUI();

		-- update restricted count
		Lootster_UpdateRestricted();

		-- show the class frame if we are visible
		if (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RaidFrame:IsVisible() or Lootster_ItemFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible()) then
			Lootster_ClassFrame:Show();
		end
	else
		-- update the class UI
		Lootster_UpdateClassUI();
	end

	-- update the UI
	Lootster_UpdateRollUI();
end

-- Roll Clear Rolls handler
function Lootster_Roll_ClearRolls_OnClick()
	-- erase rolls
	Lootster_Rolls = {};

	-- reset the roll sorts
	Lootster_RollsSort = {};

	-- reset record count
	table.setn(Lootster_RollsSort, 0);

	-- reset roll and restricted count
	Lootster_RollCount = 0;

	-- reset current roll NBG to nothing (between roll calls)
	Lootster_NBG = nil;

	-- reset list of winners
	Lootster_Won = {};

	-- reset tied indicator, rolls and count
	Lootster_Tied = false;
	Lootster_TiedRolls = {};
	Lootster_TiedItemCount = 0;

	-- reset item count
	Lootster_RollFrameItems:SetNumber(1);

	-- and spoof entry to transfer and update
	Lootster_Roll_Items_Entered();

	-- reset pass/reclaim text
	Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);

	-- update the roll
	Lootster_UpdateRoll();

	-- update received counter
	Lootster_UpdateRollUI();

	-- and update the screen
	Lootster_Roll_Update();
end

-- Items handler
function Lootster_Roll_Items_Entered()
	-- get the new item count
	Lootster_ItemCount = Lootster_RollFrameItems:GetNumber();

	-- must be positive
	if (Lootster_ItemCount < 0) then
		Lootster_ItemCount = 1;

		-- update
		Lootster_RollFrameItems:SetNumber(Lootster_ItemCount);
	end

	-- update read-only RO version
	Lootster_RollFrameItemsRO:SetText(Lootster_ItemCount);

	-- copy won item count if not tied
	if (Lootster_Tied ~= true) then
		Lootster_WonItemCount = Lootster_ItemCount;
	end

	-- update item prompt
	Lootster_UpdateItemPrompt();
end

-- Assign Loot handler
function Lootster_Roll_AssignLoot_OnClick()
	local	count, player, main ,dkp, reason;
	
	-- no loot link or running boss we are done
	if ((Lootster_ItemLink == nil) or (Lootster_Running.RaidId == nil) or (Lootster_Running.BossId == nil)) then
		return;
	end

	-- retrieve default DKP and reason text
	dkp, reason = Lootster_GetItemDKP(Lootster_ItemText);
	
	-- hide outstanding dialog, if any
	Lootster_Popup_Show();

	-- create an adjustment record for this guy
	Lootster_AdjustRec = Lootster_NewAdjust(nil, nil, Lootster_CalcServerTime(time()), dkp, Lootster_ItemLink, reason, "");
	
	-- this adjustment must go into the running boss
	Lootster_AdjustRec.BossId = Lootster_Running.BossId;

	-- copy the winner list and won item count
	Lootster_AdjustRec.Won = Lootster_CopyRecord(Lootster_Won);
	Lootster_AdjustRec.WonItemCount = Lootster_WonItemCount;
	
	-- show data adjustment frame
	Lootster_Popup_Show(Lootster_RaidFrameAdjustFrame);
end

-- Active Toggle handler
function Lootster_Roll_ActiveButton_Toggle()
	-- this is easy
	Lootster_Options.Active = (Lootster_RollFrameActive:GetChecked() ~= nil);

	-- disable/enable passive rolling checkbox
	if (Lootster_Options.Active == true) then
		Lootster_RollFramePassive:Disable();
	else
		Lootster_RollFramePassive:Enable();
	end

	-- update roll handling
	Lootster_UpdateRollUI();
end

-- Need Roll Call handler
function Lootster_Roll_NeedRoll_OnClick()
	-- set current roll NBG to need
	Lootster_NBG = LOOTSTER_NBG_NEED;

	-- if the item count is less than or equal to zero, set to 1
	if (Lootster_ItemCount <= 0) then
		-- set item count to default
		Lootster_RollFrameItems:SetNumber(1);

		-- and spoof entry to transfer and update
		Lootster_Roll_Items_Entered();
	end

	-- create roll plead and ignore texts
	Lootster_CreatePlead();

	-- calculate player positioning for DKP
	Lootster_CalculatePositions();

	-- update received roll status
	Lootster_UpdateRollUI();	

	-- format the need roll message and let everyone know
	if		(Lootster_ItemPrompt == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG, Lootster_NBG_ClassPlease, Lootster_NBG));
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt));
	else
		local	dkp, reason, items, cost;

		-- retrieve default DKP, reason text and item count
		dkp, reason, items = Lootster_GetItemDKP(Lootster_ItemText)

		if		(items == 0) then
			-- to be determined
			cost = LOOTSTER_COST_DKPTBD;
		elseif	(dkp == 0) then
			-- no cost or to be determined
			cost = LOOTSTER_COST_DKP0TBD;
		else
			-- format cost
			cost = string.format(LOOTSTER_COST_DKP, -dkp);
		end

		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK_COST, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt, cost));
	end

	-- are we using DKP?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- if this is DKP by Tier, broadcast tiers prompt
		if (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			Lootster_SendBroadcast(Lootster_TiersPrompt);
		end

		-- hammer through the roster whispering each their DKP
		for player, rosRec in pairs(Lootster_Roster) do
			-- are we using class restrictions?
			if ((Lootster_ClassRestricted == false) or ((Lootster_ClassRestrictions[rosRec.ClassType] ~= nil) and (Lootster_ClassRestrictions[rosRec.ClassType] == true))) then
				-- echo roll to player with class
				Lootster_EchoPlayerRoll(player);
			end
		end
	end
end

-- Greed Roll Call handler
function Lootster_Roll_GreedRoll_OnClick()
	-- set current roll NBG to greed
	Lootster_NBG = LOOTSTER_NBG_GREED;

	-- if the item count is less than or equal to zero, set to 1
	if (Lootster_ItemCount <= 0) then
		-- set item count to default
		Lootster_RollFrameItems:SetNumber(1);

		-- and spoof entry to transfer and update
		Lootster_Roll_Items_Entered();
	end

	-- create roll plead and ignore texts
	Lootster_CreatePlead();	

	-- calculate player positioning for DKP
	Lootster_CalculatePositions();

	-- update received roll status
	Lootster_UpdateRollUI();	

	-- format the greed roll message and let everyone know
	if (Lootster_ItemPrompt == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG, Lootster_NBG_ClassPlease, Lootster_NBG));
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt));
	else
		local	dkp, reason, items, cost;

		-- retrieve default DKP, reason text and item count
		dkp, reason, items = Lootster_GetItemDKP(Lootster_ItemText)

		if		(items == 0) then
			-- to be determined
			cost = LOOTSTER_COST_DKPTBD;
		elseif	(dkp == 0) then
			-- no cost or to be determined
			cost = LOOTSTER_COST_DKP0TBD;
		else
			-- format cost
			cost = string.format(LOOTSTER_COST_DKP, -dkp);
		end

		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK_COST, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt, cost));
	end

	-- are we using DKP?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- if this is DKP by Tier, broadcast tiers prompt
		if (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			Lootster_SendBroadcast(Lootster_TiersPrompt);
		end

		-- hammer through the roster whispering each their DKP
		for player, value in pairs(Lootster_Roster) do
			-- echo roll to player
			Lootster_EchoPlayerRoll(player);
		end
	end
end

-- 100/1000 Roll Call handler
function Lootster_Roll_1001000Roll_OnClick()
	-- set current roll NBG to 100/1000
	Lootster_NBG = LOOTSTER_NBG_1001000;

	-- if the item count is less than or equal to zero, set to 1
	if (Lootster_ItemCount <= 0) then
		-- set item count to default
		Lootster_RollFrameItems:SetNumber(1);

		-- and spoof entry to transfer and update
		Lootster_Roll_Items_Entered();
	end

	-- create roll plead and ignore texts
	Lootster_CreatePlead();

	-- calculate player positioning for DKP
	Lootster_CalculatePositions();

	-- update received roll status
	Lootster_UpdateRollUI();	

	-- format the 100/1000 roll message and let everyone know
	if		(Lootster_ItemPrompt == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG, Lootster_NBG_ClassPlease, Lootster_NBG));
	else
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt));
	end
end

-- Tied Roll Call handler
function Lootster_Roll_TiedRoll_OnClick()
	local	count, ix;

	local	msgTie = "";

	-- set current roll NBG to tied
	Lootster_NBG = LOOTSTER_NBG_TIED;

	-- reset roll count
	Lootster_RollCount = 0;

	-- set the new item count of items remaining to be distributed
	Lootster_RollFrameItems:SetNumber(Lootster_TiedItemCount);

	-- and spoof entry to transfer and update
	Lootster_Roll_Items_Entered();

	-- reset list of rolls and sort order
	Lootster_Rolls = {};
	Lootster_RollsSort = {};

	-- build list of ties to roll
	count = table.getn(Lootster_TiedRollsSort);

	for ix=1, count, 1 do
		-- copy this tied player
		Lootster_Rolls[Lootster_TiedRollsSort[ix]] = Lootster_TiedRolls[Lootster_TiedRollsSort[ix]];

		-- update the sort order
		Lootster_RollsSort[ix] = Lootster_TiedRolls[Lootster_TiedRollsSort[ix]].Player;

		-- add name
		msgTie = msgTie..Lootster_TiedRolls[Lootster_TiedRollsSort[ix]].Player;

		if		(ix < (count - 1)) then
			msgTie = msgTie..LOOTSTER_MSG_SEP;
		elseif	(ix == (count - 1)) then
			msgTie = msgTie..LOOTSTER_MSG_AND;
		end
	end

	-- update count of rolls
	table.setn(Lootster_RollsSort, count);

	-- update the screen
	Lootster_Roll_Update();

	-- update the roll
	Lootster_UpdateRoll();

	-- update received roll status
	Lootster_UpdateRollUI();	

	-- format the tied roll message and let everyone know
	if (Lootster_ItemPrompt == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBGTIED, msgTie, Lootster_NBG));
	else
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBGTIED_LINK, msgTie, Lootster_NBG, Lootster_ItemPrompt));
	end
end

-- Roll Count handler
function Lootster_Roll_RollCount_OnClick()
	local	rcount, rix, lcount, lix, player;

	local	msgLagName = "";

	local	playerLag = {};

	-- get the count of rolls
	rcount = table.getn(Lootster_RollsSort);

	-- build yet to roll or pass announcement
	for rix=1, rcount, 1 do
		-- has this guy rolled?
		if (Lootster_Rolls[Lootster_RollsSort[rix]].Roll == nil) then
			-- add the laggard
			table.insert(playerLag, rix);
		end
	end

	if (table.getn(playerLag) ~= 0) then
		-- get count of laggards
		lcount = table.getn(playerLag);

		-- build laggard announcement
		for lix=1, lcount, 1 do
			-- put the laggard in the message
			msgLagName = msgLagName..Lootster_Rolls[Lootster_RollsSort[playerLag[lix]]].Player

			if		(lix < (lcount - 1)) then
				msgLagName = msgLagName..LOOTSTER_MSG_SEP;
			elseif	(lix == (lcount - 1)) then
				msgLagName = msgLagName..LOOTSTER_MSG_AND;
			end
		end

		-- announce the laggards.  Determine message
		if (Lootster_ItemLink == nil) then
			-- see how many laggards we have
			if (lcount == 1) then
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_LAGGARD1, msgLagName));
			else
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_LAGGARDN, msgLagName));
			end
		else
			-- how many many laggards we have
			if (lcount == 1) then
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_LAGGARD1_LINK, msgLagName, Lootster_ItemLink));
			else
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_LAGGARDN_LINK, msgLagName, Lootster_ItemLink));
			end
		end

		-- hammer through each player sending them their roll command, as required
		for lix=1, lcount, 1 do
			-- snarf player
			player = Lootster_Rolls[Lootster_RollsSort[playerLag[lix]]].Player;

			-- have they switched off laggard roll command tells?
			if (Lootster_TestPlayerTell(player, "AckNoRoll") == true) then
				-- send them their roll command
				Lootster_AskForRoll(player);
			end
		end
	end
end

-- Roll Countdown handler
function Lootster_Roll_Countdown_OnClick()
	-- initialise countdown counter
	Lootster_CountdownCount = Lootster_Options.CounterSec;

	-- reset the timer frame update time
	Lootster_Timer.LastCountdownTime = 0;

	-- and let people know
	if (Lootster_ItemLink == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_COUNTDOWN, Lootster_NBG, Lootster_CountdownCount));
	else
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_COUNTDOWN_LINK, Lootster_NBG, Lootster_ItemLink, Lootster_CountdownCount));
	end
end

-- Roll Announce handler
function Lootster_Roll_Announce_OnClick()
	local	items, wcount, rcount, tcount, wix, rix, tix, cix;

	local	rollInfo, msgRollName, msgRollPrefix;

	local	msgWinName = "";
	local	msgWinRoll = "";
	local	msgTieName = "";
	local	msgRollInfo = "";

	local	msgRemain = "";

	local	playerCan = {};
	local	playerWin = {};
	local	playerTie = {};

	-- determine the roll type and whether there is roll info
	if		((Lootster_NBG == LOOTSTER_NBG_TIED) or (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM)) then
		-- no roll information, normal roll
		rollInfo = false;
		msgRollName = "";
		msgRollPrefix = LOOTSTER_ROLL_PREFIX;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
		-- has roll information, DKP-based roll
		rollInfo = true;
		msgRollName = LOOTSTER_ROLL_DKPNAME;
		msgRollPrefix = LOOTSTER_ROLL_DKPPREFIX;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
		-- has roll information, Tier-based roll
		rollInfo = true;
		msgRollName = LOOTSTER_ROLL_TIERNAME;
		msgRollPrefix = LOOTSTER_ROLL_TIERPREFIX;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
		-- has roll information, Modified DKP roll
		rollInfo = true;
		msgRollName = "";
		msgRollPrefix = LOOTSTER_ROLL_MODIFIEDPREFIX;
	else
		-- no roll information, normal roll
		rollInfo = false;
		msgRollName = "";
		msgRollPrefix = LOOTSTER_ROLL_PREFIX;
	end

	-- snarf count of items to distribute
	items = Lootster_ItemCount;

	-- snarf count of items to distribute in event of a tie
	Lootster_TiedItemCount = Lootster_ItemCount;

	-- get the count of rolls
	rcount = table.getn(Lootster_RollsSort);

	-- set roll index
	rix = 1;

	-- while we have items to win, get winners
	while ((items > 0) and (rix <= rcount)) do
		-- do we have a valid roll?
		if ((Lootster_Rolls[Lootster_RollsSort[rix]].Roll == nil) or (Lootster_Rolls[Lootster_RollsSort[rix]].Roll <= 0)) then
			-- none left in the list can be a valid roll
			rix = rcount + 1;
		else
			-- get this candidate
			playerCan = { rix };

			-- calculate starting index for ties
			tix = rix + 1;

			-- gather all the possible candidates with the same roll
			while ((tix <= rcount) and (Lootster_RollEqual(Lootster_RollsSort[rix], Lootster_RollsSort[tix]) == true)) do
				-- get tieing  player
				table.insert(playerCan, tix);

				tix = tix + 1;
			end

			-- okay, now see if all the tieing players each have a item available for them
			if ((items - (tix - rix)) >= 0) then
				-- we have some winners!
				for cix in playerCan do
					table.insert(playerWin, playerCan[cix]);
				end

				-- subtract these won items from the tied item count
				Lootster_TiedItemCount = Lootster_TiedItemCount - (tix - rix);
			else
				-- we have some ties!
				for cix in playerCan do
					table.insert(playerTie, playerCan[cix]);
				end
			end

			-- calculate the remaining items to roll on
			items = items - (tix - rix);

			-- the roll starting position is where we left off
			rix = tix;
		end
	end

	-- see if we have any outright winners
	if (table.getn(playerWin) ~= 0) then
		-- get count of winners
		wcount = table.getn(playerWin);

		-- build winners announcement
		for wix=1, wcount, 1 do
			-- add this guy's main to list of winners 
			table.insert(Lootster_Won, Lootster_GetALTMain(Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Player));

			-- add name
			msgWinName = msgWinName..Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Player;

			-- add roll
			msgWinRoll = msgWinRoll..Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Roll;

			-- is there roll information?
			if (rollInfo == true) then
				-- we have roll information - gather it up
				if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
					msgRollInfo = string.format(LOOTSTER_ROLL_INFO, msgRollName, Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Priority, Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].DKP);
				elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
					msgRollInfo = string.format(LOOTSTER_ROLL_INFO, msgRollName, Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Priority, Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Tier);
				else
					msgRollInfo = "";
				end
			else
				msgRollInfo = "";
			end

			if		(wcount == 1) then
				msgWinRoll = msgWinRoll..msgRollInfo;
			elseif	(wix < (wcount - 1)) then
				msgWinName = msgWinName..LOOTSTER_MSG_SEP;
				msgWinRoll = msgWinRoll..msgRollInfo..LOOTSTER_MSG_SEP;
			elseif	(wix == (wcount - 1)) then
				msgWinName = msgWinName..LOOTSTER_MSG_AND;
				msgWinRoll = msgWinRoll..msgRollInfo..LOOTSTER_MSG_AND;
			end
		end

		-- announce outright winners
		if (Lootster_ItemLink == nil) then
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_ANNOUNCE, msgWinName, msgRollPrefix, msgWinRoll));
		else
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_ANNOUNCE_LINK, msgWinName, Lootster_ItemLink, msgRollPrefix, msgWinRoll));
		end
	end

	-- see if we have any tied players or items left over
	if		(table.getn(playerTie) ~= 0) then
		-- reset list of tied rolls and sort order
		Lootster_TiedRolls = {};
		Lootster_TiedRollsSort = {};

		-- get count of ties
		tcount = table.getn(playerTie);

		-- copy tied players and build tied announcement
		for tix=1, tcount, 1 do
			-- copy this tied player
			Lootster_TiedRolls[Lootster_RollsSort[playerTie[tix]]] = Lootster_CopyRecord(Lootster_Rolls[Lootster_RollsSort[playerTie[tix]]]);

			-- update the sort order
			Lootster_TiedRollsSort[tix] = Lootster_Rolls[Lootster_RollsSort[playerTie[tix]]].Player;

			-- add name
			msgTieName = msgTieName..Lootster_Rolls[Lootster_RollsSort[playerTie[tix]]].Player;

			if		(tix < (tcount - 1)) then
				msgTieName = msgTieName..LOOTSTER_MSG_SEP;
			elseif	(tix == (tcount - 1)) then
				msgTieName = msgTieName..LOOTSTER_MSG_AND;
			end
		end

		-- update count of ties
		table.setn(Lootster_TiedRollsSort, tcount);

		-- is there roll information?
		if (rollInfo == true) then
			-- we have roll information - gather it up
			if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
				msgRollInfo = Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Roll..string.format(LOOTSTER_ROLL_INFO, msgRollName, Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Priority, Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].DKP);
			elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
				msgRollInfo = Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Roll..string.format(LOOTSTER_ROLL_INFO, msgRollName, Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Priority, Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Tier);
			else
				msgRollInfo = Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Roll;
			end
		else
			msgRollInfo = Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Roll;
		end

		-- announce ties
		if (Lootster_ItemLink == nil) then
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_TIED, msgTieName, msgRollPrefix, msgRollInfo));
		else
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_TIED_LINK, msgTieName, Lootster_ItemLink, msgRollPrefix, msgRollInfo));
		end

		-- now reset current roll data for the ties
		for key, value in pairs(Lootster_TiedRolls) do
			Lootster_TiedRolls[key].Roll = nil;
			Lootster_TiedRolls[key].Bad = nil;
			Lootster_TiedRolls[key].Dup = nil;
		end

		-- set tied flag
		Lootster_Tied = true;

		-- update received roll status
		Lootster_UpdateRollUI();	
	elseif	(items > 0) then
		-- announce leftovers.  Determine message
		if (Lootster_ItemLink == nil) then
			-- how many left over
			if (items == 1) then
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_UNCLAIMED1));
			else
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_UNCLAIMEDN, items));
			end
		else
			-- how many left over
			if (items == 1) then
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_UNCLAIMED1_LINK, Lootster_ItemLink));
			else
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_UNCLAIMEDN_LINK, items, Lootster_ItemLink));
			end
		end
	end
end

-- Passive Button Click handler
function Lootster_Roll_PassiveButton_Toggle()
	-- this is easy
	Lootster_Options.Passive = (Lootster_RollFramePassive:GetChecked() ~= nil);

	-- update roll handling
	Lootster_UpdateRollUI();
end

-- Roll Roll handler
function Lootster_Roll_Roll_OnClick()
	-- good luck!
	RandomRoll(1, Lootster_SelfRoll)
end

-- Roll Roll 100 handler
function Lootster_Roll_Roll100_OnClick()
	-- good luck!
	RandomRoll(1, 100)
end

-- Roll Roll 1000 handler
function Lootster_Roll_Roll1000_OnClick()
	-- good luck!
	RandomRoll(1, 1000)
end

-- Pass/Reclaim Roll handler
function Lootster_Roll_PassReclaim_OnClick()
	-- see what we need to do for ourselves
	if		((Lootster_Rolls[Lootster_Self] == nil) or (Lootster_Rolls[Lootster_Self].Roll == nil) or (Lootster_Rolls[Lootster_Self].Roll >= 0)) then
		-- see if we need to inform people
		if (Lootster_PlayerCount == 1) then
			-- just pass internally
			Lootster_PassRoll(Lootster_Self);
		else
			-- let everyone know we are passing.  If we are inactive but allowing passive
			-- rolls/passes, force this bad boy out
			if ((Lootster_Options.Active == false) and (Lootster_Options.Passive == true)) then
				-- force out to party/raid chat
				Lootster_SendBroadcast(LOOTSTER_CMD_PASS, true);
			else
				-- normal broadcast...
				Lootster_SendBroadcast(LOOTSTER_CMD_PASS);
			end				
		end
	elseif	((Lootster_Rolls[Lootster_Self] ~= nil) and ((Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll < 0))) then
		-- see if we need to inform people
		if (Lootster_PlayerCount == 1) then
			-- just reclaim internally
			Lootster_ReclaimRoll(Lootster_Self);
		else
			-- let everyone know we are reclaiming.  If we are inactive but allowing passive
			-- rolls/passes, force this bad boy out
			if ((Lootster_Options.Active == false) and (Lootster_Options.Passive == true)) then
				-- force out to party/raid chat
				Lootster_SendBroadcast(LOOTSTER_CMD_RECLAIM, true);
			else
				-- normal broadcast...
				Lootster_SendBroadcast(LOOTSTER_CMD_RECLAIM);
			end				
		end
	end
end

-- Roll Clear Item Link handler
function Lootster_Roll_ClearItem_OnClick()
	-- reset the hyperlinks
	Lootster_SetHyperlink(nil);
end

-- Roll Item Link Click handler
function Lootster_Roll_ItemLink_OnClick(button)
	local	itemLink;

	-- do we have a link?
	if (Lootster_ItemLink ~= nil) then
		-- I wonder what they think they are doing...
		if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
			-- display restrictions of the hyperlink
			Lootster_Class_Display_OnClick();
		elseif	(button == "LeftButton") then
			-- are they trying to link to chat?
			if (IsShiftKeyDown()) then
				-- make sure chat window is visible
				if (ChatFrameEditBox:IsVisible()) then
					ChatFrameEditBox:Insert(Lootster_ItemLink);
				end
			else
				-- show item reference tooltip
				ShowUIPanel(ItemRefTooltip);

				-- make sure we can see it
				if (not ItemRefTooltip:IsVisible()) then
					ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");
				end

				-- set the link
				ItemRefTooltip:SetHyperlink(Lootster_ItemID);
			end
		end
	end
end

-- Restrict Roll handler
function Lootster_Class_RestrictRoll_OnClick()
	-- reset class restrictions
	Lootster_ResetClass();

	-- update the class UI
	Lootster_UpdateClassUI();

	-- update the UI
	Lootster_UpdateRollUI();

	-- toggle the class restriction frame
	if (Lootster_ClassFrame:IsVisible()) then
		Lootster_ClassFrame:Hide();
	else
		Lootster_ClassFrame:Show();
	end
end

-- Restrict Roll Class handler
function Lootster_Class_PermitButton_Toggle()
	local	button, class, new;

	-- classes cannot be locked down
	if (Lootster_ClassRestrictedLock == false) then
		-- get the class item button
		button = getglobal("Lootster_ClassFrameClass"..this:GetID().."Text");

		-- retrieve the invariant class for this guy
		class = Lootster_ClassSingular[button:GetText()];

		-- is this a new class entry?
		if (Lootster_ClassRestrictions[class] == nil) then
			-- bump count
			table.setn(Lootster_ClassRestrictions, table.getn(Lootster_ClassRestrictions) + 1);
		end

		-- mark the class appropriately
		Lootster_ClassRestrictions[class] = (this:GetChecked() ~= nil);

		-- update the current restriction mask accordingly
		if (Lootster_ClassRestrictions[class] == false) then
			Lootster_ClassRestrictionsMaskCurr = bit.band(Lootster_ClassRestrictionsMaskCurr, bit.bnot(LOOTSTER_CLASS[class].Mask));
		else
			Lootster_ClassRestrictionsMaskCurr = bit.bor(Lootster_ClassRestrictionsMaskCurr, LOOTSTER_CLASS[class].Mask);
		end

		-- mark roll as class restricted if we have some classes marked
		Lootster_ClassRestricted = (Lootster_ClassRestrictionsMaskCurr ~= 0);

		-- update restricted count
		Lootster_UpdateRestricted();

		-- update the UI
		Lootster_UpdateRollUI();
	end
end

-- Display Custom Restrictions Class handler
function Lootster_Class_Display_OnClick(itemLink)
	local	itemText, permitted;

	-- have we been passed a link, or are we to use current?
	if (itemLink == nil) then
		-- use current link
		itemLink = Lootster_ItemLink;
	end

	-- create restructions message
	itemText, permitted = Lootster_CreateRestricts(itemLink);

	-- do we have an item?
	if (itemLink == nil) then
		-- punching this out to party/raid?
		if (Lootster_Options.EchoToChat == true) then
			-- broadcast
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_CHATRESTRICT, LOOTSTER_LABEL_LOOTSTER, permitted), true);
		end

		-- punching this out to CT_RaidAssist?
		if ((Lootster_Options.EchoToCTRA == true) and (CT_RA_Channel ~= nil) and (CT_RA_Level > 0)) then
			-- broadcast
			CT_RA_AddMessage(LOOTSTER_CTRACMD_MSG..string.format(LOOTSTER_MSG_CHATRESTRICT, LOOTSTER_LABEL_LOOTSTER, permitted));
		end
	else
		-- punching this out to party/raid?
		if (Lootster_Options.EchoToChat == true) then
			-- broadcast
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_CHATRESTRICT_LINK, LOOTSTER_LABEL_LOOTSTER, itemText, permitted), true);
		end

		-- punching this out to CT_RaidAssist and we are able to?
		if ((Lootster_Options.EchoToCTRA == true) and (CT_RA_Channel ~= nil) and (CT_RA_Level > 0)) then
			-- broadcast
			CT_RA_AddMessage(LOOTSTER_CTRACMD_MSG..string.format(LOOTSTER_MSG_CHATRESTRICT_LINK, LOOTSTER_LABEL_LOOTSTER, itemText, permitted));
		end
	end
end

-- Class Remember Restrictions handler
function Lootster_Class_Remember_OnClick()
	-- if the restrictions are not locked we can save our own settings
	if ((Lootster_ClassRestrictedLock == false) and (Lootster_ItemID ~= nil)) then
		local	class, flag;

		local	classes = {};

		-- prepare list of classes
		for class, flag in pairs(Lootster_ClassRestrictions) do
			-- this guy on?
			if (flag == true) then
				-- snarf
				table.insert(classes, class);
			end
		end

		-- update the restricted loot table
		Lootster_Restrict[Lootster_ItemID] = Lootster_NewRestrict(Lootster_ItemText, classes);

		-- update the original restrictions mask
		Lootster_ClassRestrictionsMaskOrig = Lootster_ClassRestrictionsMaskCurr;

		-- resort item data
		Lootster_Item_Sort(nil);

		-- update the UI
		Lootster_UpdateRollUI();
	end
end

-- Class Forget Restrictions handler
function Lootster_Class_Forget_OnClick()
	-- if the restricted roll button is disabled, this is class loot, and we just ignore
	if ((Lootster_ClassRestrictedLock == false) and (Lootster_ItemID ~= nil)) then
		-- smack this entry
		Lootster_Restrict[Lootster_ItemID] = nil;

		-- reset the original and current restrictions mask
		Lootster_ClassRestrictionsMaskOrig = 0;

		-- resort item data
		Lootster_Item_Sort(nil);

		-- update the UI
		Lootster_UpdateRollUI();
	end
end

-- Create Restrictions handler
function Lootster_CreateRestricts(itemLink)
	local	itemText = "";
	local	permitted = "";

	local	restrictions = {};

	-- have we been passed a link, or are we using current?
	if (itemLink == Lootster_ItemLink) then
		-- use current text and restrictions
		itemText = Lootster_ItemText;

		restrictions = Lootster_ClassRestrictions;
	else
		-- retrieve text and restrictions for the link
		_, itemText, _, _, restrictions = Lootster_GetItemDetails(itemLink);
	end

	-- see if we have class restrictions
	if (table.getn(restrictions) > 0) then
		local	class, count, ix;
		local	classes = {};

		-- build an alphabetical list of restricted classes
		for ix, flag in ipairs(LOOTSTER_CLASS_SORT) do
			-- this class restricted?
			if ((Lootster_ClassIgnore[LOOTSTER_CLASS_SORT[ix]] == nil) and (restrictions[LOOTSTER_CLASS_SORT[ix]] == true)) then
				table.insert(classes, LOOTSTER_CLASS_SORT[ix]);
			end
		end

		-- now build the class please and class ignore texts
		count = table.getn(classes);

		for ix=1, count, 1 do
			-- add plural class to please text
			permitted = permitted..LOOTSTER_CLASS[classes[ix]].Plural;

			if		(ix < (count - 1)) then
				permitted = permitted..LOOTSTER_MSG_SEP;
			elseif (ix == (count - 1)) then
				permitted = permitted..LOOTSTER_MSG_AND;
			end
		end

		-- do we have no class restrictions?
		if (count == 0) then
			-- let them know there are none
			permitted = LOOTSTER_MSG_NORESTRICTIONS;
		end
	else
		-- let them know there are none
		permitted = LOOTSTER_MSG_NORESTRICTIONS;
	end
	
	return itemText, permitted;
end

-- Roll Row Click handler
function Lootster_Roll_Button_OnClick()
end

-- Roll Update handler
function Lootster_Roll_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowName, rowRoll, rowRoll, rowClass, rowDKP, rowTier, rowBad, rowDup;

	local	item;

	-- retrieve count of roll items
	count = table.getn(Lootster_RollsSort);	

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RollFrameScrollFrame);

	-- hammer through the roll frame rows
	for row=1, LOOTSTER_ROLL_LINES, 1 do
		-- calculate actual the roll item index
		ix = row + offset;

		-- retrieve the row components
		rowButton	= getglobal("Lootster_RollFrameButton"..row);

		-- do we have roll for the row?
		if (ix <= count) then
			-- get the text elements
			rowName		= getglobal("Lootster_RollFrameButton"..row.."Name");
			rowRoll		= getglobal("Lootster_RollFrameButton"..row.."Roll");
			rowClass	= getglobal("Lootster_RollFrameButton"..row.."Class");
			rowDKP		= getglobal("Lootster_RollFrameButton"..row.."DKP");
			rowTier		= getglobal("Lootster_RollFrameButton"..row.."Tier");
			rowBad		= getglobal("Lootster_RollFrameButton"..row.."Bad");
			rowDup		= getglobal("Lootster_RollFrameButton"..row.."Dup");

			-- okay, retrieve the roll item
			item = Lootster_Rolls[Lootster_RollsSort[ix]];

			-- format the requisiste roll and stuff into the text elements
			rowName:SetText(item.Player);
			rowClass:SetText(item.Class);

			-- are we using DKP?
			if		(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
				-- set up the valies
				rowDKP:SetText(item.DKP);

				-- DKP by DKP or Tier?
				if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
					rowTier:SetText(item.Priority);
				elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
					rowTier:SetText(item.Priority..item.Tier);
				else
					rowTier:SetText("");
				end
			elseif	((Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000)) then
				-- determine if they have rolled Need or Greed
				if		(item.Priority == LOOTSTER_ENUM_NBG.NEED) then
					rowDKP:SetText(LOOTSTER_NBG_NEED);
				elseif	(item.Priority == LOOTSTER_ENUM_NBG.GREED) then
					rowDKP:SetText(LOOTSTER_NBG_GREED);
				else
					rowDKP:SetText("");
				end

				-- erase values
				rowTier:SetText("");
			else
				-- erase values
				rowDKP:SetText("");
				rowTier:SetText("");
			end

			-- the rest of the data maybe nil
			if (item.Roll == nil) then
				rowRoll:SetText("-");
			else
				rowRoll:SetText(item.Roll);
			end

			if (item.Bad == nil) then
				rowBad:SetText("-");
			else
				rowBad:SetText(item.Bad);
			end

			if (item.Dup == nil) then
				rowDup:SetText("-");
			else
				rowDup:SetText(item.Dup);
			end

			-- and show the row
			rowButton:Show();
		else
			-- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_RollFrameScrollFrame, count, LOOTSTER_ROLL_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Data Whisper All handler
function Lootster_Data_WhisperAll_OnClick()
	-- hammer through the roster whispering each their DKP
	for player, value in pairs(Lootster_Roster) do
		-- echo DKP and roll to player
		Lootster_EchoPlayerDKP(player, player);
		Lootster_EchoPlayerRoll(player, true);
	end
end

-- Data Whisper Player handler
function Lootster_Data_DKP_WhisperPlayer_OnClick()
	local	offset, button, key, player;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_DataFrameDKPFrameScrollFrame);

	-- calculate actual the dkp item index and get the dkp record key
	key = Lootster_DKPSort[this:GetParent():GetID() + offset];

	-- get the DKP item
	player = Lootster_DKP[key].Player;

	-- echo DKP to player
	Lootster_EchoPlayerDKP(player, player, true);
end

-- Data DKP Row Click handler
function Lootster_Data_DKP_Button_OnClick()
	local	offset, key, tooltip;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_DataFrameDKPFrameScrollFrame);

	-- calculate actual the dkp item index and get the dkp record key
	key = Lootster_DKPSort[this:GetID() + offset];

	-- snarf the new player Id
	Lootster_PlayerId = Lootster_DKP[key].Player;
	
	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);
end

-- Data Player Row Click handler
function Lootster_Data_Player_Button_OnClick(button)
	local	offset, key, itemLink;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_DataFramePlayerFrameScrollFrame);

	-- calculate actual the adjustment item index and get the adjustment record index
	key = Lootster_PlayerSort[this:GetID() + offset];

	-- are they trying to link to chat, ourselves or looking at tooltip?
	if		(IsShiftKeyDown()) then
		-- make sure chat window is visible
		if (ChatFrameEditBox:IsVisible()) then
			ChatFrameEditBox:Insert(Lootster_Adjust[key].Link);
		else
			-- set as the current link
			Lootster_SetHyperlink(Lootster_Adjust[key].Link);
		end
	elseif	(IsControlKeyDown()) then
		-- extract link for tooltip
		for itemLink in string.gfind(Lootster_Adjust[key].Link, LOOTSTER_ITEMLINK_PATTERN) do
			-- show item reference tooltip
			ShowUIPanel(ItemRefTooltip);

			-- make sure we can see it
			if (not ItemRefTooltip:IsVisible()) then
				ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");
			end

			-- set the link
			ItemRefTooltip:SetHyperlink(itemLink);
		end
	end
end

-- Data Player Row Enter handler
function Lootster_Data_Player_Button_OnEnter()
	local	offset, key, tooltip;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_DataFramePlayerFrameScrollFrame);

	-- calculate actual the adjustment item index and get the adjustment record index
	key = Lootster_PlayerSort[this:GetID() + offset];

	-- format the tooltip message according to record type
	if (Lootster_Adjust[key].DKP == nil) then
		-- total record - use player DKP record
		tooltip = string.format(LOOTSTER_MSG_DKPTOOLTIPTOT, Lootster_GetMainALT(Lootster_Adjust[key].Player), Lootster_DKP[Lootster_Adjust[key].Player].DKPAdj);
	else
		-- adjustment record, using DKP if we are using DKP rolling
		if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
			tooltip = string.format(LOOTSTER_MSG_DKPTOOLTIPADJ, Lootster_GetMainALT(Lootster_Adjust[key].Player), Lootster_Adjust[key].DKP, Lootster_Adjust[key].Reason);
		else
			tooltip = string.format(LOOTSTER_MSG_NODKPTOOLTIPADJ, Lootster_GetMainALT(Lootster_Adjust[key].Player), Lootster_Adjust[key].Reason);
		end
	end

	return tooltip;
end

-- Update Raid UI handler
function Lootster_UpdateRaidUI()
	-- if we have loot linked, we will allow them to assign loot (Bank/Rotted) if we have a running boss
	if ((Lootster_ItemLink ~= nil) and (Lootster_Running.RaidId ~= nil) and (Lootster_Running.BossId ~= nil)) then
		-- allow loot assignment without roll
		Lootster_RollFrameAssignLoot:Enable();
	else
		-- disallow loot assignment
		Lootster_RollFrameAssignLoot:Disable();
	end

	-- any raids?
	if (table.getn(Lootster_RaidSort) == 0) then
		-- disable all raid reporting
		Lootster_RaidFrameReportFull:Disable();

		-- disable raid delete all
		Lootster_RaidFrameRaidFrameDeleteAll:Disable();
	else
		-- enable all raid reporting
		Lootster_RaidFrameReportFull:Enable();

		-- enable raid delete all
		Lootster_RaidFrameRaidFrameDeleteAll:Enable();
	end		

	-- determine state of raid/boss/attendance/adjustment buttons
	if	(Lootster_RaidId == nil) then
		-- disable raid reporting
		Lootster_RaidFrameReportRaid:Disable();

		-- disable raid modification and deletion
		Lootster_RaidFrameRaidFrameModify:Disable();
		Lootster_RaidFrameRaidFrameDelete:Disable();

		-- disable boss creation
		Lootster_RaidFrameBossFrameCreate:Disable();

		-- disable boss delete all
		Lootster_RaidFrameBossFrameDeleteAll:Disable();
	else
		-- enable raid reporting
		Lootster_RaidFrameReportRaid:Enable();

		-- enable raid modification
		Lootster_RaidFrameRaidFrameModify:Enable();

		-- is this the running raid?
		if (Lootster_RaidId == Lootster_Running.RaidId) then
			-- disable raid deletion
			Lootster_RaidFrameRaidFrameDelete:Disable();
		else
			-- enable raid deletion
			Lootster_RaidFrameRaidFrameDelete:Enable();
		end

		-- enable boss creation
		Lootster_RaidFrameBossFrameCreate:Enable();

		-- any bosses?
		if (table.getn(Lootster_Raid[Lootster_RaidId].BossSet) == 0) then
			Lootster_RaidFrameBossFrameDeleteAll:Disable();
		else
			Lootster_RaidFrameBossFrameDeleteAll:Enable();
		end		
	end

	if	(Lootster_BossId == nil) then
		-- disable boss reporting
		Lootster_RaidFrameReportBoss:Disable();

		-- disable boss modification and deletion
		Lootster_RaidFrameBossFrameModify:Disable();
		Lootster_RaidFrameBossFrameDelete:Disable();

		-- disable taking roster
		Lootster_RaidFrameBossAttendFrameUseRoster:Disable();

		-- disable attendance and adjustment creation
		Lootster_RaidFrameBossAttendFrameCreate:Disable();
		Lootster_RaidFrameBossAdjustFrameCreate:Disable();

		-- disable attendance and adjustment delete all
		Lootster_RaidFrameBossAttendFrameDeleteAll:Disable();
		Lootster_RaidFrameBossAdjustFrameDeleteAll:Disable();
	else
		-- enable boss reporting
		Lootster_RaidFrameReportBoss:Enable();

		-- enable boss modification
		Lootster_RaidFrameBossFrameModify:Enable();

		-- is this the running boss?
		if (Lootster_BossId == Lootster_Running.BossId) then
			-- disable boss deletion
			Lootster_RaidFrameBossFrameDelete:Disable();
		else
			-- enable boss deletion
			Lootster_RaidFrameBossFrameDelete:Enable();
		end

		-- enable taking roster
		Lootster_RaidFrameBossAttendFrameUseRoster:Enable();

		-- enable attendance and adjustment creation
		Lootster_RaidFrameBossAttendFrameCreate:Enable();
		Lootster_RaidFrameBossAdjustFrameCreate:Enable();

		-- any attendances?
		if (table.getn(Lootster_Boss[Lootster_BossId].AttendSet) == 0) then
			Lootster_RaidFrameBossAttendFrameDeleteAll:Disable();
		else
			Lootster_RaidFrameBossAttendFrameDeleteAll:Enable();
		end		

		-- any adjustments?
		if (table.getn(Lootster_Boss[Lootster_BossId].AdjustSet) == 0) then
			Lootster_RaidFrameBossAdjustFrameDeleteAll:Disable();
		else
			Lootster_RaidFrameBossAdjustFrameDeleteAll:Enable();
		end		
	end

	if	(Lootster_AttendId == nil) then
		-- disable attend modification and deletion
		Lootster_RaidFrameBossAttendFrameModify:Disable();
		Lootster_RaidFrameBossAttendFrameDelete:Disable();
	else
		-- enable attend modification and deletion
		Lootster_RaidFrameBossAttendFrameModify:Enable();
		Lootster_RaidFrameBossAttendFrameDelete:Enable();
	end

	if	(Lootster_AdjustId == nil) then
		-- disable adjust modification and deletion
		Lootster_RaidFrameBossAdjustFrameModify:Disable();
		Lootster_RaidFrameBossAdjustFrameDelete:Disable();
	else
		-- enable adjust modification and deletion
		Lootster_RaidFrameBossAdjustFrameModify:Enable();
		Lootster_RaidFrameBossAdjustFrameDelete:Enable();
	end

	-- deteremine which way we are raid viewing
	if		(Lootster_ViewRaidType == LOOTSTER_ENUM_VIEWRAID.BYATTEND) then
		-- hide boss adjustment frame
		Lootster_RaidFrameBossAdjustFrame:Hide();

		-- show boss attendance frame
		Lootster_RaidFrameBossAttendFrame:Show();

		-- make sure the attend scroll window is updated
		Lootster_Raid_Attend_Update();
	elseif	(Lootster_ViewRaidType == LOOTSTER_ENUM_VIEWRAID.BYADJUST) then
		-- hide boss attendance frame
		Lootster_RaidFrameBossAttendFrame:Hide();

		-- show boss adjustment frame
		Lootster_RaidFrameBossAdjustFrame:Show();

		-- make sure the adjust scroll window is updated
		Lootster_Raid_Adjust_Update();
	end
	
	-- update MiniMap buttons
	Lootster_MiniMapButton_SwitchState();
end

--  Raid Synchronise Click handler
function Lootster_Raid_Sync_OnClick()
	-- show the raid sync dialog
	Lootster_Popup_Show(Lootster_RaidSyncFrame);
end

--  Full Report Click handler
function Lootster_Raid_ReportFull_OnClick()
	-- hook the report write for the full report
	Lootster_ReportWriterCB = Lootster_WriteReportFull;
	
	-- and show the report
	Lootster_Popup_Show(Lootster_RaidFrameReportFrame);
end

--  Raid Report Click handler
function Lootster_Raid_ReportRaid_OnClick()
	-- hook the report write for the raid report
	Lootster_ReportWriterCB = Lootster_WriteReportRaid;
	
	-- and show the report
	Lootster_Popup_Show(Lootster_RaidFrameReportFrame);
end

--  Boss Report Click handler
function Lootster_Raid_ReportBoss_OnClick()
	-- hook the report write for the boss report
	Lootster_ReportWriterCB = Lootster_WriteReportBoss;
	
	-- and show the report
	Lootster_Popup_Show(Lootster_RaidFrameReportFrame);
end

-- Raid Raid Row Click handler
function Lootster_Raid_Raid_Button_OnClick()
	local	offset, key, tooltip;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameRaidFrameScrollFrame);

	-- calculate actual the raid item index and get the raid record key
	key = Lootster_RaidSort[this:GetID() + offset];

	-- if this is a different raid, snarf
	if (key ~= Lootster_RaidId) then
		-- snarf the new raid Id
		Lootster_RaidId = key;

		-- reset the current boss Id
		Lootster_BossId = nil;

		-- reset the current attend Id
		Lootster_AttendId = nil;

		-- reset the current adjust Id
		Lootster_AdjustId = nil;

		-- resort raid data using current sort
		Lootster_Raid_Raid_Sort(nil);

		-- resort boss data using current sort
		Lootster_Raid_Boss_Sort(nil);

		-- resort attendance data using current sort
		Lootster_Raid_Attend_Sort(nil);

		-- resort adjustment data using current sort
		Lootster_Raid_Adjust_Sort(nil);

		-- update the raid UI
		Lootster_UpdateRaidUI();
	end
end

-- Raid Create Raid handler
function Lootster_Raid_Raid_Create_OnClick()
	local	zone, wowId, dateExp;

	-- get the zone name (instance name if appropriate)
	zone = GetRealZoneText();

	-- determine the WoW instance id and instance reset date
	wowId, dateExp = Lootster_GetInstanceId(zone);

	-- hide outstanding dialog, if any
	Lootster_Popup_Show();

	-- instantiate a new raid record
	Lootster_RaidRec = Lootster_NewRaid(zone, wowId, Lootster_CalcServerTime(time()), dateExp);

	-- and show the raid dialog
	Lootster_Popup_Show(Lootster_RaidFrameRaidFrame);
end

-- Raid Modify Raid handler
function Lootster_Raid_Raid_Modify_OnClick()
	-- make sure we have a raid selected
	if (Lootster_RaidId == nil) then
		return;
	end

	-- hide outstanding dialog, if any
	Lootster_Popup_Show();

	-- copy the raid record
	Lootster_RaidRec = Lootster_CopyRecord(Lootster_Raid[Lootster_RaidId]);

	-- and show the raid dialog
	Lootster_Popup_Show(Lootster_RaidFrameRaidFrame);
end

-- Raid Delete Raid Click handler
function Lootster_Raid_Raid_Delete_OnClick()
	-- make sure we have a raid selected
	if (Lootster_RaidId == nil) then
		return;
	end

	-- copy the raid record
	Lootster_RaidRec = Lootster_CopyRecord(Lootster_Raid[Lootster_RaidId]);

	-- and show delete dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_RAID_DELETE");
end

-- Raid Delete Raid Accept handler
function Lootster_Raid_Raid_Delete_OnAccept()
	local wowIdOrg, dateExpOrg;

	-- no raid record we are done
	if (Lootster_RaidRec == nil) then
		return;
	end

	-- see if we have a valid modified instance id and reset date
	if (Lootster_RaidRec.WoWId ~= nil) then
		-- snarf as set, if any
		wowIdMod = Lootster_RaidRec.WoWId;

		if (Lootster_RaidRec.DateExp ~= nil) then
            dateExpMod = Lootster_FormatServerTime(Lootster_RaidRec.DateExp);
		else
		    dateExpMod = LOOTSTER_RAIDRAID_NODATEEXP;
		end
	else
		-- reset
		wowIdMod = LOOTSTER_RAIDRAID_NOWOWID;
		dateExpMod = LOOTSTER_RAIDRAID_NODATEEXP;
	end

	-- let them know
	Lootster_SendBroadcast(string.format(LOOTSTER_MSG_RAIDDELETED, Lootster_RaidRec.Zone, wowIdMod, Lootster_FormatServerTime(Lootster_RaidRec.DateOpn), dateExpMod));

	-- delete this raid record
	Lootster_DeleteRaid(Lootster_RaidRec.Id);

	-- if this was the running raid, reset
	if (Lootster_RaidId == Lootster_Running.RaidId) then
		-- no running raid
		Lootster_Running.RaidId = nil;

		-- no running boss
		Lootster_Running.BossId = nil;
	end

	-- get the next raid id
	Lootster_RaidId = Lootster_GetNextId(Lootster_RaidSort, Lootster_RaidRec.Id);

	-- reset the current boss Id
	Lootster_BossId = nil;
	
	-- reset the current attend Id
	Lootster_AttendId = nil;
	
	-- reset the current adjust Id
	Lootster_AdjustId = nil;

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);

	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);
	
	-- resort adjust data using current sort
	Lootster_Raid_Adjust_Sort(nil);

	-- reset raid record
	Lootster_RaidRec = nil;

	-- could our DKP change?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- update our roll text
		Lootster_UpdateRoll();
	end

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Delete Raid Cancel handler
function Lootster_Raid_Raid_Delete_OnCancel()
	-- reset raid record
	Lootster_RaidRec = nil;
end

-- Raid Delete ALL Raid handler
function Lootster_Raid_Raid_DeleteAll_OnClick()
	-- make sure we have some raids
	if (table.getn(Lootster_RaidSort) == 0) then
		return;
	end

	-- and show delete ALL dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_RAID_DELETEALL");
end

-- Raid Delete ALL Raid Accept handler
function Lootster_Raid_Raid_DeleteAll_OnAccept()
	-- delete all raids
	Lootster_DeleteAllRaid();

	-- let them know
	Lootster_SendBroadcast(LOOTSTER_MSG_RAIDDELETEDALL);

	-- reset id seed
	Lootster_Id = 1;

	-- reset the current raid id
	Lootster_RaidId = nil;

	-- reset the current boss Id
	Lootster_BossId = nil;
	
	-- reset the current attend Id
	Lootster_AttendId = nil;
	
	-- reset the current adjust Id
	Lootster_AdjustId = nil;
	
	-- reset running raid
	Lootster_Running.RaidId = nil;

	-- reset running boss
	Lootster_Running.BossId = nil;

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);

	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);
	
	-- resort adjust data using current sort
	Lootster_Raid_Adjust_Sort(nil);

	-- could our DKP change?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- update our roll text
		Lootster_UpdateRoll();
	end

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Show Raid handler
function Lootster_Raid_Raid_OnShow()
	local	opCode;
	
	-- no raid record means we are done
	if (Lootster_RaidRec == nil) then
		-- rehide frame
		Lootster_RaidFrameRaidFrame:Hide();
	else
		-- set prompts for player depending on operation
		if (Lootster_RaidRec.Id == nil) then
			opCode = LOOTSTER_RAID_INSERT;
		else
			opCode = LOOTSTER_RAID_MODIFY;
		end

		-- format and set raid operation
		Lootster_RaidFrameRaidFrameText:SetText(string.format(LOOTSTER_RAIDRAID_TITLE, opCode));
		Lootster_RaidFrameRaidFrameApply:SetText(string.format(LOOTSTER_RAIDRAID_APPLY, opCode));

		-- raid zone
		Lootster_RaidFrameRaidFrameZone:SetText(Lootster_RaidRec.Zone);

		-- is this the running guy?
		if ((Lootster_RaidRec.Id == nil) or (Lootster_RaidRec.Id == Lootster_Running.RaidId)) then
			-- this is or will be the running raid
			Lootster_RaidFrameRaidFrameRunning:SetChecked(true);
		else
			-- not to be running raid
			Lootster_RaidFrameRaidFrameRunning:SetChecked(false);
		end
		
		-- see if instance information updated
		Lootster_CheckInstanceInfo(Lootster_RaidRec);

		-- WoW instance id
		Lootster_RaidFrameRaidFrameWoWId:SetText(Lootster_RaidRec.WoWId);

		-- begin and reset dates
		Lootster_SetDateTime(Lootster_RaidFrameRaidFrameDateOpn, Lootster_RaidRec.DateOpn, Lootster_Raid_Raid_DateOpn_Entered);
		Lootster_SetDateTime(Lootster_RaidFrameRaidFrameDateExp, Lootster_RaidRec.DateExp);

		-- update comment
		Lootster_RaidFrameRaidFrameCommentText:SetText(Lootster_RaidRec.Comment);

		-- update raid raid UI
		Lootster_RaidRaidUpdateUI();
	end
end

-- Hide Raid handler
function Lootster_Raid_Raid_OnHide()
	-- default operation code
	Lootster_RaidFrameRaidFrameText:SetText(LOOTSTER_RAIDRAID_TITLE);
	Lootster_RaidFrameRaidFrameApply:SetText(LOOTSTER_RAIDRAID_APPLY);

	-- no raid zone
	Lootster_RaidFrameRaidFrameZone:SetText("");
	
	-- reset running raid
	Lootster_RaidFrameRaidFrameRunning:SetChecked(false);

	-- no WoW instance id
	Lootster_RaidFrameRaidFrameWoWId:SetText("");

	-- no begin or reset dates
	Lootster_SetDateTime(Lootster_RaidFrameRaidFrameDateOpn, nil, Lootster_Raid_Raid_DateOpn_Entered);
	Lootster_SetDateTime(Lootster_RaidFrameRaidFrameDateExp, nil);

	-- reset raid comment
	Lootster_RaidFrameRaidFrameCommentText:SetText("\n");

	-- smoke raid record
	Lootster_RaidRec = nil;
end

-- Raid Raid Zone handler
function Lootster_Raid_Raid_Zone_Entered()
	-- update raid raid UI
	Lootster_RaidRaidUpdateUI();
end

-- Raid Raid Use Here handler
function Lootster_Raid_Raid_UseHere_OnClick()
	-- make raid the current zone
	Lootster_RaidFrameRaidFrameZone:SetText(GetRealZoneText());

	-- update raid raid UI
	Lootster_RaidRaidUpdateUI();
end

-- Raid Raid Running handler
function Lootster_Raid_Raid_Running_Toggle()
end

-- Raid Raid Date Open Change handler
function Lootster_Raid_Raid_DateOpn_Entered()
	-- update raid raid UI
	Lootster_RaidRaidUpdateUI();
end

-- Raid Raid Comment handler
function Lootster_Raid_Raid_Comment_TextChanged()
end

-- Raid Raid Apply handler
function Lootster_Raid_Apply_OnClick()
	local wowIdOrg, dateExpOrg, wowIdMod, dateExpMod, raidId;

	-- no raid record we are done
	if (Lootster_RaidRec == nil) then
		return;
	end

	-- retrieve data
	Lootster_RaidRec.Zone = Lootster_RaidFrameRaidFrameZone:GetText();
	Lootster_RaidRec.DateOpn = Lootster_GetDateTime(Lootster_RaidFrameRaidFrameDateOpn);
	Lootster_RaidRec.Comment = Lootster_AppendTrailingLineBreak(Lootster_RaidFrameRaidFrameCommentText:GetText());

	-- see if we have a valid modified instance id and reset date
	if (Lootster_RaidRec.WoWId ~= nil) then
		-- snarf as set, if any
		wowIdMod = Lootster_RaidRec.WoWId;

		if (Lootster_RaidRec.DateExp ~= nil) then
            dateExpMod = Lootster_FormatServerTime(Lootster_RaidRec.DateExp);
		else
		    dateExpMod =LOOTSTER_RAIDRAID_NODATEEXP;
		end
	else
		-- reset
		wowIdMod = LOOTSTER_RAIDRAID_NOWOWID;
		dateExpMod = LOOTSTER_RAIDRAID_NODATEEXP;
	end

	-- are we creating or modifying a raid record?
	if (Lootster_RaidRec.Id == nil) then
		-- let players know a raid was created
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_RAIDCREATED, Lootster_RaidRec.Zone, wowIdMod, Lootster_FormatServerTime(Lootster_RaidRec.DateOpn), dateExpMod));

		-- create raid
		raidId = Lootster_CreateRaid(Lootster_RaidRec);
	else
		-- see if we have a valid original instance id and reset date
		if (Lootster_RaidRec.Id ~= nil) then
			-- snarf as set
			if (Lootster_Raid[Lootster_RaidRec.Id].WoWId ~= nil) then
	            wowIdOrg = Lootster_Raid[Lootster_RaidRec.Id].WoWId;
			else
			    wowIdOrg = LOOTSTER_RAIDRAID_NOWOWID;
			end

			if (Lootster_Raid[Lootster_RaidRec.Id].DateExp ~= nil) then
	            dateExpOrg = Lootster_FormatServerTime(Lootster_Raid[Lootster_RaidRec.Id].DateExp);
			else
			    dateExpOrg = LOOTSTER_RAIDRAID_NODATEEXP;
			end
		else
			-- reset
			wowIdOrg = LOOTSTER_RAIDRAID_NOWOWID;
			dateExpOrg = LOOTSTER_RAIDRAID_NODATEEXP;
		end

		-- let players know a raid was modified
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_RAIDCHANGED, Lootster_RaidRec.Zone, wowIdMod, Lootster_FormatServerTime(Lootster_RaidRec.DateOpn), dateExpMod, Lootster_Raid[Lootster_RaidRec.Id].Zone, wowIdOrg, Lootster_FormatServerTime(Lootster_Raid[Lootster_RaidRec.Id].DateOpn), dateExpOrg));

		-- modify the raid
		Lootster_ModifyRaid(Lootster_RaidRec);
	end

	-- retrieve raid Id as necessary
	if (raidId == nil) then
		-- retrieve raid Id
		raidId = Lootster_RaidRec.Id;
	end
	
	-- are we making this the running raid?
	if (Lootster_RaidFrameRaidFrameRunning:GetChecked() ~= nil) then
		-- did the running raid change?
		if (Lootster_Running.RaidId ~= raidId) then
			-- make this guy the running raid
			Lootster_Running.RaidId = raidId;

			-- reset running boss
			Lootster_Running.BossId = nil;
		end
	else
		-- are we reseting the running raid?
		if (Lootster_Running.RaidId == raidId) then
			-- reset the currently running raid
			Lootster_Running.RaidId = nil;

			-- reset the currently running boss
			Lootster_Running.BossId = nil;
		end
	end		

	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- reset raid record
	Lootster_RaidRec = nil;

	-- hide the UI
	Lootster_RaidFrameRaidFrame:Hide();

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Raid Cancel handler
function Lootster_Raid_Cancel_OnClick()
	-- smoke raid record
	Lootster_RaidRec = nil;
end

-- Raid Raid Update UI handler
function Lootster_RaidRaidUpdateUI()
	local	dateOpnP, dateOpnT, dateOpnF;
	
	-- determine if open date fully entered
	dateOpnP, dateOpnT, dateOpnF = Lootster_IsDateTimePartial(Lootster_RaidFrameRaidFrameDateOpn);
	
	-- enable raid button if zone entered and open date fully entered
	if ((Lootster_RaidFrameRaidFrameZone:GetText() == "") and (dateOpnT ~= true)) then
		Lootster_RaidFrameRaidFrameApply:Disable();
	else
		Lootster_RaidFrameRaidFrameApply:Enable();
	end
end

-- Raid Boss Row Click handler
function Lootster_Raid_Boss_Button_OnClick(key)
	local	offset, tooltip;

	-- if no key passed, retrieve
	if (key == nil) then
		-- retrieve the scroll offset
		offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossFrameScrollFrame);

		-- calculate actual the boss item index and get the boss record key
		key = Lootster_BossSort[this:GetID() + offset];
	end

	-- update the key
	Lootster_BossId = key;

	-- reset attend and adjust Id
	Lootster_AttendId = nil;
	Lootster_AdjustId = nil;

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- depending on what was the current item before, sort attendance/adjustment
	if		(Lootster_ViewRaidType == LOOTSTER_ENUM_VIEWRAID.BYATTEND) then
		-- resort attendance data using current sort
		Lootster_Raid_Attend_Sort(nil);
	elseif	(Lootster_ViewRaidType == LOOTSTER_ENUM_VIEWRAID.BYADJUST) then
		-- resort attedance data using current sort
		Lootster_Raid_Adjust_Sort(nil);
	end

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Boss Run Click handler
function Lootster_Raid_Boss_Run_Toggle()
	local	offset, bossId;
	
	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossFrameScrollFrame);

	-- calculate actual the boss item index and get the boss record key
	bossId = Lootster_BossSort[this:GetParent():GetID() + offset];
	
	-- did the running boss change?
	if (Lootster_Running.BossId ~= bossId) then
		-- make sure we have the correct running raid
		Lootster_Running.RaidId = Lootster_Boss[bossId].RaidId;

		-- make this guy the running boss
		Lootster_Running.BossId = bossId;
		
		-- see if instance information updated
		Lootster_CheckInstanceInfo();
	else
		-- reset the currently running boss
		Lootster_Running.BossId = nil;
	end

	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);
	
	-- resort adjust data using current sort
	Lootster_Raid_Adjust_Sort(nil);

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Boss Attend Click handler
function Lootster_Raid_Boss_Attend_OnClick()
	local	offset;

	-- first, flip raid view mode to attendance
	Lootster_ViewRaidType = LOOTSTER_ENUM_VIEWRAID.BYATTEND;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossFrameScrollFrame);

	-- and set the current boss to the one pressed
	Lootster_Raid_Boss_Button_OnClick(Lootster_BossSort[this:GetParent():GetID() + offset]);
	
	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Boss Adjust Click handler
function Lootster_Raid_Boss_Adjust_OnClick()
	local	offset;

	-- first, flip raid view mode to adjustment
	Lootster_ViewRaidType = LOOTSTER_ENUM_VIEWRAID.BYADJUST;
	
	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossFrameScrollFrame);
	
	-- and set the current boss to the one pressed
	Lootster_Raid_Boss_Button_OnClick(Lootster_BossSort[this:GetParent():GetID() + offset]);
	
	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Create Boss handler
function Lootster_Raid_Boss_Create_OnClick()
	local	boss, name, tbd, mobkey, mobsRec;

	-- no raid we are done
	if (Lootster_RaidId == nil) then
		return;
	end

	-- get the boss name
	_, boss = Lootster_HasRaidBossChanged();

	-- not a real boss then we need to fake one
	if (boss == nil) then
		-- use To Be Determined boss initially
		boss = LOOTSTER_RAIDBOSS_TBD;

		-- have we a running raid?
		if (Lootster_Running.RaidId ~= nil) then
			-- use raid zone as the partial lookup
			name = string.lower(Lootster_Raid[Lootster_Running.RaidId].Zone);

			-- hammer through mob list looking for first one with the zone name in it
			for mobkey, mobsRec in pairs(Lootster_MobsDKP) do
				-- does this mob match the passed name
				if (string.find(mobsRec.Name, name) ~= nil) then
					-- right, you'll do!
					boss = mobsRec.Name;

					break;
				end
			end
		end

		-- boss is TBD
		tbd = true;
	else
		tbd = false;
	end

	-- hide outstanding dialog, if any
	Lootster_Popup_Show();

	-- instantiate a new boss record
	Lootster_BossRec = Lootster_NewBoss(boss, Lootster_CalcServerTime(time()), tbd);

	-- and show the boss dialog
	Lootster_Popup_Show(Lootster_RaidFrameBossFrame);
end

-- Raid Modify Boss handler
function Lootster_Raid_Boss_Modify_OnClick()
	-- make sure we have a boss selected
	if (Lootster_BossId == nil) then
		return;
	end

	-- hide outstanding dialog, if any
	Lootster_Popup_Show();

	-- copy the boss record
	Lootster_BossRec = Lootster_CopyRecord(Lootster_Boss[Lootster_BossId]);

	-- and show the boss dialog
	Lootster_Popup_Show(Lootster_RaidFrameBossFrame);
end

-- Raid Delete Boss Click handler
function Lootster_Raid_Boss_Delete_OnClick()
	-- make sure we have a boss selected
	if (Lootster_BossId == nil) then
		return;
	end

	-- copy the boss record
	Lootster_BossRec = Lootster_CopyRecord(Lootster_Boss[Lootster_BossId]);

	-- and show delete dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_BOSS_DELETE");
end

-- Raid Delete Boss Accept handler
function Lootster_Raid_Boss_Delete_OnAccept()
	local	dateEndOrg;
	
	-- no boss record we are done
	if (Lootster_BossRec == nil) then
		return;
	end

	-- do we have an end date?
	if (Lootster_BossRec.DateEnd ~= nil) then
		dateEndOrg = Lootster_FormatServerTime(Lootster_BossRec.DateEnd);
	else
		dateEndOrg = LOOTSTER_RAIDBOSS_NODATEEND;
	end

	-- let them know
	Lootster_SendBroadcast(string.format(LOOTSTER_MSG_BOSSDELETED, Lootster_BossRec.Boss, Lootster_FormatServerTime(Lootster_BossRec.DateBeg), dateEndOrg));

	-- delete this boss record
	Lootster_DeleteBoss(Lootster_BossRec.Id);

	-- if this was the running boss, reset
	if (Lootster_BossId == Lootster_Running.BossId) then
		-- no running boss
		Lootster_Running.BossId = nil;
	end

	-- get the next boss id
	Lootster_BossId = Lootster_GetNextId(Lootster_BossSort, Lootster_BossRec.Id);

	-- reset the current attend Id
	Lootster_AttendId = nil;
	
	-- reset the current adjust Id
	Lootster_AdjustId = nil;

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);

	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);
	
	-- resort adjust data using current sort
	Lootster_Raid_Adjust_Sort(nil);

	-- reset boss record
	Lootster_BossRec = nil;

	-- could our DKP change?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- update our roll text
		Lootster_UpdateRoll();
	end

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Delete Boss Cancel handler
function Lootster_Raid_Boss_Delete_OnCancel()
	-- reset boss record
	Lootster_BossRec = nil;
end

-- Raid Delete ALL Boss handler
function Lootster_Raid_Boss_DeleteAll_OnClick()
	-- make sure we have some bosses
	if ((Lootster_RaidId == nil) or (table.getn(Lootster_BossSort) == 0)) then
		return;
	end

	-- copy the first boss record so we retain the selected raid id if they switch raids on us
	Lootster_BossRec = Lootster_CopyRecord(Lootster_Boss[Lootster_BossSort[1]]);

	-- and show delete ALL dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_BOSS_DELETEALL");
end

-- Raid Delete ALL Boss handler
function Lootster_Raid_Boss_DeleteAll_OnAccept()
	-- no boss record we are done
	if (Lootster_BossRec == nil) then
		return;
	end
	
	-- delete all bosss
	Lootster_DeleteAllBoss(Lootster_BossRec.RaidId);

	-- let them know
	Lootster_SendBroadcast(string.format(LOOTSTER_MSG_BOSSDELETEDALL, Lootster_Raid[Lootster_BossRec.RaidId].Zone));

	-- reset the current boss Id
	Lootster_BossId = nil;
	
	-- reset the current attend Id
	Lootster_AttendId = nil;
	
	-- reset the current adjust Id
	Lootster_AdjustId = nil;

	-- no running boss
	Lootster_Running.BossId = nil;

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);

	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);
	
	-- resort adjust data using current sort
	Lootster_Raid_Adjust_Sort(nil);
	
	-- reset boss record
	Lootster_BossRec = nil;

	-- could our DKP change?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- update our roll text
		Lootster_UpdateRoll();
	end

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Delete ALL Boss Cancel handler
function Lootster_Raid_Boss_DeleteAll_OnCancel()
	-- reset boss record
	Lootster_BossRec = nil;
end

-- Show Boss handler
function Lootster_Raid_Boss_OnShow()
	local	opCode;

	-- no boss record means we are done
	if (Lootster_BossRec == nil) then
		-- rehide frame
		Lootster_RaidFrameBossFrame:Hide();
	else
		-- set prompts for player depending on operation
		if (Lootster_BossRec.Id == nil) then
			opCode = LOOTSTER_RAID_INSERT;
		else
			opCode = LOOTSTER_RAID_MODIFY;
		end

		-- format and set boss operation
		Lootster_RaidFrameBossFrameText:SetText(string.format(LOOTSTER_RAIDBOSS_TITLE, opCode));
		Lootster_RaidFrameBossFrameApply:SetText(string.format(LOOTSTER_RAIDBOSS_APPLY, opCode));

		-- boss
		Lootster_RaidFrameBossFrameBoss:SetText(Lootster_BossRec.Boss);

		-- is this the running guy?
		if ((Lootster_BossRec.Id == nil) or (Lootster_BossRec.Id == Lootster_Running.BossId)) then
			-- this is or will be the running boss
			Lootster_RaidFrameBossFrameRunning:SetChecked(true);
		else
			-- not to be running boss
			Lootster_RaidFrameBossFrameRunning:SetChecked(false);
		end

		-- begin and end dates
		Lootster_SetDateTime(Lootster_RaidFrameBossFrameDateBeg, Lootster_BossRec.DateBeg, Lootster_Raid_Boss_DateBeg_Entered);
		Lootster_SetDateTime(Lootster_RaidFrameBossFrameDateEnd, Lootster_BossRec.DateEnd, Lootster_Raid_Boss_DateEnd_Entered);

		-- update raid boss UI
		Lootster_RaidBossUpdateUI();
	end
end

-- Hide Boss handler
function Lootster_Raid_Boss_OnHide()
	-- default operation code
	Lootster_RaidFrameBossFrameText:SetText(LOOTSTER_RAIDBOSS_TITLE);
	Lootster_RaidFrameBossFrameApply:SetText(LOOTSTER_RAIDBOSS_APPLY);

	-- no boss
	Lootster_RaidFrameBossFrameBoss:SetText("");
	
	-- reset running boss
	Lootster_RaidFrameBossFrameRunning:SetChecked(false);

	-- no begin or end dates
	Lootster_SetDateTime(Lootster_RaidFrameBossFrameDateBeg, nil, Lootster_Raid_Boss_DateBeg_Entered);
	Lootster_SetDateTime(Lootster_RaidFrameBossFrameDateEnd, nil, Lootster_Raid_Boss_DateEnd_Entered);

	-- smoke boss record
	Lootster_BossRec = nil;
end

-- Raid Boss Boss handler
function Lootster_Raid_Boss_Boss_Entered()
	-- update raid boss UI
	Lootster_RaidBossUpdateUI();
end

-- Raid Boss Make TDB handler
function Lootster_Raid_Boss_MakeTBD_OnClick()
	-- make the boss TDB
	Lootster_RaidFrameBossFrameBoss:SetText(LOOTSTER_RAIDBOSS_TBD);

	-- update raid boss UI
	Lootster_RaidBossUpdateUI();
end

-- Raid Boss Use Target handler
function Lootster_Raid_Boss_UseTarget_OnClick()
	-- have we a target and it is an enemy?
	if ((UnitExists("target") == nil) or (UnitIsEnemy("target", "player") == nil)) then
		return;
	end

	-- make the target the boss
	Lootster_RaidFrameBossFrameBoss:SetText(UnitName("target"));

	-- update raid boss UI
	Lootster_RaidBossUpdateUI();
end

-- Raid Boss Running handler
function Lootster_Raid_Boss_Running_Toggle()
end

-- Raid Boss Date Begin Change handler
function Lootster_Raid_Boss_DateBeg_Entered()
	-- update raid boss UI
	Lootster_RaidBossUpdateUI();
end

-- Raid Boss Date End Change handler
function Lootster_Raid_Boss_DateEnd_Entered()
	-- update raid boss UI
	Lootster_RaidBossUpdateUI();
end

-- Raid Boss Apply handler
function Lootster_Boss_Apply_OnClick()
	local raidId, player, bossId, tbd, dateEndOrg, dateEndMod;

	-- no boss record  we are done
	if (Lootster_BossRec == nil) then
		return;
	end
	
	-- use boss record raid if present
	if (Lootster_BossRec.RaidId ~= nil) then
		-- use this raid id
		raidId = Lootster_BossRec.RaidId;
	else
		-- use selected raid
		raidId = Lootster_RaidId;
	end

	-- no raid id we are done
	if (raidId == nil) then
		return;
	end
	
	-- retrieve data
	Lootster_BossRec.Boss = Lootster_RaidFrameBossFrameBoss:GetText();
	Lootster_BossRec.DateBeg = Lootster_GetDateTime(Lootster_RaidFrameBossFrameDateBeg);
	Lootster_BossRec.DateEnd = Lootster_GetDateTime(Lootster_RaidFrameBossFrameDateEnd);

	-- do we have a modified end date?
	if (Lootster_BossRec.DateEnd ~= nil) then
		dateEndMod = Lootster_FormatServerTime(Lootster_BossRec.DateEnd);
	else
		dateEndMod = LOOTSTER_RAIDBOSS_NODATEEND;
	end
	
	-- has the boss been set to TBD?
	if (Lootster_BossRec.Boss == LOOTSTER_RAIDBOSS_TBD) then
		-- mark as TBD
		Lootster_BossRec.TBD = true;
	end

	-- are we creating or modifying a boss record?
	if (Lootster_BossRec.Id == nil) then
		-- let players know a boss was created
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_BOSSCREATED, Lootster_BossRec.Boss, Lootster_FormatServerTime(Lootster_BossRec.DateBeg), dateEndMod));

		-- create the boss
		bossId = Lootster_CreateBoss(Lootster_BossRec);

		-- and insert boss into raid
		Lootster_InsertBoss(raidId, bossId);
	else
		-- do we have a modified end date?
		if (Lootster_Boss[Lootster_BossRec.Id].DateEnd ~= nil) then
			dateEndOrg = Lootster_FormatServerTime(Lootster_Boss[Lootster_BossRec.Id].DateEnd);
		else
			dateEndOrg = LOOTSTER_RAIDBOSS_NODATEEND;
		end
	
		-- let players know a boss was modified
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_BOSSCHANGED, Lootster_BossRec.Boss, Lootster_FormatServerTime(Lootster_BossRec.DateBeg), dateEndMod, Lootster_Boss[Lootster_BossRec.Id].Boss, Lootster_FormatServerTime(Lootster_Boss[Lootster_BossRec.Id].DateBeg), dateEndOrg));

		-- modify the boss
		Lootster_ModifyBoss(Lootster_BossRec);
	end

	-- retrieve boss Id as necessary
	if (bossId == nil) then
		-- retrieve boss Id
		bossId = Lootster_BossRec.Id;
	end

	-- are we making this the running boss?
	if (Lootster_RaidFrameBossFrameRunning:GetChecked() ~= nil) then
		-- did the running boss change?
		if (Lootster_Running.BossId ~= bossId) then
			-- make sure we have the correct running raid
			Lootster_Running.RaidId = raidId;

			-- make this guy the running boss
			Lootster_Running.BossId = bossId;
		end
	else
		-- are we reseting the running boss?
		if (Lootster_Running.BossId == bossId) then
			-- reset the currently running boss
			Lootster_Running.BossId = nil;
		end
	end		

	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- reset boss record
	Lootster_BossRec = nil;

	-- hide the UI
	Lootster_RaidFrameBossFrame:Hide();

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Boss Cancel handler
function Lootster_Boss_Cancel_OnClick()
	-- smoke boss record
	Lootster_BossRec = nil;
end

-- Raid Boss Update UI handler
function Lootster_RaidBossUpdateUI()
	local	dateBegP, dateBegT, dateBegF, dateEndP, dateEndT, dateEndF;

	-- have we a target and it is an enemy?
	if ((UnitExists("target") == nil) or (UnitIsEnemy("target", "player") == nil)) then
		Lootster_RaidFrameBossFrameUseTarget:Disable();
	else
		Lootster_RaidFrameBossFrameUseTarget:Enable();
	end
	
	-- determine if begin and end date fully entered
	dateOpnP, dateOpnT, dateOpnF = Lootster_IsDateTimePartial(Lootster_RaidFrameBossFrameDateBeg);
	dateEndP, dateEndT, dateEndF = Lootster_IsDateTimePartial(Lootster_RaidFrameBossFrameDateEnd);
	
	-- enable boss button if boss entered, begin date is fully entered and end date is not partially entered
	if ((Lootster_RaidFrameBossFrameBoss:GetText() == "") or (dateOpnT ~= true) or (dateEndP == true)) then
		Lootster_RaidFrameBossFrameApply:Disable();
	else
		Lootster_RaidFrameBossFrameApply:Enable();
	end
end

-- Raid Attend Row Click handler
function Lootster_Raid_Attend_Button_OnClick()
	local	offset, key, tooltip;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossAttendFrameScrollFrame);

	-- calculate actual the attend item index and get the attend record key
	key = Lootster_AttendSort[this:GetID() + offset];

	-- if this is a different attend, snarf
	if (key ~= Lootster_AttendId) then
		-- snarf the new attendance Id
		Lootster_AttendId = key;

		-- resort attend data using current sort
		Lootster_Raid_Attend_Sort(nil);

		-- update the raid UI
		Lootster_UpdateRaidUI();
	end
end

-- Raid Take Attendance handler
function Lootster_Raid_Attend_UseRoster_OnClick()
	-- no raid or boss id  we are done
	if ((Lootster_RaidId == nil) or (Lootster_BossId == nil)) then
		return;
	end

	-- do we have attendance so far?
	if (table.getn(Lootster_Boss[Lootster_BossId].AttendSet) == 0) then
		-- take attendance, no missing (so all full raid)
		Lootster_TakeAttendance(Lootster_BossId, LOOTSTER_ENUM_ATTENDED.FULL);
	else
		-- take attendance, marking missing as partials
		Lootster_TakeAttendance(Lootster_BossId, LOOTSTER_ENUM_ATTENDED.PARTIAL);
	end
end

-- Raid Create Attend handler
function Lootster_Raid_Attend_Create_OnClick()
	-- no raid or boss id  we are done
	if ((Lootster_RaidId == nil) or (Lootster_BossId == nil)) then
		return;
	end

	-- hide outstanding dialog, if any
	Lootster_Popup_Show();

	-- create an attendance record
	Lootster_AttendRec = Lootster_NewAttend(nil, nil, LOOTSTER_ENUM_ATTENDED.FULL);

	-- and show the attend dialog
	Lootster_Popup_Show(Lootster_RaidFrameAttendFrame);
end

-- Raid Modify Attend handler
function Lootster_Raid_Attend_Modify_OnClick()
	-- make sure we have a attendance selected
	if (Lootster_AttendId == nil) then
		return;
	end

	-- hide outstanding dialog, if any
	Lootster_Popup_Show();

	-- copy the attendance record
	Lootster_AttendRec = Lootster_CopyRecord(Lootster_Attend[Lootster_AttendId]);

	-- and show the attend dialog
	Lootster_Popup_Show(Lootster_RaidFrameAttendFrame);
end

-- Raid Delete Attend Click handler
function Lootster_Raid_Attend_Delete_OnClick()
	-- make sure we have a attendance selected
	if (Lootster_AttendId == nil) then
		return;
	end

	-- copy the attendance record
	Lootster_AttendRec = Lootster_CopyRecord(Lootster_Attend[Lootster_AttendId]);

	-- and show delete dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_ATTEND_DELETE");
end

-- Raid Delete Attend Accept handler
function Lootster_Raid_Attend_Delete_OnAccept()
	local	player;
	
	-- no attendance record we are done
	if (Lootster_AttendRec == nil) then
		return;
	end
	
	-- get the alt for this player
	player = Lootster_GetMainALT(Lootster_AttendRec.Player);

	-- let player know their DKP was changed if they are on roster
	if (Lootster_Roster[player] ~= nil) then
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ATTENDDELETED, LOOTSTER_DATA_ATTENDEDLIST[Lootster_AttendRec.Attended]));
	end

	-- delete this attendance record
	Lootster_DeleteAttend(Lootster_AttendRec.Id);
	
	-- get the next attend id
	Lootster_AttendId = Lootster_GetNextId(Lootster_AttendSort, Lootster_AttendRec.Id);

	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);
	
	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attend data using current sort
	Lootster_Raid_Attend_Sort(nil);

	-- reset attend record
	Lootster_AttendRec = nil;

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Delete Attend Cancel handler
function Lootster_Raid_Attend_Delete_OnCancel()
	-- reset attend record
	Lootster_AttendRec = nil;
end

-- Raid Delete ALL Attend handler
function Lootster_Raid_Attend_DeleteAll_OnClick()
	-- make sure we have some attendances
	if ((Lootster_RaidId == nil) or (Lootster_BossId == nil) or (table.getn(Lootster_AttendSort) == 0)) then
		return;
	end

	-- copy the first attendance record so we retain the selected boss id if they switch bosses on us
	Lootster_AttendRec = Lootster_CopyRecord(Lootster_Attend[Lootster_AttendSort[1]]);

	-- and show delete ALL dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_ATTEND_DELETEALL");
end

-- Raid Delete ALL Attend handler
function Lootster_Raid_Attend_DeleteAll_OnAccept()
	-- no attendance record we are done
	if (Lootster_AttendRec == nil) then
		return;
	end
	
	-- delete all attendances from the boss
	Lootster_DeleteAllAttend(Lootster_AttendRec.BossId);
	
	-- let them know
	Lootster_SendBroadcast(string.format(LOOTSTER_MSG_ATTENDDELETEDALL, Lootster_Raid[Lootster_Boss[Lootster_AttendRec.BossId].RaidId].Zone, Lootster_Boss[Lootster_AttendRec.BossId].Boss));

	-- smoke the current attend id
	Lootster_AttendId = nil;
	
	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);
	
	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attend data using current sort
	Lootster_Raid_Attend_Sort(nil);

	-- reset attend record
	Lootster_AttendRec = nil;

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Delete ALL Attend Cancel handler
function Lootster_Raid_Attend_DeleteAll_OnCancel()
	-- reset attend record
	Lootster_AttendRec = nil;
end

-- Raid Attend DKP handler
function Lootster_Raid_Attend_OnShow()
	local	opCode;

	-- no attendance record or boss means we are done
	if ((Lootster_AttendRec == nil) or ((Lootster_BossId == nil) and (Lootster_AttendRec.BossId == nil))) then
		-- rehide frame
		Lootster_RaidFrameAttendFrame:Hide();
	else
		-- set prompts for player depending on operation
		if (Lootster_AttendRec.Id == nil) then
			opCode = LOOTSTER_RAID_INSERT;
		else
			opCode = LOOTSTER_RAID_MODIFY;
		end

		-- format and set attendance operation
		Lootster_RaidFrameAttendFrameText:SetText(string.format(LOOTSTER_RAIDATTEND_TITLE, opCode));
		Lootster_RaidFrameAttendFrameApply:SetText(string.format(LOOTSTER_RAIDATTEND_APPLY, opCode));
	
		-- update attendance
		Lootster_Raid_Attend_RadioButton_OnClick(nil);
	end
end

-- Hide Attend DKP handler
function Lootster_Raid_Attend_OnHide()
	-- default operation code
	Lootster_RaidFrameAttendFrameText:SetText(LOOTSTER_RAIDATTEND_TITLE);
	Lootster_RaidFrameAttendFrameApply:SetText(LOOTSTER_RAIDATTEND_APPLY);
	
	-- reset attendance
	Lootster_Raid_Attend_RadioButton_OnClick(nil);

	-- smoke attend record
	Lootster_AttendRec = nil;
end

-- Raid Attend Player Show handler
function Lootster_Raid_Attend_Player_OnShow()
	-- ignore if no attend record
	if (Lootster_AttendRec == nil) then
		return;
	end

	-- setup the player drop down
	UIDropDownMenu_Initialize(this, Lootster_Raid_Attend_Player_Initialise, "MENU");

	-- set width
	UIDropDownMenu_SetWidth(160);

	-- and justify left
	Lootster_RaidFrameAttendFramePlayerDropDownText:SetJustifyH("LEFT");
end

-- Raid Attend Player Initaliser handler
function Lootster_Raid_Attend_Player_Initialise()
	-- ignore if no attend record
	if (Lootster_AttendRec == nil) then
		return;
	end

	-- build player dropdown for attendance
	Lootster_Build_Player_DropDown(LOOTSTER_RAIDATTEND_SELECT, Lootster_Raid_Attend_OnSelect, LOOTSTER_RAIDATTEND_OTHERPLAYER, Lootster_Raid_Attend_OnPlayer);
	
	-- select the winner if we have one
	if (Lootster_AttendRec.Player ~= nil) then
		-- get the alt if he is present
		player = Lootster_GetMainALT(Lootster_AttendRec.Player);

		-- he's a winner!
		UIDropDownMenu_SetText(player, Lootster_RaidFrameAttendFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAttendFramePlayerDropDown, player);
	else
		-- no winner yet - reset
		UIDropDownMenu_SetText("", Lootster_RaidFrameAttendFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAttendFramePlayerDropDown, nil);
	end
	
	-- update raid attendance UI
	Lootster_RaidAttendUpdateUI();
end

-- Raid Attend Player Select handler
function Lootster_Raid_Attend_OnSelect()
	-- ignore if no attend record
	if (Lootster_AttendRec == nil) then
		return;
	end
	
	-- retrieve the selected playa (could be an alt)
	Lootster_AttendRec.Alt = this.value;
	
	-- retrieve the selected playa main
	Lootster_AttendRec.Player = Lootster_GetALTMain(Lootster_AttendRec.Alt);

	-- and select him in the drop down
	UIDropDownMenu_SetText(this.value, Lootster_RaidFrameAttendFramePlayerDropDown);
	UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAttendFramePlayerDropDown, this.value);
	
	-- update raid attendance UI
	Lootster_RaidAttendUpdateUI();

	-- close menus
	CloseDropDownMenus();
end

-- Raid Attend Enter Other Player handler
function Lootster_Raid_Attend_OnPlayer()
	-- ignore if no attend record
	if (Lootster_AttendRec == nil) then
		return;
	end

	-- show edit box for player name
	StaticPopup_Show("LOOTSTER_PROMPT_ATTEND_PLAYER");
end

-- Raid Attend Attendance handler
function Lootster_Raid_Attend_RadioButton_OnClick(index)
	-- ignore if no attend record
	if (Lootster_AttendRec == nil) then
		return;
	end

	-- do we have a attended value?
	if (index ~= nil) then
		-- snarf attended value
		Lootster_AttendRec.Attended = index;
	end

	-- determine the attendance button
	Lootster_RaidFrameAttendFrameAttendFull:SetChecked(Lootster_AttendRec.Attended == LOOTSTER_ENUM_ATTENDED.FULL);
	Lootster_RaidFrameAttendFrameAttendPartial:SetChecked(Lootster_AttendRec.Attended == LOOTSTER_ENUM_ATTENDED.PARTIAL);
	Lootster_RaidFrameAttendFrameAttendNotAtAll:SetChecked(Lootster_AttendRec.Attended == LOOTSTER_ENUM_ATTENDED.NOTATALL);
	
	-- update raid attendance UI
	Lootster_RaidAttendUpdateUI();
	
	-- play sound if selected
	if (index ~= nil) then
		PlaySound("igMainMenuOptionCheckBoxOn");
	end
end

-- Raid Attend Apply handler
function Lootster_Attend_Apply_OnClick()
	local bossId, player, attendId;
	
	-- no attend record or assignee we are done
	if ((Lootster_AttendRec == nil) or (Lootster_AttendRec.Player == nil)) then
		return;
	end
	
	-- use attend record boss if present
	if (Lootster_AttendRec.BossId ~= nil) then
		-- use this boss id
		bossId = Lootster_AttendRec.BossId;
	else
		-- use selected boss
		bossId = Lootster_BossId;
	end

	-- no boss id we are done
	if (bossId == nil) then
		return;
	end
	
	-- get the player
	player = Lootster_AttendRec.Alt;
	
	-- retrieve data
	if		(Lootster_RaidFrameAttendFrameAttendFull:GetChecked() ~= nil) then
		Lootster_AttendRec.Attended = LOOTSTER_ENUM_ATTENDED.FULL;
	elseif	(Lootster_RaidFrameAttendFrameAttendPartial:GetChecked() ~= nil) then
		Lootster_AttendRec.Attended = LOOTSTER_ENUM_ATTENDED.PARTIAL;
	elseif	(Lootster_RaidFrameAttendFrameAttendNotAtAll:GetChecked() ~= nil) then
		Lootster_AttendRec.Attended = LOOTSTER_ENUM_ATTENDED.NOTATALL;
	else
		-- not set, so ignore
		return;		
	end
	
	-- are we creating or modifying an attendance record?
	if (Lootster_AttendRec.Id == nil) then
		-- let player know there DKP was created if they are on roster
		if (Lootster_Roster[player] ~= nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ATTENDCREATED, LOOTSTER_DATA_ATTENDEDLIST[Lootster_AttendRec.Attended]));
		end

		-- insert attendance into the boss
		Lootster_InsertAttend(bossId, Lootster_CreateAttend(Lootster_AttendRec));
	else
		-- let player know there DKP was changed if they are on roster
		if (Lootster_Roster[player] ~= nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ATTENDCHANGED, LOOTSTER_DATA_ATTENDEDLIST[Lootster_AttendRec.Attended], LOOTSTER_DATA_ATTENDEDLIST[Lootster_Attend[Lootster_AttendRec.Id].Attended]));
		end

		-- modify the attendance
		Lootster_ModifyAttend(Lootster_AttendRec);
	end

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);
	
	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);

	-- reset attend record
	Lootster_AttendRec = nil;
	
	-- hide the UI
	Lootster_RaidFrameAttendFrame:Hide();

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Attend Cancel handler
function Lootster_Attend_Cancel_OnClick()
	-- smoke attendance record
	Lootster_AttendRec = nil;
end

-- Raid Attend Update UI handler
function Lootster_RaidAttendUpdateUI()
	-- enable attend button if player and attendance selected
	if ((Lootster_AttendRec.Player == nil) or (Lootster_AttendRec.Attended == nil)) then
		Lootster_RaidFrameAttendFrameApply:Disable();
	else
		Lootster_RaidFrameAttendFrameApply:Enable();
	end
end

-- Raid Adjust Row Click handler
function Lootster_Raid_Adjust_Button_OnClick(button)
	local	offset, key, itemLink;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossAdjustFrameScrollFrame);

	-- calculate actual the adjust item index and get the adjust record key
	key = Lootster_AdjustSort[this:GetID() + offset];

	-- if this is a different adjustment, snarf
	if (key ~= Lootster_AdjustId) then
		-- snarf the new adjustment Id
		Lootster_AdjustId = key;

		-- resort adjust data using current sort
		Lootster_Raid_Adjust_Sort(nil);

		-- update the raid UI
		Lootster_UpdateRaidUI();
	end

	-- are they trying to link to chat, ourselves or looking at tooltip?
	if		(IsShiftKeyDown()) then
		-- make sure chat window is visible
		if (ChatFrameEditBox:IsVisible()) then
			ChatFrameEditBox:Insert(Lootster_Adjust[key].Link);
		else
			-- set as the current link
			Lootster_SetHyperlink(Lootster_Adjust[key].Link);
		end
	elseif	(IsControlKeyDown()) then
		-- extract link for tooltip
		for itemLink in string.gfind(Lootster_Adjust[key].Link, LOOTSTER_ITEMLINK_PATTERN) do
			-- show item reference tooltip
			ShowUIPanel(ItemRefTooltip);

			-- make sure we can see it
			if (not ItemRefTooltip:IsVisible()) then
				ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");
			end

			-- set the link
			ItemRefTooltip:SetHyperlink(itemLink);
		end
	end
end

-- Raid Adjust Row Enter handler
function Lootster_Raid_Adjust_Button_OnEnter()
	local	offset, key, tooltip;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossAdjustFrameScrollFrame);

	-- get actual the adjustment item key and get the adjustment record index
	key = Lootster_AdjustSort[this:GetID() + offset];

	-- adjustment record, using DKP if we are using DKP rolling
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		tooltip = string.format(LOOTSTER_MSG_DKPTOOLTIPADJ, Lootster_GetMainALT(Lootster_Adjust[key].Player), Lootster_Adjust[key].DKP, Lootster_Adjust[key].Reason);
	else
		tooltip = string.format(LOOTSTER_MSG_NODKPTOOLTIPADJ, Lootster_GetMainALT(Lootster_Adjust[key].Player), Lootster_Adjust[key].Reason);
	end

	return tooltip;
end

-- Raid Create Adjust handler
function Lootster_Raid_Adjust_Create_OnClick()
	local	dkp, reason, comment;

	-- no raid or boss id  we are done
	if ((Lootster_RaidId == nil) or (Lootster_BossId == nil)) then
		return;
	end

	-- set default DKP value and reason
	dkp = 0;
	reason = "";
	comment = ""
	
	-- do we have a loot link?
	if (Lootster_ItemLink ~= nil) then
		-- determine dkp and reason for this link
		dkp, reason = Lootster_GetItemDKP(Lootster_ItemText);
	end

	-- hide outstanding dialog, if any
	Lootster_Popup_Show();

	-- create an adjustment record
	Lootster_AdjustRec = Lootster_NewAdjust(nil, nil, Lootster_CalcServerTime(time()), dkp, Lootster_ItemLink, reason, comment);

	-- and show the adjust dialog
	Lootster_Popup_Show(Lootster_RaidFrameAdjustFrame);
end

-- Raid Modify Adjust handler
function Lootster_Raid_Adjust_Modify_OnClick()
	-- make sure we have a adjustment selected
	if (Lootster_AdjustId == nil) then
		return;
	end

	-- hide outstanding dialog, if any
	Lootster_Popup_Show();

	-- copy the adjustment record
	Lootster_AdjustRec = Lootster_CopyRecord(Lootster_Adjust[Lootster_AdjustId]);

	-- and show the adjust dialog
	Lootster_Popup_Show(Lootster_RaidFrameAdjustFrame);
end

-- Raid Delete Adjust Click handler
function Lootster_Raid_Adjust_Delete_OnClick()
	-- make sure we have a adjustment selected
	if (Lootster_AdjustId == nil) then
		return;
	end

	-- copy the adjustment record
	Lootster_AdjustRec = Lootster_CopyRecord(Lootster_Adjust[Lootster_AdjustId]);

	-- and show delete dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_ADJUST_DELETE");
end

-- Raid Delete Adjust Accept handler
function Lootster_Raid_Adjust_Delete_OnAccept()
	local	player, reason;
	
	-- no adustment record we are done
	if (Lootster_AdjustRec == nil) then
		return;
	end
	
	-- get the alt for this player
	player = Lootster_GetMainALT(Lootster_AdjustRec.Player);

	-- let player know their DKP was changed if they are on roster
	if (Lootster_Roster[player] ~= nil) then
		-- use link if given
		if (Lootster_AdjustRec.Link ~= nil) then
			-- use link
			reason = Lootster_AdjustRec.Link;
		else
			-- just use reason
			reason = Lootster_AdjustRec.Reason;
		end

		-- determine if we are in DKP mode
		if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ADJUSTDELETEDDKP, Lootster_AdjustRec.DKP, reason));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ADJUSTDELETEDNODKP, reason));
		end
	end

	-- delete this adjustment record
	Lootster_DeleteAdjust(Lootster_AdjustRec.Id);
	
	-- get the next adjust id
	Lootster_AdjustId = Lootster_GetNextId(Lootster_AdjustSort, Lootster_AdjustRec.Id);

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);
	
	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);
	
	-- resort adjust data using current sort
	Lootster_Raid_Adjust_Sort(nil);

	-- echo DKP and roll to player if in roster
	if (Lootster_Roster[player] ~= nil) then
		Lootster_EchoPlayerDKP(player, player);
		Lootster_EchoPlayerRoll(player, true);
	end

	-- did our DKP change?
	if ((player == Lootster_Self) and (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP)) then
		-- update our roll text
		Lootster_UpdateRoll();
	end

	-- reset adjust record
	Lootster_AdjustRec = nil;

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Delete Adjust Cancel handler
function Lootster_Raid_Adjust_Delete_OnCancel()
	-- reset adjust record
	Lootster_AdjustRec = nil;
end

-- Raid Delete ALL Adjust handler
function Lootster_Raid_Adjust_DeleteAll_OnClick()
	-- make sure we have some adjustments
	if ((Lootster_RaidId == nil) or (Lootster_BossId == nil) or (table.getn(Lootster_AdjustSort) == 0)) then
		return;
	end

	-- copy the first adjustment record so we retain the selected boss id if they switch bosses on us
	Lootster_AdjustRec = Lootster_CopyRecord(Lootster_Adjust[Lootster_AdjustSort[1]]);

	-- and show delete ALL dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_ADJUST_DELETEALL");
end

-- Raid Delete ALL Adjust handler
function Lootster_Raid_Adjust_DeleteAll_OnAccept()
	-- no adjustment record we are done
	if (Lootster_AdjustRec == nil) then
		return;
	end
	
	-- delete all adjustments from the boss
	Lootster_DeleteAllAdjust(Lootster_AdjustRec.BossId);

	-- let them know
	Lootster_SendBroadcast(string.format(LOOTSTER_MSG_ADJUSTDELETEDALL, Lootster_Raid[Lootster_Boss[Lootster_AdjustRec.BossId].RaidId].Zone, Lootster_Boss[Lootster_AdjustRec.BossId].Boss));
	
	-- smoke the current adjust id
	Lootster_AdjustId = nil;

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);
	
	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);

	-- resort adjust data using current sort
	Lootster_Raid_Adjust_Sort(nil);

	-- reset adjust record
	Lootster_AdjustRec = nil;

	-- did our DKP change?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- update our roll text
		Lootster_UpdateRoll();
	end

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Delete ALL Adjust Cancel handler
function Lootster_Raid_Adjust_DeleteAll_OnCancel()
	-- reset adjust record
	Lootster_AdjustRec = nil;
end

-- Show Adjust DKP handler
function Lootster_Raid_Adjust_OnShow()
	local	opCode, wcount;

	-- no adjustment record and boss means we are done
	if ((Lootster_AdjustRec == nil) or ((Lootster_BossId == nil) and (Lootster_AdjustRec.BossId == nil))) then
		-- rehide frame
		Lootster_RaidFrameAdjustFrame:Hide();
	else
		-- set prompts for player depending on operation
		if (Lootster_AdjustRec.Id == nil) then
			opCode = LOOTSTER_RAID_INSERT;
		else
			opCode = LOOTSTER_RAID_MODIFY;
		end

		-- format and set adjustment operation
		Lootster_RaidFrameAdjustFrameText:SetText(string.format(LOOTSTER_RAIDADJUST_TITLE, opCode));
		Lootster_RaidFrameAdjustFrameApply:SetText(string.format(LOOTSTER_RAIDADJUST_APPLY, opCode));

		-- do we have a multi-player list?
		if		((Lootster_AdjustRec.Won ~= nil) and (Lootster_AdjustRec.WonItemCount ~= nil)) then
			-- show and check the master looted item check box
			Lootster_RaidFrameAdjustFrameUseML:Show();
			Lootster_RaidFrameAdjustFrameUseML:SetChecked(false);

			-- snarf item count
			wcount = Lootster_AdjustRec.WonItemCount;

			-- how many items?
			if		(wcount == 1) then
				-- no assignee list.  Do we have a winning player?
				if (table.getn(Lootster_AdjustRec.Won) == 1) then
					-- use player drop down
					Lootster_AdjustRec.Player = Lootster_GetALTMain(Lootster_AdjustRec.Won[1]);

					Lootster_AdjustRec.Alt = Lootster_AdjustRec.Won[1];

					-- and cause menu to update
					UIDropDownMenu_SetText(Lootster_AdjustRec.Alt, Lootster_RaidFrameAdjustFramePlayerDropDown);
					UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAdjustFramePlayerDropDown, Lootster_AdjustRec.Alt);
				end
			elseif	(wcount > 1) then
				-- set the count
				Lootster_RaidFrameAdjustFrameItemItemsText:SetText(wcount);
				Lootster_RaidFrameAdjustFrameReasonItemsText:SetText(wcount);
			end
		else
			-- hide the master looted item check box
			Lootster_RaidFrameAdjustFrameUseML:Hide();

			-- single winner only
			wcount = 1;
		end

		-- show count frames if more than one winner
		if (wcount > 1) then
			-- show multiple assignee frame
			Lootster_RaidFrameAdjustFrameAssignFrame:Show();

			-- show count frames
			Lootster_RaidFrameAdjustFrameItemItemsFrame:Show();
			Lootster_RaidFrameAdjustFrameReasonItemsFrame:Show();

			-- update assignee list
			Lootster_RaidAdjust_Update();
		else
			-- hide multiple assignee frame
			Lootster_RaidFrameAdjustFrameAssignFrame:Hide();

			-- hide count frames
			Lootster_RaidFrameAdjustFrameItemItemsFrame:Hide();
			Lootster_RaidFrameAdjustFrameReasonItemsFrame:Hide();
		end
	
		-- update DKP value, link (if any) and reason
		Lootster_RaidFrameAdjustFrameDKP:SetNumber(Lootster_AdjustRec.DKP);
		Lootster_RaidFrameAdjustFrameReason:SetText(Lootster_AdjustRec.Reason);
		Lootster_RaidFrameAdjustFrameCommentText:SetText(Lootster_AdjustRec.Comment);
	end
end

-- Hide Adjust DKP handler
function Lootster_Raid_Adjust_OnHide()
	-- default operation code
	Lootster_RaidFrameAdjustFrameText:SetText(LOOTSTER_RAIDADJUST_TITLE);
	Lootster_RaidFrameAdjustFrameApply:SetText(LOOTSTER_RAIDADJUST_APPLY);

	-- reset adjust DKP values
	Lootster_RaidFrameAdjustFrameDKP:SetNumber(0);
	Lootster_RaidFrameAdjustFrameReason:SetText("");
	Lootster_RaidFrameAdjustFrameCommentText:SetText("\n");

	-- smoke adjust record
	Lootster_AdjustRec = nil;
end

-- Raid Adjust Player Show handler
function Lootster_Raid_Adjust_Player_OnShow()
	-- ignore if no adjust record
	if (Lootster_AdjustRec == nil) then
		return;
	end

	-- setup the player drop down
	UIDropDownMenu_Initialize(this, Lootster_Raid_Adjust_Player_Initialise, "MENU");

	-- set width
	UIDropDownMenu_SetWidth(160);

	-- and justify left
	Lootster_RaidFrameAdjustFramePlayerDropDownText:SetJustifyH("LEFT");
end

-- Raid Adjust Player Initaliser handler
function Lootster_Raid_Adjust_Player_Initialise()
	-- ignore if no adjust record
	if (Lootster_AdjustRec == nil) then
		return;
	end

	-- build player dropdown for adjustment
	Lootster_Build_Player_DropDown(LOOTSTER_RAIDADJUST_SELECT, Lootster_Raid_Adjust_OnSelect, LOOTSTER_RAIDADJUST_OTHERPLAYER, Lootster_Raid_Adjust_OnPlayer);
	
	-- select the winner if we have one unless we have a multi-assignee list
	if (((Lootster_AdjustRec.Won == nil) or (Lootster_AdjustRec.WonItemCount == nil)) and (Lootster_AdjustRec.Player ~= nil)) then
		-- get the alt if he is present
		player = Lootster_GetMainALT(Lootster_AdjustRec.Player);

		-- he's a winner!
		UIDropDownMenu_SetText(player, Lootster_RaidFrameAdjustFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAdjustFramePlayerDropDown, player);
	else
		-- no winner or multiple assignees - reset
		UIDropDownMenu_SetText("", Lootster_RaidFrameAdjustFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAdjustFramePlayerDropDown, nil);
	end

	-- update raid adjust UI
	Lootster_RaidAdjustUpdateUI();
end

-- Raid Adjust Player Select handler
function Lootster_Raid_Adjust_OnSelect()
	-- ignore if no adjust record
	if (Lootster_AdjustRec == nil) then
		return;
	end
	
	-- retrieve the selected playa (could be an alt)
	Lootster_AdjustRec.Alt = this.value;
	
	-- retrieve the selected playa main
	Lootster_AdjustRec.Player = Lootster_GetALTMain(Lootster_AdjustRec.Alt);

	-- and select him in the drop down
	UIDropDownMenu_SetText(this.value, Lootster_RaidFrameAdjustFramePlayerDropDown);
	UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAdjustFramePlayerDropDown, this.value);

	-- update raid adjust UI
	Lootster_RaidAdjustUpdateUI();

	-- close menus
	CloseDropDownMenus();
end

-- Raid Adjust Enter Other Player handler
function Lootster_Raid_Adjust_OnPlayer()
	-- ignore if no adjust record
	if (Lootster_AdjustRec == nil) then
		return;
	end

	-- show edit box for player name
	StaticPopup_Show("LOOTSTER_PROMPT_ADJUST_PLAYER");
end

-- Raid Adjust Assign Show handler
function Lootster_Raid_Adjust_Assign_OnShow()
end

-- Raid Adjust Assign Append handler
function Lootster_Raid_Adjust_Assign_Append_OnClick()
	-- do we have a selected player?
	if (Lootster_AdjustRec.Player == nil) then
		return;
	end

	-- append this entry
	table.insert(Lootster_AdjustRec.Won, Lootster_AdjustRec.Player);

	-- reset the player and alt
	Lootster_AdjustRec.Player = nil;
	Lootster_AdjustRec.Alt = nil;

	-- reset player selection
	UIDropDownMenu_SetText("", Lootster_RaidFrameAdjustFramePlayerDropDown);
	UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAdjustFramePlayerDropDown, nil);

	-- update assignee list
	Lootster_RaidAdjust_Update();

	-- scroll to end of list
	Lootster_RaidFrameAdjustFrameAssignScrollFrame:SetVerticalScroll(table.getn(Lootster_AdjustRec.Won));

	-- update raid adjust UI
	Lootster_RaidAdjustUpdateUI();
end

-- Raid Adjust Assign Remove handler
function Lootster_Raid_Adjust_Assign_Remove_OnClick()
	local	count;

	-- do we have a selected index?
	if (Lootster_AdjustRec.PlayerIx == nil) then
		return;
	end

	-- remove this entry
	table.remove(Lootster_AdjustRec.Won, Lootster_AdjustRec.PlayerIx);

	-- get count of remaining entries
	count = table.getn(Lootster_AdjustRec.Won);

	-- last entry?
	if		(count == 0) then
		-- nothing selected now
		Lootster_AdjustRec.PlayerIx = nil;
	elseif	(Lootster_AdjustRec.PlayerIx > count) then
		-- last is selected
		Lootster_AdjustRec.PlayerIx = count;
	end

	-- update assignee list
	Lootster_RaidAdjust_Update();

	-- update raid adjust UI
	Lootster_RaidAdjustUpdateUI();
end

-- Raid Adjust Assign Remove All handler
function Lootster_Raid_Adjust_Assign_RemoveAll_OnClick()
	-- this is easy
	Lootster_AdjustRec.Won = {};

	-- nothing selected now
	Lootster_AdjustRec.PlayerIx = nil;

	-- update assignee list
	Lootster_RaidAdjust_Update();

	-- update raid adjust UI
	Lootster_RaidAdjustUpdateUI();
end

-- Raid Adjust Assign Button handler
function Lootster_Raid_Adjust_Assign_Button_OnClick()
	local	offset, item, ix;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameAdjustFrameAssignScrollFrame);

	-- calculate the selected assignee index
	Lootster_AdjustRec.PlayerIx = this:GetID() + offset;

	-- update assignee list
	Lootster_RaidAdjust_Update();

	-- update raid adjust UI
	Lootster_RaidAdjustUpdateUI();
end

-- Raid Adjust Master Loot Item handler
function Lootster_Raid_Adjust_MLItem_Toggle()
end

-- Raid Adjust DKP handler
function Lootster_Raid_Adjust_DKP_Entered()
end

-- Raid Adjust Item Link Click handler
function Lootster_Raid_Adjust_ItemLink_OnClick(button)
	local	itemLink;

	-- do we have a link?
	if (Lootster_AdjustRec.Link ~= nil) then
		-- I wonder what they think they are doing...
		if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
			-- display restrictions of the hyperlink
			Lootster_Class_Display_OnClick(Lootster_AdjustRec.Link);
		elseif	(button == "LeftButton") then
			-- are they trying to link to chat?
			if (IsShiftKeyDown()) then
				-- make sure chat window is visible
				if (ChatFrameEditBox:IsVisible()) then
					ChatFrameEditBox:Insert(Lootster_AdjustRec.Link);
				end
			else
				-- extract link for tooltip
				for itemLink in string.gfind(Lootster_AdjustRec.Link, LOOTSTER_ITEMLINK_PATTERN) do
					-- show item reference tooltip
					ShowUIPanel(ItemRefTooltip);

					-- make sure we can see it
					if (not ItemRefTooltip:IsVisible()) then
						ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");
					end

					-- set the link
					ItemRefTooltip:SetHyperlink(itemLink);
				end
			end
		end
	end
end

-- Raid Adjust Reason handler
function Lootster_Raid_Adjust_Reason_Entered()
	local	itemID, itemText, isML, itemLink;

	-- not master looted item
	isML = false;

	-- no initial item link
	itemLink = "";

	-- is the current link text the same?
	if		(Lootster_RaidFrameAdjustFrameReason:GetText() == Lootster_ItemText) then
		-- use current item ID and link
		itemID = Lootster_ItemID;
		itemLink = Lootster_ItemLink;
	elseif (Lootster_AdjustRec.Link ~= nil) then
		-- get link text
		itemID, itemText = Lootster_GetItemDetails(Lootster_AdjustRec.Link, true);

		-- is this the same as the entered text?
		if (Lootster_RaidFrameAdjustFrameReason:GetText() == itemText) then
			-- use item link
			itemLink = Lootster_AdjustRec.Link;
		end
	end

	-- see if we have an item ID
	if (itemID ~= nil) then
		-- are there items that were master looted items for this raid?
		isML = Lootster_IsMasterLoot(Lootster_Boss[Lootster_AdjustRec.BossId].RaidId, itemID);
	end

	-- can we use master looted inventory?
	if (isML == true) then
		-- enable master looted item check box
		Lootster_RaidFrameAdjustFrameUseML:Enable();
	else
		-- disable master looted item check box
		Lootster_RaidFrameAdjustFrameUseML:Disable();
	end

	-- and check it appropriately
	Lootster_RaidFrameAdjustFrameUseML:SetChecked(isML);

	-- set whatever link
	Lootster_RaidFrameAdjustFrameItemText:SetText(itemLink);

	-- update raid adjust UI
	Lootster_RaidAdjustUpdateUI();
end

-- Raid Adjust Comment handler
function Lootster_Raid_Adjust_Comment_TextChanged()
end

-- Raid Adjust Apply handler
function Lootster_Adjust_Apply_OnClick()
	local bossId, player, isML, count, ix, itemID, adjustId, oldReason, newReason;
	
	-- no adjust record we are done
	if (Lootster_AdjustRec == nil) then
		return;
	end
	
	-- use adjust record boss if present
	if (Lootster_AdjustRec.BossId ~= nil) then
		-- use this boss id
		bossId = Lootster_AdjustRec.BossId;
	else
		-- use selected boss
		bossId = Lootster_BossId;
	end

	-- no boss id we are done
	if (bossId == nil) then
		return;
	end

	-- is this a non-bookkeep item?
	if ((Lootster_AdjustRec.Won == nil) or (Lootster_AdjustRec.WonItemCount == nil)) then
		-- no assignee we are done
		if (Lootster_AdjustRec.Player == nil) then
			return;
		end
		
		-- spoof a assign list by using this player
		Lootster_AdjustRec.Won = { Lootster_AdjustRec.Player };
		Lootster_AdjustRec.WonItemCount = 1;

		-- no master looted inventory handling
		isML = false;
	else
		-- a bookkeep item, but single items don't use the assignee list
		if (Lootster_AdjustRec.WonItemCount == 1) then
			-- no assignee we are done
			if (Lootster_AdjustRec.Player == nil) then
				return;
			end
			
			-- spoof a assign list by using this player
			Lootster_AdjustRec.Won = { Lootster_AdjustRec.Player };
		end

		-- we are handling loot assignment - are we to use Master Looted inventory?
		isML = (Lootster_RaidFrameAdjustFrameUseML:GetChecked() ~= nil);
	end

	-- retrieve data
	Lootster_AdjustRec.DKP = Lootster_RaidFrameAdjustFrameDKP:GetNumber();
	Lootster_AdjustRec.Link = Lootster_RaidFrameAdjustFrameItemText:GetText();
	Lootster_AdjustRec.Reason = Lootster_RaidFrameAdjustFrameReason:GetText();
	Lootster_AdjustRec.Comment = Lootster_AppendTrailingLineBreak(Lootster_RaidFrameAdjustFrameCommentText:GetText());

	-- no item link means no link
	if (Lootster_AdjustRec.Link == "") then
		Lootster_AdjustRec.Link = nil;
	end

	-- get link id
	itemID = Lootster_GetItemDetails(Lootster_AdjustRec.Link, true);

	-- determine if we are bookkeeping all items
	if (table.getn(Lootster_AdjustRec.Won) < Lootster_AdjustRec.WonItemCount) then
		-- only use assigned
		count = table.getn(Lootster_AdjustRec.Won);
	else
		-- use item count
		count = Lootster_AdjustRec.WonItemCount
	end

	-- create/modify adjustments for each player
	for ix=1, count do
		-- get the player and the alt from the list
		Lootster_AdjustRec.Player = Lootster_AdjustRec.Won[ix];

		Lootster_AdjustRec.Alt = Lootster_GetMainALT(Lootster_AdjustRec.Player);

		-- use the alt as the player
		player = Lootster_AdjustRec.Alt;
		
		-- if we are using previously Master Looted items, get one from the inventory
		if (isML == true) then
			-- attempt to get an item out of Master Looted inventory
			Lootster_AdjustRec.Id = Lootster_GetMasterLoot(Lootster_Boss[Lootster_AdjustRec.BossId].RaidId, itemID);
		end

		-- are we creating or modifying an adjustment record?
		if (Lootster_AdjustRec.Id == nil) then
			-- let player know there DKP was created if they are on roster
			if (Lootster_Roster[player] ~= nil) then
				-- use link if given
				if (Lootster_AdjustRec.Link ~= nil) then
					-- use link
					reason = Lootster_AdjustRec.Link;
				else
					-- just use reason
					reason = Lootster_AdjustRec.Reason;
				end

				-- determine if we are in DKP mode
				if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ADJUSTCREATEDDKP, Lootster_AdjustRec.DKP, reason));
				else
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ADJUSTCREATEDNODKP, reason));
				end
			end

			-- insert adjustment into the boss
			Lootster_InsertAdjust(bossId, Lootster_CreateAdjust(Lootster_AdjustRec));
		else
			-- let player know there DKP was changed if they are on roster
			if (Lootster_Roster[player] ~= nil) then
				-- use old link if given
				if (Lootster_Adjust[Lootster_AdjustRec.Id].Link ~= nil) then
					-- use old link
					oldReason = Lootster_Adjust[Lootster_AdjustRec.Id].Link;
				else
					-- just use old reason
					oldReason = Lootster_Adjust[Lootster_AdjustRec.Id].Reason;
				end

				-- use link if given
				if (Lootster_AdjustRec.Link ~= nil) then
					-- use new link
					newReason = Lootster_AdjustRec.Link;
				else
					-- just use new reason
					newReason = Lootster_AdjustRec.Reason;
				end

				-- determine if we are in DKP mode
				if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ADJUSTCHANGEDDKP, Lootster_AdjustRec.DKP, newReason, Lootster_Adjust[Lootster_AdjustRec.Id].DKP, oldReason));
				else
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ADJUSTCHANGEDNODKP, newReason, oldReason));
				end
			end

			-- modify the adjustment
			Lootster_ModifyAdjust(Lootster_AdjustRec);
		end

		-- echo DKP and roll to player if in roster
		if (Lootster_Roster[player] ~= nil) then
			Lootster_EchoPlayerDKP(player, player);
			Lootster_EchoPlayerRoll(player, true);
		end

		-- did our DKP change?
		if ((player == Lootster_Self) and (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP)) then
			-- update our roll text
			Lootster_UpdateRoll();
		end
	end

	-- resort DKP data using current sort
	Lootster_Data_DKP_Sort(nil);

	-- resort player data using current sort
	Lootster_Data_Player_Sort(nil);
	
	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);

	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);

	-- resort attendance data using current sort
	Lootster_Raid_Attend_Sort(nil);

	-- resort adjustment data using current sort
	Lootster_Raid_Adjust_Sort(nil);

	-- reset adjust record
	Lootster_AdjustRec = nil;

	-- hide the UI
	Lootster_RaidFrameAdjustFrame:Hide();

	-- update the raid UI
	Lootster_UpdateRaidUI();
end

-- Raid Adjust Cancel handler
function Lootster_Adjust_Cancel_OnClick()
	-- smoke adjustment record
	Lootster_AdjustRec = nil;
end

-- Raid Adjust Update UI handler
function Lootster_RaidAdjustUpdateUI()
	-- enable adjustment button if player(s) selected and reason entered
	if		(Lootster_RaidFrameAdjustFrameReason:GetText() == "") then
		Lootster_RaidFrameAdjustFrameApply:Disable();
	elseif	((Lootster_AdjustRec.Won == nil) and (Lootster_AdjustRec.Player == nil)) then
		Lootster_RaidFrameAdjustFrameApply:Disable();
	elseif	((Lootster_AdjustRec.Won ~= nil) and (Lootster_AdjustRec.WonItemCount == 1) and (Lootster_AdjustRec.Player == nil)) then
		Lootster_RaidFrameAdjustFrameApply:Disable();
	elseif	((Lootster_AdjustRec.Won ~= nil) and (Lootster_AdjustRec.WonItemCount > 1) and (table.getn(Lootster_AdjustRec.Won) == 0)) then
		Lootster_RaidFrameAdjustFrameApply:Disable();
	else
		Lootster_RaidFrameAdjustFrameApply:Enable();
	end

	-- update raid adjust assign UI
	Lootster_RaidAdjustAssignUpdateUI();
end

-- Raid Adjust Update Assign UI handler
function Lootster_RaidAdjustAssignUpdateUI()
	-- are we showing an assignee list?
	if ((Lootster_AdjustRec.Won ~= nil) and (Lootster_AdjustRec.WonItemCount ~= nil)) then
		-- set current count of assignees
		Lootster_RaidFrameAdjustFrameColumnHeader1:SetText(string.format(LOOTSTER_RAIDADJUST_ASSIGNEES, table.getn(Lootster_AdjustRec.Won)));	

		-- do we have a player to append and we have room?
		if ((Lootster_AdjustRec.Player == nil) or (table.getn(Lootster_AdjustRec.Won) == Lootster_AdjustRec.WonItemCount)) then
			Lootster_RaidFrameAdjustFrameAssignAppend:Disable();
		else
			Lootster_RaidFrameAdjustFrameAssignAppend:Enable();
		end

		-- do we have a player selected?
		if (Lootster_AdjustRec.PlayerIx == nil) then
			Lootster_RaidFrameAdjustFrameAssignRemove:Disable();
		else
			Lootster_RaidFrameAdjustFrameAssignRemove:Enable();
		end

		-- do we have any players in the list?
		if (table.getn(Lootster_AdjustRec.Won) == 0) then
			Lootster_RaidFrameAdjustFrameAssignRemoveAll:Disable();
		else
			Lootster_RaidFrameAdjustFrameAssignRemoveAll:Enable();
		end

		-- if we have allocate all the items, no more player drop down
		if ((Lootster_AdjustRec.WonItemCount > 1) and (table.getn(Lootster_AdjustRec.Won) == Lootster_AdjustRec.WonItemCount)) then
			Lootster_RaidFrameAdjustFrameDropDownShow:Disable();
		else
			Lootster_RaidFrameAdjustFrameDropDownShow:Enable();
		end
	end
end

-- Item Synchronise handler
function Lootster_Item_Sync_OnClick()
	-- show the item sync dialog
	Lootster_Popup_Show(Lootster_ItemSyncFrame);
end

-- Item Clear Item Link handler
function Lootster_Item_ClearItem_OnClick()
	-- reset the hyperlinks
	Lootster_SetHyperlink(nil);
end

-- Item Item Link Click handler
function Lootster_Item_ItemLink_OnClick(button)
	local	itemLink;

	-- do we have a link?
	if (Lootster_ItemLink ~= nil) then
		-- I wonder what they think they are doing...
		if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
			-- display restrictions of the hyperlink
			Lootster_Class_Display_OnClick();
		elseif	(button == "LeftButton") then
			-- are they trying to link to chat?
			if (IsShiftKeyDown()) then
				-- make sure chat window is visible
				if (ChatFrameEditBox:IsVisible()) then
					ChatFrameEditBox:Insert(Lootster_ItemLink);
				end
			else
				-- show item reference tooltip
				ShowUIPanel(ItemRefTooltip);

				-- make sure we can see it
				if (not ItemRefTooltip:IsVisible()) then
					ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");
				end

				-- set the link
				ItemRefTooltip:SetHyperlink(Lootster_ItemID);
			end
		end
	end
end

-- Item Row Click handler
function Lootster_Item_Button_OnClick()
	local	offset, item, name, quality, link;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_ItemFrameScrollFrame);

	-- calculate actual the restricted item index and get the item record key
	item = Lootster_ItemSort[this:GetID() + offset];

	-- get the item information
	name, _, quality = GetItemInfo(item);

	-- is item cached?
	if (name == nil) then
		-- use saved text
		name = Lootster_Restrict[item].Text;

		-- spoof quality
		quality = 0;
	end

	-- form the link
	link = string.format(LOOTSTER_ITEMLINK_FORMAT, ITEM_QUALITY_COLORS[quality].hex, item, name);

	-- are they trying to link to chat, ourselves or looking at tooltip?
	if		(IsShiftKeyDown()) then
		-- make sure chat window is visible
		if (ChatFrameEditBox:IsVisible()) then
			ChatFrameEditBox:Insert(link);
		else
			-- set as the current link
			Lootster_SetHyperlink(link);
		end
	elseif	(IsControlKeyDown()) then
		-- show item reference tooltip
		ShowUIPanel(ItemRefTooltip);

		-- make sure we can see it
		if (not ItemRefTooltip:IsVisible()) then
			ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");
		end

		-- set the link
		ItemRefTooltip:SetHyperlink(item);
	end
end

-- Item Row Enter handler
function Lootster_Item_Button_OnEnter()
	local	offset, item, name, link, quality, itemText, permitted, tooltip;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_ItemFrameScrollFrame);

	-- calculate actual the restricted item index and get the item record key
	item = Lootster_ItemSort[this:GetID() + offset];

	-- get the item information
	name, _, quality = GetItemInfo(item);
	
	-- is item cached?
	if (name == nil) then
		-- use saved text
		name = Lootster_Restrict[item].Text;

		-- spoof quality
		quality = 0;
	end

	-- create restrictions text
	itemText, permitted = Lootster_CreateRestricts(string.format(LOOTSTER_ITEMLINK_FORMAT, ITEM_QUALITY_COLORS[quality].hex, item, name));
	
	-- format restricted item tooltip
	tooltip = string.format(LOOTSTER_MSG_ITEMTOOLTIP, itemText, permitted);
	
	return tooltip;	
end

-- Item Delete Click handler
function Lootster_Item_Delete_OnClick()
	local	offset;
	
	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_ItemFrameScrollFrame);

	-- calculate actual the restricted item index and get the item record key
	Lootster_ItemSel = Lootster_ItemSort[this:GetParent():GetID() + offset];

	-- and show delete dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_ITEM_DELETE");
end

-- Item Delete ALL handler
function Lootster_Item_DeleteAll_OnClick()
	-- show delete ALL dialog
	Lootster_StaticPopup_Show("LOOTSTER_PROMPT_ITEM_DELETEALL");
end

-- Item Delete Accept handler
function Lootster_Item_Delete_OnAccept()
	-- far too easy
	Lootster_Restrict[Lootster_ItemSel] = nil;

	-- is this our current item?
	if (Lootster_ItemID == Lootster_ItemSel) then
		-- resnarf as existing hyperlink
		Lootster_SetHyperlink(Lootster_ItemLink);
	end
	
	-- reset selected item ID
	Lootster_ItemSel = nil;
	
	-- resort item list
	Lootster_Item_Sort();
end

-- Item Delete Cancel handler
function Lootster_Item_Delete_OnCancel()
	-- reset restricted item key
	Lootster_ItemSel = nil;
end

-- Item Delete ALL Accept handler
function Lootster_Item_DeleteAll_OnAccept()
	-- far too easy
	Lootster_Restrict = {};

	-- resnarf existing hyperlink, if any
	Lootster_SetHyperlink(Lootster_ItemLink);
	
	-- resort item list
	Lootster_Item_Sort();
end

-- Item Class Toggle handler
function Lootster_Item_Class_Toggle()
	local	offset, itemId, classId, check, ix;
	
	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_ItemFrameScrollFrame);

	-- calculate actual the restricted item index and get the item record key
	itemId = Lootster_ItemSort[this:GetParent():GetID() + offset];
	
	-- get the class id that was hit
	classId = this:GetID();

	-- see which way we are switching
	if (this:GetChecked() ~= nil) then
		-- add this class
		table.insert(Lootster_Restrict[itemId].Classes, LOOTSTER_CLASS_SORT[classId]);
	else
		-- search through class list for removal
		for ix, class in ipairs(Lootster_Restrict[itemId].Classes) do
			-- right class?
			if (LOOTSTER_CLASS_SORT[classId] == class) then
				-- remove this class
				table.remove(Lootster_Restrict[itemId].Classes, ix);
				break;
			end
		end
	end
	
	-- is this our current item?
	if (Lootster_ItemID == itemId) then
		-- resnarf as existing hyperlink
		Lootster_SetHyperlink(Lootster_ItemLink);
	end
	
	-- repaint item list
	Lootster_Item_Update();
end

-- Show Raid Synchronise handler
function Lootster_RaidSync_OnShow()
	-- reset synchronise user
	Lootster_SyncUser = nil;

	-- reset progress
	Lootster_RaidSyncFrameProgress:SetValue(0);

	-- reset receiving state
	Lootster_RaidSyncFrameProgressState:SetText("");	

	-- disable apply and enable close
	Lootster_RaidSyncFrameApply:Disable();
	Lootster_RaidSyncFrameCancel:Enable();
	Lootster_RaidSyncFrameCancel:SetText(LOOTSTER_RAIDSYNC_CLOSE);
end

-- Hide Raid Synchronise handler
function Lootster_RaidSync_OnHide()
	-- reset synchronise user
	Lootster_SyncUser = nil;

	-- reset progress
	Lootster_RaidSyncFrameProgress:SetValue(0);
end

-- Raid Synchronise Player Show handler
function Lootster_RaidSync_Player_OnShow()
	-- setup the player drop down
	UIDropDownMenu_Initialize(this, Lootster_RaidSync_Player_Initialise, "MENU");

	-- set width
	UIDropDownMenu_SetWidth(160);

	-- and justify left
	Lootster_RaidSyncFramePlayerDropDownText:SetJustifyH("LEFT");
end

-- Raid Synchronise Player Initaliser handler
function Lootster_RaidSync_Player_Initialise()
	-- build player dropdown for attendance
	Lootster_Build_Player_DropDown(LOOTSTER_RAIDSYNC_SELECT, Lootster_RaidSync_OnSelect, LOOTSTER_RAIDSYNC_OTHERPLAYER, Lootster_RaidSync_OnPlayer, true, true);
	
	-- select the player if we have one
	if (Lootster_SyncUser ~= nil) then
		-- he's a winner!
		UIDropDownMenu_SetText(Lootster_SyncUser, Lootster_RaidFrameAdjustFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_RaidFrameAdjustFramePlayerDropDown, Lootster_SyncUser);
	else
		-- no player yet - reset
		UIDropDownMenu_SetText("", Lootster_RaidSyncFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_RaidSyncFramePlayerDropDown, nil);
	end

	-- update raid synchronise UI
	Lootster_RaidSyncUpdateUI();
end

-- Raid Synchronise Player Select handler
function Lootster_RaidSync_OnSelect()
	-- snarf the selected player
	Lootster_SyncUser = this.value;

	-- select him in the drop down
	UIDropDownMenu_SetText(this.value, Lootster_RaidSyncFramePlayerDropDown);
	UIDropDownMenu_SetSelectedName(Lootster_RaidSyncFramePlayerDropDown, this.value);
	
	-- update raid attendance UI
	Lootster_RaidSyncUpdateUI();

	-- close menus
	CloseDropDownMenus();
end

-- Raid Synchronise Enter Other Player handler
function Lootster_RaidSync_OnPlayer()
	-- show edit box for player name
	StaticPopup_Show("LOOTSTER_PROMPT_RAIDSYNC_PLAYER");
end

-- Raid Synchronise Apply handler
function Lootster_RaidSync_Apply_OnClick()
	-- no synchronise user means we are done
	if (Lootster_SyncUser == nil) then
		return;
	end
	
	-- set synchronise function
	Lootster_SyncType = LOOTSTER_SYNC_CMD_SYNCRAID;

	-- set synchronise title
	Lootster_SyncTitle = LOOTSTER_RAIDSYNC_TITLE;

	-- initiate contact
	Lootster_SendPrivate(Lootster_SyncUser, string.format(LOOTSTER_SYNC_EXP_SYNCRAID, LOOTSTER_SYNC_VERSION), true);
	
	-- update raid synchronise UI
	Lootster_Sync_StateUpdate();
end

-- Raid Synchronise Cancel handler
function Lootster_RaidSync_Cancel_OnClick()
	-- are we in progress?
	if (Lootster_SyncType == LOOTSTER_SYNC_CMD_SYNCRAID) then
		-- cancelled by player - abort
		Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADCANCEL, Lootster_SyncTitle), true);

		-- abort synchronise
		Lootster_SendPrivate(Lootster_SyncUser, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

		-- cancelled operation
		Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_CANCEL);
	else
		-- just hide user interface
		Lootster_RaidSyncFrame:Hide();
	end
end

-- Raid Synchronise Update UI handler
function Lootster_RaidSyncUpdateUI(terminal)
	-- we started to synchronise?
	if		(terminal ~= nil) then
		-- reset player
		UIDropDownMenu_SetText("", Lootster_RaidSyncFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_RaidSyncFramePlayerDropDown, nil);

		-- update terminal state
		Lootster_RaidSyncFrameProgressState:SetText(terminal);

		-- disable apply and enable cancel
		Lootster_RaidSyncFrameApply:Disable();
		Lootster_RaidSyncFrameCancel:Enable();
		Lootster_RaidSyncFrameCancel:SetText(LOOTSTER_RAIDSYNC_CLOSE);
	elseif	(Lootster_SyncType == nil) then
		-- pre-sync or post-sync?
		if (Lootster_RaidSyncFrameCancel:IsEnabled() ~= nil) then
			-- enable apply button if player selected
			if (Lootster_SyncUser == nil) then
				Lootster_RaidSyncFrameApply:Disable();
			else
				Lootster_RaidSyncFrameApply:Enable();
			end
		else
			-- enable apply and cancel
			Lootster_RaidSyncFrameApply:Enable();
			Lootster_RaidSyncFrameCancel:Enable();
			Lootster_RaidSyncFrameCancel:SetText(LOOTSTER_RAIDSYNC_CLOSE);
		end
	elseif	(Lootster_SyncType == LOOTSTER_SYNC_CMD_SYNCRAID) then
		-- synchronising.  Manage each stage of the sychronise
		if		((Lootster_SyncCount == 0) and (Lootster_SyncTotal == 0)) then
			-- disable apply and change to cancel
			Lootster_RaidSyncFrameApply:Disable();
			Lootster_RaidSyncFrameCancel:SetText(LOOTSTER_RAIDSYNC_CANCEL);

			-- reset progress
			Lootster_RaidSyncFrameProgress:SetValue(0);

			-- set contacting state
			Lootster_RaidSyncFrameProgressState:SetText(LOOTSTER_SYNC_STATE_CONTACT);
		elseif	(Lootster_SyncAcks == 1) then
			-- set acknowledge state
			Lootster_RaidSyncFrameProgressState:SetText(LOOTSTER_SYNC_STATE_ACKED);
		elseif	(Lootster_SyncCount == 0) then
			-- initialise progress bar
			Lootster_RaidSyncFrameProgress:SetMinMaxValues(0, Lootster_SyncTotal);

			-- set receiving state
			Lootster_RaidSyncFrameProgressState:SetText(LOOTSTER_SYNC_STATE_RECEIVE);	
		elseif	(Lootster_SyncCount ~= Lootster_SyncTotal) then
			-- update progress bar
			Lootster_RaidSyncFrameProgress:SetValue(Lootster_SyncCount);
		elseif	(Lootster_SyncCount == Lootster_SyncTotal) then
			-- update progress bar
			Lootster_RaidSyncFrameProgress:SetValue(Lootster_SyncCount);

			-- set commiting state
			Lootster_RaidSyncFrameProgressState:SetText(LOOTSTER_SYNC_STATE_COMMIT);
		end
	end
end

-- Show Raid Report handler
function Lootster_RaidReport_OnShow()
	-- setup report attendance buttons
	Lootster_RaidReport_Attend_Toggle();

	-- simply build raid report
	Lootster_RaidReport_Refresh_OnClick();
end

-- Refresh Raid Report handler
function Lootster_RaidReport_Refresh_OnClick()
	local	txtReport = "";

	-- call the required report writer if we have one
	if (Lootster_ReportWriterCB ~= nil) then
		txtReport = Lootster_ReportWriterCB();
	end

	-- and send to report frame
	Lootster_RaidFrameReportFrameReport:SetText(txtReport);

	-- hack to cause scroll frame to be positioned at top
	Lootster_RaidFrameReportFrameReport.Reposition = 0;
end

-- Raid Report Raid Sort Load handler
function Lootster_RaidReport_RaidSort_OnLoad()
	-- set width
	UIDropDownMenu_SetWidth(100);
end

-- Raid Report Raid Sort Show handler
function Lootster_RaidReport_RaidSort_OnShow()
	-- setup the raid sort drop down
	UIDropDownMenu_Initialize(Lootster_RaidFrameReportFrameRaidSort, Lootster_RaidReport_RaidSort_Initialise);

	-- set initial selection
	UIDropDownMenu_SetSelectedValue(Lootster_RaidFrameReportFrameRaidSort, Lootster_Options.RepRaidSortCol);
end

-- Raid Report Raid Sort Load Initaliser handler
function Lootster_RaidReport_RaidSort_Initialise()
	local	ix, entry, info;

	for ix, entry in ipairs(LOOTSTER_RAIDREPORT_RAIDSORTLIST) do
		-- form mode button
		info = {};
		info.text = entry.Prompt;
		info.func = Lootster_RaidReport_RaidSort_OnSelect;
		info.value = entry.Field;

		-- add raid sort button
		UIDropDownMenu_AddButton(info);
	end
end

-- Raid Report Raid Sort Select handler
function Lootster_RaidReport_RaidSort_OnSelect()
	-- snarf new raid sort column
	Lootster_Options.RepRaidSortCol = this.value;

	-- and select this entry
	UIDropDownMenu_SetSelectedValue(Lootster_RaidFrameReportFrameRaidSort, this.value);
end

-- Raid Report Raid Sort Show handler
function Lootster_RaidReport_RaidSortOrd_OnShow()
	-- set raid sort order toggle
	Lootster_RaidReport_RaidSortOrd_Toggle(Lootster_Options.RepRaidSortColOrd);
end

-- Raid Report Raid Sort Order Toggle handler
function Lootster_RaidReport_RaidSortOrd_Toggle(ord)
	-- toggle value if not specified
	if (ord == nil) then
		Lootster_Options.RepRaidSortColOrd = not Lootster_Options.RepRaidSortColOrd;
	else
		Lootster_Options.RepRaidSortColOrd = ord;
	end

	-- manage the order button
	if (Lootster_Options.RepRaidSortColOrd ~= true) then
		-- show descending order arrow
		Lootster_RaidFrameReportFrameRaidSortOrd:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up");
		Lootster_RaidFrameReportFrameRaidSortOrd:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down");
		Lootster_RaidFrameReportFrameRaidSortOrd:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight");
	else
		-- show ascending order arrow
		Lootster_RaidFrameReportFrameRaidSortOrd:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up");
		Lootster_RaidFrameReportFrameRaidSortOrd:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down");
		Lootster_RaidFrameReportFrameRaidSortOrd:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight");
	end
end

-- Boss Report Boss Sort Load handler
function Lootster_RaidReport_BossSort_OnLoad()
	-- set width
	UIDropDownMenu_SetWidth(100);
end

-- Raid Report Boss Sort Show handler
function Lootster_RaidReport_BossSort_OnShow()
	-- setup the boss sort drop down
	UIDropDownMenu_Initialize(Lootster_RaidFrameReportFrameBossSort, Lootster_RaidReport_BossSort_Initialise);

	-- set initial selection
	UIDropDownMenu_SetSelectedValue(Lootster_RaidFrameReportFrameBossSort, Lootster_Options.RepBossSortCol);
end

-- Raid Report Boss Sort Load Initaliser handler
function Lootster_RaidReport_BossSort_Initialise()
	local	ix, entry, info;

	for ix, entry in ipairs(LOOTSTER_RAIDREPORT_BOSSSORTLIST) do
		-- form mode button
		info = {};
		info.text = entry.Prompt;
		info.func = Lootster_RaidReport_BossSort_OnSelect;
		info.value = entry.Field;

		-- add boss field button
		UIDropDownMenu_AddButton(info);
	end
end

-- Raid Raid Report Boss Sort Select handler
function Lootster_RaidReport_BossSort_OnSelect()
	-- snarf new boss sort column
	Lootster_Options.RepBossSortCol = this.value;

	-- and select this entry
	UIDropDownMenu_SetSelectedValue(Lootster_RaidFrameReportFrameBossSort, this.value);
end

-- Raid Report Boss Sort Show handler
function Lootster_RaidReport_BossSortOrd_OnShow()
	-- set boss sort order toggle
	Lootster_RaidReport_BossSortOrd_Toggle(Lootster_Options.RepBossSortColOrd);
end

-- Raid Report Boss Sort Order Toggle handler
function Lootster_RaidReport_BossSortOrd_Toggle(ord)
	-- toggle value if not specified
	if (ord == nil) then
		Lootster_Options.RepBossSortColOrd = not Lootster_Options.RepBossSortColOrd;
	else
		Lootster_Options.RepBossSortColOrd = ord;
	end

	-- manage the order button
	if (Lootster_Options.RepBossSortColOrd ~= true) then
		-- show descending order arrow
		Lootster_RaidFrameReportFrameBossSortOrd:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up");
		Lootster_RaidFrameReportFrameBossSortOrd:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down");
		Lootster_RaidFrameReportFrameBossSortOrd:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight");
	else
		-- show ascending order arrow
		Lootster_RaidFrameReportFrameBossSortOrd:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up");
		Lootster_RaidFrameReportFrameBossSortOrd:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down");
		Lootster_RaidFrameReportFrameBossSortOrd:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight");
	end
end

-- Raid Report Attend Sort Load handler
function Lootster_RaidReport_AttendSort_OnLoad()
	-- set width
	UIDropDownMenu_SetWidth(100);
end

-- Raid Report Attend Sort Show handler
function Lootster_RaidReport_AttendSort_OnShow()
	-- setup the attendance sort drop down
	UIDropDownMenu_Initialize(Lootster_RaidFrameReportFrameAttendSort, Lootster_RaidReport_AttendSort_Initialise);

	-- set initial selection
	UIDropDownMenu_SetSelectedValue(Lootster_RaidFrameReportFrameAttendSort, Lootster_Options.RepAttendSortCol);
end

-- Raid Report Attend Sort Load Initaliser handler
function Lootster_RaidReport_AttendSort_Initialise()
	local	ix, entry, info;

	for ix, entry in ipairs(LOOTSTER_RAIDREPORT_ATTENDSORTLIST) do
		-- form mode button
		info = {};
		info.text = entry.Prompt;
		info.func = Lootster_RaidReport_AttendSort_OnSelect;
		info.value = entry.Field;

		-- add attendance field button
		UIDropDownMenu_AddButton(info);
	end
end

-- Raid Report Attend Sort Select handler
function Lootster_RaidReport_AttendSort_OnSelect()
	-- snarf new attendance sort column
	Lootster_Options.RepAttendSortCol = this.value;

	-- and select this entry
	UIDropDownMenu_SetSelectedValue(Lootster_RaidFrameReportFrameAttendSort, this.value);
end

-- Raid Report Attend Sort Show handler
function Lootster_RaidReport_AttendSortOrd_OnShow()
	-- set attendance sort order toggle
	Lootster_RaidReport_AttendSortOrd_Toggle(Lootster_Options.RepAttendSortColOrd);
end

-- Raid Report Attend Sort Order Toggle handler
function Lootster_RaidReport_AttendSortOrd_Toggle(ord)
	-- toggle value if not specified
	if (ord == nil) then
		Lootster_Options.RepAttendSortColOrd = not Lootster_Options.RepAttendSortColOrd;
	else
		Lootster_Options.RepAttendSortColOrd = ord;
	end

	-- manage the order button
	if (Lootster_Options.RepAttendSortColOrd ~= true) then
		-- show descending order arrow
		Lootster_RaidFrameReportFrameAttendSortOrd:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up");
		Lootster_RaidFrameReportFrameAttendSortOrd:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down");
		Lootster_RaidFrameReportFrameAttendSortOrd:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight");
	else
		-- show ascending order arrow
		Lootster_RaidFrameReportFrameAttendSortOrd:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up");
		Lootster_RaidFrameReportFrameAttendSortOrd:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down");
		Lootster_RaidFrameReportFrameAttendSortOrd:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight");
	end
end

-- Raid Report Adjust Sort Load handler
function Lootster_RaidReport_AdjustSort_OnLoad()
	-- set width
	UIDropDownMenu_SetWidth(100);
end

-- Raid Report Adjust Sort Show handler
function Lootster_RaidReport_AdjustSort_OnShow()
	-- setup the adjustment sort drop down
	UIDropDownMenu_Initialize(Lootster_RaidFrameReportFrameAdjustSort, Lootster_RaidReport_AdjustSort_Initialise);

	-- set initial selection
	UIDropDownMenu_SetSelectedValue(Lootster_RaidFrameReportFrameAdjustSort, Lootster_Options.RepAdjustSortCol);
end

-- Raid Report Adjust Sort Load Initaliser handler
function Lootster_RaidReport_AdjustSort_Initialise()
	local	ix, entry, info;

	for ix, entry in ipairs(LOOTSTER_RAIDREPORT_ADJUSTSORTLIST) do
		-- form mode button
		info = {};
		info.text = entry.Prompt;
		info.func = Lootster_RaidReport_AdjustSort_OnSelect;
		info.value = entry.Field;

		-- add adjustment field button
		UIDropDownMenu_AddButton(info);
	end
end

-- Raid Report Adjust Sort Select handler
function Lootster_RaidReport_AdjustSort_OnSelect()
	-- snarf new adjustment sort column
	Lootster_Options.RepAdjustSortCol = this.value;

	-- and select this entry
	UIDropDownMenu_SetSelectedValue(Lootster_RaidFrameReportFrameAdjustSort, this.value);
end

-- Raid Report Adjust Sort Show handler
function Lootster_RaidReport_AdjustSortOrd_OnShow()
	-- set adjustment sort order toggle
	Lootster_RaidReport_AdjustSortOrd_Toggle(Lootster_Options.RepAdjustSortColOrd);
end

-- Raid Report Adjust Sort Order Toggle handler
function Lootster_RaidReport_AdjustSortOrd_Toggle(ord)
	-- toggle value if not specified
	if (ord == nil) then
		Lootster_Options.RepAdjustSortColOrd = not Lootster_Options.RepAdjustSortColOrd;
	else
		Lootster_Options.RepAdjustSortColOrd = ord;
	end

	-- manage the order button
	if (Lootster_Options.RepAdjustSortColOrd ~= true) then
		-- show descending order arrow
		Lootster_RaidFrameReportFrameAdjustSortOrd:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up");
		Lootster_RaidFrameReportFrameAdjustSortOrd:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down");
		Lootster_RaidFrameReportFrameAdjustSortOrd:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight");
	else
		-- show ascending order arrow
		Lootster_RaidFrameReportFrameAdjustSortOrd:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up");
		Lootster_RaidFrameReportFrameAdjustSortOrd:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down");
		Lootster_RaidFrameReportFrameAdjustSortOrd:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight");
	end
end

-- Raid Report Report Attendances Button Toggle handler
function Lootster_RaidReport_Attend_Toggle()
	-- retrieve value
	Lootster_Options.RepAttend = (Lootster_RaidFrameReportFrameAttend:GetChecked() ~= nil);

	-- enable attendance details as required
	if (Lootster_Options.RepAttend == true) then
		Lootster_RaidFrameReportFrameAttendDetail:Enable();
	else
		Lootster_RaidFrameReportFrameAttendDetail:Disable();
	end
end

-- Raid Report Show Detailed Attendance Button Toggle handler
function Lootster_RaidReport_AttendDetail_Toggle()
	-- retrieve value
	Lootster_Options.RepAttendDetail = (Lootster_RaidFrameReportFrameAttendDetail:GetChecked() ~= nil);
end

-- Raid Report Report Adjustments Button Toggle handler
function Lootster_RaidReport_Adjust_Toggle()
	-- retrieve value
	Lootster_Options.RepAdjust = (Lootster_RaidFrameReportFrameAdjust:GetChecked() ~= nil);
end

-- Raid Report Consolidate Bosses Button Toggle handler
function Lootster_RaidReport_Consolidate_Toggle()
	-- retrieve value
	Lootster_Options.RepConsolidate = (Lootster_RaidFrameReportFrameConsolidate:GetChecked() ~= nil);
end

-- Show Item Synchronise handler
function Lootster_ItemSync_OnShow()
	-- reset synchronise user
	Lootster_SyncUser = nil;
	
	-- overwrite is always initially OFF (failsafe)
	Lootster_ItemSyncFrameOverwrite:SetChecked(false);

	-- reset progress
	Lootster_ItemSyncFrameProgress:SetValue(0);
	
	-- disable apply and enable cancel
	Lootster_ItemSyncFrameApply:Disable();
	Lootster_ItemSyncFrameCancel:Enable();
	Lootster_ItemSyncFrameCancel:SetText(LOOTSTER_ITEMSYNC_CLOSE);
end

-- Hide Item Synchronise handler
function Lootster_ItemSync_OnHide()
	-- reset synchronise user
	Lootster_SyncUser = nil;

	-- reset progress
	Lootster_ItemSyncFrameProgress:SetValue(0);
end

-- Item Synchronise Overwrite Button Toggle handler
function Lootster_ItemSync_Overwrite_Toggle()
	-- we don't care for the moment - only at commit time
end

-- Item Synchronise Player Show handler
function Lootster_ItemSync_Player_OnShow()
	-- setup the player drop down
	UIDropDownMenu_Initialize(this, Lootster_ItemSync_Player_Initialise, "MENU");

	-- set width
	UIDropDownMenu_SetWidth(160);

	-- and justify left
	Lootster_ItemSyncFramePlayerDropDownText:SetJustifyH("LEFT");
end

-- Item Synchronise Player Initaliser handler
function Lootster_ItemSync_Player_Initialise()
	-- build player dropdown for attendance
	Lootster_Build_Player_DropDown(LOOTSTER_ITEMSYNC_SELECT, Lootster_ItemSync_OnSelect, LOOTSTER_ITEMSYNC_OTHERPLAYER, Lootster_ItemSync_OnPlayer, true, true);
	
	-- select the player if we have one
	if (Lootster_SyncUser ~= nil) then
		-- he's a winner!
		UIDropDownMenu_SetText(Lootster_SyncUser, Lootster_ItemFrameAdjustFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_ItemFrameAdjustFramePlayerDropDown, Lootster_SyncUser);
	else
		-- no player yet - reset
		UIDropDownMenu_SetText("", Lootster_ItemSyncFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_ItemSyncFramePlayerDropDown, nil);
	end

	-- update item synchronise UI
	Lootster_ItemSyncUpdateUI();
end

-- Item Synchronise Player Select handler
function Lootster_ItemSync_OnSelect()
	-- snarf the selected player
	Lootster_SyncUser = this.value;

	-- select him in the drop down
	UIDropDownMenu_SetText(this.value, Lootster_ItemSyncFramePlayerDropDown);
	UIDropDownMenu_SetSelectedName(Lootster_ItemSyncFramePlayerDropDown, this.value);
	
	-- update item attendance UI
	Lootster_ItemSyncUpdateUI();

	-- close menus
	CloseDropDownMenus();
end

-- Item Synchronise Enter Other Player handler
function Lootster_ItemSync_OnPlayer()
	-- show edit box for player name
	StaticPopup_Show("LOOTSTER_PROMPT_ITEMSYNC_PLAYER");
end

-- Item Synchronise Apply handler
function Lootster_ItemSync_Apply_OnClick()
	-- no synchronise user means we are done
	if (Lootster_SyncUser == nil) then
		return;
	end
	
	-- set synchronise function
	Lootster_SyncType = LOOTSTER_SYNC_CMD_SYNCITEM;

	-- set synchronise title
	Lootster_SyncTitle = LOOTSTER_ITEMSYNC_TITLE;

	-- initiate contact
	Lootster_SendPrivate(Lootster_SyncUser, string.format(LOOTSTER_SYNC_EXP_SYNCITEM, LOOTSTER_SYNC_VERSION), true);
	
	-- update item synchronise UI
	Lootster_Sync_StateUpdate();
end

-- Item Synchronise Cancel handler
function Lootster_ItemSync_Cancel_OnClick()
	-- are we in progress?
	if (Lootster_SyncType == LOOTSTER_SYNC_CMD_SYNCITEM) then
		-- cancelled by player - abort
		Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADCANCEL, Lootster_SyncTitle), true);

		-- abort synchronise
		Lootster_SendPrivate(Lootster_SyncUser, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

		-- cancelled operation
		Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_CANCEL);
	else
		-- just hide user interface
		Lootster_ItemSyncFrame:Hide();
	end
end

-- Item Synchronise Update UI handler
function Lootster_ItemSyncUpdateUI(terminal)
	-- we started to synchronise?
	if		(terminal ~= nil) then
		-- reset player
		UIDropDownMenu_SetText("", Lootster_ItemSyncFramePlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_ItemSyncFramePlayerDropDown, nil);

		-- update terminal state
		Lootster_ItemSyncFrameProgressState:SetText(terminal);

		-- disable apply and enable close
		Lootster_ItemSyncFrameApply:Disable();
		Lootster_ItemSyncFrameCancel:Enable();
		Lootster_ItemSyncFrameCancel:SetText(LOOTSTER_ITEMSYNC_CLOSE);
	elseif	(Lootster_SyncType == nil) then
		-- pre-sync or post-sync?
		if (Lootster_ItemSyncFrameCancel:IsEnabled() ~= nil) then
			-- enable apply button if player selected
			if (Lootster_SyncUser == nil) then
				Lootster_ItemSyncFrameApply:Disable();
			else
				Lootster_ItemSyncFrameApply:Enable();
			end
		else
			-- enable overwrite checkbox
			Lootster_ItemSyncFrameOverwrite:Enable();

			-- enable apply and close
			Lootster_ItemSyncFrameApply:Enable();
			Lootster_ItemSyncFrameCancel:Enable();
			Lootster_ItemSyncFrameCancel:SetText(LOOTSTER_ITEMSYNC_CLOSE);
		end
	elseif	(Lootster_SyncType == LOOTSTER_SYNC_CMD_SYNCITEM) then
		-- synchronising.  Manage each stage of the sychronise
		if		((Lootster_SyncCount == 0) and (Lootster_SyncTotal == 0)) then
			-- disable apply
			Lootster_ItemSyncFrameApply:Disable();
			Lootster_ItemSyncFrameCancel:SetText(LOOTSTER_ITEMSYNC_CANCEL);

			-- disable overwrite checkbox
			Lootster_ItemSyncFrameOverwrite:Disable();

			-- reset progress
			Lootster_ItemSyncFrameProgress:SetValue(0);

			-- set contacting state
			Lootster_ItemSyncFrameProgressState:SetText(LOOTSTER_SYNC_STATE_CONTACT);	
		elseif	(Lootster_SyncAcks == 1) then
			-- set acknowledge state
			Lootster_RaidSyncFrameProgressState:SetText(LOOTSTER_SYNC_STATE_ACKED);
		elseif	(Lootster_SyncCount == 0) then
			-- initialise progress bar
			Lootster_ItemSyncFrameProgress:SetMinMaxValues(0, Lootster_SyncTotal);

			-- set receiving state
			Lootster_ItemSyncFrameProgressState:SetText(LOOTSTER_SYNC_STATE_RECEIVE);	
		elseif	(Lootster_SyncCount ~= Lootster_SyncTotal) then
			-- update progress bar
			Lootster_ItemSyncFrameProgress:SetValue(Lootster_SyncCount);
		elseif	(Lootster_SyncCount == Lootster_SyncTotal) then
			-- update progress bar
			Lootster_ItemSyncFrameProgress:SetValue(Lootster_SyncCount);

			-- set commiting state
			Lootster_ItemSyncFrameProgressState:SetText(LOOTSTER_SYNC_STATE_COMMIT);
		end
	end
end

-- Data DKP Update handler
function Lootster_Data_DKP_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowName, rowClass, rowDKP, rowDKPRaw, rowDKPAdj, rowTier;

	local	item, name;
	
	-- retrieve count of DKP items
	count = table.getn(Lootster_DKPSort);

	-- retrieve the scroll offset for DKP view
	offset = FauxScrollFrame_GetOffset(Lootster_DataFrameDKPFrameScrollFrame);

	-- hammer through the dkp frame rows
	for row=1, LOOTSTER_DKP_LINES, 1 do
		-- calculate actual the DKP/adjust item index
		ix = row + offset;

		-- retrieve the DKP row button
		rowButton	= getglobal("Lootster_DataFrameDKPFrameButton"..row);

		-- do we have data for the row?
		if (ix <= count) then
			-- get the text elements
			rowName		= getglobal("Lootster_DataFrameDKPFrameButton"..row.."Name");
			rowClass	= getglobal("Lootster_DataFrameDKPFrameButton"..row.."Class");
			rowDKP		= getglobal("Lootster_DataFrameDKPFrameButton"..row.."DKP");
			rowDKPRaw	= getglobal("Lootster_DataFrameDKPFrameButton"..row.."DKPRaw");
			rowDKPAdj	= getglobal("Lootster_DataFrameDKPFrameButton"..row.."DKPAdj");
			rowTier		= getglobal("Lootster_DataFrameDKPFrameButton"..row.."Tier");

			-- okay, retrieve the DKP item
			item = Lootster_DKP[Lootster_DKPSort[ix]];

			-- this is main record, but the alt may be playing.  Resolve to that alt if it is playing
			name = Lootster_GetMainALT(item.Player);

			-- format the requisiste data and stuff into the text elements
			rowName:SetText(name);
			rowClass:SetText(item.Class);
			rowDKP:SetText(item.DKP);
			rowDKPRaw:SetText(string.format("%.3f", item.DKPRaw));
			rowDKPAdj:SetText(item.DKPAdj);

			-- DKP by DKP or Tier?
			if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
				rowTier:SetText(item.Priority);
			elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
				rowTier:SetText(item.Priority..item.Tier);
			else
				rowTier:SetText("");
			end

			-- is this the current player?
			if (item.Player == Lootster_PlayerId) then
				-- highlight the row
				rowButton:LockHighlight();
			else
				-- normalise the row
				rowButton:UnlockHighlight();
			end

			-- and show the row
			rowButton:Show();
		else
			-- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_DataFrameDKPFrameScrollFrame, count, LOOTSTER_DKP_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Data Player Update handler
function Lootster_Data_Player_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowPlayer, rowDateAdj, rowDKPAdj, rowDKPTot, rowReason;

	local	item, name;
	local	currPlayer = "";
	local   currDKPTot;

	-- retrieve count of adjust items
	count = table.getn(Lootster_PlayerSort);

	-- retrieve the scroll offset for adjust view
	offset = FauxScrollFrame_GetOffset(Lootster_DataFramePlayerFrameScrollFrame);

	-- hammer through the data frame rows
	for row=1, LOOTSTER_PLAYER_LINES, 1 do
		-- calculate actual the adjust item index
		ix = row + offset;

		-- retrieve the adjust row components
		rowButton	= getglobal("Lootster_DataFramePlayerFrameButton"..row);

		-- do we have data for the row?
		if (ix <= count) then
			-- get the text elements
			rowPlayer	= getglobal("Lootster_DataFramePlayerFrameButton"..row.."Player");
			rowDateAdj	= getglobal("Lootster_DataFramePlayerFrameButton"..row.."DateAdj");
			rowDKPAdj	= getglobal("Lootster_DataFramePlayerFrameButton"..row.."DKPAdj");
			rowDKPTot	= getglobal("Lootster_DataFramePlayerFrameButton"..row.."DKPTot");
			rowReason	= getglobal("Lootster_DataFramePlayerFrameButton"..row.."Reason");

			-- okay, retrieve the adjust item
			item = Lootster_Adjust[Lootster_PlayerSort[ix]];

			-- is this the same player as the last one?
			if (currPlayer ~= item.Player) then
				-- this is main record, but the alt may be playing.  Resolve to that alt if it is playing
				name = Lootster_GetMainALT(item.Player);

				-- set current player and reset current total DKP
				currPlayer = item.Player;
				currDKPTot = 0;
			end

			-- format the requisiste data and stuff into the text elements
			rowPlayer:SetText(name);

			-- no adjustment DKP means this is a total record
			if (item.DKP ~= nil) then
				rowDateAdj:SetText(Lootster_FormatServerTime(item.DateAdj));
				rowDKPAdj:SetText(item.DKP);

				-- add this adjustment to the running total
				currDKPTot = currDKPTot + item.DKP;
			else
				rowDateAdj:SetText("");
				rowDKPAdj:SetText("");
			end

			-- update the running total and reason
			rowDKPTot:SetText(currDKPTot);

			-- if we have a link, use it instead
			if (item.Link ~= nil) then
				rowReason:SetText(item.Link);
			else
				rowReason:SetText(item.Reason);
			end

			-- and show this row
			rowButton:Show();
		else
		    -- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_DataFramePlayerFrameScrollFrame, count, LOOTSTER_PLAYER_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Raid Raid Update handle
function Lootster_Raid_Raid_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowZone, rowDateOpn, rowDateExp, rowBoss, rowAttend, rowAdjust, rowDKP;
	
	local	item, dateExp;

	-- retrieve count of raid items
	count = table.getn(Lootster_RaidSort);

	-- retrieve the scroll offset for raid view
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameRaidFrameScrollFrame);

	-- hammer through the raid frame rows
	for row=1, LOOTSTER_RAID_LINES, 1 do
		-- calculate actual the raid item index
		ix = row + offset;

		-- retrieve the raid row components
		rowButton	= getglobal("Lootster_RaidFrameRaidFrameButton"..row);

		-- do we have data for the row?
		if (ix <= count) then
			-- get the text elements
			rowZone		= getglobal("Lootster_RaidFrameRaidFrameButton"..row.."Zone");
			rowDateOpn	= getglobal("Lootster_RaidFrameRaidFrameButton"..row.."DateOpn");
			rowDateExp	= getglobal("Lootster_RaidFrameRaidFrameButton"..row.."DateExp");
			rowBoss		= getglobal("Lootster_RaidFrameRaidFrameButton"..row.."Boss");
			rowAttend	= getglobal("Lootster_RaidFrameRaidFrameButton"..row.."Attend");
			rowAdjust	= getglobal("Lootster_RaidFrameRaidFrameButton"..row.."Adjust");
			rowDKP		= getglobal("Lootster_RaidFrameRaidFrameButton"..row.."DKP");

			-- okay, retrieve the raid item
			item = Lootster_Raid[Lootster_RaidSort[ix]];

			-- determine expiry date
			if (item.DateExp ~= nil) then
				dateExp = Lootster_FormatServerTime(item.DateExp);
			else
				dateExp = LOOTSTER_RAIDRAID_NODATEEXP;
			end

			-- format the requisite data and stuff into the text elements
			rowZone:SetText(item.Zone);
			rowDateOpn:SetText(Lootster_FormatServerTime(item.DateOpn));
			rowDateExp:SetText(dateExp);
			rowBoss:SetText(table.getn(item.BossSet));
			rowAttend:SetText(table.getn(item.AttendSet));
			rowAdjust:SetText(table.getn(item.AdjustSet));

			-- show DKP if in DKP mode
			if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
				rowDKP:SetText(item.DKP);
			else
				rowDKP:SetText("");
			end

			-- is this the current raid?
			if (item.Id == Lootster_RaidId) then
				-- highlight the row
				rowButton:LockHighlight();
			else
				-- normalise the row
				rowButton:UnlockHighlight();
			end

			-- is this the running raid?
			if (item.Id ~= Lootster_Running.RaidId) then
				-- set as normal
				rowZone:SetVertexColor(LOOTSTER_RAID_NORMAL_CLR.r, LOOTSTER_RAID_NORMAL_CLR.g, LOOTSTER_RAID_NORMAL_CLR.b);
			else
				-- set as running
				rowZone:SetVertexColor(LOOTSTER_RAID_RUNNING_CLR.r, LOOTSTER_RAID_RUNNING_CLR.g, LOOTSTER_RAID_RUNNING_CLR.b);
			end

			-- and show the row
			rowButton:Show();
		else
			-- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_RaidFrameRaidFrameScrollFrame, count, LOOTSTER_RAID_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Raid Boss Update handle
function Lootster_Raid_Boss_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowBoss, rowDateBeg, rowDateEnd, rowRun, rowAttend, rowAdjust, rowDKP;

	local	item, dateEnd;

	-- retrieve count of boss items
	count = table.getn(Lootster_BossSort);

	-- retrieve the scroll offset for boss view
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossFrameScrollFrame);

	-- hammer through the boss frame rows
	for row=1, LOOTSTER_BOSS_LINES, 1 do
		-- calculate actual the boss item index
		ix = row + offset;

		-- retrieve the boss row components
		rowButton	= getglobal("Lootster_RaidFrameBossFrameButton"..row);

		-- do we have data for the row?
		if (ix <= count) then
			-- get the text elements
			rowBoss		= getglobal("Lootster_RaidFrameBossFrameButton"..row.."Boss");
			rowDateBeg	= getglobal("Lootster_RaidFrameBossFrameButton"..row.."DateBeg");
			rowDateEnd	= getglobal("Lootster_RaidFrameBossFrameButton"..row.."DateEnd");
			rowRun		= getglobal("Lootster_RaidFrameBossFrameButton"..row.."Run");
			rowAttend	= getglobal("Lootster_RaidFrameBossFrameButton"..row.."Attend");
			rowAdjust	= getglobal("Lootster_RaidFrameBossFrameButton"..row.."Adjust");
			rowDKP		= getglobal("Lootster_RaidFrameBossFrameButton"..row.."DKP");

			-- okay, retrieve the boss item
			item = Lootster_Boss[Lootster_BossSort[ix]];

			-- determine expiry date
			if (item.DateEnd ~= nil) then
				dateEnd = Lootster_FormatServerTime(item.DateEnd);
			else
				dateEnd = LOOTSTER_RAIDBOSS_NODATEEND;
			end

			-- format the requisite data and stuff into the text elements
			rowBoss:SetText(item.Boss);
			rowDateBeg:SetText(Lootster_FormatServerTime(item.DateBeg));
			rowDateEnd:SetText(dateEnd);
			rowRun:SetChecked(item.Id == Lootster_Running.BossId);
			rowAttend:SetText(table.getn(item.AttendSet));
			rowAdjust:SetText(table.getn(item.AdjustSet));

			-- show DKP if in DKP mode
			if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
				rowDKP:SetText(item.DKP);
			else
				rowDKP:SetText("");
			end

			-- is this the current boss?
			if (item.Id == Lootster_BossId) then
				-- highlight the row
				rowButton:LockHighlight();
			else
				-- normalise the row
				rowButton:UnlockHighlight();
			end

			-- is this the running boss?
			if (item.Id ~= Lootster_Running.BossId) then
				-- set as normal
				rowBoss:SetVertexColor(LOOTSTER_RAID_NORMAL_CLR.r, LOOTSTER_RAID_NORMAL_CLR.g, LOOTSTER_RAID_NORMAL_CLR.b);
			else
				-- set as running
				rowBoss:SetVertexColor(LOOTSTER_RAID_RUNNING_CLR.r, LOOTSTER_RAID_RUNNING_CLR.g, LOOTSTER_RAID_RUNNING_CLR.b);
			end

			-- and show the row
			rowButton:Show();
		else
			-- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_RaidFrameBossFrameScrollFrame, count, LOOTSTER_BOSS_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Raid Attend Update handler
function Lootster_Raid_Attend_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowMain, rowPlayer, rowAttended, rowAdjust, rowDKP;

	local	item;

	-- retrieve count of attend items
	count = table.getn(Lootster_AttendSort);

	-- retrieve the scroll offset for attend view
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossAttendFrameScrollFrame);

	-- hammer through the attend frame rows
	for row=1, LOOTSTER_ATTEND_LINES, 1 do
		-- calculate actual the attend item index
		ix = row + offset;

		-- retrieve the attend row components
		rowButton	= getglobal("Lootster_RaidFrameBossAttendFrameButton"..row);

		-- do we have data for the row?
		if (ix <= count) then
			-- get the text elements
			rowMain		= getglobal("Lootster_RaidFrameBossAttendFrameButton"..row.."Main");
			rowPlayer	= getglobal("Lootster_RaidFrameBossAttendFrameButton"..row.."Player");
			rowAttended	= getglobal("Lootster_RaidFrameBossAttendFrameButton"..row.."Attended");
			rowAdjust	= getglobal("Lootster_RaidFrameBossAttendFrameButton"..row.."Adjust");
			rowDKP		= getglobal("Lootster_RaidFrameBossAttendFrameButton"..row.."DKP");

			-- okay, retrieve the attend item
			item = Lootster_Attend[Lootster_AttendSort[ix]];

			-- format the requisiste data and stuff into the text elements.  Note we use alt as player as appropriate
			rowMain:SetText(item.Player);
			rowPlayer:SetText(Lootster_GetMainALT(item.Player));
			rowAttended:SetText(LOOTSTER_DATA_ATTENDEDLIST[item.Attended]);
			rowAdjust:SetText(table.getn(item.AdjustSet));

			-- show DKP if in DKP mode
			if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
				rowDKP:SetText(item.DKP);
			else
				rowDKP:SetText("");
			end

			-- is this the current attendance?
			if (item.Id == Lootster_AttendId) then
				-- highlight the row
				rowButton:LockHighlight();
			else
				-- normalise the row
				rowButton:UnlockHighlight();
			end

			-- and show the row
			rowButton:Show();
		else
			-- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_RaidFrameBossAttendFrameScrollFrame, count, LOOTSTER_ATTEND_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Raid Adjust Update handler
function Lootster_Raid_Adjust_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowPlayer, rowDateAdj, rowDKP, rowReason;

	local	item;

	-- retrieve count of adjust items
	count = table.getn(Lootster_AdjustSort);

	-- retrieve the scroll offset for adjust view
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameBossAdjustFrameScrollFrame);

	-- hammer through the adjust frame rows
	for row=1, LOOTSTER_ADJUST_LINES, 1 do
		-- calculate actual the adjust item index
		ix = row + offset;

		-- retrieve the adjust row components
		rowButton	= getglobal("Lootster_RaidFrameBossAdjustFrameButton"..row);

		-- do we have data for the row?
		if (ix <= count) then
			-- get the text elements
			rowPlayer	= getglobal("Lootster_RaidFrameBossAdjustFrameButton"..row.."Player");
			rowDateAdj	= getglobal("Lootster_RaidFrameBossAdjustFrameButton"..row.."DateAdj");
			rowDKP		= getglobal("Lootster_RaidFrameBossAdjustFrameButton"..row.."DKP");
			rowReason	= getglobal("Lootster_RaidFrameBossAdjustFrameButton"..row.."Reason");

			-- okay, retrieve the adjust item
			item = Lootster_Adjust[Lootster_AdjustSort[ix]];

			-- format the requisiste data and stuff into the text elements.  Note we use alt as player as appropriate
			rowPlayer:SetText(Lootster_GetMainALT(item.Player));
			rowDateAdj:SetText(Lootster_FormatServerTime(item.DateAdj));

			-- show DKP if in DKP mode
			if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
				rowDKP:SetText(item.DKP);
			else
				rowDKP:SetText("");
			end

			-- if we have a link, use it instead
			if (item.Link ~= nil) then
				rowReason:SetText(item.Link);
			else
				rowReason:SetText(item.Reason);
			end

			-- is this the current adjustment?
			if (item.Id == Lootster_AdjustId) then
				-- highlight the row
				rowButton:LockHighlight();
			else
				-- normalise the row
				rowButton:UnlockHighlight();
			end

			-- and show the row
			rowButton:Show();
		else
			-- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_RaidFrameBossAdjustFrameScrollFrame, count, LOOTSTER_ADJUST_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Item Update handler
function Lootster_Item_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowIcon, rowText, rowClass;
	local	name, quality, texture;
	local	item, cix, classes, class;
	
	-- retrieve count of restrict items
	count = table.getn(Lootster_ItemSort);

	-- retrieve the scroll offset for item view
	offset = FauxScrollFrame_GetOffset(Lootster_ItemFrameScrollFrame);

	-- hammer through the item frame rows
	for row=1, LOOTSTER_ITEM_LINES, 1 do
		-- calculate actual the restrict item index
		ix = row + offset;

		-- retrieve the item row components
		rowButton	= getglobal("Lootster_ItemFrameButton"..row);

		-- do we have data for the row?
		if (ix <= count) then
			-- get the display elements
			rowIcon	= getglobal("Lootster_ItemFrameButton"..row.."Icon");
			rowText	= getglobal("Lootster_ItemFrameButton"..row.."Text");

			-- retrieve item id
			id = Lootster_ItemSort[ix];

			-- retrieve the item
			item = Lootster_Restrict[id];

			-- okay, retrieve the restricted item details
			name, _, quality, _, _, _, _, _, texture = GetItemInfo(id);

			-- handle uncached data
			if (name == nil) then
				-- not cached, so just use remembered name
				rowIcon:SetTexture("Interface\\InventoryItems\\WoWUnknownItem01");
				rowText:SetText(item.Text);
			else
				-- format the requisiste data and stuff into the display elements
				rowIcon:SetTexture(texture);
				rowText:SetText(string.format(LOOTSTER_ITEMLINK_FORMAT, ITEM_QUALITY_COLORS[quality].hex, id, name));
			end

			-- gather item classes
			classes = {};

			for cix, class in ipairs(item.Classes) do
				classes[class] = true;
			end

			-- go through each class to reveal restriction
			for cix, class in ipairs(LOOTSTER_CLASS_SORT) do
				-- get this class check box
				rowClass = getglobal("Lootster_ItemFrameButton"..row.."Class"..cix);

				-- set state appropriately
				rowClass:SetChecked(classes[class] == true);
			end

			-- and show the row
			rowButton:Show();
		else
			-- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_ItemFrameScrollFrame, count, LOOTSTER_ITEM_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Raid Adjust Player Update handler
function Lootster_RaidAdjust_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowName;

	-- we need an adjustment record with a player won list
	if ((Lootster_AdjustRec ~= nil) and (Lootster_AdjustRec.Won ~= nil)) then
		-- retrieve count of players
		count = table.getn(Lootster_AdjustRec.Won);
	else
		-- no assugnees
		count = 0;
	end

	-- retrieve the scroll offset for player view
	offset = FauxScrollFrame_GetOffset(Lootster_RaidFrameAdjustFrameAssignScrollFrame);

	-- hammer through the raid adjust player frame rows
	for row=1, LOOTSTER_RAIDADJUST_LINES, 1 do
		-- calculate actual the raid adjust player index
		ix = row + offset;

		-- retrieve the raid adjust player row components
		rowButton	= getglobal("Lootster_RaidFrameAdjustFrameButton"..row);

		-- do we have data for the row?
		if (ix <= count) then
			-- get the display elements
			rowName	= getglobal("Lootster_RaidFrameAdjustFrameButton"..row.."Name");

			-- set player name but as the alt
			rowName:SetText(Lootster_GetMainALT(Lootster_AdjustRec.Won[ix]));

			-- is this the current assignee?
			if (ix == Lootster_AdjustRec.PlayerIx) then
				-- highlight the row
				rowButton:LockHighlight();
			else
				-- normalise the row
				rowButton:UnlockHighlight();
			end

			-- and show the row
			rowButton:Show();
		else
			-- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_RaidFrameAdjustFrameAssignScrollFrame, count, LOOTSTER_RAIDADJUST_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Show Help handler
function Lootster_Rule_ShowHelp_OnClick(player)
	-- output the help to party/raid/player
	for ix, msg in ipairs(LOOTSTER_HELP) do
		-- punching this out to the party/raid?
		if (player == nil) then
			-- party/raid
			Lootster_SendBroadcast(msg);
		else
			-- player
			Lootster_SendPrivate(player, msg);
		end
	end

	-- is DKP in use?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- output the help to party/raid/player
		for ix, msg in ipairs(LOOTSTER_HELPDKP) do
			-- punching this out to the party/raid?
			if (player == nil) then
				-- party/raid
				Lootster_SendBroadcast(msg);
			else
				-- player
				Lootster_SendPrivate(player, msg);
			end
		end
	end
end

-- Show Rules handler
function Lootster_Rule_ShowRules_OnClick(player)
	local ix = 1;
	local rules, msg;

	-- determine which rule set to use
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		rules = Lootster_Rules.RulesDKP;
	else
		rules = Lootster_Rules.RulesNorm;
	end

	-- chop the looting rules up according to line ends
	for msg in string.gfind(rules, "(.-)\n") do
		-- punching this out to the party/raid?
		if (player == nil) then
			-- party/raid
			Lootster_SendBroadcast(msg);
		else
			-- player
			Lootster_SendPrivate(player, msg);
		end
	end

	-- get the roll handling message
	msg = Lootster_GetRollHandling();

	-- punching this out to the party/raid?
	if (player == nil) then
		-- party/raid
		Lootster_SendBroadcast(msg);
	else
		-- player
		Lootster_SendPrivate(player, msg);
	end
end

-- Looting Rules Text Changed handler
function Lootster_Rule_Rules_TextChanged()
	local	rules;

	-- snarf rules
	rules = Lootster_AppendTrailingLineBreak(Lootster_RuleFrameRulesFrameText:GetText());

	-- determine which rule set to set
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		Lootster_Rules.RulesDKP = rules;
	else
		Lootster_Rules.RulesNorm = rules;
	end
end

-- Option MiniMap Button Toggle handler
function Lootster_Option_MiniMapButton_Toggle()
	-- retrieve value
	Lootster_Options.MiniMap = (Lootster_OptionsFrameMiniMapButton:GetChecked() ~= nil);

	-- and show/hide the actual button
	if (Lootster_Options.MiniMap == true) then
		-- on she goes
		PlaySound("igMainMenuOptionCheckBoxOn");

	else
		-- off she goes
		PlaySound("igMainMenuOptionCheckBoxOff");
	end

	-- and show/hide the MiniMap button and hide/show the title
	Lootster_MiniMapButton_SwitchState();
end

-- Option MiniMap Button Value handler
function Lootster_Option_MiniMapButton_OnValue()
	-- retrieve value
	Lootster_Options.MiniMapPos = Lootster_OptionsFrameMiniMapSlider:GetValue();

	-- update slidertext
	Lootster_OptionsFrameMiniMapSliderText:SetText(Lootster_Options.MiniMapPos);

	-- reflect the position
	Lootster_MiniMapButton_UpdatePosition();
end

-- Option Suppress Chat Toggle handler
function Lootster_Option_Suppress_Toggle()
	-- retrieve value
	Lootster_Options.Suppress = (Lootster_OptionsFrameSuppress:GetChecked() ~= nil);
end

-- Option Acknowledge Roll Toggle handler
function Lootster_Option_AckRoll_Toggle()
	-- retrieve value
	Lootster_Options.AckRoll = (Lootster_OptionsFrameAckRoll:GetChecked() ~= nil);
end

-- Option Acknowledge No Call Toggle handler
function Lootster_Option_AckNoCall_Toggle()
	-- retrieve value
	Lootster_Options.AckNoCall = (Lootster_OptionsFrameAckNoCall:GetChecked() ~= nil);
end

-- Option Acknowledge No Roll Toggle handler
function Lootster_Option_AckNoRoll_Toggle()
	-- retrieve value
	Lootster_Options.AckNoRoll = (Lootster_OptionsFrameAckNoRoll:GetChecked() ~= nil);
end

-- Option Acknowledge No Help Toggle handler
function Lootster_Option_AckNoHelp_Toggle()
	-- retrieve value
	Lootster_Options.AckNoHelp = (Lootster_OptionsFrameAckNoHelp:GetChecked() ~= nil);
end

-- Option Counter Toggle handler
function Lootster_Option_Counter_Toggle()
	-- retrieve value
	Lootster_Options.Counter = (Lootster_OptionsFrameCounter:GetChecked() ~= nil);

	-- update the countdown button
	Lootster_UpdateRollUI();
end

-- Option Counter Value handler
function Lootster_Option_Counter_Entered()
	-- retrieve value
	Lootster_Options.CounterSec = Lootster_OptionsFrameSeconds:GetNumber();

	-- must be positive
	if (Lootster_Options.CounterSec < 0) then
		Lootster_Options.CounterSec = -Lootster_Options.CounterSec;

		-- update
		Lootster_OptionsFrameSeconds:SetNumber(Lootster_Options.CounterSec);
	end

	-- update the countdown button
	Lootster_UpdateRollUI();
end

-- Option Echo Restrictions Toggle handler
function Lootster_Option_EchoRestrict_Toggle()
	-- retrieve value
	Lootster_Options.EchoRestrict = (Lootster_OptionsFrameEchoRestrict:GetChecked() ~= nil);

	-- update echo UI
	Lootster_CheckEchoUse();
end

-- Option Echo By Click Toggle handler
function Lootster_Option_EchoByClick_Toggle()
	-- retrieve value
	Lootster_Options.EchoByClick = (Lootster_OptionsFrameEchoByClick:GetChecked() ~= nil);

	-- update echo UI
	Lootster_CheckEchoUse();
end

-- Option Echo By Group Loot Toggle handler
function Lootster_Option_EchoByGroupLoot_Toggle()
	-- retrieve value
	Lootster_Options.EchoByGroupLoot = (Lootster_OptionsFrameEchoByGroupLoot:GetChecked() ~= nil);

	-- update echo UI
	Lootster_CheckEchoUse();
end

-- Option Echo to Chat Toggle handler
function Lootster_Option_EchoToChat_Toggle()
	-- retrieve value
	Lootster_Options.EchoToChat = (Lootster_OptionsFrameEchoToChat:GetChecked() ~= nil);
end

-- Option Echo to CT_RaidAssist Toggle handler
function Lootster_Option_EchoToCTRA_Toggle()
	-- retrieve value
	Lootster_Options.EchoToCTRA = (Lootster_OptionsFrameEchoToCTRA:GetChecked() ~= nil);
end

-- Option Auto-Snoop Toggle handler
function Lootster_Option_AutoSnoop_Toggle()
	-- retrieve value
	Lootster_Options.AutoSnoop = (Lootster_OptionsFrameAutoSnoop:GetChecked() ~= nil);
end

-- Option Debug Messages Chat Toggle handler
function Lootster_Option_DebugMsgs_Toggle()
	-- retrieve value
	Lootster_Options.DebugMsgs = (Lootster_OptionsFrameDebugMsgs:GetChecked() ~= nil);

	-- if we are switching on debug messages, clear the From Whisper queue
	if (Lootster_Options.DebugMsgs) then
		Lootster_FromWhisperQue = nil;
	end
end

-- Option Roll Mode Load handler
function Lootster_Option_RollMode_OnLoad()
	-- initially disable
	Lootster_OptionsFrameRollModeButton:Disable();

	-- set width
	UIDropDownMenu_SetWidth(150);
end

-- Option Roll Mode Show handler
function Lootster_Option_RollMode_OnShow()
	-- setup the roll mode drop down
	UIDropDownMenu_Initialize(Lootster_OptionsFrameRollMode, Lootster_Option_RollMode_Initialise);

	-- set initial selection
	UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollMode, Lootster_Options.RollMode);
end

-- Option Roll Mode Load Initaliser handler
function Lootster_Option_RollMode_Initialise()
	local ix, type, info;

	for ix, type in ipairs(LOOTSTER_OPTION_ROLLMODELIST) do
		-- form mode button
		info = {};
		info.text = type;
		info.func = Lootster_Option_RollMode_OnSelect;

		-- add roll mode button
		UIDropDownMenu_AddButton(info);
	end
end

-- Option Roll Mode Select handler
function Lootster_Option_RollMode_OnSelect()
	-- select this entry
	UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollMode, this:GetID());

	-- and snarf new mode
	Lootster_Options.RollMode = this:GetID();

	-- update roll handling
	Lootster_UpdateRollHandling();

	-- and show/hide the MiniMap button and hide/show the title
	Lootster_MiniMapButton_SwitchState();
end

-- Option Roll Type Load handler
function Lootster_Option_RollType_OnLoad()
	-- set width
	UIDropDownMenu_SetWidth(150);
end

-- Option Roll Type Show handler
function Lootster_Option_RollType_OnShow()
	-- setup the roll type drop down
	UIDropDownMenu_Initialize(Lootster_OptionsFrameRollType, Lootster_Option_RollType_Initialise);

	-- set initial selection depending on mode
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- DKP type
		UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollType, Lootster_Options.DKPType);
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
		-- normal type
		UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollType, Lootster_Options.NormType);
	end
end

-- Option Roll Type Load Initaliser handler
function Lootster_Option_RollType_Initialise()
	local list, ix, type, info;

	-- determine which list to use
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- DKP type
		list = LOOTSTER_OPTION_DKPTYPELIST;
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
		-- normal type
		list = LOOTSTER_OPTION_NORMTYPELIST;
	else
		list = {};
	end

	for ix, type in ipairs(list) do
		-- form type button
		info = {};
		info.text = type;
		info.func = Lootster_Option_RollType_OnSelect;

		-- add DKP type button
		UIDropDownMenu_AddButton(info);
	end
end

-- Option Roll Type Select handler
function Lootster_Option_RollType_OnSelect()
	-- select this entry
	UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollType, this:GetID());

	-- and snarf new type
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- DKP type
		Lootster_Options.DKPType = this:GetID();
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
		-- normal type
		Lootster_Options.NormType = this:GetID();
	end

	-- update roll handling
	Lootster_UpdateRollHandling();
end

-- Option DKP Priority Toggle handler
function Lootster_Option_DKPPriority_Toggle()
	-- retrieve value
	Lootster_Options.DKPPrior = (Lootster_OptionsFrameDKPPriority:GetChecked() ~= nil);

	-- update roll handling
	Lootster_UpdateRollHandling();
end

-- Option DKP Caps Toggle handler
function Lootster_Option_DKPCaps_Toggle()
	-- retrieve value
	Lootster_Options.DKPCaps = (Lootster_OptionsFrameDKPCaps:GetChecked() ~= nil);

	-- update roll handling
	Lootster_UpdateRollHandling();
end

-- Option DKP Hi Cap Focus Gained handler
function Lootster_Option_DKPHi_FocusGained()
	-- save the current value so we can detect changes
	Lootster_DKPHiSave = Lootster_Options.DKPHi;
end

-- Option DKP Hi Cap Value handler
function Lootster_Option_DKPHi_Entered()
	-- retrieve value
	Lootster_Options.DKPHi = Lootster_OptionsFrameDKPHi:GetNumber();

	-- must be positive
	if (Lootster_Options.DKPHi < 0) then
		Lootster_Options.DKPHi = -Lootster_Options.DKPHi;

		-- update
		Lootster_OptionsFrameDKPHi:SetNumber(Lootster_Options.DKPHi);
	end

	-- update read-only RO version
	Lootster_OptionsFrameDKPHiRO:SetText(Lootster_Options.DKPHi);

	-- reformat our roll button text
	Lootster_UpdateRoll();
end

-- Option DKP Hi Cap Focus Lost handler
function Lootster_Option_DKPHi_FocusLost()
	-- did the Hi DKP cap change?
	if (Lootster_DKPHiSave ~= Lootster_Options.DKPHi) then
		-- update roll handling to setup caps
		Lootster_UpdateRollHandling();
	end

	-- and reset the DKP Hi cap save
	Lootster_DKPHiSave = nil;
end

-- Option DKP Lo Cap Focus Gained handler
function Lootster_Option_DKPLo_FocusGained()
	-- save the current value so we can detect changes
	Lootster_DKPLoSave = Lootster_Options.DKPLo;
end

-- Option DKP Lo Cap Value handler
function Lootster_Option_DKPLo_Entered()
	-- retrieve value
	Lootster_Options.DKPLo = Lootster_OptionsFrameDKPLo:GetNumber();

	-- must be positive
	if (Lootster_Options.DKPLo < 0) then
		Lootster_Options.DKPLo = -Lootster_Options.DKPLo;

		-- update
		Lootster_OptionsFrameDKPLo:SetNumber(Lootster_Options.DKPLo);
	end

	-- update read-only RO version
	Lootster_OptionsFrameDKPLoRO:SetText(Lootster_Options.DKPLo);

	-- reformat our roll button text
	Lootster_UpdateRoll();
end

-- Option DKP Lo Cap Focus Lost handler
function Lootster_Option_DKPLo_FocusLost()
	-- did the Lo DKP cap change?
	if (Lootster_DKPLoSave ~= Lootster_Options.DKPLo) then
		-- update roll handling to setup caps
		Lootster_UpdateRollHandling();
	end

	-- and reset the DKP Lo cap save
	Lootster_DKPLoSave = nil;
end

-- Option DKP Factoring Toggle handler
function Lootster_Option_DKPFactoring_Toggle()
	-- retrieve value
	Lootster_Options.DKPFactoring = (Lootster_OptionsFrameDKPFactoring:GetChecked() ~= nil);

	-- update roll handling
	Lootster_UpdateRollHandling();
end

-- Option DKP Factor Focus Gained handler
function Lootster_Option_DKPFactor_FocusGained()
	-- save the current value so we can detect changes
	Lootster_DKPFactorSave = Lootster_Options.DKPFactor;
end

-- Option DKP Factor Entered handler
function Lootster_Option_DKPFactor_Entered()
	local	factor;

	-- retrieve
	Lootster_Options.DKPFactor = Lootster_OptionsFrameDKPFactor:GetNumber();

	-- must be non-nil and non-zero
	if ((Lootster_Options.DKPFactor == nil) or (Lootster_Options.DKPFactor == 0)) then
		-- restore to default of 1
		Lootster_Options.DKPFactor = 1;
	end

	-- update read-only RO version
	Lootster_OptionsFrameDKPFactorRO:SetText(Lootster_Options.DKPFactor);

	-- reformat our roll button text
	Lootster_UpdateRoll();
end

-- Option DKP Factor Focus Lost handler
function Lootster_Option_DKPFactor_FocusLost()
	-- did the DKP factor change?
	if (Lootster_DKPFactorSave ~= Lootster_Options.DKPFactor) then
		-- update roll handling to setup DKP factoring
		Lootster_UpdateRollHandling();
	end

	-- and reset the DKP factor
	Lootster_DKPFactorSave = nil;
end

-- Option Normal 100/1000 Roll Toggle handler
function Lootster_Option_NormCorKRoll_Toggle()
	-- retrieve value
	Lootster_Options.CorKRoll = (Lootster_OptionsFrameNormCorKRoll:GetChecked() ~= nil);

	-- update roll handling to setup 100/1000 rolling
	Lootster_UpdateRollHandling();
end

-- Option Normal 100/1000 Open Toggle handler
function Lootster_Option_NormCorKOpen_Toggle()
	-- retrieve value
	Lootster_Options.CorKOpen = (Lootster_OptionsFrameNormCorKOpen:GetChecked() ~= nil);
end

-- Option Normal 100/1000 Close Toggle handler
function Lootster_Option_NormCorKClose_Toggle()
	-- retrieve value
	Lootster_Options.CorKClose = (Lootster_OptionsFrameNormCorKClose:GetChecked() ~= nil);
end

-- Option Track By Click handler
function Lootster_Option_Track_RadioButton_OnClick(index)
	-- snarf index
	Lootster_Options.TrackBy = index;
	
	-- determine the attendance button
	Lootster_OptionFrameRaidFrameTrackRaid:SetChecked(index == LOOTSTER_ENUM_AUTORAID.RAID);
	Lootster_OptionFrameRaidFrameTrackRaidNBoss:SetChecked(index == LOOTSTER_ENUM_AUTORAID.RAIDNBOSS);
	
	-- play sound if selected
	if (index ~= nil) then
		PlaySound("igMainMenuOptionCheckBoxOn");
	end

	-- update raid management UI
	Lootster_CheckRaidUse();

	-- and show/hide the MiniMap button and hide/show the title
	Lootster_MiniMapButton_SwitchState();
end

-- Option Raid Icon Toggle handler
function Lootster_Option_RaidIcon_Toggle()
	-- retrieve value
	Lootster_Options.RaidIcon = (Lootster_OptionsFrameRaidIcon:GetChecked() ~= nil);

	-- and show/hide the MiniMap button and hide/show the title
	Lootster_MiniMapButton_SwitchState();
end

-- Option Boss Icon Toggle handler
function Lootster_Option_BossIcon_Toggle()
	-- retrieve value
	Lootster_Options.BossIcon = (Lootster_OptionsFrameBossIcon:GetChecked() ~= nil);

	-- and show/hide the MiniMap button and hide/show the title
	Lootster_MiniMapButton_SwitchState();
end

-- Option Auto Raid Toggle handler
function Lootster_Option_AutoRaid_Toggle()
	-- retrieve value
	Lootster_Options.AutoRaid = (Lootster_OptionsFrameAutoRaid:GetChecked() ~= nil);
end

-- Option Loot Mode Load handler
function Lootster_Option_LootMode_OnLoad()
	-- set width
	UIDropDownMenu_SetWidth(115);
end

-- Option Loot Mode Show handler
function Lootster_Option_LootMode_OnShow()
	-- setup the loot mode drop down
	UIDropDownMenu_Initialize(Lootster_OptionsFrameLootMode, Lootster_Option_LootMode_Initialise);

	-- set initial selection
	UIDropDownMenu_SetSelectedValue(Lootster_OptionsFrameLootMode, Lootster_Options.LootMode);
end

-- Option Loot Mode Load Initaliser handler
function Lootster_Option_LootMode_Initialise()
	local quality, info;

	-- load up loot quality
	for quality=LOOTSTER_ENUM_LOOTMODE.UNCOMMON, LOOTSTER_ENUM_LOOTMODE.LEGENDARY do
		-- form mode button
		info = {};
		info.text = getglobal("ITEM_QUALITY"..quality.."_DESC");
		info.func = Lootster_Option_LootMode_OnSelect;
		info.textR = ITEM_QUALITY_COLORS[quality].r;
		info.textG = ITEM_QUALITY_COLORS[quality].g;
		info.textB = ITEM_QUALITY_COLORS[quality].b;
		info.value = quality;

		-- add loot mode button
		UIDropDownMenu_AddButton(info);
	end
end

-- Option Loot Mode Select handler
function Lootster_Option_LootMode_OnSelect()
	-- and snarf new mode
	Lootster_Options.LootMode = this.value;

	-- select this entry
	UIDropDownMenu_SetSelectedValue(Lootster_OptionsFrameLootMode, this.value);

	-- and show/hide the MiniMap button and hide/show the title
	Lootster_MiniMapButton_SwitchState();
end

-- Option Auto DKP Loot Toggle handler
function Lootster_Option_AutoDKPLoot_Toggle()
	-- retrieve value
	Lootster_Options.AutoDKPLoot = (Lootster_OptionsFrameAutoDKPLoot:GetChecked() ~= nil);
end

-- Option Auto NonDKP Loot Toggle handler
function Lootster_Option_AutoNonDKPLoot_Toggle()
	-- retrieve value
	Lootster_Options.AutoNonDKPLoot = (Lootster_OptionsFrameAutoNonDKPLoot:GetChecked() ~= nil);
end

-- Option Auto Loot Raid Toggle handler
function Lootster_Option_AutoLootRaid_Toggle()
	-- retrieve value
	Lootster_Options.AutoLootRaid = (Lootster_OptionsFrameAutoLootRaid:GetChecked() ~= nil);
end

-- Switch MiniMap Button State handler
function Lootster_MiniMapButton_SwitchState(state)
	-- show/hide the button according to toggle
	if		(Lootster_Options.MiniMap == false) then
		-- hide the mini map frames
		Lootster_MiniMapButton:Hide();
		Lootster_MiniMapRaidButton:Hide();
		Lootster_MiniMapBossButton:Hide();

		-- show the title frame
		Lootster_Title:Show();

		-- ensure the button state is set as appropriate
		if (state ~= nil) then
			Lootster_Title:SetChecked(state);
		end

		-- showing raid icon?
		if	(Lootster_Options.RaidIcon ~= true) then
			-- hide the frame
			Lootster_TitleRaidButton:Hide();
		else
			-- show the frame
			Lootster_TitleRaidButton:Show();

			-- is this button operative?
			if ((Lootster_Running.BossId ~= nil) and (Lootster_Options.TrackBy ~= LOOTSTER_ENUM_AUTORAID.RAID)) then
				-- disable the guy
				Lootster_TitleRaidButton:Disable();
			else
				-- enable the guy
				Lootster_TitleRaidButton:Enable();		

				-- set begin/end textures
				if		(Lootster_Running.RaidId == nil) then
					-- set begin textures
					Lootster_TitleRaidButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterRaidBegButton-Up");
					Lootster_TitleRaidButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterRaidBegButton-Down");
				else
					-- set end textures
					Lootster_TitleRaidButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterRaidEndButton-Up");
					Lootster_TitleRaidButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterRaidEndButton-Down");
				end
			end
		end

		-- show boss icon?
		if	((Lootster_Options.TrackBy == LOOTSTER_ENUM_AUTORAID.RAID) or (Lootster_Options.BossIcon ~= true)) then
			-- hide the frame
			Lootster_TitleBossButton:Hide();
		else
			-- show the frame
			Lootster_TitleBossButton:Show();

			-- is this button operative?
			if (Lootster_Running.RaidId == nil) then
				-- disable the guy
				Lootster_TitleBossButton:Disable();
			else
				-- enable the guy
				Lootster_TitleBossButton:Enable();		

				-- set begin/end textures
				if (Lootster_Running.BossId == nil) then
					-- set begin textures
					Lootster_TitleBossButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterBossBegButton-Up");
					Lootster_TitleBossButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterBossBegButton-Down");
				else
					-- set end textures
					Lootster_TitleBossButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterBossEndButton-Up");
					Lootster_TitleBossButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterBossEndButton-Down");
				end
			end
		end
	else
		-- show the mini map button frame
		Lootster_MiniMapButton:Show();

		-- set textures according to state
		if		(state == false) then
			-- set normal textures
			Lootster_MiniMapButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterMiniMapButton-Up");
			Lootster_MiniMapButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterMiniMapButton-Down");
		elseif	(state == true) then
			-- set highlight textures
			Lootster_MiniMapButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterMiniMapButton-HighUp");
			Lootster_MiniMapButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterMiniMapButton-HighDown");
		end

		-- hide the title frame
		Lootster_Title:Hide();	

		-- ensure the button state is set as appropriate
		if (state ~= nil) then
			Lootster_Title:SetChecked(state);
		end

		-- showing raid icon?
		if	(Lootster_Options.RaidIcon ~= true) then
			-- hide the frame
			Lootster_MiniMapRaidButton:Hide();
		else
			-- show the frame
			Lootster_MiniMapRaidButton:Show();

			-- is this button operative?
			if ((Lootster_Running.BossId ~= nil) and (Lootster_Options.TrackBy ~= LOOTSTER_ENUM_AUTORAID.RAID)) then
				-- disable the guy
				Lootster_MiniMapRaidButton:Disable();
			else
				-- enable the guy
				Lootster_MiniMapRaidButton:Enable();		

				-- set begin/end textures
				if		(Lootster_Running.RaidId == nil) then
					-- set begin textures
					Lootster_MiniMapRaidButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterRaidBegButton-Up");
					Lootster_MiniMapRaidButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterRaidBegButton-Down");
				else
					-- set end textures
					Lootster_MiniMapRaidButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterRaidEndButton-Up");
					Lootster_MiniMapRaidButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterRaidEndButton-Down");
				end
			end
		end

		-- show boss icon?
		if	((Lootster_Options.TrackBy == LOOTSTER_ENUM_AUTORAID.RAID) or (Lootster_Options.BossIcon ~= true)) then
			-- hide the frame
			Lootster_MiniMapBossButton:Hide();
		else
			-- show the frame
			Lootster_MiniMapBossButton:Show();

			-- is this button operative?
			if (Lootster_Running.RaidId == nil) then
				-- disable the guy
				Lootster_MiniMapBossButton:Disable();
			else
				-- enable the guy
				Lootster_MiniMapBossButton:Enable();		

				-- set begin/end textures
				if (Lootster_Running.BossId == nil) then
					-- set begin textures
					Lootster_MiniMapBossButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterBossBegButton-Up");
					Lootster_MiniMapBossButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterBossBegButton-Down");
				else
					-- set end textures
					Lootster_MiniMapBossButton:SetNormalTexture("Interface\\AddOns\\Lootster\\Images\\LootsterBossEndButton-Up");
					Lootster_MiniMapBossButton:SetPushedTexture("Interface\\AddOns\\Lootster\\Images\\LootsterBossEndButton-Down");
				end
			end
		end
	end
end

-- MiniMap Button Position handler
function Lootster_MiniMapButton_UpdatePosition()
	-- update the MiniMap button position
	Lootster_MiniMapButton:SetPoint("TOPLEFT", "Minimap", "TOPLEFT",
									(52 - (80 * cos(Lootster_Options.MiniMapPos))),
									(80 * sin(Lootster_Options.MiniMapPos)) - 52);

	-- update the MiniMap raid icon position
	Lootster_MiniMapRaidButton:SetPoint("TOPLEFT", "Minimap", "TOPLEFT",
										(52 - (108 * cos(Lootster_Options.MiniMapPos + 8))),
										(108 * sin(Lootster_Options.MiniMapPos + 8)) - 52);

	-- update the MiniMap boss icon position
	Lootster_MiniMapBossButton:SetPoint("TOPLEFT", "Minimap", "TOPLEFT",
										(52 - (108 * cos(Lootster_Options.MiniMapPos - 8))),
										(108 * sin(Lootster_Options.MiniMapPos - 8)) - 52);
end

-- Send Broadcast Message handler
function Lootster_SendBroadcast(msg, show)
	local   chan = "SAY";

	-- deterine the channel we should broadcast on
	if		(GetNumRaidMembers() > 0) then
		chan = "RAID";
	elseif	(GetNumPartyMembers() > 0) then
		chan = "PARTY";
	end

	-- are we active?
	if (((Lootster_Options.Active == true) or (show == true)) and (chan ~= "SAY")) then
		-- send to party/raid
		SendChatMessage(msg, chan);
	else
		-- send to ourselves and let it decide
		Lootster_SendPrivate(chan, msg);
	end
end

-- Send Private Message handler
function Lootster_SendPrivate(player, msg, show, sync)
	-- are we active or we always show?
	if		(((Lootster_Options.Active == true) or (show == true)) and (player ~= "SAY")) then
		-- no, so place this message on the To Whisper queue
		Lootster_ToWhisper_Enqueue(player, msg, sync);
	elseif	(Lootster_Options.DebugMsgs == true) then
		-- debugging, send to ourselves
		if (DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage(string.format("<To %s> %s", player, msg));
		end
	end
end

-- Player Inquiry handler
function Lootster_PlayerInquiry(player, msg, noop)
	local	cmd, subcmd, syncmsg, synccmd, payload;

	local	proc = false;
	local	help = false;

	-- we received a whisper - see if it's a lootster command or message.  Chunk it up baby
	_, _, cmd		= string.find(msg, LOOTSTER_CMD_PATTERN);
	_, _, subcmd	= string.find(msg, LOOTSTER_SUBCMD_PATTERN);
	_, _, syncmsg	= string.find(msg, LOOTSTER_SYNC_IMP_PATTERN);

	if		(cmd == LOOTSTER_CMD_LOOT) then
		-- loot command - see what the subcommand was
		if		(noop == true) then
			-- no-op 
		elseif	(subcmd ~= nil) then
			-- see what the subcommand is
			if		(subcmd == LOOTSTER_SUBCMD_HELP) then
				-- echo help
				Lootster_Rule_ShowHelp_OnClick(player);
			elseif	(subcmd == LOOTSTER_SUBCMD_ROLL) then
				-- echo player's roll command
				Lootster_EchoPlayerRoll(player, true);
			elseif	(subcmd == LOOTSTER_SUBCMD_RULES) then
				-- echo rules
				Lootster_Rule_ShowRules_OnClick(player);
			elseif	(subcmd == LOOTSTER_SUBCMD_VERSION) then
				-- echo current version
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_LOAD, LOOTSTER_VERSION), true);
			else
				-- please help me
				help = true;
			end
		else
			-- please help me
			help = true;
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_ADJ) then
		-- adjust command - see what the subcommand is, if any
		if		(noop == true) then
			-- no-op 
		elseif	(subcmd == nil) then
			-- echo player's adjustments
			Lootster_EchoPlayerAdjusts(player, player);
		else
			local	class, name;

			-- see what the subcommand is a class or a player
			class = string.lower(subcmd);

			name = string.lower(subcmd);

			if (Lootster_ClassLower[class] ~= nil) then
				-- they want the adjusts for players in the class
				for playerkey, rosRec in pairs(Lootster_Roster) do
					-- is this player of that class?
					if (rosRec.ClassType == Lootster_ClassLower[class]) then
						-- echo this player's adjustments
						Lootster_EchoPlayerAdjusts(player, playerkey);
					end
				end
			else
				-- they want the adjusts for matching players
				for playerkey, rosRec in pairs(Lootster_Roster) do
					-- does this player match the passed name
					if (string.find(rosRec.Name, name) ~= nil) then
						-- echo this player's adjustments
						Lootster_EchoPlayerAdjusts(player, playerkey);
					end
				end
			end
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_DKP) then
		-- DKP command - see what the subcommand is, if any
		if		(noop == true) then
			-- no-op 
		elseif	(subcmd == nil) then
			-- echo player's DKP
			Lootster_EchoPlayerDKP(player, player);
		else
			local	class, name;

			-- see what the subcommand is a class or a player
			class = string.lower(subcmd);

			name = string.lower(subcmd);

			if (LOOTSTER_CLASS[class] ~= nil) then
				-- they want the DKP for players in the class
				for playerkey, rosRec in pairs(Lootster_Roster) do
					-- is this player of that class?
					if (rosRec.ClassType == LOOTSTER_CLASS[class].ClassType) then
						-- echo this player's DKP
						Lootster_EchoPlayerDKP(player, playerkey);
					end
				end
			else
				-- they want the DKP for matching players
				for playerkey, rosRec in pairs(Lootster_Roster) do
					-- does this player match the passed name
					if (string.find(rosRec.Name, name) ~= nil) then
						-- echo this player's DKP
						Lootster_EchoPlayerDKP(player, playerkey);
					end
				end
			end
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_MOB) then
		-- item command - see what the item subcommand is
		if		(noop == true) then
			-- no-op 
		elseif	(subcmd == nil) then
			-- please help me
			help = true;
		else
			local	name;

			name = string.lower(subcmd);

			-- they want the DKP for items dropped by matching mobs
			for mobkey, mobsRec in pairs(Lootster_MobsDKP) do
				-- does this mob match the passed name
				if (string.find(mobsRec.Name, name) ~= nil) then
					-- hammer through all items looking for items dropped by this guy
					for itemkey, itemRec in pairs(Lootster_ItemDKP) do
						-- does this player match the passed name
						if (mobkey == itemRec.Mob) then
							-- echo this item's DKP
							Lootster_EchoItemDKP(player, itemkey);
						end
					end
				end
			end
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_ITEM) then
		-- item command - see what the item subcommand is
		if		(noop == true) then
			-- no-op 
		elseif	(subcmd == nil) then
			-- please help me
			help = true;
		else
			local	name;

			name = string.lower(subcmd);

			-- they want the DKP for matching items
			for itemkey, itemRec in pairs(Lootster_ItemDKP) do
				-- does this player match the passed name
				if (string.find(itemRec.Name, name) ~= nil) then
					-- echo this item's DKP
					Lootster_EchoItemDKP(player, itemkey);
				end
			end
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_TELL) then
		-- tell command - see what the subcommand was
		if		(noop == true) then
			-- no-op 
		elseif	(subcmd ~= nil) then
			-- see what the subcommand is
			if		(subcmd == LOOTSTER_SUBCMD_ROLL) then
				-- toggle this player's roll whispers
				Lootster_Players[player].AckRoll = not Lootster_TestPlayerTell(player, "AckRoll");

				-- let em know
				if (Lootster_Players[player].AckRoll == true) then
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKROLL, LOOTSTER_TOGGLE_ON));
				else
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKROLL, LOOTSTER_TOGGLE_OFF));
				end
			elseif	(subcmd == LOOTSTER_SUBCMD_NOCALL) then
				-- toggle this player's no call whispers
				Lootster_Players[player].AckNoCall = not Lootster_TestPlayerTell(player, "AckNoCall");

				-- let em know
				if (Lootster_Players[player].AckNoCall == true) then
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOCALL, LOOTSTER_TOGGLE_ON));
				else
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOCALL, LOOTSTER_TOGGLE_OFF));
				end
			elseif	(subcmd == LOOTSTER_SUBCMD_NOROLL) then
				-- toggle this player's no laggard roll command whispers
				Lootster_Players[player].AckNoRoll = not Lootster_TestPlayerTell(player, "AckNoRoll");

				-- let em know
				if (Lootster_Players[player].AckNoRoll == true) then
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOROLL, LOOTSTER_TOGGLE_ON));
				else
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOROLL, LOOTSTER_TOGGLE_OFF));
				end
			elseif	(subcmd == LOOTSTER_SUBCMD_NOHELP) then
				-- toggle this player's no help on bad whisper command whispers
				Lootster_Players[player].AckNoHelp = not Lootster_TestPlayerTell(player, "AckNoHelp");

				-- let em know
				if (Lootster_Players[player].AckNoHelp == true) then
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOHELP, LOOTSTER_TOGGLE_ON));
				else
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOHELP, LOOTSTER_TOGGLE_OFF));
				end
			elseif	(subcmd == LOOTSTER_SUBCMD_RESET) then
				-- remove any player whisper toggle overrides
				Lootster_Players[player] = nil;

				-- let em know
				Lootster_SendPrivate(player, LOOTSTER_MSG_TELL_RESET);
			else
				-- please help me
				help = true;
			end
		else
			-- please help me
			help = true;
		end

		-- processed this guy
		proc = true;
	elseif	(syncmsg ~= nil) then
		if (noop == true) then
			-- no-op 
			proc = true;
		else
			-- is this a continutation record?
			if		((string.len(msg) == LOOTSTER_SYNC_MESSAGELEN) and (string.sub(msg, -1) == LOOTSTER_SYNC_POSTFIXCONT)) then
				-- continuation records are received after initiation
				if	((Lootster_SyncType == nil) or (Lootster_SyncUser ~= player)) then
					-- eep!  Player is not our synchronise target - no message as it can spam
					return false;
				end

				-- have we a current continuation record?
				if (Lootster_SyncCont == nil) then
					-- snarf initial continuation record
					Lootster_SyncCont = syncmsg;
				else
					-- next continuation record - just add payload sans continuation marker
					Lootster_SyncCont = Lootster_SyncCont..string.sub(syncmsg, 1, -1);
				end

				-- update timers so we don't timeout
				Lootster_Sync_StateUpdate();
				return true;
			elseif	(Lootster_SyncCont ~= nil) then
				-- continuation records are received after initiation
				if	((Lootster_SyncType == nil) or (Lootster_SyncUser ~= player)) then
					-- eep!  Player is not our synchronise target - no message as it can spam
					return false;
				end

				-- final continuation record - add payload and make this the real message
				syncmsg = Lootster_SyncCont..syncmsg;

				-- reset continuation record
				Lootster_SyncCont = nil;
			end

			-- extract synchronise command and payload
			_, _, synccmd, payload	= string.find(syncmsg, LOOTSTER_SYNC_IMP_COMMAND);

			-- Lootster to Lootster synchronise command
			proc = Lootster_Sync_Process(player, synccmd, payload);
		end
	end

	-- are they are noddy?
	if (help == true) then
		-- have they switched off help on bad whispers?
		if (Lootster_TestPlayerTell(player, "AckNoHelp") == true) then
			-- tell them they got it wrong, then echo help
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_BADCOMMAND, msg));
	
			Lootster_Rule_ShowHelp_OnClick(player);
		end
	end

	return proc;
end

-- Add Roller
function Lootster_AddRoller(player)
	-- if the roll table is empty, we bookkeep all the guys so we have a visual
	-- on who has and has not rolled
	if (table.getn(Lootster_RollsSort) == 0) then
		-- add this roller first
		Lootster_AddPlayer(player);

		-- do the rest of the raid
		for key, value in pairs(Lootster_Roster) do
			-- in the roll list?
			if (Lootster_Rolls[key] == nil) then
				-- add this player
				Lootster_AddPlayer(key);
			end
		end
	else
		-- just make sure this guy is added (joined after roll started)
		Lootster_AddPlayer(player);
	end
end

-- Add Player
function Lootster_AddPlayer(player)
	-- is this guy in the roll roster?
	if (Lootster_RosterRoll[player] == nil) then
		-- ignore this guy
		return;
	end

	-- is the player already in the table?
	if (Lootster_Rolls[player] == nil) then
		-- nope, so insert with default data
		Lootster_Rolls[player] = Lootster_NewRolls(player, nil, Lootster_Roster[player].Class, Lootster_RosterRoll[player].DKP, Lootster_RosterRoll[player].Tier, Lootster_RosterRoll[player].Trial, Lootster_RosterRoll[player].App, Lootster_RosterRoll[player].Priority);
	end
end

-- Ask Player for a Roll handler
function Lootster_AskForRoll(player)
	-- see what roll mode we are in
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		local	rngRoll;

		-- determine DKP roll
		rngRoll = Lootster_GetPlayerRoll(player);

		-- ask them to roll
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASKN, Lootster_NBG, rngRoll));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASKN_LINK, Lootster_NBG, Lootster_ItemLink, rngRoll));
		end
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
		-- 100/1000 or Need then Greed?
		if		(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			-- ask them to roll 100/1000
			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASK1000, Lootster_NBG));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASK1000_LINK, Lootster_NBG, Lootster_ItemLink));
			end
		elseif	(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BYNEEDGREED) then
			-- ask them to roll 100
			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASK100, Lootster_NBG));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASK100_LINK, Lootster_NBG, Lootster_ItemLink));
			end
		end
	end
end

-- Update Roll Text handler
function Lootster_UpdateRoll()
	-- update our roll button text
	if		((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_Rolls[Lootster_Self] ~= nil)) then
		-- tied roll is 100
		Lootster_SelfRoll = 100;
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- get our DKP roll
		Lootster_SelfRoll = Lootster_GetPlayerRoll(Lootster_Self);
	else
		-- default roll
		Lootster_SelfRoll = 100;
	end

	-- format for the roll button
	Lootster_RollFrameRoll:SetText(string.format(LOOTSTER_ROLL_ROLLRNG_FMT, Lootster_SelfRoll));
end

-- Reset Class handler
function Lootster_ResetClass()
	-- reset restricted count
	Lootster_RestrictedCount = 0;

	-- make sure we clear current class restriction flags
	Lootster_ClassRestricted = false;
	Lootster_ClassRestrictedLock = false;

	-- no classes
	Lootster_ClassRestrictions = {};

	-- reset the restriction masks
	Lootster_ClassRestrictionsMaskOrig = 0;
	Lootster_ClassRestrictionsMaskCurr = 0;

	-- reset count
	table.setn(Lootster_ClassRestrictions, 0);
end

-- Update Class handler
function Lootster_UpdateClassUI()
	local	cix;
	local	button;

	-- set the class restrictions
	for cix = 1, table.getn(LOOTSTER_CLASS_SORT), 1 do
		-- get the class item button
		button = getglobal("Lootster_ClassFrameClass"..cix);

		-- is this guy allowed?
		if ((Lootster_ClassRestrictions[LOOTSTER_CLASS_SORT[cix]] ~= nil) and (Lootster_ClassRestrictions[LOOTSTER_CLASS_SORT[cix]] == true)) then
			button:SetChecked(true);
		else
			button:SetChecked(false);
		end

		-- enable/disable the button depending on whether these class restrictions are locked down
		if (Lootster_ClassRestrictedLock == true) then
			button:Disable();
		else
			button:Enable();
		end
	end
end

-- Update Restricted Count handler
function Lootster_UpdateRestricted()
	-- reset restricted count
	Lootster_RestrictedCount = 0;

	-- hammer through the roster counting allowed classes
	for player, rosRec in pairs(Lootster_Roster) do
		-- is this player allowed to roll?
		if ((Lootster_ClassRestrictions[rosRec.ClassType] ~= nil) and (Lootster_ClassRestrictions[rosRec.ClassType] == true)) then
			Lootster_RestrictedCount = Lootster_RestrictedCount + 1;
		end
	end
end

-- Process Roll handler
function Lootster_ProcessRoll(player, roll, minRoll, maxRoll)
	local   rngRoll;

	-- if no roll call, are we in Normal 100/1000 mode using auto-roll?
	if ((Lootster_NBG == nil) and (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) and (Lootster_Options.CorKRoll == true)) then
		-- we are allowing auto-roll, so force that mode
		Lootster_Roll_1001000Roll_OnClick();

		-- is the Looster window open?
		if (not (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RaidFrame:IsVisible() or Lootster_ItemFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible())) then
			-- Lootster is close, so are we to open on roll?
			if (Lootster_Options.CorKOpen == true) then
				-- yup, so fire up the window
				Lootster_Toggle();
			else
				-- toggle highligh state of MiniMap button/title
				Lootster_MiniMapButton_SwitchState(true);
			end
		end
	end

	-- make sure there has been a roll call and player is in roster
	if		(Lootster_NBG == nil) then
		-- are we to ack the no call for roll?
		if (Lootster_TestPlayerTell(player, "AckNoCall") == true) then
			-- format the no roll call message for the player and let them know
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NONBGPLAYER, Lootster_Self));

			-- format the no roll call message for ourselves and let us know
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_NONBGSELF, player));
		end
		return;
	elseif	(Lootster_Roster[player] == nil) then
		-- format the no member message for ourselves and let us know
		Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_NOTMEMBER, player));
		return;
	elseif	(Lootster_NBG == LOOTSTER_NBG_TIED) then
		-- in a tied situation, only the tied players are allowed to roll
		if (Lootster_Rolls[player] == nil) then
			-- too bad buddy - format the not tied winner message
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTTIEDPLAYER));

			-- format the not tied winner message for ourselves and let us know
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_NOTTIEDSELF, player));
			return;
		end
	end

	-- convert roll values
	roll	= tonumber(roll);
	minRoll	= tonumber(minRoll);
	maxRoll	= tonumber(maxRoll);

	-- if we are not using DKP, rolls must be normal (1-100)
	if		(Lootster_NBG == LOOTSTER_NBG_TIED) then
		-- tied roll range is 100
		rngRoll = 100;
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- calculate DKP roll
		rngRoll = Lootster_GetPlayerRoll(player);
	else
		-- normal is 100
		rngRoll = 100;
	end

	-- is this guy allowed to roll?
	if		(Lootster_RosterRoll[player] == nil) then
		-- naughty naughty bad Zoot!
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTROLLCLASS, roll, minRoll, maxRoll, Lootster_NBG_ClassIgnore));
		return;
	elseif	((Lootster_NBG == LOOTSTER_NBG_1001000) and (maxRoll == 100) and (Lootster_ClassRestricted == true) and 
			 ((Lootster_ClassRestrictions[Lootster_Roster[player].ClassType] == nil) or (Lootster_ClassRestrictions[Lootster_Roster[player].ClassType] == false))) then
		-- this is 100/1000 call, and they rolled Need for something that is class restricted against them
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTROLLCLASS, roll, minRoll, maxRoll, Lootster_NBG_ClassIgnore));
		return;
	end

	-- bookkeep the roller
	Lootster_AddRoller(player);

	-- check for reclaim, valid and duplicate rolls
	if		((Lootster_Rolls[player].Roll ~= nil) and (Lootster_Rolls[player].Roll > 0)) then
		-- if this is 100/1000 mode, then they are allowed to downgrade from Need to Greed
		if ((Lootster_NBG == LOOTSTER_NBG_1001000) and (minRoll == 1) and (maxRoll == 1000) and (Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED)) then
			-- are we to ack the roll?
			if (Lootster_TestPlayerTell(player, "AckRoll") == true) then
				-- format the ack message and let them know
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKROLLTOGREED, roll, minRoll, maxRoll));
			end

			-- bookkeep the roll
			Lootster_Rolls[player].Roll = roll;

			-- this is now a Greed
			Lootster_Rolls[player].Priority = LOOTSTER_ENUM_NBG.GREED;
		else
			-- format the duplicate message and let them know
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_DUP, roll, minRoll, maxRoll, Lootster_Rolls[player].Roll));

			-- bookkeep the duplicate roll
			if (Lootster_Rolls[player].Dup == nil) then
				Lootster_Rolls[player].Dup = 1;
			else
				Lootster_Rolls[player].Dup = Lootster_Rolls[player].Dup + 1;
			end
		end
	elseif	((Lootster_Rolls[player].Roll ~= nil) and (Lootster_Rolls[player].Roll < 0)) then
		-- if this is 100/1000 mode, then they are allowed to downgrade from Need to Greed
		if ((Lootster_NBG == LOOTSTER_NBG_1001000) and (minRoll == 1) and (maxRoll == 1000) and (Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED)) then
			-- are we to ack the roll?
			if (Lootster_TestPlayerTell(player, "AckRoll") == true) then
				-- format the ack message and let them know
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKROLLTOGREED, roll, minRoll, maxRoll));
			end

			-- bookkeep the roll
			Lootster_Rolls[player].Roll = roll;

			-- this is now a Greed
			Lootster_Rolls[player].Priority = LOOTSTER_ENUM_NBG.GREED;

			-- did this come from us?
			if (player == Lootster_Self) then
				-- update the text to indicate pass
				Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
			end
		else
			-- they passed a previous roll - let them know they need to reclaim rather than reroll
			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_MUSTRECLAIMROLL, -Lootster_Rolls[player].Roll, Lootster_NBG));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_MUSTRECLAIMROLL_LINK, -Lootster_Rolls[player].Roll, Lootster_NBG, Lootster_ItemLink));
			end
			return;
		end
	elseif	((minRoll ~= 1) or 
			 ((maxRoll ~= rngRoll) and ((Lootster_NBG ~= LOOTSTER_NBG_1001000) or (maxRoll ~= 1000)))) then
		-- format the reject message and let them know
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_REJECT, roll, minRoll, maxRoll));

		-- inform user to roll
		Lootster_AskForRoll(player);

		-- bookkeep the bad roll
		if (Lootster_Rolls[player].Bad == nil) then
			Lootster_Rolls[player].Bad = 1;
		else
			Lootster_Rolls[player].Bad = Lootster_Rolls[player].Bad + 1;
		end
	else
		-- are we to ack the roll?
		if (Lootster_TestPlayerTell(player, "AckRoll") == true) then
			-- format the ack message and let them know
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKROLL, roll, minRoll, maxRoll));
		end

		-- bump roll count unless they had passed
		if (Lootster_Rolls[player].Roll ~= 0) then
			Lootster_RollCount = Lootster_RollCount + 1;
		end

		-- bookkeep the roll
		Lootster_Rolls[player].Roll = roll;

		-- are we using 100/1000?
		if (Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- 100 is a Greed roll
			if (maxRoll == 100) then
				-- this is Need
				Lootster_Rolls[player].Priority = LOOTSTER_ENUM_NBG.NEED;
			else
				-- this is Greed
				Lootster_Rolls[player].Priority = LOOTSTER_ENUM_NBG.GREED;
			end
		end
	end

	-- resort the rolls
	Lootster_Roll_Sort();

	-- update received roll status
	Lootster_UpdateRollUI();	

	-- update the screen
	Lootster_Roll_Update();
end

-- Create Roll Plead handler
function Lootster_CreatePlead()
	local	class, count, ix;

	local	classes = {};

	-- handle the class restrictions if we are rolling Need or 100/1000 and they are set
	if ((Lootster_NBG ~= nil) and ((Lootster_NBG == LOOTSTER_NBG_NEED) or (Lootster_NBG == LOOTSTER_NBG_1001000))) then
		-- see if we have class restrict
		if (table.getn(Lootster_ClassRestrictions) > 0) then
			-- build an alphabetical list of restricted classes
			for ix, flag in ipairs(LOOTSTER_CLASS_SORT) do
				-- is this not the ignore class and this class restricted?
				if ((Lootster_ClassIgnore[LOOTSTER_CLASS_SORT[ix]] == nil) and (Lootster_ClassRestrictions[LOOTSTER_CLASS_SORT[ix]] == true)) then
					table.insert(classes, LOOTSTER_CLASS_SORT[ix]);
				end
			end

			-- now build the class please and class ignore texts
			count = table.getn(classes);

			Lootster_NBG_ClassPlease = "";
			Lootster_NBG_ClassIgnore = "";

			for ix=1, count, 1 do
				-- add plural class to please text
				Lootster_NBG_ClassPlease = Lootster_NBG_ClassPlease..LOOTSTER_CLASS[classes[ix]].Plural;

				if		(ix < (count - 1)) then
					Lootster_NBG_ClassPlease = Lootster_NBG_ClassPlease..LOOTSTER_MSG_SEP;
				elseif (ix == (count - 1)) then
					Lootster_NBG_ClassPlease = Lootster_NBG_ClassPlease..LOOTSTER_MSG_AND;
				end

				-- add singular class to ignore text
				Lootster_NBG_ClassIgnore = Lootster_NBG_ClassIgnore..LOOTSTER_CLASS[classes[ix]].Singular;

				if		(ix < (count - 1)) then
					Lootster_NBG_ClassIgnore = Lootster_NBG_ClassIgnore..LOOTSTER_MSG_SEP;
				elseif (ix == (count - 1)) then
					Lootster_NBG_ClassIgnore = Lootster_NBG_ClassIgnore..LOOTSTER_MSG_OR;
				end
			end

			-- do we have no class restrictions?
			if (count == 0) then
				-- reset class restrictions
				Lootster_ResetClass();

				-- update the class UI
				Lootster_UpdateClassUI();

				-- update the UI
				Lootster_UpdateRollUI();

				-- nope, so use normal plead
				Lootster_NBG_ClassPlease = LOOTSTER_MSG_PLEASE;
			else
				-- yup, so use the class plead
				Lootster_NBG_ClassPlease = string.format(LOOTSTER_MSG_PLEASE_CLASS, Lootster_NBG_ClassPlease);
			end
		else
			-- set the normal plead 
			Lootster_NBG_ClassPlease = LOOTSTER_MSG_PLEASE;
		end
	else
		-- set the normal plead 
		Lootster_NBG_ClassPlease = LOOTSTER_MSG_PLEASE;
	end
end

-- Update Roll UI handler
function Lootster_UpdateRollUI()
	-- enable clear rolls and NBGs depending on state
	if		((Lootster_Tied == true) and (Lootster_NBG ~= LOOTSTER_NBG_TIED)) then
		-- clearable
		Lootster_RollFrameClearRolls:Enable();

		-- waiting for tied roll
		Lootster_RollFrameTiedRoll:Enable();
	elseif	(Lootster_NBG ~= nil) then
		-- clearable
		Lootster_RollFrameClearRolls:Enable();

		-- waiting for rolls
		Lootster_RollFrameNeedRoll:Disable();
		Lootster_RollFrameGreedRoll:Disable();
		Lootster_RollFrame1001000Roll:Disable();
		Lootster_RollFrameTiedRoll:Disable();
	else
		-- can't clear!
		Lootster_RollFrameClearRolls:Disable();

		-- waiting for roll call
		Lootster_RollFrameNeedRoll:Enable();
		Lootster_RollFrameGreedRoll:Enable();
		Lootster_RollFrame1001000Roll:Enable();
		Lootster_RollFrameTiedRoll:Disable();
	end

	-- format received count out of players
	if		(Lootster_NBG == LOOTSTER_NBG_TIED) then
		Lootster_RollFrameRollCount:SetText(string.format(LOOTSTER_ROLL_ROLLCOUNT_FMT, Lootster_RollCount, table.getn(Lootster_RollsSort)));
	elseif	((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true)) then
		Lootster_RollFrameRollCount:SetText(string.format(LOOTSTER_ROLL_ROLLCOUNT_FMT, Lootster_RollCount, Lootster_RestrictedCount));
	else
		Lootster_RollFrameRollCount:SetText(string.format(LOOTSTER_ROLL_ROLLCOUNT_FMT, Lootster_RollCount, Lootster_PlayerCount));
	end

	-- set the text color appropriately
	if		((Lootster_NBG == nil) or (Lootster_RollCount == 0)) then
		Lootster_RollFrameRollCount:Disable();
	elseif	((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_RollCount < table.getn(Lootster_RollsSort))) then
		Lootster_RollFrameRollCount:Enable();
	elseif	((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and (Lootster_RollCount < Lootster_RestrictedCount)) then
		Lootster_RollFrameRollCount:Enable();
	elseif	(((Lootster_NBG ~= LOOTSTER_NBG_NEED) or (Lootster_ClassRestricted == false)) and (Lootster_RollCount < Lootster_PlayerCount)) then
		Lootster_RollFrameRollCount:Enable();
	else	
		Lootster_RollFrameRollCount:Disable();
	end

	-- enable countdown button if NBG set
	if ((Lootster_Options.Counter == false) or (Lootster_Options.CounterSec == 0) or (Lootster_NBG == nil) or 
		((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_RollCount == table.getn(Lootster_RollsSort))) or
		((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and (Lootster_RollCount == Lootster_RestrictedCount)) or
		(((Lootster_NBG ~= LOOTSTER_NBG_NEED) or (Lootster_ClassRestricted == false)) and (Lootster_RollCount == Lootster_PlayerCount))) then
		Lootster_RollFrameCountdown:Disable();
	else
		Lootster_RollFrameCountdown:Enable();
	end

	-- enable announce button if we have (unpassed) rolls.  Also handle loot assignment if using DKP
	if		(Lootster_ItemCount <= 0) then
		-- no items left	
		Lootster_RollFrameAnnounce:Disable();
	elseif	((Lootster_RollCount == 0) or (Lootster_Rolls[Lootster_RollsSort[1]].Roll <= 0)) then
		-- and disallow announcement	
		Lootster_RollFrameAnnounce:Disable();
	else
		-- and allow announcement	
		Lootster_RollFrameAnnounce:Enable();
	end

	-- if we have loot linked, we will allow them to assign loot (Bank/Rotted) if we have a running boss
	if ((Lootster_ItemLink ~= nil) and (Lootster_Running.RaidId ~= nil) and (Lootster_Running.BossId ~= nil)) then
		-- allow loot assignment without roll
		Lootster_RollFrameAssignLoot:Enable();
	else
		-- disallow loot assignment
		Lootster_RollFrameAssignLoot:Disable();
	end

	-- enable roll button if we haven't (pass) rolled (and we are allowed too in a tie)
	if		((Lootster_Options.Active == false) and (Lootster_Options.Passive == true)) then
		-- we are not the active looter in passive roll/pass mode, so enable rolling if we ourselves are not class restricted or its not a Need roll
		if		((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
			Lootster_RollFrameRoll:Disable();
		elseif	(Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- 100/1000 rolling - only enable 100 roll if we are allowed to
			if ((Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
				Lootster_RollFrameRoll100:Disable();
			else
				Lootster_RollFrameRoll100:Enable();
			end

			Lootster_RollFrameRoll1000:Enable();
		else
			Lootster_RollFrameRoll:Enable();
			Lootster_RollFrameRoll100:Enable();
			Lootster_RollFrameRoll1000:Enable();
		end
	elseif	(Lootster_NBG == nil) then
		Lootster_RollFrameRoll:Disable();

		-- are in 100/1000 and are allowed to roll without a call?
		if ((Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) and (Lootster_Options.CorKRoll == true)) then
			Lootster_RollFrameRoll100:Enable();
			Lootster_RollFrameRoll1000:Enable();
		else
			Lootster_RollFrameRoll100:Disable();
			Lootster_RollFrameRoll1000:Disable();
		end
	elseif	((Lootster_Rolls[Lootster_Self] ~= nil) and (Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll ~= 0)) then
		Lootster_RollFrameRoll:Disable();
		Lootster_RollFrameRoll100:Disable();

		-- if we are in 100/1000 mode, and they rolled Need, we can downgrade to Greed
		if ((Lootster_NBG == LOOTSTER_NBG_1001000) and (Lootster_Rolls[Lootster_Self].Priority == LOOTSTER_ENUM_NBG.NEED)) then
			Lootster_RollFrameRoll1000:Enable();
		else
			Lootster_RollFrameRoll1000:Disable();
		end
	else
		-- see if we are in a tie or restricted or its not a Need roll 
		if		((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_Rolls[Lootster_Self] == nil)) then
			Lootster_RollFrameRoll:Disable();
		elseif	((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
			Lootster_RollFrameRoll:Disable();
		elseif	(Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- 100/1000 rolling - only enable 100 roll if we are allowed to
			if ((Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
				Lootster_RollFrameRoll100:Disable();
			else
				Lootster_RollFrameRoll100:Enable();
			end

			Lootster_RollFrameRoll1000:Enable();
		else
			Lootster_RollFrameRoll:Enable();
			Lootster_RollFrameRoll100:Enable();
			Lootster_RollFrameRoll1000:Enable();
		end
	end

	-- handle pass/reclaim button depending if they have rolled
	if		((Lootster_Options.Active == false) and (Lootster_Options.Passive == true)) then
		-- we are not the active looter in passive roll/pass mode, so enable pass/reclaim if we ourselves are not class restricted or its not a Need roll
		Lootster_RollFramePassReclaim:Enable();
		if ((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
			Lootster_RollFramePassReclaim:Disable();
		else
			Lootster_RollFramePassReclaim:Enable();
		end
	elseif	(Lootster_NBG == nil) then
		-- nothing to roll on yet
		Lootster_RollFramePassReclaim:Disable();
	elseif	(Lootster_Rolls[Lootster_Self] ~= nil) then
		-- pass/reclaim if we haven't/have passed
		if		((Lootster_Rolls[Lootster_Self].Roll == nil) or (Lootster_Rolls[Lootster_Self].Roll ~= 0)) then
			-- they can pass/reclaim as the case may be
			Lootster_RollFramePassReclaim:Enable();
		elseif	((Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll == 0)) then
			-- they can roll if they want
			Lootster_RollFramePassReclaim:Disable();
		end
	elseif	((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
		Lootster_RollFramePassReclaim:Disable();
	else
		-- no roll yet, but they can pass
		Lootster_RollFramePassReclaim:Enable();
	end

	-- if we are in roll mode, disable item count, DKP use toggle and DKP caps
	if ((Lootster_NBG ~= nil) or (Lootster_Tied == true)) then
		-- disable item count
		Lootster_RollFrameItems:Hide();

		Lootster_RollFrameItemsROFrame:Show();

		-- do we have DKP handling?
		if (Lootster_HasDKP == true) then
			-- disable roll mode dropdown
			Lootster_OptionsFrameRollModeButton:Disable();
		end

		-- disable roll type dropdown
		Lootster_OptionsFrameRollTypeButton:Disable();

		-- disable DKP priority option
		Lootster_OptionsFrameDKPPriority:Disable();

		-- disable DKP cap options
		Lootster_OptionsFrameDKPCaps:Disable();
		Lootster_OptionsFrameDKPHi:Hide();
		Lootster_OptionsFrameDKPLo:Hide();

		Lootster_OptionsFrameDKPHiROFrame:Show();
		Lootster_OptionsFrameDKPLoROFrame:Show();

		-- disable DKP factor options
		Lootster_OptionsFrameDKPFactoring:Disable();
		Lootster_OptionsFrameDKPFactor:Hide();

		Lootster_OptionsFrameDKPFactorROFrame:Show();
	else
		-- enable item count
		Lootster_RollFrameItems:Show();

		Lootster_RollFrameItemsROFrame:Hide();

		-- do we have DKP handling?
		if (Lootster_HasDKP == true) then
			-- enable roll mode dropdown
			Lootster_OptionsFrameRollModeButton:Enable();
		end

		-- enable roll type dropdown
		Lootster_OptionsFrameRollTypeButton:Enable();

		-- enable DKP priority option
		Lootster_OptionsFrameDKPPriority:Enable();

		-- enable DKP cap options
		Lootster_OptionsFrameDKPCaps:Enable();
		Lootster_OptionsFrameDKPHi:Show();
		Lootster_OptionsFrameDKPLo:Show();

		Lootster_OptionsFrameDKPHiROFrame:Hide();
		Lootster_OptionsFrameDKPLoROFrame:Hide();

		-- enable DKP factor options
		Lootster_OptionsFrameDKPFactoring:Enable();
		Lootster_OptionsFrameDKPFactor:Show();

		Lootster_OptionsFrameDKPFactorROFrame:Hide();
	end

	-- are these restrictions locked down?
	if ((Lootster_ClassRestrictedLock == true) or (Lootster_ClassRestrictionsMaskOrig ~= 0)) then
		-- disable the restrict roll button
		Lootster_RollFrameRestrictRoll:Disable();
	else
		-- enable the restrict roll button
		Lootster_RollFrameRestrictRoll:Enable();
	end

	-- update state of class restrict remember button
	if ((Lootster_ItemID ~= nil) and (Lootster_ClassRestrictedLock == false) and (Lootster_ClassRestrictionsMaskOrig ~= Lootster_ClassRestrictionsMaskCurr)) then
		-- enable remember button
		Lootster_ClassFrameRemember:Enable();
	else
		-- disable remember button
		Lootster_ClassFrameRemember:Disable();
	end

	-- update state of class restrict forget button
	if ((Lootster_ItemID ~= nil) and (Lootster_ClassRestrictedLock == false) and (Lootster_ClassRestrictionsMaskOrig ~= 0)) then
		-- enable remember button
		Lootster_ClassFrameForget:Enable();
	else
		-- disable remember button
		Lootster_ClassFrameForget:Disable();
	end
end

-- Update Roll Handling handler
function Lootster_UpdateRollHandling()
	-- reposition tabs and update UI
	Lootster_CheckModeUse();

	-- reformat our roll button text
	Lootster_UpdateRoll();

	-- update received roll status
	Lootster_UpdateRollUI();

	-- broadcast the roll handling message
	Lootster_SendBroadcast(Lootster_GetRollHandling());
end

-- Pass Roll handler
function Lootster_PassRoll(player)
	-- see if a roll is called
	if (Lootster_NBG == nil) then
		-- no need for us to bookkeep
		return;
	end

	-- if we are in a tied roll, only the tied players can pass/reclaim
	if ((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_Rolls[player] == nil)) then
		-- no processing
		return;
	end

	-- is this guy allowed to roll?
	if (Lootster_RosterRoll[player] == nil) then
		-- naughty naughty bad Zoot!
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTPASSCLASS, Lootster_NBG_ClassIgnore));

		return;
	end

	-- bookkeep the roller
	Lootster_AddRoller(player);

	-- check if they have rolled before
	if		(Lootster_Rolls[player].Roll == nil) then
		-- simply set to zero to indicate no roll
		Lootster_Rolls[player].Roll = 0;

		-- bump roll count
		Lootster_RollCount = Lootster_RollCount + 1;

		-- ack the pass
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSNONE, Lootster_NBG));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSNONE_LINK, Lootster_NBG, Lootster_ItemLink));
		end
	elseif	(Lootster_Rolls[player].Roll > 0) then
		local	nbg = Lootster_NBG;

		-- if we are in 100/1000 mode, they rolled one or the other.  Reflect that
		if (Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- determine if they rolled need or greed
			if		(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED) then
				nbg = LOOTSTER_NBG_NEED;
			elseif	(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.GREED) then
				nbg = LOOTSTER_NBG_GREED;
			end
		end

		-- simply set to the negative to indicate passed
		Lootster_Rolls[player].Roll = -Lootster_Rolls[player].Roll;

		-- ack the pass
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSROLL, -Lootster_Rolls[player].Roll, nbg));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSROLL_LINK, -Lootster_Rolls[player].Roll, nbg, Lootster_ItemLink));
		end
	else
		-- already passed - ignore - ack the pass anyway
		if (Lootster_Rolls[player].Roll == 0) then
			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSNONE, Lootster_NBG));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSNONE_LINK, Lootster_NBG, Lootster_ItemLink));
			end
		else
			local	nbg = Lootster_NBG;

			-- if we are in 100/1000 mode, they rolled one or the other.  Reflect that
			if (Lootster_NBG == LOOTSTER_NBG_1001000) then
				-- determine if they rolled need or greed
				if		(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED) then
					nbg = LOOTSTER_NBG_NEED;
				elseif	(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.GREED) then
					nbg = LOOTSTER_NBG_GREED;
				end
			end

			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSROLL, -Lootster_Rolls[player].Roll, nbg));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSROLL_LINK, -Lootster_Rolls[player].Roll, nbg, Lootster_ItemLink));
			end
		end

		return;
	end

	-- did this come from us?
	if (player == Lootster_Self) then
		-- update the text to indicate pass or reclaim
		if		((Lootster_Rolls[Lootster_Self] == nil) or (Lootster_Rolls[Lootster_Self].Roll == nil) or (Lootster_Rolls[Lootster_Self].Roll >= 0)) then
			-- set text for passing
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
		elseif	((Lootster_Rolls[Lootster_Self] ~= nil) and (Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll <= 0)) then
			-- set text for reclaiming
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_RECLAIM);
		else
			-- default is pass
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
		end
	end

	-- resort the rolls
	Lootster_Roll_Sort();

	-- update received roll status
	Lootster_UpdateRollUI();	

	-- update the screen
	Lootster_Roll_Update();
end

-- Reclaim Roll handler
function Lootster_ReclaimRoll(player)
	-- see if a roll is called
	if (Lootster_NBG == nil) then
		-- no need for us to bookkeep
		return;
	end

	-- if we are in a tied roll, only the tied players can pass/reclaim
	if ((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_Rolls[player] == nil)) then
		-- no processing
		return;
	end

	-- is this guy allowed to roll?
	if (Lootster_RosterRoll[player] == nil) then
		-- naughty naughty bad Zoot!
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTRECLAIMCLASS, Lootster_NBG_ClassIgnore));

		return;
	end

	-- bookkeep the roller
	Lootster_AddRoller(player);

	-- check if they have rolled before
	if		((Lootster_Rolls[player].Roll == nil) or (Lootster_Rolls[player].Roll == 0)) then
		-- let them know they have not rolled before
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKRECLAIMNONE, Lootster_NBG));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKRECLAIMNONE_LINK, Lootster_NBG, Lootster_ItemLink));
		end

		-- and ask them nicely to roll
		Lootster_AskForRoll(player);

		return;
	elseif	(Lootster_Rolls[player].Roll < 0) then
		local	nbg = Lootster_NBG;

		-- if we are in 100/1000 mode, they rolled one or the other.  Reflect that
		if (Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- determine if they rolled need or greed
			if		(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED) then
				nbg = LOOTSTER_NBG_NEED;
			elseif	(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.GREED) then
				nbg = LOOTSTER_NBG_GREED;
			end
		end

		-- simply set to the re-negate to indicate reclaim
		Lootster_Rolls[player].Roll = -Lootster_Rolls[player].Roll;

		-- ack the reclaim
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKRECLAIMROLL, Lootster_Rolls[player].Roll, nbg));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKRECLAIMROLL_LINK, Lootster_Rolls[player].Roll, nbg, Lootster_ItemLink));
		end
	else
		local	nbg = Lootster_NBG;

		-- if we are in 100/1000 mode, they rolled one or the other.  Reflect that
		if (Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- determine if they rolled need or greed
			if		(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED) then
				nbg = LOOTSTER_NBG_NEED;
			elseif	(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.GREED) then
				nbg = LOOTSTER_NBG_GREED;
			end
		end

		-- roll is still active
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACTIVEROLL, Lootster_Rolls[player].Roll, nbg));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACTIVEROLL_LINK, Lootster_Rolls[player].Roll, nbg, Lootster_ItemLink));
		end

		return;
	end

	-- did this come from us?
	if (player == Lootster_Self) then
		-- update the text to indicate pass or reclaim
		if		((Lootster_Rolls[Lootster_Self] == nil) or (Lootster_Rolls[Lootster_Self].Roll == nil) or (Lootster_Rolls[Lootster_Self].Roll >= 0)) then
			-- set text for passing
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
		elseif	((Lootster_Rolls[Lootster_Self] ~= nil) and (Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll <= 0)) then
			-- set text for reclaiming
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_RECLAIM);
		else
			-- default is pass
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
		end
	end

	-- resort the rolls
	Lootster_Roll_Sort();

	-- update received roll status
	Lootster_UpdateRollUI();	

	-- update the screen
	Lootster_Roll_Update();
end

-- Calculate the Server Time handler
function Lootster_CalcServerTime(time)
	-- simply add our time zone offset to passed time.  This will then be used in UTC formatting
	return time + (Lootster_TZOffsetSvrCur * 3600);
end

-- Format the Server Time handler
function Lootster_FormatServerTime(time)
	-- the time is expected to be in server time
	return date(LOOTSTER_ECHO_DATE, time);
end

-- Calculate DKP handler
function Lootster_CalcDKP(dkp)
	-- round to whole DKP
	dkp = tonumber(string.format("%.0f", dkp));

	return dkp;
end

-- Calculate Tier handler
function Lootster_CalcTier(dkp)
	local   found	= false;
	local	tier	= LOOTSTER_TIER_UNKNOWN;

	-- hammer through tier table
	for ix, dkpRec in ipairs(Lootster_TierDKP) do
		-- see how to apply the range
		if		(dkpRec.Lo == nil) then
			found = (dkp < dkpRec.Hi);
		elseif  (dkpRec.Hi == nil) then
			found = (dkp >= dkpRec.Lo);
		else
			found = (dkp >= dkpRec.Lo) and (dkp < dkpRec.Hi);
		end

		if (found) then
			-- snarf tier if we found it
			tier = dkpRec.Tier;
			break;
		end
	end

	return tier;
end

-- Calculate Priority handler
function Lootster_CalcPriority(trial, app)
	local	prior = "";

	-- determine the priority flags to use
	if ((trial == false) and (app == false)) then
		-- Full member
		prior = LOOTSTER_DKP_PRIOR_FULL..prior;
	else
		-- applicant and/or trial flags
		if (app == true) then
			-- Applicant Member
			prior = LOOTSTER_DKP_PRIOR_APP..prior;
		end

		if (trial == true) then
			-- Trial Member
			prior = LOOTSTER_DKP_PRIOR_TRIAL..prior;
		end
	end

	return prior;
end

-- Update DKP handler
function Lootster_UpdateDKP(player)
	local	dkp, tier;

	-- determine the new DKP tier for this player
	dkp = Lootster_CalcDKP(Lootster_DKP[player].DKPRaw + Lootster_DKP[player].DKPAdj);
	tier = Lootster_CalcTier(Lootster_DKP[player].DKPRaw + Lootster_DKP[player].DKPAdj);

	-- update the player's DKP and tier
	Lootster_DKP[player].DKP = dkp;
	Lootster_DKP[player].Tier = tier;

	return;
end

-- Retrieve Player DKP handler
function Lootster_GetPlayerDKP(player)
	local	main;
	local	dkp = 0.0;

	-- resolve the player into a main
	main = Lootster_GetALTMain(player);

	-- do we have DKP for this player?
	if (Lootster_DKP[main] ~= nil) then
		-- snarf DKP
		dkp = Lootster_DKP[main].DKP;
	end

	-- round to whole DKP
	dkp = Lootster_CalcDKP(dkp);

	-- do we apply caps?
	if (Lootster_Options.DKPCaps == true) then
		-- yup, so apply hi/lo as appropriate
		if	  ((dkp < 0) and (math.abs(dkp) > Lootster_Options.DKPLo)) then
			-- set to low limit
			dkp = - Lootster_Options.DKPLo;
		elseif	((dkp > 0) and (dkp > Lootster_Options.DKPHi)) then
			-- set to high limit
			dkp = Lootster_Options.DKPHi;
		end
	end

	return dkp;
end

-- Retrieve Player Tier handler
function Lootster_GetPlayerTier(player)
	local	dkp;
	local	tier;

	-- get the player's capped DKP
	dkp = Lootster_GetPlayerDKP(player);

	-- and determine the capped tier
	tier = Lootster_CalcTier(dkp);

	return tier;
end

-- Retrieve Player Roll handler
function Lootster_GetPlayerRoll(player)
	local	roll, dkp;

	-- see what type of DKP we are using
	if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
		-- By DKP, so roll is 100
		roll = 100;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
		-- By Tier, so roll is 100
		roll = 100;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
		-- get the player DKP
		dkp = Lootster_GetPlayerDKP(player);

		-- are we using modified DKP rolling and we are using DKP factoring?
		if ((Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) and (Lootster_Options.DKPFactoring == true)) then
			-- apply the factor to the dkp
			dkp = Lootster_CalcDKP(dkp / Lootster_Options.DKPFactor);
		end

		-- By Modified Roll, so roll is (factored) DKP + 100
		roll = dkp + 100;
	else
		-- use 100 since we don't know any better
		roll = 100;
	end

	return roll;
end

-- Get Player Priority handler
function Lootster_GetPlayerPriority(player)
	local	prior = "";

	-- do we have membership in effect?
	if (Lootster_Options.DKPPrior == true) then
		-- calculate priority
		prior = Lootster_CalcPriority(Lootster_GetPlayerMembership(player));
	end

	return prior;
end

-- Retrieve Player Position handler
function Lootster_GetPlayerPosition(player)
	local	high = LOOTSTER_ECHO_NA;
	local	equal = LOOTSTER_ECHO_NA;

	-- do we have DKP for this player?
	if (Lootster_RosterRoll[player] ~= nil) then
		-- snarf position
		high = Lootster_RosterRoll[player].High;
		equal = Lootster_RosterRoll[player].Equal;
	end

	return high, equal;
end

-- Retrieve Player Membership handler
function Lootster_GetPlayerMembership(player)
	local	main;
	local	trial = true;
	local	app = false;

	-- resolve the player into a main
	main = Lootster_GetALTMain(player);

	-- do we have DKP for this player?
	if (Lootster_DKP[main] ~= nil) then
		-- snarf trial and app membership
		trial = Lootster_DKP[main].Trial;
		app = Lootster_DKP[main].App;
	end

	return trial, app;
end

-- Retrieve Player Tell Toggle handler
function Lootster_TestPlayerTell(player, key)
	-- does this player have a tell override?
	if ((Lootster_Players[player] ~= nil) and (Lootster_Players[player][key] ~= nil)) then
		-- return player's preference
		return Lootster_Players[player][key];
	else
		-- return master preference
		return Lootster_Options[key];
	end
end

-- Get Alt Look-aside Table Main hander
function Lootster_GetALTMain(player)
	local	name = player;

	-- is this a player an alt?
	if (Lootster_ALTMain[player] ~= nil) then
		-- this is an alt - return main name for reference
		name = Lootster_ALTMain[player];
	end

	return name;
end

-- Get Main to Alt Look-aside Table hander
function Lootster_GetMainALT(player)
	local	name = player;

	-- is this a player a main?
	if (Lootster_MainALT[player] ~= nil) then
		-- this is main - return alt name for reference
		name = Lootster_MainALT[player];
	end

	return name;
end

-- Get Roll Handling handler
function Lootster_GetRollHandling()
	local	msg = "";

	-- send the roll handling message
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		local	mode, prior, caps;

		-- determine the DKP type
		if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
			mode = LOOTSTER_MSG_TYPEDKP;
		elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			mode = LOOTSTER_MSG_TYPETIER;
		elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
			mode = LOOTSTER_MSG_TYPEMODIFIED;
		else
			-- unknown DKP type - hammer into tier type and recall
			Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYTIER;

			return(Lootster_GetRollHandling());
		end

		-- determine membership priority
		if (Lootster_Options.DKPPrior == true) then
			prior = LOOTSTER_MSG_PRIORUSED;
		else
			prior = LOOTSTER_MSG_PRIORNONE;
		end

		-- determine if we have DKP caps in effect
		if (Lootster_Options.DKPCaps == true) then
			-- format caps
			caps = string.format(LOOTSTER_MSG_CAPSUSED, Lootster_Options.DKPHi, Lootster_Options.DKPLo);
		else
			-- no caps in effect
			caps = LOOTSTER_MSG_CAPSNONE;
		end

		-- format DKP mode message
		msg = string.format(LOOTSTER_MSG_DKPMODE, mode, prior, caps);
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
		local	mode, call;

		-- determine the normal type
		if		(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			-- tell everyone that we are using 100/1000
			mode = LOOTSTER_MSG_TYPE1001000;

			-- see if roll calls are required
			if (Lootster_Options.CorKRoll == true) then
				call = LOOTSTER_MSG_OPTIONAL;
			else
				call = LOOTSTER_MSG_REQUIRED;
			end
		elseif	(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BYNEEDGREED) then
			-- tell everyone that we are using Need then Greed
			mode = LOOTSTER_MSG_TYPENEEDGREED;

			-- roll calls always required
			call = LOOTSTER_MSG_REQUIRED;
		else
			-- unknown normal type - hammer into greed then need type and recall
			Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BYNEEDGREED;

			return(Lootster_GetRollHandling());
		end

		-- format normal mode message
		msg = string.format(LOOTSTER_MSG_NORMMODE, mode, call);
	else
		-- unknown roll type - hammer into normal mode and recall
		Lootster_Options.RollMode = LOOTSTER_ENUM_ROLLMODE.USENORM;

		return(Lootster_GetRollHandling());
	end

	return msg;
end

-- Retrieve Item DKP handler
function Lootster_GetItemDKP(itemText)
	local	name, items, dkp, reason;

	-- reset located items, dkp and text
	items = 0;
	dkp = 0;
	reason = "";

	-- do we have link text?
	if (itemText ~= nil) then
		-- attempt to locate this item
		name = string.lower(itemText);

		for itemkey, itemRec in pairs(Lootster_ItemDKP) do
			-- does this item match the current loot?
			if (string.find(itemRec.Name, name) ~= nil) then
				-- snarf the dkp
				dkp = -itemRec.DKP;
				
				-- snarf the reason
				reason = itemRec.Name;

				-- and bump located count
				items = items + 1;
			end
		end

		-- if we found more that one item, reset DKP since we don't know which one
		if		(items ~= 1) then
			-- indeterminate DKP
			dkp = 0;
			
			-- snarf orginal item text for reason
			reason = itemText;
		elseif	(reason == "") then
			-- snarf item text for reason
			reason = itemText;
		end
	end

	return dkp, reason, items;
end

-- Retrieve Item Details handler
function Lootster_GetItemDetails(itemLink, noRestrict)
	local	ix, field, item, text, singluars, singluar, classes, class, flag;

	local	itemID = nil;
	local	itemText = "";

	local	restricted = false;
	local	restrictedLock = false;

	local	restrictions = {};
	local	restrictionsMask = 0;

	local	bindingType = LOOTSTER_ENUM_BIND.UNK;

	-- do we have an item?
	if (itemLink ~= nil) then
		-- extract the ID of the item
		for item in string.gfind(itemLink, LOOTSTER_ITEMLINK_PATTERN) do
			-- this is the invariant identifer for the item
			itemID = item;
		end

		-- extract the name of the item
		for text in string.gfind(itemLink, LOOTSTER_ITEMTEXT_PATTERN) do
			itemText = text;
		end
		
		-- are we only getting item id and text?
		if (noRestrict == true) then
			-- easy
			return itemID, itemText;
		end

		-- extract the item link information
		for itemLink in string.gfind(itemLink, LOOTSTER_ITEMLINK_PATTERN) do
			-- set tooltip owner
			Lootster_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");

			-- process the item for class restrictions by getting the game tooltip to parse prepare the data
			Lootster_Tooltip:SetHyperlink(itemLink);

			-- hammer through the tooltip text items looking for any class restrictions
			for ix=1, 30, 1 do
				-- get left text field (the prompt)
				field = getglobal("Lootster_TooltipTextLeft"..ix);

				if ((field ~= nil) and field:IsShown()) then
					text = field:GetText();

					-- if we have a line break, end processing to prevent processing the restrictions on the item
					-- that is produced by this item
					if (string.sub(text, 1, 1) == "\n") then
						text = nil;

						ix = 30;
					end
				else
					text = nil;
				end

				-- do we have text?
				if (text ~= nil) then
					-- test for bindings
					if		((ix < 6) and (text == LOOTSTER_OPTION_BINDTYPELIST[LOOTSTER_ENUM_BIND.BoE])) then
						bindingType = LOOTSTER_ENUM_BIND.BoE;
					elseif	((ix < 6) and (text == LOOTSTER_OPTION_BINDTYPELIST[LOOTSTER_ENUM_BIND.BoP])) then
						bindingType = LOOTSTER_ENUM_BIND.BoP;
					else
						-- see if it is a singluar class qualifiers
						_, _, singulars = string.find(text, LOOTSTER_CLASSES_PATTERN);

						if (singulars ~= nil) then
							-- hmm, dude is class restricted and locked
							restricted = true;
							restrictedLock = true;

							-- okay, snarf out the singluar classes
							for singular in string.gfind(singulars, LOOTSTER_CLASS_PATTERN) do
								-- we have an invariant for this guy?
								if (Lootster_ClassSingular[singular] ~= nil) then
									-- map this singular to the invariant
									class = Lootster_ClassSingular[singular];

									-- class allowed
									restrictions[class] = true;

									-- add to mask
									restrictionsMask = bit.bor(restrictionsMask, LOOTSTER_CLASS[class].Mask);

									-- bump count
									table.setn(restrictions, table.getn(restrictions) + 1);
								end
							end
						end
					end
				end
			end

			-- did we find class restrictions on the item?
			if (restricted == false) then
				-- no, so see if we have quest imposed class restrictions
				if		(LOOTSTER_CLASS_LOOT[itemText] ~= nil) then
					-- hmm, dude should be class restricted and locked
					restricted = true;
					restrictedLock = true;

					classes = LOOTSTER_CLASS_LOOT[itemText];
				elseif	((itemID ~= nil) and (Lootster_Restrict[itemID] ~= nil)) then
					-- hmm, dude should be class restricted but is not locked
					restricted = true;
					restrictedLock = false;

					classes = Lootster_Restrict[itemID].Classes;
				end

				-- did we find some class restrictions?
				if (restricted == true) then
					-- get each restriction.  Note that faction classes will be ignored when later processed
					for ix, class in ipairs(classes) do
						-- class allowed
						restrictions[class] = true;

						-- add to mask if on
						restrictionsMask = bit.bor(restrictionsMask, LOOTSTER_CLASS[class].Mask);
					end

					-- set count
					table.setn(restrictions, table.getn(classes));
				end
			end
		end
	end

	return itemID, itemText, restricted, restrictedLock, restrictions, restrictionsMask, bindingType;
end

-- Get Zone Instance Id handler
function Lootster_GetInstanceId(zone)
	local	ix, count, instance, wowId, timeExp;
	
	-- get count of instances
	count = GetNumSavedInstances();
	
	-- look for passed zone
	for ix=1, count do
		-- get this saved instance information
		instance, wowId, timeExp = GetSavedInstanceInfo(ix);
		
		-- the one we are looking for?
		if (zone == instance) then
			-- woot! We are done
			return wowId, Lootster_CalcServerTime(time() + timeExp);
		end
	end
	
	return nil, nil;
end

-- Echo Item DKP handler
function Lootster_EchoItemDKP(requestor, itemkey)
	-- do we have DKP for this item?
	if (Lootster_ItemDKP[itemkey] ~= nil) then
		-- snarf it
		dkp = Lootster_ItemDKP[itemkey].DKP;

		-- send to the requestor
		Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_ITEMDKP, Lootster_ItemDKP[itemkey].DKP, itemkey, Lootster_ItemDKP[itemkey].Mob));
	end
end

-- Echo Player Adjustments handler
function Lootster_EchoPlayerAdjusts(requestor, playerkey, notpartied)
	local	main, key, dkp, reason;

	-- resolve the player into a main
	main = Lootster_GetALTMain(playerkey);

	-- use sorted list of adjustments
	for ix, key in ipairs(Lootster_AdjustSort) do
		-- our player?
		if (main == Lootster_Adjust[key].Player) then
			-- if total record we are done
			if (Lootster_Adjust[key].DKP == nil) then
				break;
			end

			-- get dkp and reason
			dkp = Lootster_Adjust[key].DKP;

			-- use link if given
			if (Lootster_AdjustRec.Link ~= nil) then
				-- use link
				reason = Lootster_AdjustRec.Link;
			else
				-- just use reason
				reason = Lootster_AdjustRec.Reason;
			end

			-- we have the ability to whisper to a non-roster player
			if ((Lootster_Roster[requestor] ~= nil) or ((notpartied ~= nil) and (notpartied == true))) then
				-- are we using DKP?
				if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
					-- send to the requestor with DKP
					Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_ADJUSTDKP, dkp, playerkey, reason));
				else
					-- send to the requestor with DKP
					Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_ADJUSTNPDKP, playerkey, reason));
				end
			end
		end
	end

	-- whisper DKP information as well
	Lootster_EchoPlayerDKP(requestor, playerkey, notpartied);
end

-- Echo Player DKP handler
function Lootster_EchoPlayerDKP(requestor, playerkey, notpartied)
	local	main;
	local	adj = 0;
	local	dkpBase = 0;
	local	tierBase = LOOTSTER_TIER_UNKNOWN;
	local	priorBase = "";

	-- are we using DKP?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- resolve the player into a main
		main = Lootster_GetALTMain(playerkey);

		-- do we have DKP for this player?
		if (Lootster_DKP[main] ~= nil) then
			-- snarf base data
			dkpBase = Lootster_DKP[main].DKP;
			tierBase = Lootster_DKP[main].Tier
			priorBase = Lootster_DKP[main].Priority

			-- snarf adjustment data
			adj = Lootster_DKP[main].DKPAdj;
		end

		-- we have the ability to whisper to a non-roster player
		if ((Lootster_Roster[requestor] ~= nil) or ((notpartied ~= nil) and (notpartied == true))) then
			-- are we applying caps?
			local	dkpEffect, tierEffect, priorEffect;

			-- snarf effective data
			dkpEffect = Lootster_GetPlayerDKP(playerkey);
			tierEffect = Lootster_GetPlayerTier(playerkey);
			priorEffect = Lootster_GetPlayerPriority(playerkey);

			-- send to the requestor base and effective information
			Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYER, dkpBase, priorBase, tierBase, dkpEffect, priorEffect, tierEffect, adj, playerkey));
		end
	end	
end

-- Echo Player Roll handler
function Lootster_EchoPlayerRoll(requestor, noPos)
	-- are we using DKP?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- we do nothing if the requestor is not in the party/raid
		if (Lootster_Roster[requestor] ~= nil) then
			local	dkp, roll;

			-- calculate the DKP and roll 
			dkp = Lootster_GetPlayerDKP(requestor);
			roll = Lootster_GetPlayerRoll(requestor);

			-- see which DKP type we are using
			if		((Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) or (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER)) then
				local	high;
				local	equal;

				-- get the position
				high, equal = Lootster_GetPlayerPosition(requestor);

				-- by DKP or tier?
				if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
					local	prior;

					-- get the tier name
					prior = Lootster_GetPlayerPriority(requestor);

					-- send DKP statement to the requestor with position as required
					if ((noPos ~= nil) and (noPos == true)) then
						Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLDKP, prior, dkp, roll));
					else
						Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLDKPPOS, prior, dkp, high, equal, roll));
					end
				elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
					local	tier, prior;

					-- get the tier
					tier = Lootster_GetPlayerTier(requestor);
					prior = Lootster_GetPlayerPriority(requestor);

					-- send DKP statement to the requestor with position as required
					if ((noPos ~= nil) and (noPos == true)) then
						Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLTIER, dkp, prior, tier, roll));
					else
						Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLTIERPOS, dkp, prior, tier, high, equal, roll));
					end
				end
			elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
				-- send DKP statement to the requestor
				Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLMODIFIED, dkp, roll));
			end
		end
	end
end

-- Calculate Player DKP Positions handler
function Lootster_CalculatePositions()
	local	playerO, rosRecO, tierName, playerI, rosRecI, dkp, tier, prior, trial, app;
	local	testOP, testIP, testOT, testIT, tiers;

	local	count, ix;

	-- reset current tier list
	Lootster_Tiers = {};

	-- reset the tier sorts
	Lootster_TiersSort = {};

	-- reset record count
	table.setn(Lootster_TiersSort, 0);

	-- reset the tiers prompt
	Lootster_TiersPrompt = "";

	-- reset the roll roster
	Lootster_RosterRoll = {};

	-- prime the effective dkp and tier roll roster
	for playerO, rosRecO in pairs(Lootster_Roster) do
		-- see if this guy is class restricted
		if (((Lootster_NBG ~= LOOTSTER_NBG_NEED) or (Lootster_ClassRestricted == false)) or 
			((Lootster_ClassRestrictions[rosRecO.ClassType] ~= nil) and (Lootster_ClassRestrictions[rosRecO.ClassType] == true))) then
			-- get this guys dkp, tier and priority flags
			dkp = Lootster_GetPlayerDKP(playerO);
			tier = Lootster_GetPlayerTier(playerO);
			prior = Lootster_GetPlayerPriority(playerO);
			trial, app = Lootster_GetPlayerMembership(playerO);

			-- and add to the roll roster, along with initialised high and equal counts
			Lootster_RosterRoll[playerO] = Lootster_NewRosterRoll(dkp, tier, trial, app, prior);
		end
	end

	-- hammer through the roll roster, calculating player positions
	for playerO, rosRecO in pairs(Lootster_RosterRoll) do
		-- are we using DKP by Tier?
		if (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			-- create tier name
			tierName = Lootster_RosterRoll[playerO].Priority..Lootster_RosterRoll[playerO].Tier;

			-- count this tier
			if (Lootster_Tiers[tierName] == nil) then
				-- initial tier count
				Lootster_Tiers[tierName] = Lootster_NewTiers(tierName, rosRecO.Tier, rosRecO.Trial, rosRecO.App);
			else
				-- bump tier count
				Lootster_Tiers[tierName].Count = Lootster_Tiers[tierName].Count + 1;
			end
		end

		-- hammer through the rest of the roll roster, determining if they have a higher or equal ranking
		for playerI, rosRecI in pairs(Lootster_RosterRoll) do
			-- determine the priority
			testOP = Lootster_PriorityTest(rosRecO.Trial, rosRecO.App, rosRecI.Trial, rosRecI.App);
			testIP = Lootster_PriorityTest(rosRecI.Trial, rosRecI.App, rosRecO.Trial, rosRecO.App);

			-- see if priority will determine the outcome
			if		(testIP == true) then
				-- this guy is outranked by DKP type
				Lootster_RosterRoll[playerO].High = Lootster_RosterRoll[playerO].High + 1;
			elseif	((testOP == false) and (testIP == false)) then
				-- DKP type determines ranking
				if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
					-- use DKP
					testOT = rosRecO.DKP > rosRecI.DKP;
					testIT = rosRecI.DKP > rosRecO.DKP;
				elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
					-- use Tier
					testOT = rosRecO.Tier < rosRecI.Tier;
					testIT = rosRecI.Tier < rosRecO.Tier;
				else
					-- roll is only test
					testOT = false;
					testIT = false;
				end

				-- see where this guy sits
				if		(testIT == true) then
					-- this guy is outranked by priority
					Lootster_RosterRoll[playerO].High = Lootster_RosterRoll[playerO].High + 1;
				elseif	((testOT == false) and (testIT == false) and (playerO ~= playerI)) then
					-- both are false, this guy is an equal (and not us!)
					Lootster_RosterRoll[playerO].Equal = Lootster_RosterRoll[playerO].Equal + 1;
				end
			end
		end
	end

	-- are we are using DKP?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- are we using tiers?
		if (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			-- resort the tiers
			Lootster_Tier_Sort();

			-- build list of tiers
			count = table.getn(Lootster_TiersSort);

			for ix=1, count, 1 do
				-- add name
				Lootster_TiersPrompt = Lootster_TiersPrompt..string.format(LOOTSTER_ECHO_TIERCOUNT, Lootster_Tiers[Lootster_TiersSort[ix]].TierName, Lootster_Tiers[Lootster_TiersSort[ix]].Count);

				if		(ix < (count - 1)) then
					Lootster_TiersPrompt = Lootster_TiersPrompt..LOOTSTER_MSG_SEP;
				elseif (ix == (count - 1)) then
					Lootster_TiersPrompt = Lootster_TiersPrompt..LOOTSTER_MSG_AND;
				end
			end

			-- format the tier breakdown prompt
			Lootster_TiersPrompt = string.format(LOOTSTER_ECHO_TIERBREAKDOWN, Lootster_TiersPrompt);
		end
	end
end

-- Sort Rolls handler
function Lootster_Roll_Sort()
	local	ix = 0;

	-- setup sort indirection
	Lootster_RollsSort = {};

	for key, value in pairs(Lootster_Rolls) do
		ix = ix + 1;
		Lootster_RollsSort[ix] = key;
	end

	-- constrain the roll indirection table
	table.setn(Lootster_RollsSort, ix);

	-- resort the roll data on the roll
	table.sort(Lootster_RollsSort, Lootster_RollTest);
end

-- Roll Test handler
function Lootster_RollTest(i1, i2)
	local	r1, r2;

	-- retrieve indirected roll data
	r1 = Lootster_Rolls[i1].Roll;
	r2 = Lootster_Rolls[i2].Roll;

	-- preprocess nil and passed rolls
	if		((r1 == nil) and (r2 == nil)) then
		-- both haven't rolled, which means that we will still sort them as usual, but by setting roll to 
		-- zero so highest priority yet to roll player will appear first
		r1 = 0;
		r2 = 0;
	elseif	(r1 == nil) then
		return false;
	elseif	(r2 == nil) then
		return true;
	elseif	((r1 <= 0) and (r2 <= 0)) then
		-- both passed, which means that we will still sort them as usual, but by negating rolls so highest
		-- priority/roll passed roller will appear first
		r1 = -r1;
		r2 = -r2;
	elseif	(r1 <= 0) then
		return false;
	elseif	(r2 <= 0) then
		return true;
	end

	-- handle sort based on roll mode, type and the rolls themselves 
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- test using a DKP method
		if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
			local	pa1, pa2;
			local	pt1, pt2;
			local	d1, d2;

			-- priority then DKP then roll.  Retrieve priority and DKP data
			pa1 = Lootster_Rolls[i1].App;
			pa2 = Lootster_Rolls[i2].App;
			pt1 = Lootster_Rolls[i1].Trial;
			pt2 = Lootster_Rolls[i2].Trial;
			d1 = Lootster_Rolls[i1].DKP;
			d2 = Lootster_Rolls[i2].DKP;

			-- By priority then DKP then roll
			if		(Lootster_PriorityTest(pa1, pt1, pa2, pt2) == true) then
				-- priority made a difference
				return true;
			elseif	(d1 ~= d2) then
				-- differing DKP so use it
				return d1 > d2;
			else
				-- same priority and DKP, so use roll difference
				return r1 > r2;
			end
		elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			local	pa1, pa2;
			local	pt1, pt2;
			local	t1, t2;

			-- By priority then Tier then roll.  Retrieve indirected priority and tier data
			pa1 = Lootster_Rolls[i1].App;
			pa2 = Lootster_Rolls[i2].App;
			pt1 = Lootster_Rolls[i1].Trial;
			pt2 = Lootster_Rolls[i2].Trial;
			t1 = Lootster_Rolls[i1].Tier;
			t2 = Lootster_Rolls[i2].Tier;

			-- priority then Tier then roll
			if		(Lootster_PriorityTest(pa1, pt1, pa2, pt2) == true) then
				-- priority made a difference
				return true;
			elseif	(t1 ~= t2) then
				-- lower tiers have higher priority
				return t1 < t2;
			else
				-- same priority and Tier, so use roll difference
				return r1 > r2;
			end
		elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
			local	pa1, pa2;
			local	pt1, pt2;

			-- By Modified Roll then priority
			pa1 = Lootster_Rolls[i1].App;
			pa2 = Lootster_Rolls[i2].App;
			pt1 = Lootster_Rolls[i1].Trial;
			pt2 = Lootster_Rolls[i2].Trial;

			-- if priority show no change, decide by roll
			if (Lootster_PriorityTest(pa1, pt1, pa2, pt2) == true) then
				-- priority made a difference
				return true;
			else
				-- same priority, so use roll difference
				return r1 > r2;
			end
		else
			-- no idea what DKP type, so just use roll
			return r1 > r2;
		end
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USENORM) then
		-- use Normal method
		if		(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			local	p1, p2;

			-- Priority then roll.  Retrieve Priority data
			p1 = Lootster_Rolls[i1].Priority;
			p2 = Lootster_Rolls[i2].Priority;

			-- by priority, which is Need Before Greed
			if		(p1 ~= p2) then
				-- differing Priority so use it
				return p1 < p2;
			else
				-- same priority, so use roll difference
				return r1 > r2;
			end
		elseif	(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BYNEEDGREED) then
			-- just use roll difference
			return r1 > r2;
		else
			-- no idea what Normal type, so just use roll
			return r1 > r2;
		end
	else
		-- no idea what mode, so just use roll
		return r1 > r2;
	end
end

-- Roll Equal handler
function Lootster_RollEqual(i1, i2)
	-- they are equal if the roll test is the same with each switched
	return (not Lootster_RollTest(i1, i2)) and (not Lootster_RollTest(i2, i1));
end

-- Sort Tiers handler
function Lootster_Tier_Sort()
	local	ix = 0;

	-- setup sort indirection
	Lootster_TiersSort = {};

	for key, value in pairs(Lootster_Tiers) do
		ix = ix + 1;
		Lootster_TiersSort[ix] = key;
	end

	-- constrain the tier indirection table
	table.setn(Lootster_TiersSort, ix);

	-- resort the tier data on the tier and priority
	table.sort(Lootster_TiersSort, Lootster_TierTest);
end

-- Tier Test handler
function Lootster_TierTest(i1, i2)
	local	t1, t2;
	
	-- see if priorities are in effect
	if		(Lootster_PriorityTest(Lootster_Tiers[i1].Trial, Lootster_Tiers[i1].App, Lootster_Tiers[i2].Trial, Lootster_Tiers[i2].App) == true) then
		-- first priority is higher
		return true;
	else
		-- priorities the same - retrieve indirected tier data
		t1 = Lootster_Tiers[i1].Tier;
		t2 = Lootster_Tiers[i2].Tier;
	
		-- do the tiers differ?
		if		(t1 < t2) then
			-- first tier is higher
			return true;
		else
			-- first tier is lower or equal
			return false;
		end
	end
end

-- Priority Test handler
function Lootster_PriorityTest(pt1, pa1, pt2, pa2)
	-- using Full/Trial/App priority and the rolls are the same.  Sort based on priority:
	--
	-- !T & !A Full
	--  T & !A Trial Member
	--  T &  A Trial and Applicant Member
	-- !T &  A Applicant Member
	--
	-- if priority not in use, there is no priority
	if		(Lootster_Options.DKPPrior == false) then
		-- no priority
		return false;
	elseif	((pt1 == pt2) and (pa1 == pa2)) then
		-- same priority, so no difference
		return false;
	elseif	(pt1 == pt2) then
		-- trial flags equal - based on player 2's applicant flag 
		return pa2;
	elseif	(pa1 == pa2) then
		-- applicant flags equal - based on player 2's trial flag
		return pt2;
	else
		-- all flags unequal - based on player 2's applicant flag
		return pa2;
	end
end

-- Data DKP Sort handler
function Lootster_Data_DKP_Sort(col)
	local	ix = 0;

	-- are we doing current sort order?
	if		(col ~= nil) then
		-- are we inverting sort order?
		if (col == Lootster_DKPSortCol) then
			-- flip sort order
			Lootster_DKPSortOrd = not Lootster_DKPSortOrd;
		else
			-- force ascending
			Lootster_DKPSortOrd = true;
		end

		Lootster_DKPSortCol = col;
	end

	-- setup sort indirection
	Lootster_DKPSort = {};

	-- get each of the DKP records
	for key, value in pairs(Lootster_DKP) do
		ix = ix + 1;
		Lootster_DKPSort[ix] = key;
	end

	-- constrain the DKP sort indirection table
	table.setn(Lootster_DKPSort, ix);

	-- resort the DKP data.  We use a sorted indirection table
	table.sort(Lootster_DKPSort, Lootster_DataDKPTest);

	-- and update screen
	Lootster_Data_DKP_Update();
end

-- Data DKP Test handler
function Lootster_DataDKPTest(i1, i2)
	local	d1, d2;

	-- make sure we handle tiers seperately
	if (Lootster_DKPSortCol ~= "Tier") then
		-- retrieve indirected data
		d1 = Lootster_DKP[i1][Lootster_DKPSortCol];
		d2 = Lootster_DKP[i2][Lootster_DKPSortCol];

		-- are we sorting by player?
		if (Lootster_DKPSortCol == "Player") then
			-- indeed.  Get the alt if it is playing and sort on that
			d1 = Lootster_GetMainALT(d1);
			d2 = Lootster_GetMainALT(d2);
		end

		-- handle nil data first
		if		((d1 == nil) and (d2 == nil)) then
			return false;
		elseif	(d1 == nil) then
			return not Lootster_DKPSortOrd;
		elseif	(d2 == nil) then
			return Lootster_DKPSortOrd;
		elseif	(d1 == d2) then
			return false;
		else	
			return (d1 < d2) == Lootster_DKPSortOrd;
		end
	else
		-- tiers sort - check priority first
		if		(Lootster_PriorityTest(Lootster_DKP[i1].Trial, Lootster_DKP[i1].App, Lootster_DKP[i2].Trial, Lootster_DKP[i2].App) == true) then
			-- priority made a difference
			return true;
		else
			-- use tier
			return Lootster_DKP[i1].Tier < Lootster_DKP[i2].Tier;
		end
	end
end

-- Player Sort handler
function Lootster_Data_Player_Sort(col)
	local	attendId, adjustRec;
	local	ix = 0;

	-- setup sort indirection
	Lootster_PlayerSort = {};

	-- do we have a current player?
	if (Lootster_PlayerId ~= nil) then
		-- gather each of the player's adjustments
		for attendId, adjustRec in pairs(Lootster_Adjust) do
			-- is this our player?
			if (adjustRec.Player == Lootster_PlayerId) then
				-- make sure it is not a legacy record
				if (type(attendId) == "string") then
					ix = ix + 1;
					Lootster_PlayerSort[ix] = attendId;
				end
			end
		end
	end

	-- constrain the player sort indirection table
	table.setn(Lootster_PlayerSort, ix);

	-- resort the player data.  We use a sorted indirection table
	table.sort(Lootster_PlayerSort, Lootster_DataPlayerTest);

	-- and update screen
	Lootster_Data_Player_Update();
end

-- Data Player Test handler
function Lootster_DataPlayerTest(i1, i2)
	local	p1, p2;
	local	d1, d2;
	local	e1, e2;

	-- retrieve adjustment player data
	p1 = Lootster_Adjust[i1].Player;
	p2 = Lootster_Adjust[i2].Player;

	-- if the players are different, just sort by name
	if (p1 ~= p2) then
		-- get the alt if it is playing and sort on that
		p1 = Lootster_GetMainALT(p1);
		p2 = Lootster_GetMainALT(p2);

		return p1 < p2;
	end

	-- retrieve adjustment DKP data
	d1 = Lootster_Adjust[i1].DKP;
	d2 = Lootster_Adjust[i2].DKP;

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return false;
	elseif	(d2 == nil) then
		return true;
	else
		-- retrieve adjustment date
		e1 = Lootster_Adjust[i1].DateAdj;
		e2 = Lootster_Adjust[i2].DateAdj;

		-- we are not sorting the adjustment, just which one was put in first
		return e1 < e2;
	end
end

-- Raid Sort handler
function Lootster_Raid_Raid_Sort(col)
	local	raidId, raidRec;
	local	ix = 0;

	-- are we doing current sort order?
	if		(col ~= nil) then
		-- are we inverting sort order?
		if (col == Lootster_RaidSortCol) then
			-- flip sort order
			Lootster_RaidSortOrd = not Lootster_RaidSortOrd;
		else
			-- force ascending
			Lootster_RaidSortOrd = true;
		end

		Lootster_RaidSortCol = col;
	end

	-- setup sort indirection
	Lootster_RaidSort = {};

	-- get each of the raids
	for raidId, raidRec in pairs(Lootster_Raid) do
		ix = ix + 1;
		Lootster_RaidSort[ix] = raidId;
	end

	-- constrain the raid sort indirection table
	table.setn(Lootster_RaidSort, ix);

	-- resort the raid data.  We use a sorted indirection table
	table.sort(Lootster_RaidSort, Lootster_RaidRaidTest);

	-- and update screen
	Lootster_Raid_Raid_Update();
end

-- Raid Test handler
function Lootster_RaidRaidTest(i1, i2)
	local	d1, d2;

	-- retrieve indirected data
	d1 = Lootster_Raid[i1][Lootster_RaidSortCol];
	d2 = Lootster_Raid[i2][Lootster_RaidSortCol];
	
	-- if these items are sets (tables), get their item count instead
	if (type(d1) == "table") then
		d1 = table.getn(d1);
	end

	if (type(d2) == "table") then
		d2 = table.getn(d2);
	end

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_RaidSortOrd;
	elseif	(d2 == nil) then
		return Lootster_RaidSortOrd;
	elseif	(d1 == d2) then
		return false;
	else
		return (d1 < d2) == Lootster_RaidSortOrd;
	end
end

-- Boss Sort handler
function Lootster_Raid_Boss_Sort(col)
	local	bossId, bossRec;
	local	ix = 0;

	-- are we doing current sort order?
	if		(col ~= nil) then
		-- are we inverting sort order?
		if (col == Lootster_BossSortCol) then
			-- flip sort order
			Lootster_BossSortOrd = not Lootster_BossSortOrd;
		else
			-- force ascending
			Lootster_BossSortOrd = true;
		end

		Lootster_BossSortCol = col;
	end

	-- setup sort indirection
	Lootster_BossSort = {};

	-- do we have a current raid?
	if (Lootster_RaidId ~= nil) then
		-- get each of the raid bosses into the boss sort indirection table
		for bossId, bossRec in pairs(Lootster_Raid[Lootster_RaidId].BossSet) do
			ix = ix + 1;
			Lootster_BossSort[ix] = bossId;
		end
	end

	-- constrain the boss sort indirection table
	table.setn(Lootster_BossSort, ix);

	-- resort the boss data.  We use a sorted indirection table
	table.sort(Lootster_BossSort, Lootster_RaidBossTest);

	-- and update screen
	Lootster_Raid_Boss_Update();
end

-- Boss Test handler
function Lootster_RaidBossTest(i1, i2)
	local	d1, d2;

	-- retrieve indirected data
	d1 = Lootster_Boss[i1][Lootster_BossSortCol];
	d2 = Lootster_Boss[i2][Lootster_BossSortCol];

	-- if these items are sets (tables), get their item count instead
	if (type(d1) == "table") then
		d1 = table.getn(d1);
	end

	if (type(d2) == "table") then
		d2 = table.getn(d2);
	end

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_BossSortOrd;
	elseif	(d2 == nil) then
		return Lootster_BossSortOrd;
	elseif	(d1 == d2) then
		return false;
	else
		return (d1 < d2) == Lootster_BossSortOrd;
	end
end

-- Attendance Sort handler
function Lootster_Raid_Attend_Sort(col)
	local	player, attendId;
	local	ix = 0;

	-- are we doing current sort order?
	if		(col ~= nil) then
		-- are we inverting sort order?
		if (col == Lootster_AttendSortCol) then
			-- flip sort order
			Lootster_AttendSortOrd = not Lootster_AttendSortOrd;
		else
			-- force ascending
			Lootster_AttendSortOrd = true;
		end

		Lootster_AttendSortCol = col;
	end

	-- setup sort indirection
	Lootster_AttendSort = {};

	-- do we have a current boss?
	if (Lootster_BossId ~= nil) then
		-- get each of the boss attendances into the attend sort indirection table
		for player, attendId in pairs(Lootster_Boss[Lootster_BossId].AttendSet) do
			ix = ix + 1;
			Lootster_AttendSort[ix] = attendId;
		end
	end

	-- constrain the attend sort indirection table
	table.setn(Lootster_AttendSort, ix);

	-- resort the attend data.  We use a sorted indirection table
	table.sort(Lootster_AttendSort, Lootster_RaidAttendTest);

	-- and update screen
	Lootster_Raid_Attend_Update();
end

-- Attendance Test handler
function Lootster_RaidAttendTest(i1, i2)
	local	d1, d2;

	-- are we sorting by alt?
	if (Lootster_AttendSortCol == "Alt") then
		-- indeed.  Get the alt if it is playing and sort on that
		d1 = Lootster_GetMainALT(Lootster_Attend[i1].Player);
		d2 = Lootster_GetMainALT(Lootster_Attend[i2].Player);
	else
		-- retrieve indirected data
		d1 = Lootster_Attend[i1][Lootster_AttendSortCol];
		d2 = Lootster_Attend[i2][Lootster_AttendSortCol];

		-- if these items are sets (tables), get their item count instead
		if (type(d1) == "table") then
			d1 = table.getn(d1);
		end
	
		if (type(d2) == "table") then
			d2 = table.getn(d2);
		end
	end
	
	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_AttendSortOrd;
	elseif	(d2 == nil) then
		return Lootster_AttendSortOrd;
	elseif	(d1 == d2) then
		return false;
	else
		return (d1 < d2) == Lootster_AttendSortOrd;
	end
end

-- Adjust Sort handler
function Lootster_Raid_Adjust_Sort(col)
	local	adjustId, adjustRec;
	local	ix = 0;

	-- are we doing current sort order?
	if		(col ~= nil) then
		-- are we inverting sort order?
		if (col == Lootster_AdjustSortCol) then
			-- flip sort order
			Lootster_AdjustSortOrd = not Lootster_AdjustSortOrd;
		else
			-- force ascending
			Lootster_AdjustSortOrd = true;
		end

		Lootster_AdjustSortCol = col;
	end

	-- setup sort indirection
	Lootster_AdjustSort = {};

	-- do we have a current boss?
	if (Lootster_BossId ~= nil) then
		-- get each of the boss attendances into the attend sort indirection table
		for adjustId, adjustRec in pairs(Lootster_Boss[Lootster_BossId].AdjustSet) do
			ix = ix + 1;
			Lootster_AdjustSort[ix] = adjustId;
		end
	end

	-- constrain the adjust sort indirection table
	table.setn(Lootster_AdjustSort, ix);

	-- resort the adjust data.  We use a sorted indirection table
	table.sort(Lootster_AdjustSort, Lootster_RaidAdjustTest);

	-- and update screen
	Lootster_Raid_Adjust_Update();
end

-- Adjust Test handler
function Lootster_RaidAdjustTest(i1, i2)
	local	d1, d2;

	-- are we sorting by alt?
	if (Lootster_AdjustSortCol == "Alt") then
		-- indeed.  Get the alt if it is playing and sort on that
		d1 = Lootster_GetMainALT(Lootster_Adjust[i1].Player);
		d2 = Lootster_GetMainALT(Lootster_Adjust[i2].Player);
	else
		-- retrieve indirected data
		d1 = Lootster_Adjust[i1][Lootster_AdjustSortCol];
		d2 = Lootster_Adjust[i2][Lootster_AdjustSortCol];
	end

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_AdjustSortOrd;
	elseif	(d2 == nil) then
		return Lootster_AdjustSortOrd;
	elseif	(d1 == d2) then
		return false;
	else
		return (d1 < d2) == Lootster_AdjustSortOrd;
	end
end

-- Item Sort handler
function Lootster_Item_Sort(col)
	local	itemId, itemRec;
	local	ix = 0;

	-- are we doing current sort order?
	if		(col ~= nil) then
		-- are we inverting sort order?
		if (col == Lootster_ItemSortCol) then
			-- flip sort order
			Lootster_ItemSortOrd = not Lootster_ItemSortOrd;
		else
			-- force ascending
			Lootster_ItemSortOrd = true;
		end

		Lootster_ItemSortCol = col;
	end

	-- setup sort indirection
	Lootster_ItemSort = {};

	-- get each of the item into the item sort indirection table
	for itemId, itemRec in pairs(Lootster_Restrict) do
		ix = ix + 1;
		Lootster_ItemSort[ix] = itemId;
	end

	-- constrain the item sort indirection table
	table.setn(Lootster_ItemSort, ix);

	-- resort the item data.  We use a sorted indirection table
	table.sort(Lootster_ItemSort, Lootster_ItemTest);

	-- and update screen
	Lootster_Item_Update();
end

-- Item Test handler
function Lootster_ItemTest(i1, i2)
	local	d1, d2;

	-- retrieve adjustment data
	d1 = Lootster_Restrict[i1][Lootster_ItemSortCol];
	d2 = Lootster_Restrict[i2][Lootster_ItemSortCol];

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_ItemSortOrd;
	elseif	(d2 == nil) then
		return Lootster_ItemSortOrd;
	elseif	(d1 == d2) then
		return false;
	else
		return (d1 < d2) == Lootster_ItemSortOrd;
	end
end

-- Raid Report Raid Sort handler
function Lootster_RaidReport_Raid_Sort()
	local	raidSort, raidId, raidRec;
	local	ix = 0;

	-- setup sort indirection
	raidSort = {};

	-- get each of the raids
	for raidId, raidRec in pairs(Lootster_Raid) do
		ix = ix + 1;
		raidSort[ix] = raidId;
	end

	-- constrain the raid report sort indirection table
	table.setn(raidSort, ix);

	-- resort the raid data.  We use a sorted indirection table
	table.sort(raidSort, Lootster_RaidReportRaidTest);

	return raidSort;
end

-- Raid Report Raid Test handler
function Lootster_RaidReportRaidTest(i1, i2)
	local	d1, d2;

	-- retrieve indirected data
	d1 = Lootster_Raid[i1][Lootster_Options.RepRaidSortCol];
	d2 = Lootster_Raid[i2][Lootster_Options.RepRaidSortCol];
	
	-- if these items are sets (tables), get their item count instead
	if (type(d1) == "table") then
		d1 = table.getn(d1);
	end

	if (type(d2) == "table") then
		d2 = table.getn(d2);
	end

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_Options.RepRaidSortColOrd;
	elseif	(d2 == nil) then
		return Lootster_Options.RepRaidSortColOrd;
	elseif	(d1 == d2) then
		return false;
	else
		return (d1 < d2) == Lootster_Options.RepRaidSortColOrd;
	end
end

-- Raid Report Boss Sort handler
function Lootster_RaidReport_Boss_Sort(raidId)
	local	bossSort, bossId, bossRec;
	local	ix = 0;

	-- setup sort indirection
	bossSort = {};

	-- do we have a raid?
	if (raidId ~= nil) then
		-- get each of the raid bosses into the boss sort indirection table
		for bossId, bossRec in pairs(Lootster_Raid[raidId].BossSet) do
			ix = ix + 1;
			bossSort[ix] = bossId;
		end
	end

	-- constrain the boss sort indirection table
	table.setn(bossSort, ix);

	-- resort the boss data.  We use a sorted indirection table
	table.sort(bossSort, Lootster_RaidReportBossTest);

	return bossSort;
end

-- Raid Report Boss Test handler
function Lootster_RaidReportBossTest(i1, i2)
	local	d1, d2;

	-- retrieve indirected data
	d1 = Lootster_Boss[i1][Lootster_Options.RepBossSortCol];
	d2 = Lootster_Boss[i2][Lootster_Options.RepBossSortCol];

	-- if these items are sets (tables), get their item count instead
	if (type(d1) == "table") then
		d1 = table.getn(d1);
	end

	if (type(d2) == "table") then
		d2 = table.getn(d2);
	end

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_Options.RepBossSortColOrd;
	elseif	(d2 == nil) then
		return Lootster_Options.RepBossSortColOrd;
	elseif	(d1 == d2) then
		return false;
	else
		return (d1 < d2) == Lootster_Options.RepBossSortColOrd;
	end
end

-- Raid Report Attendance Sort handler
function Lootster_RaidReport_Attend_Sort(bossId)
	local	attendSort, player, attendId;
	local	ix = 0;

	-- setup sort indirection
	attendSort = {};

	-- do we have a boss?
	if (bossId ~= nil) then
		-- get each of the boss attendances into the attend sort indirection table
		for player, attendId in pairs(Lootster_Boss[bossId].AttendSet) do
			ix = ix + 1;
			attendSort[ix] = attendId;
		end
	end

	-- constrain the attend sort indirection table
	table.setn(attendSort, ix);

	-- resort the attend data.  We use a sorted indirection table
	table.sort(attendSort, Lootster_RaidReportAttendTest);

	return attendSort;
end

-- Raid Report Consolidate Attendance Sort handler
function Lootster_RaidReport_ConsolidateAttend_Sort(bossSort)
	local	attendSort, bix, bossId, player, attendId;
	local	aix = 0;

	-- setup sort indirection
	attendSort = {};

	-- do we have a boss set?
	if (bossSort ~= nil) then
		-- gather attendances for each boss
		for bix, bossId in ipairs(bossSort) do
			-- get each of the boss attendances into the attend sort indirection table
			for player, attendId in pairs(Lootster_Boss[bossId].AttendSet) do
				aix = aix + 1;
				attendSort[aix] = attendId;
			end
		end
	end

	-- constrain the attend sort indirection table
	table.setn(attendSort, aix);

	-- resort the attend data.  We use a sorted indirection table
	table.sort(attendSort, Lootster_RaidReportAttendTest);

	return attendSort;
end

-- Raid Report Attendance Test handler
function Lootster_RaidReportAttendTest(i1, i2)
	local	d1, d2;

	-- are we sorting by alt?
	if (Lootster_Options.RepAttendSortCol == "Alt") then
		-- indeed.  Get the alt if it is playing and sort on that
		d1 = Lootster_GetMainALT(Lootster_Attend[i1].Player);
		d2 = Lootster_GetMainALT(Lootster_Attend[i2].Player);
	else
		-- retrieve indirected data
		d1 = Lootster_Attend[i1][Lootster_Options.RepAttendSortCol];
		d2 = Lootster_Attend[i2][Lootster_Options.RepAttendSortCol];

		-- if these items are sets (tables), get their item count instead
		if (type(d1) == "table") then
			d1 = table.getn(d1);
		end
	
		if (type(d2) == "table") then
			d2 = table.getn(d2);
		end
	end
	
	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_Options.RepAttendSortColOrd;
	elseif	(d2 == nil) then
		return Lootster_Options.RepAttendSortColOrd;
	elseif	(d1 == d2) then
		return false;
	else
		return (d1 < d2) == Lootster_Options.RepAttendSortColOrd;
	end
end

-- Raid Report Adjust Sort handler
function Lootster_RaidReport_Adjust_Sort(bossId)
	local	adjustSort, adjustId, adjustRec;
	local	ix = 0;

	-- setup sort indirection
	adjustSort = {};

	-- do we have a current boss?
	if (bossId ~= nil) then
		-- get each of the boss attendances into the attend sort indirection table
		for adjustId, adjustRec in pairs(Lootster_Boss[bossId].AdjustSet) do
			ix = ix + 1;
			adjustSort[ix] = adjustId;
		end
	end

	-- constrain the adjust sort indirection table
	table.setn(adjustSort, ix);

	-- resort the adjust data.  We use a sorted indirection table
	table.sort(adjustSort, Lootster_RaidReportAdjustTest);

	return adjustSort;
end

-- Raid Report Consolidate Adjust Sort handler
function Lootster_RaidReport_ConsolidateAdjust_Sort(bossSort)
	local	adjustSort, bix, bossId, adjustId, adjustRec;
	local	aix = 0;

	-- setup sort indirection
	adjustSort = {};

	-- do we have a boss set?
	if (bossSort ~= nil) then
		-- gather attendances for each boss
		for bix, bossId in ipairs(bossSort) do
			-- get each of the boss attendances into the attend sort indirection table
			for adjustId, adjustRec in pairs(Lootster_Boss[bossId].AdjustSet) do
				aix = aix + 1;
				adjustSort[aix] = adjustId;
			end
		end
	end

	-- constrain the adjust sort indirection table
	table.setn(adjustSort, aix);

	-- resort the adjust data.  We use a sorted indirection table
	table.sort(adjustSort, Lootster_RaidReportAdjustTest);

	return adjustSort;
end

-- Raid Report Adjust Test handler
function Lootster_RaidReportAdjustTest(i1, i2)
	local	c1, c2, d1, d2;

	-- are we sorting by alt or quality?
	if		(Lootster_Options.RepAdjustSortCol == "Alt") then
		-- by Alt.  Get the alt if it is playing and sort on that
		d1 = Lootster_GetMainALT(Lootster_Adjust[i1].Player);
		d2 = Lootster_GetMainALT(Lootster_Adjust[i2].Player);
	elseif	(Lootster_Options.RepAdjustSortCol == "Quality") then
		-- by Quality.  Get the quality via the link colour
		if (Lootster_Adjust[i1].Link ~= nil) then
			-- get the link colour and lookup quality
			_, _, c1 = string.find(Lootster_Adjust[i1].Link, LOOTSTER_ITEMQUAL_PATTERN);

			if (c1 ~= nil) then
				d1 = Lootster_LootQuality[c1];
			end
		end

		if (Lootster_Adjust[i2].Link ~= nil) then
			-- get the link colour and lookup quality
			_, _, c2 = string.find(Lootster_Adjust[i2].Link, LOOTSTER_ITEMQUAL_PATTERN);

			if (c2 ~= nil) then
				d2 = Lootster_LootQuality[c2];
			end
		end
	else
		-- retrieve indirected data
		d1 = Lootster_Adjust[i1][Lootster_Options.RepAdjustSortCol];
		d2 = Lootster_Adjust[i2][Lootster_Options.RepAdjustSortCol];
	end

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_Options.RepAdjustSortColOrd;
	elseif	(d2 == nil) then
		return Lootster_Options.RepAdjustSortColOrd;
	elseif	(d1 == d2) then
		return false;
	else
		return (d1 < d2) == Lootster_Options.RepAdjustSortColOrd;
	end
end

-- Build Player Drop Down handler
function Lootster_Build_Player_DropDown(textSelect, funcSelect, textPlayer, funcPlayer, notSelf, notPark)
	local	pcount, pix, player, gix, group;
	local	groupInfo = {};
	local	playerInfo = {};
	
	-- see what menu level we are
	if		(UIDROPDOWNMENU_MENU_LEVEL == 1) then
		-- is this a raid?
		if (GetNumRaidMembers() > 0) then
			-- reset assignment details
			Lootster_AssignGroups = {};
			Lootster_AssignPlayers = {};

			-- get player count
			pcount = GetNumRaidMembers();

			-- form menu level for raid groups
			playerInfo = {};
			playerInfo.text = textSelect;
			playerInfo.isTitle = 1;
			playerInfo.notCheckable = 1;

			-- add title button
			UIDropDownMenu_AddButton(playerInfo);

			-- gather players and groups
			for pix=1, pcount do
				-- accumulate all the groups 
				player, _, group = GetRaidRosterInfo(pix);

				-- add group to group list
				Lootster_AssignGroups[group] = true;

				-- add player to group list, making sure we have a table for him
				if (Lootster_AssignPlayers[group] == nil) then
					Lootster_AssignPlayers[group] = {};
				end

				table.insert(Lootster_AssignPlayers[group], player);
			end

			-- form group buttons
			for gix=1, 8 do
				-- this group exists?
				if ((Lootster_AssignGroups[gix] ~= nil) and (Lootster_AssignGroups[gix] == true)) then
					-- form group button
					groupInfo = {};
					groupInfo.text = GROUP.." "..gix;
					groupInfo.hasArrow = 1;
					groupInfo.notCheckable = 1;
					groupInfo.value = gix;
					groupInfo.func = nil;

					-- add group button
					UIDropDownMenu_AddButton(groupInfo);
				end
			end

			-- add park players?
			if ((notPark == nil) or (notPark == false)) then
				-- form park player buttons
				for currIx, player in ipairs(Lootster_ParkSort) do
					-- form park player button
					playerInfo = {};
					playerInfo.text = player;
					playerInfo.value = player;
					playerInfo.func = funcSelect;
	
					-- add player button
					UIDropDownMenu_AddButton(playerInfo);
				end
			end

			-- form other player button
			playerInfo = {};
			playerInfo.text = textPlayer;
			playerInfo.value = "";
			playerInfo.func = funcPlayer;

			-- add player button
			UIDropDownMenu_AddButton(playerInfo);
		else
			-- setup the group with no menuing.  First, us as required
			if ((notSelf == nil) or (notSelf == false)) then
				playerInfo = {};
				playerInfo.text = Lootster_Self;
				playerInfo.value = Lootster_Self;
				playerInfo.func = funcSelect;

				-- add player button
				UIDropDownMenu_AddButton(playerInfo, UIDROPDOWNMENU_MENU_LEVEL);
			end

			for currIx=1, MAX_PARTY_MEMBERS, 1 do
				-- get party member
				player = UnitName("party"..currIx);

				-- no player (no information there yet) or unknown, move on
				if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
					-- form player button
					playerInfo = {};
					playerInfo.text = player;
					playerInfo.value = player;
					playerInfo.func = funcSelect;

					-- add player button
					UIDropDownMenu_AddButton(playerInfo);
				end
			end

			-- add park players?
			if ((notPark == nil) or (notPark == false)) then
				-- form park player buttons
				for currIx, player in ipairs(Lootster_ParkSort) do
					-- form park player button
					playerInfo = {};
					playerInfo.text = player;
					playerInfo.value = player;
					playerInfo.func = funcSelect;
	
					-- add player button
					UIDropDownMenu_AddButton(playerInfo);
				end
			end

			-- form other player button
			playerInfo = {};
			playerInfo.text = textPlayer;
			playerInfo.value = "";
			playerInfo.func = funcPlayer;

			-- add player button
			UIDropDownMenu_AddButton(playerInfo);
		end
	elseif	(UIDROPDOWNMENU_MENU_LEVEL == 2) then
		-- form the buttons for the group's players
		for pix=1, table.getn(Lootster_AssignPlayers[UIDROPDOWNMENU_MENU_VALUE]) do

			-- get the player name
			player = Lootster_AssignPlayers[UIDROPDOWNMENU_MENU_VALUE][pix];

			-- no player (no information there yet) or unknown, move on
			if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
				-- add self?
				if ((notSelf == nil) or (notSelf == false) or (Lootster_Self ~= player)) then
					-- form player button
					playerInfo = {};
					playerInfo.text = player;
					playerInfo.value = player;
					playerInfo.func = funcSelect;
	
					-- add player button
					UIDropDownMenu_AddButton(playerInfo, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end
	end
end

-- Instantiate a DKP Entry handler
function Lootster_NewDKP(player, class, dkpRaw, dkpAdj, trial, app)
	local	trial;

	-- determine the dkp and tier for this raw dkp
	dkp = Lootster_CalcDKP(dkpRaw + dkpAdj);
	tier = Lootster_CalcTier(dkpRaw + dkpAdj);

	-- determine trial and applicant flags
	trial = (trial ~= nil) and trial;
	app = (app == nil) or app;

	-- calculate membership priority
	prior = Lootster_CalcPriority(trial, app);

	-- easy
	return { Player=player, Class=class, DKP=dkp, DKPRaw=dkpRaw, DKPAdj=dkpAdj, Tier=tier, Trial=trial, App=app, Priority=prior };
end

-- Instantiate a Roster Entry handler
function Lootster_NewRoster(player, class, classType)
	-- easy
	return { Name=name, Class=class, ClassType=classType };
end

-- Instantiate a Restrict Entry handler
function Lootster_NewRestrict(text, classes)
	-- easy
	return { Text=text, Classes=classes };
end

-- Instantiate a Rolls Entry handler
function Lootster_NewRolls(player, roll, class, dkp, tier, trial, app, prior)
	-- easy
	return { Player=player, Roll=nil, Class=class, DKP=dkp, Tier=tier, Trial=trial, App=app, Priority=prior, Bad=nil, Dup=nil };
end

-- Instantiate a Tiers Entry handler
function Lootster_NewTiers(name, tier, trial, app)
	-- easy
	return { TierName=name, Tier=tier, Trial=trial, App=app, Count=1 };
end

-- Instantiate a Roster Roll Entry handler
function Lootster_NewRosterRoll(dkp, tier, trial, app, prior)
	-- easy
	return { DKP=dkp, Tier=tier, Trial=trial, App=app, Priority=prior, High=0, Equal=0 };
end

-- Instantiate a Raid Entry handler
function Lootster_NewRaid(zone, wowId, dateOpn, dateExp)
	-- easy
	return { Id=nil, Zone=zone, WoWId=wowId, DateOpn=dateOpn, DateExp=dateExp, Comment="", BossSet={}, AttendSet={}, AdjustSet={}, DKP=0 };
end

-- Instantiate a Boss Entry handler
function Lootster_NewBoss(boss, dateBeg, tbd)
	-- if no boss TBD flag, must be known
	if (tbd == nil) then
		tbd = false;
	end
	
	-- easy
	return { Id=nil, RaidId=nil, Boss=boss, DateBeg=dateBeg, DateEnd=nil, TBD=tbd, Combat=false, Killed=false, AttendSet={}, AdjustSet={}, DKP=0 };
end

-- Instantiate a Attend Entry handler
function Lootster_NewAttend(player, alt, attended)
	-- easy
	return { Id=nil, BossId=nil, Player=player, Alt=alt, Attended=attended, AdjustSet={}, DKP=0 };
end

-- Instantiate a Adjust Entry handler
function Lootster_NewAdjust(player, alt, dateAdj, dkp, link, reason, comment)
	-- easy
	return { Id=nil, BossId=nil, Player=player, Alt=alt, DateAdj=dateAdj, ML=false, DKP=dkp, Link=link, Reason=reason, Comment=comment };
end

-- Instantiate a Legacy Adjust Entry handler
function Lootster_NewLegacy(player, dkp, epoch, reason, comment)
	-- easy - this is here only for data synchronisation
	return { Player=player, DKPAct=dkp, DKPTot=dkp, Epoch=epoch, Reason=reason, Comment=comment };
end

-- Create Identifier handler
function Lootster_CreateId(type)
	local   id;

	-- allocate id number and bump for uniqueness
	id = Lootster_Id;

	Lootster_Id = Lootster_Id + 1;

	-- format and return id
	return type..id;
end

-- Create Raid handler
function Lootster_CreateRaid(raidRec, raidId)
	-- do we have a supplied raid id?
	if (raidId == nil) then
		-- create a raid id
		raidId = Lootster_CreateId(LOOTSTER_ENUM_IDTYPE.RAID);
	end

	-- insert into raid table
	Lootster_Raid[raidId] = Lootster_CopyRecord(raidRec);
	
	-- and update it's id
	Lootster_Raid[raidId].Id = raidId;
	
	return raidId;
end

-- Create Boss handler
function Lootster_CreateBoss(bossRec, bossId)
	-- do we have a supplied boss id?
	if (bossId == nil) then
		-- create a boss id
		bossId = Lootster_CreateId(LOOTSTER_ENUM_IDTYPE.BOSS);
	end
	
	-- insert into raid table
	Lootster_Boss[bossId] = Lootster_CopyRecord(bossRec);
	
	-- and update it's id
	Lootster_Boss[bossId].Id = bossId;

	return bossId;
end

-- Create Attendance handler
function Lootster_CreateAttend(attendRec, attendId)
	-- do we have a supplied attend id?
	if (attendId == nil) then
		-- create a attendance id
		attendId = Lootster_CreateId(LOOTSTER_ENUM_IDTYPE.ATTEND);
	end
	
	-- and insert into attendance table
	Lootster_Attend[attendId] = Lootster_CopyRecord(attendRec);
	
	-- and update it's id
	Lootster_Attend[attendId].Id = attendId;

	return attendId;
end

-- Create Adjustment handler
function Lootster_CreateAdjust(adjustRec, adjustId)
	-- do we have a supplied adjust id?
	if (adjustId == nil) then
		-- create a adjustment id
		adjustId = Lootster_CreateId(LOOTSTER_ENUM_IDTYPE.ADJUST);
	end
	
	-- insert into adjustment table
	Lootster_Adjust[adjustId] =  Lootster_CopyRecord(adjustRec);
	
	-- and update it's id
	Lootster_Adjust[adjustId].Id = adjustId;

	return adjustId;
end

-- Delete Raid handler
function Lootster_DeleteRaid(raidId)
	local	bossId, boss;
	
	-- have we a raid?
	if (Lootster_Raid[raidId] == nil) then
	    -- no raid
	    return false;
	end
	
	-- delete all bosses
	Lootster_DeleteAllBoss(raidId);
	
	-- erase from raid table
	Lootster_Raid[raidId] = nil;
	
	return true;
end

-- Delete Boss handler
function Lootster_DeleteBoss(bossId)
	-- have we a boss?
	if (Lootster_Boss[bossId] == nil) then
	    -- no boss
	    return false;
	end

	-- remove all attednances
	Lootster_DeleteAllAttend(bossId);
	
	-- delete all adjustments
	Lootster_DeleteAllAdjust(bossId);
	
	-- remove boss from raid
	Lootster_RemoveBoss(bossId);

	-- erase from boss table
	Lootster_Boss[bossId] = nil;

	return true;
end

-- Delete Attendance handler
function Lootster_DeleteAttend(attendId)
	-- have we a attendance?
	if (Lootster_Attend[attendId] == nil) then
	    -- no attendance
	    return false;
	end

	-- smack the attendance
	Lootster_RemoveAttend(attendId);

	-- erase from attendance table
	Lootster_Attend[attendId] = nil;

	return true;
end

-- Delete Adjustment handler
function Lootster_DeleteAdjust(adjustId)
	-- have we a adjustment?
	if (Lootster_Adjust[adjustId] == nil) then
	    -- no adjustment
	    return false;
	end

	-- smack the adjustment
	Lootster_RemoveAdjust(adjustId);

	-- erase from adjustment table
	Lootster_Adjust[adjustId] = nil;

	return true;
end

-- Delete All Raids handler
function Lootster_DeleteAllRaid()
	local	raidId, raidRec, adjustIx, adjustRec;

	-- delete each boss
	for raidId, raidRec in pairs(Lootster_Raid) do
		-- delete this raid
		Lootster_DeleteRaid(raidId);
	end

	-- delete all legacy adjustments
	for adjustIx, adjustRec in ipairs(Lootster_Adjust) do
		-- remove legacy record
		table.remove(Lootster_Adjust, adjustIx);
	end

	return true;
end

-- Delete All Bosses handler
function Lootster_DeleteAllBoss(raidId)
	local	bossSet, bossId, flag;

	-- have we a raid?
	if (Lootster_Raid[raidId] == nil) then
	    -- no boss
	    return false;
	end
	
	-- hammer through each boss
	for bossId, flag in pairs(Lootster_Raid[raidId].BossSet) do
		-- delete boss
		Lootster_DeleteBoss(bossId);
	end

	-- erase bosses from raid
	Lootster_Raid[raidId].BossSet = {};

    -- wack boss count
    table.setn(Lootster_Raid[raidId].BossSet, 0);

	return true;
end

-- Delete All Attendance handler
function Lootster_DeleteAllAttend(bossId)
	local	attendSet, attendId;
	
	-- have we a boss?
	if (Lootster_Boss[bossId] == nil) then
	    -- no attendance
	    return false;
	end
	
	-- copy the set of attend ids
	attendSet = Lootster_CopyRecord(Lootster_Boss[bossId].AttendSet);

	-- remove all attendances
	Lootster_RemoveAllAttend(bossId);

	-- hammer through each attendance
	for player, attendId in pairs(attendSet) do
		-- erase from attendance table
		Lootster_Attend[attendId] = nil;
	end

	return true;
end

-- Delete All Adjustment handler
function Lootster_DeleteAllAdjust(bossId)
	local	adjustSet, adjustId;
	
	-- have we a boss?
	if (Lootster_Boss[bossId] == nil) then
	    -- no adjustment
	    return false;
	end
	
	-- copy the set of adjust ids
	adjustSet = Lootster_CopyRecord(Lootster_Boss[bossId].AdjustSet);

	-- remove all adjustments
	Lootster_RemoveAllAdjust(bossId);

	-- hammer through each adjustment
	for adjustId, player in pairs(adjustSet) do
		-- erase from adjustment table
		Lootster_Adjust[adjustId] = nil;
	end

	return true;
end

-- Add Boss to Raid handler
function Lootster_InsertBoss(raidId, bossId)
	local   player, attendId;
	
	-- have we a raid?
	if (Lootster_Raid[raidId] == nil) then
	    -- no raid
	    return false;
	end

	-- is this boss already in the raid?
	if (Lootster_Raid[raidId].BossSet[bossId] ~= nil) then
	    -- done
	    return true;
	end
	
	-- add boss to raid
	Lootster_Raid[raidId].BossSet[bossId] = true;

    -- bump boss count
    table.setn(Lootster_Raid[raidId].BossSet, table.getn(Lootster_Raid[raidId].BossSet) + 1);

    -- add to raid to boss
    Lootster_Boss[bossId].RaidId = raidId;

	-- roll up accounting of attendance
	for player, attendId in pairs(Lootster_Boss[bossId].AttendSet) do
	    -- is this player already in raid?
	    if (Lootster_Raid[raidId].AttendSet[player] == nil) then
	        -- new guy
	        Lootster_Raid[raidId].AttendSet[player] = 1;

	        -- bump attend count
	        table.setn(Lootster_Raid[raidId].AttendSet, table.getn(Lootster_Raid[raidId].AttendSet) + 1);
		else
		    -- bump times counted
		    Lootster_Raid[raidId].AttendSet[player] = Lootster_Raid[raidId].AttendSet[player] + 1;
		end
	end

	-- roll up accounting of adjustment
	for adjustId, player in pairs(Lootster_Boss[bossId].AdjustSet) do
	    -- new guy
	    Lootster_Raid[raidId].AdjustSet[adjustId] = player;

	    -- bump adjust count
	    table.setn(Lootster_Raid[raidId].AdjustSet, table.getn(Lootster_Raid[raidId].AdjustSet) + 1);
	
		-- add DKP
		Lootster_Raid[raidId].DKP = Lootster_Raid[raidId].DKP + Lootster_Adjust[adjustId].DKP;
	end
	
	return true;
end

-- Add Attendance to Boss handler
function Lootster_InsertAttend(bossId, attendId)
	local   raidId, player;

	-- have we a boss?
	if (Lootster_Boss[bossId] == nil) then
	    -- no boss
	    return false;
	end

    -- get the player for this entry
    player = Lootster_Attend[attendId].Player;

	-- is this attendance already in the boss?
	if (Lootster_Boss[bossId].AttendSet[player] ~= nil) then
	    -- done
	    return true;
	end

	-- add attendance to boss
	Lootster_Boss[bossId].AttendSet[player] = attendId;

    -- bump attend count
    table.setn(Lootster_Boss[bossId].AttendSet, table.getn(Lootster_Boss[bossId].AttendSet) + 1);

    -- add to boss to attendance
    Lootster_Attend[attendId].BossId = bossId;
	
	-- make sure we sum the adjustments for this new guy
	Lootster_SumAttendAdjusts(bossId, attendId);

	-- get the raid Id
	raidId = Lootster_Boss[bossId].RaidId;

	-- roll up accounting of attendance into raid?
	if (raidId ~= nil) then
	    -- is this player already in raid?
	    if (Lootster_Raid[raidId].AttendSet[player] == nil) then
	        -- new guy
	        Lootster_Raid[raidId].AttendSet[player] = 1;

	        -- bump attend count
	        table.setn(Lootster_Raid[raidId].AttendSet, table.getn(Lootster_Raid[raidId].AttendSet) + 1);
		else
		    -- bump times counted
		    Lootster_Raid[raidId].AttendSet[player] = Lootster_Raid[raidId].AttendSet[player] + 1;
		end
	end

	return true;
end

-- Add Adjustment to Boss handler
function Lootster_InsertAdjust(bossId, adjustId)
	-- have we a boss?
	if (Lootster_Boss[bossId] == nil) then
	    -- no boss
	    return false;
	end

	-- is this adjustment already in the boss?
	if (Lootster_Boss[bossId].AdjustSet[adjustId] ~= nil) then
	    -- done
	    return true;
	end

	-- add adjustment to boss
	Lootster_Boss[bossId].AdjustSet[adjustId] = Lootster_Adjust[adjustId].Player;

    -- bump adjust count
    table.setn(Lootster_Boss[bossId].AdjustSet, table.getn(Lootster_Boss[bossId].AdjustSet) + 1);

    -- add to boss to adjustment
    Lootster_Adjust[adjustId].BossId = bossId;

	-- add this adjustment to boss/attendance/raid
	Lootster_AddAdjust(adjustId);

	-- inert master loot item for the raid
	Lootster_InsertMasterLoot(adjustId);

	return true;
end

-- Modify Raid handler
function Lootster_ModifyRaid(raidRec)
	local	raidId;
	
	-- retrieve raid id
	raidId = raidRec.Id;
	
	-- have we a raid?
	if ((raidId == nil) or (Lootster_Raid[raidId] == nil)) then
	    -- no raid
	    return false;
	end

	-- simply update the data from the passed record.  Note that the various data sets are
	-- left  untouched since there are other means to modify those
	Lootster_Raid[raidId].Zone		= raidRec.Zone;
	Lootster_Raid[raidId].WoWId		= raidRec.WoWId;
	Lootster_Raid[raidId].DateOpn	= raidRec.DateOpn;
	Lootster_Raid[raidId].DateExp	= raidRec.DateExp;
	Lootster_Raid[raidId].Comment	= raidRec.Comment;
	
	return true;	
end

-- Modify Boss handler
function Lootster_ModifyBoss(bossRec)
	local	bossId;
	
	-- retrieve boss id
	bossId = bossRec.Id;
	
	-- have we a boss?
	if ((bossId == nil) or (Lootster_Boss[bossId] == nil)) then
	    -- no boss
	    return false;
	end

	-- simply update the data from the passed record.  Note that the various data sets are
	-- left  untouched since there are other means to modify those
	Lootster_Boss[bossId].Boss		= bossRec.Boss;
	Lootster_Boss[bossId].DateBeg	= bossRec.DateBeg;
	Lootster_Boss[bossId].DateEnd	= bossRec.DateEnd;
	
	return true;	
end

-- Modify Attend handler
function Lootster_ModifyAttend(attendRec)
	local	attendId, bossId, raidId, player;
	
	-- retrieve attend id
	attendId = attendRec.Id;
	
	-- have we a attendance?
	if ((attendId == nil) or (Lootster_Attend[attendId] == nil)) then
	    -- no attendance
	    return false;
	end
	
	-- retrieve the boss, if any
	bossId = Lootster_Attend[attendId].BossId;
	
	-- do we have a boss?
	if (bossId ~= nil) then
		-- get the raid Id
		raidId = Lootster_Boss[bossId].RaidId;
	else
		-- no raid
		raidId = nil;
	end

	-- get the player for this entry
	player = Lootster_Attend[attendId].Player;

	-- player change?
	bDelta = player ~= attendRec.Player;

	-- unwind player from attendance if player changed
	if (bDelta == true) then
		-- remove attendance from boss
		Lootster_Boss[bossId].AttendSet[player] = nil;
	end

	-- unwind accounting of attendance from raid
	if (raidId ~= nil) then
	    -- is this player in raid?
	    if (Lootster_Raid[raidId].AttendSet[player] ~= nil) then
	        -- is his attendance for the raid going zero?
	        if (Lootster_Raid[raidId].AttendSet[player] == 1) then
	            -- no longer in raid
		        Lootster_Raid[raidId].AttendSet[player] = nil;

		        -- wack attend count
		        table.setn(Lootster_Raid[raidId].AttendSet, table.getn(Lootster_Raid[raidId].AttendSet) - 1);
			else
			    -- wack times counted
			    Lootster_Raid[raidId].AttendSet[player] = Lootster_Raid[raidId].AttendSet[player] - 1;
			end
		end
	end

	-- update the data from the passed record
	Lootster_Attend[attendId].Player	= attendRec.Player;
	Lootster_Attend[attendId].Alt		= attendRec.Alt;
	Lootster_Attend[attendId].Attended	= attendRec.Attended;

	-- get the player for this entry
	player = Lootster_Attend[attendId].Player;

	-- add player from attendance if player changed
	if (bDelta == true) then
		-- add attendance to boss
		Lootster_Boss[bossId].AttendSet[player] = attendId;

		-- sum adjustments for this guy
		Lootster_SumAttendAdjusts(bossId, attendId);
	end

	-- roll up accounting of attendance into raid
	if (raidId ~= nil) then
	    -- is this player already in raid?
	    if (Lootster_Raid[raidId].AttendSet[player] == nil) then
	        -- new guy
	        Lootster_Raid[raidId].AttendSet[player] = 1;

	        -- bump attend count
	        table.setn(Lootster_Raid[raidId].AttendSet, table.getn(Lootster_Raid[raidId].AttendSet) + 1);
		else
		    -- bump times counted
		    Lootster_Raid[raidId].AttendSet[player] = Lootster_Raid[raidId].AttendSet[player] + 1;
		end
	end
	
	return true;	
end

-- Modify Adjust handler
function Lootster_ModifyAdjust(adjustRec)
	local	adjustId, bossId, raidId, isMLDelta;
	
	-- retrieve adjustment id
	adjustId = adjustRec.Id;
	
	-- have we an adjustment?
	if ((adjustId == nil) or (Lootster_Adjust[adjustId] == nil)) then
	    -- no adjustment
	    return false;
	end
	
	-- retrieve the boss, if any
	bossId = Lootster_Adjust[adjustId].BossId;
	
	-- do we have a boss?
	if (bossId ~= nil) then
		-- get the raid Id
		raidId = Lootster_Boss[bossId].RaidId;
	else
		-- no raid
		raidId = nil;
	end

	-- determine if master looted item flag changed
	isMLDelta = Lootster_Adjust[adjustId].ML ~= adjustRec.ML;

	-- has the master looted flag changed?
	if (isMLDelta == true) then
		-- remove master looted item for the raid
		Lootster_RemoveMasterLoot(adjustId);
	end

	-- unwind accounting of adjustment from boss/attendance/raid
	Lootster_SubAdjust(adjustId);

	-- update the data from the passed record
	Lootster_Adjust[adjustId].Player	= adjustRec.Player;
	Lootster_Adjust[adjustId].Alt		= adjustRec.Alt;
	Lootster_Adjust[adjustId].DateAdj	= adjustRec.DateAdj;
	Lootster_Adjust[adjustId].ML		= adjustRec.ML;
	Lootster_Adjust[adjustId].DKP		= adjustRec.DKP;
	Lootster_Adjust[adjustId].Link		= adjustRec.Link;
	Lootster_Adjust[adjustId].Reason	= adjustRec.Reason;
	Lootster_Adjust[adjustId].Comment	= adjustRec.Comment;
	
	-- roll up accounting of adjustment into boss/attendance/raid
	Lootster_AddAdjust(adjustId);

	-- has the master looted flag changed?
	if (isMLDelta == true) then
		-- insert master looted item for the raid
		Lootster_InsertMasterLoot(adjustId);
	end
		
	return true;
end

-- Remove Boss from Raid handler
function Lootster_RemoveBoss(bossId)
	local	raidId;
	
	-- is this boss?
	if (Lootster_Boss[bossId] == nil) then
	    -- done
	    return true;
	end

	-- remove all attendance
	Lootster_RemoveAllAttend(bossId);

	-- remove all adjustments
	Lootster_RemoveAllAdjust(bossId);
	
	-- grab the raid id, if any
	raidId = Lootster_Boss[bossId].RaidId;
	
	-- do we have a raid for this boss?
	if (raidId ~= nil) then
		-- erase boss from raid
		Lootster_Raid[raidId].BossSet[bossId] = nil;
	
	    -- wack boss count
	    table.setn(Lootster_Raid[raidId].BossSet, table.getn(Lootster_Raid[raidId].BossSet) - 1);

		-- erase raid from boss
		Lootster_Boss[bossId].RaidId = nil;
	end
	
	return true;
end

-- Remove Attendance from Boss handler
function Lootster_RemoveAttend(attendId)
	local   bossId, player, raidId;

	-- have we a attendance?
	if (Lootster_Attend[attendId] == nil) then
	    -- no boss
	    return false;
	end
	
	-- get the boss id, if any
	bossId = Lootster_Attend[attendId].BossId;
	
	-- do we have a boss for this attendance?
	if (bossId ~= nil) then
		-- get the raid id, if any
		raidId = Lootster_Boss[bossId].RaidId;
	
		-- get the player for this entry
		player = Lootster_Attend[attendId].Player;

		-- roll up accounting of attendance into raid?
		if (raidId ~= nil) then
		    -- is this player in raid?
		    if (Lootster_Raid[raidId].AttendSet[player] ~= nil) then
		        -- is his attendance for the raid going zero?
		        if (Lootster_Raid[raidId].AttendSet[player] == 1) then
		            -- no longer in raid
			        Lootster_Raid[raidId].AttendSet[player] = nil;
	
			        -- wack attend count
			        table.setn(Lootster_Raid[raidId].AttendSet, table.getn(Lootster_Raid[raidId].AttendSet) - 1);
				else
				    -- wack times counted
				    Lootster_Raid[raidId].AttendSet[player] = Lootster_Raid[raidId].AttendSet[player] - 1;
				end
			end
		end
	
		-- delete attendance from boss
		Lootster_Boss[bossId].AttendSet[player] = nil;
	
	    -- wack attend count
	    table.setn(Lootster_Boss[bossId].AttendSet, table.getn(Lootster_Boss[bossId].AttendSet) - 1);

		-- erase boss from attendance
		Lootster_Attend[attendId].BossId = nil;
	end
	
	return true;
end

-- Remove Adjustment from Boss handler
function Lootster_RemoveAdjust(adjustId)
	local   bossId;

	-- have we a adjust?
	if (Lootster_Adjust[adjustId] == nil) then
	    -- no adjust
	    return false;
	end
	
	-- get the boss id, if any
	bossId = Lootster_Adjust[adjustId].BossId;
	
	-- do we have a boss for this adjustment?
	if (bossId ~= nil) then
		-- remove master loot items from the raid
		Lootster_RemoveMasterLoot(adjustId);

		-- remove this adjustment from boss/attendance/raid
		Lootster_SubAdjust(adjustId);

		-- delete adjustment from boss
		Lootster_Boss[bossId].AdjustSet[adjustId] = nil;
	
	    -- wack adjust count
	    table.setn(Lootster_Boss[bossId].AdjustSet, table.getn(Lootster_Boss[bossId].AdjustSet) - 1);

		-- erase boss from adjustment
		Lootster_Adjust[adjustId].BossId = nil;
	end

	return true;
end

-- Remove All Bosses from Raid handler
function Lootster_RemoveAllBoss(raidId)
	local   bossId;

	-- have we a raid?
	if (Lootster_Raid[raidId] == nil) then
	    -- no raid
	    return false;
	end
	
	-- hammer through each boss
	for bossId, flag in pairs(Lootster_Raid[raidId].BossSet) do
		-- remove all attendance
		Lootster_RemoveAllAttend(bossId);
	
		-- remove all adjustments
		Lootster_RemoveAllAdjust(bossId);

		-- erase raid from boss
		Lootster_Boss[bossId].RaidId = nil;
	end

	-- erase bosses from raid
	Lootster_Raid[raidId].BossSet = {};

    -- wack boss count
    table.setn(Lootster_Raid[raidId].BossSet, 0);

	return true;
end

-- Remove All Attendances from Boss handler
function Lootster_RemoveAllAttend(bossId)
	local   raidId, player, attendId;

	-- have we a boss?
	if (Lootster_Boss[bossId] == nil) then
	    -- no boss
	    return false;
	end

	-- get the raid id
	raidId = Lootster_Boss[bossId].RaidId;

	-- hammer through all the adjustments
	for player, attendId in pairs(Lootster_Boss[bossId].AttendSet) do
		-- roll up accounting of attendance into raid?
		if (raidId ~= nil) then
		    -- is this player in raid?
		    if (Lootster_Raid[raidId].AttendSet[player] ~= nil) then
		        -- is his attendance for the raid going zero?
		        if (Lootster_Raid[raidId].AttendSet[player] == 1) then
		            -- no longer in raid
			        Lootster_Raid[raidId].AttendSet[player] = nil;
	
			        -- wack attend count
			        table.setn(Lootster_Raid[raidId].AttendSet, table.getn(Lootster_Raid[raidId].AttendSet) - 1);
				else
				    -- wack times counted
				    Lootster_Raid[raidId].AttendSet[player] = Lootster_Raid[raidId].AttendSet[player] - 1;
				end
			end
		end

		-- erase boss from attendance
		Lootster_Attend[attendId].BossId = nil;
	end

	-- delete attendances from boss
	Lootster_Boss[bossId].AttendSet = {};

    -- wack attend count
    table.setn(Lootster_Boss[bossId].AttendSet, 0);

	return true;
end

-- Remove All Adjustments from Boss handler
function Lootster_RemoveAllAdjust(bossId)
	local   raidId, adjustId, player, playerSet, attendId;

	-- have we a boss?
	if (Lootster_Boss[bossId] == nil) then
	    -- no boss
	    return false;
	end
	
	-- no players to update
	playerSet = {};
	
	-- get the raid Id
	raidId = Lootster_Boss[bossId].RaidId;

	-- hammer through all the adjustments
	for adjustId, player in pairs(Lootster_Boss[bossId].AdjustSet) do
		-- remove master loot items from the raid
		Lootster_RemoveMasterLoot(adjustId);

		-- roll up accounting of adjustment into raid?
		if (raidId ~= nil) then
			-- remove DKP
			Lootster_Raid[raidId].DKP = Lootster_Raid[raidId].DKP - Lootster_Adjust[adjustId].DKP;

		    -- no longer in raid
			Lootster_Raid[raidId].AdjustSet[adjustId] = nil;

			-- wack adjust count
			table.setn(Lootster_Raid[raidId].AdjustSet, table.getn(Lootster_Raid[raidId].AdjustSet) - 1);
		end

		-- we may not have a DKP entry for this guy if the main/alt relationship has changed since the
		-- adjustment
		if (Lootster_DKP[player] ~= nil) then
			-- update player's adjusted DKP
			Lootster_DKP[player].DKPAdj = Lootster_DKP[player].DKPAdj - Lootster_Adjust[adjustId].DKP;

			-- add this player to the set of player's need a DKP update
			playerSet[player] = true;
		end

		-- erase boss from adjustment
		Lootster_Adjust[adjustId].BossId = nil;
	end

	-- hammer through all the attendances
	for player, attendId in pairs(Lootster_Boss[bossId].AttendSet) do
		-- reset DKP to zero
		Lootster_Attend[attendId].DKP = 0;
	end
	
	-- update the player DKP values
	for player, flag in playerSet do
		-- update player's DKP values
		Lootster_UpdateDKP(player);
	end
	
	-- delete adjustments from boss
	Lootster_Boss[bossId].AdjustSet = {};

    -- wack adjust count
    table.setn(Lootster_Boss[bossId].AdjustSet, 0);

	-- reset DKP for boss
	Lootster_Boss[bossId].DKP = 0;

	return true;
end

-- Sum Adjustments for Attendance handler
function Lootster_SumAttendAdjusts(bossId, attendId)
	local	player, adjustId;

	-- make sure we have a boss and attendance
	if ((Lootster_Boss[bossId] == nil) or (Lootster_Attend[attendId] == nil)) then
		return false;
	end
	
	-- reset adjustment set
	Lootster_Attend[attendId].AdjustSet = {};

    -- wack adjust count
    table.setn(Lootster_Attend[attendId].AdjustSet, 0);
	
	-- reset DKP to zero
	Lootster_Attend[attendId].DKP = 0;
	
	-- hammer through adjustments in this boss
	for adjustId, player in pairs(Lootster_Boss[bossId].AdjustSet) do
		-- is this our guy?
		if (Lootster_Attend[attendId].Player == player) then
			-- add DKP for this guy
			Lootster_Attend[attendId].DKP = Lootster_Attend[attendId].DKP + Lootster_Adjust[adjustId].DKP;

			-- add the adjustment to this guy
			Lootster_Attend[attendId].AdjustSet[adjustId] = adjustId;

			-- add adjust count
			table.setn(Lootster_Attend[attendId].AdjustSet, table.getn(Lootster_Attend[attendId].AdjustSet) + 1);
		end
	end
	
	return true;
end

-- Add Adjustment handler
function Lootster_AddAdjust(adjustId)
	local	bossId, raidId, player, attendId;

	-- have we a adjustment?
	if (Lootster_Adjust[adjustId] == nil) then
	    -- no adjustment
	    return false;
	end
	
	-- retrieve the boss, if any
	bossId = Lootster_Adjust[adjustId].BossId;
	
	-- do we have a boss?
	if (bossId ~= nil) then
		-- get the raid Id
		raidId = Lootster_Boss[bossId].RaidId;
	else
		-- no raid
		raidId = nil;
	end
	
	-- retrieve the player
	player = Lootster_Adjust[adjustId].Player;

	-- make sure this player has a DKP entry
	if (Lootster_DKP[player] == nil) then
		-- create DKP entry for player
		Lootster_DKP[player] = Lootster_NewDKP(player, "-", 0, 0);

		-- create an total adjustment entry for this guy
		Lootster_CreateAdjust(Lootster_NewAdjust(player, player, Lootster_CalcServerTime(time()), nil, LOOTSTER_MSG_ADJUSTTOTAL, ""), player);
	end

	-- update player's adjusted DKP
	Lootster_DKP[player].DKPAdj = Lootster_DKP[player].DKPAdj + Lootster_Adjust[adjustId].DKP;

	-- update player's DKP values
	Lootster_UpdateDKP(player);
	
	-- roll up accounting of adjustment into boss
	if (bossId ~= nil) then
		-- add in DKP
	    Lootster_Boss[bossId].DKP = Lootster_Boss[bossId].DKP + Lootster_Adjust[adjustId].DKP;

		-- get the attendance id, if any
		attendId = Lootster_Boss[bossId].AttendSet[player];

	    -- add DKP and adjustment to player, if attending
	    if (attendId ~= nil) then
	    	Lootster_Attend[attendId].DKP = Lootster_Attend[attendId].DKP + Lootster_Adjust[adjustId].DKP;

			-- add the adjustment to this guy
			Lootster_Attend[attendId].AdjustSet[adjustId] = adjustId;

			-- add adjust count
			table.setn(Lootster_Attend[attendId].AdjustSet, table.getn(Lootster_Attend[attendId].AdjustSet) + 1);
	    end
	end

	-- roll up accounting of adjustment into raid
	if (raidId ~= nil) then
	    -- new guy
	    Lootster_Raid[raidId].AdjustSet[adjustId] = player;

	    -- bump adjust count
	    table.setn(Lootster_Raid[raidId].AdjustSet, table.getn(Lootster_Raid[raidId].AdjustSet) + 1);

		-- add in DKP
		Lootster_Raid[raidId].DKP = Lootster_Raid[raidId].DKP + Lootster_Adjust[adjustId].DKP;
	end
	
	return true;
end

-- Subtract Adjustment handler
function Lootster_SubAdjust(adjustId)
	local	bossId, raidId, player, attendId;

	-- have we a adjustment?
	if (Lootster_Adjust[adjustId] == nil) then
	    -- no adjustment
	    return false;
	end
	
	-- retrieve the boss, if any
	bossId = Lootster_Adjust[adjustId].BossId;
	
	-- do we have a boss?
	if (bossId ~= nil) then
		-- get the raid Id
		raidId = Lootster_Boss[bossId].RaidId;
	else
		-- no raid
		raidId = nil;
	end
	
	-- retrieve the player
	player = Lootster_Adjust[adjustId].Player;
	
	-- we may not have a DKP entry for this guy if the main/alt relationship has changed since the
	-- adjustment
	if (Lootster_DKP[player] ~= nil) then
		-- update player's adjusted DKP
		Lootster_DKP[player].DKPAdj = Lootster_DKP[player].DKPAdj - Lootster_Adjust[adjustId].DKP;

		-- update player's DKP values
		Lootster_UpdateDKP(player);
	end
	
	-- unwind accounting of adjustment from boss
	if (bossId ~= nil) then
	    -- remove DKP from boss
	    Lootster_Boss[bossId].DKP = Lootster_Boss[bossId].DKP - Lootster_Adjust[adjustId].DKP;

		-- get the attendance id, if any
		attendId = Lootster_Boss[bossId].AttendSet[player];

	    -- remove DKP and adjustment from player, if attending
	    if (attendId ~= nil) then
	    	Lootster_Attend[attendId].DKP = Lootster_Attend[attendId].DKP - Lootster_Adjust[adjustId].DKP;

			-- remove the adjustment to this guy
			Lootster_Attend[attendId].AdjustSet[adjustId] = nil;

			-- wack adjust count
			table.setn(Lootster_Attend[attendId].AdjustSet, table.getn(Lootster_Attend[attendId].AdjustSet) - 1);
	    end
	end

	-- unwind accounting of attendance from raid
	if (raidId ~= nil) then
		-- remove DKP
		Lootster_Raid[raidId].DKP = Lootster_Raid[raidId].DKP - Lootster_Adjust[adjustId].DKP;

	    -- no longer in raid
		Lootster_Raid[raidId].AdjustSet[adjustId] = nil;

		-- wack adjust count
		table.setn(Lootster_Raid[raidId].AdjustSet, table.getn(Lootster_Raid[raidId].AdjustSet) - 1);
	end
	
	return true;
end

-- Retrieve Next Id handler
function Lootster_GetNextId(sortList, currId)
	local	count, ix, found, nextId;

	-- no next id found so far
	found = nil;

	-- no sort list we are done
	if (sortList == nil) then
		return nil;
	end

	-- get count of ids
	count = table.getn(sortList);

	-- don't bother if only one entry
	if (count < 2) then
		return nil;
	end

	-- search for the current id
	for ix=1, count do
		-- is this the one we are looking for?
		if (sortList[ix] == currId) then
			-- found!
			found = ix;
			break;
		end
	end

	-- how did we do?
	if (found == nil) then
		return nil;
	end

	-- retrieve the next id after this guy, if any
	if (found == count) then
		-- get previous entry
		nextId = sortList[found - 1];
	else
		-- get next entry
		nextId = sortList[found + 1];
	end

	return nextId;
end

-- Insert Master Looted Item handler
function Lootster_InsertMasterLoot(adjustId)
	local	raidId, itemId;

	-- no adjustment, or item link, or was master looted we are done
	if ((adjustId == nil) or (Lootster_Adjust[adjustId].Link == nil) or (Lootster_Adjust[adjustId].ML ~= true)) then
		return;
	end

	-- get the raid id
	raidId = Lootster_Boss[Lootster_Adjust[adjustId].BossId].RaidId;

	-- get the item id
	itemId = Lootster_GetItemDetails(Lootster_Adjust[adjustId].Link, true);

	-- do we have an existing raid?
	if (Lootster_MasterLooted[raidId] == nil) then
		-- create raid entry
		Lootster_MasterLooted[raidId] = {};

		-- bump raid count
		table.setn(Lootster_MasterLooted, table.getn(Lootster_MasterLooted) + 1);
	end

	-- do we have an existing item entry for raid?
	if (Lootster_MasterLooted[raidId][itemId] == nil) then
		-- create item entry in raid
		Lootster_MasterLooted[raidId][itemId] = {};

		-- bump item count
		table.setn(Lootster_MasterLooted[raidId], table.getn(Lootster_MasterLooted[raidId]) + 1);
	end

	-- add this adjustment to end of list
	table.insert(Lootster_MasterLooted[raidId][itemId], adjustId);
end

-- Remove Master Looted Item handler
function Lootster_RemoveMasterLoot(adjustId)
	local	raidId, itemId, adjCount, adjIx;

	-- no adjustment, or item link, or was master looted we are done
	if ((adjustId == nil) or (Lootster_Adjust[adjustId].Link == nil) or (Lootster_Adjust[adjustId].ML ~= true)) then
		return;
	end

	-- get the raid id
	raidId = Lootster_Boss[Lootster_Adjust[adjustId].BossId].RaidId;

	-- get the item id
	itemId = Lootster_GetItemDetails(Lootster_Adjust[adjustId].Link, true);

	-- do we have an existing raid?
	if (Lootster_MasterLooted[raidId] ~= nil) then
		-- do we have an existing item in raid
		if (Lootster_MasterLooted[raidId][itemId] ~= nil) then
			-- get count of adjustments for this item
			adjustCount = table.getn(Lootster_MasterLooted[raidId][itemId]);

			-- hammer through the adjustment list looking for this guy
			for adjustIx=1, adjustCount do
				-- this our man?
				if (Lootster_MasterLooted[raidId][itemId][adjustIx] == adjustId) then
					-- remove from table
					table.remove(Lootster_MasterLooted[raidId][itemId], adjustIx);

					-- no more adjustments for the item?
					if (table.getn(Lootster_MasterLooted[raidId][itemId]) == 0) then
						-- remove item entry for raid
						Lootster_MasterLooted[raidId][itemId] = nil;

						-- decrement item count
						table.setn(Lootster_MasterLooted[raidId], table.getn(Lootster_MasterLooted[raidId]) - 1);

						-- no more items for the raid?
						if (table.getn(Lootster_MasterLooted[raidId]) == 0) then
							-- remove raid entry
							Lootster_MasterLooted[raidId] = nil;

							-- decrement raid count
							table.setn(Lootster_MasterLooted, table.getn(Lootster_MasterLooted) - 1);
						end
					end
				end

				-- found and done
				break;
			end
		end
	end
end

-- Determine if Master Looted Item handler
function Lootster_IsMasterLoot(raidId, itemId)
	-- do we have a raid id and item id?
	if ((raidId == nil) or (itemId == nil)) then
		return;
	end

	-- do we have a raid and item list for the raid?
	return (Lootster_MasterLooted[raidId] ~= nil) and (Lootster_MasterLooted[raidId][itemId] ~= nil);
end

-- Get Master Looted Item handler
function Lootster_GetMasterLoot(raidId, itemId)
	-- do we have a raid id and item id?
	if ((raidId == nil) or (itemId == nil)) then
		return;
	end

	-- do we have a raid and item list for the raid?
	if ((Lootster_MasterLooted[raidId] ~= nil) and (Lootster_MasterLooted[raidId][itemId] ~= nil)) then
		-- return this adjustment id
		return Lootster_MasterLooted[raidId][itemId][1];
	else
		-- no adjustment
		return nil;
	end
end

-- Set Column Width handler
function Lootster_SetColWidth(width, frame)
	-- make sure we have a frame
	if (not frame) then
 		frame = this;
 	end

	-- force it's width
 	frame:SetWidth(width);

	-- and the text area
 	getglobal(frame:GetName().."Middle"):SetWidth(width - 9);
end

-- Set Hyperlink handler
function Lootster_SetHyperlink(link, slot)
	local	dkp, reason;

	-- process the item for class restrictions
	Lootster_ProcessRestrictions(link, slot);

	-- update the item prompt according to item count
	Lootster_UpdateItemPrompt();

	-- update the item text and comment for the roll and item frame
	if (Lootster_ItemLink ~= nil) then
		Lootster_RollFrameItemText:SetText(Lootster_ItemLink);
		Lootster_ItemFrameItemText:SetText(Lootster_ItemLink);
	else
		Lootster_RollFrameItemText:SetText("");
		Lootster_ItemFrameItemText:SetText("");
	end

	-- update the item text for the adjust DKP frame if visible
	if (Lootster_RaidFrameAdjustFrame:IsVisible()) then
		-- retrieve default DKP and reason text
		dkp, reason = Lootster_GetItemDKP(Lootster_ItemText)

		-- update the adjust record
		Lootster_AdjustRec.DKP = dkp;
		Lootster_AdjustRec.Link = Lootster_ItemLink;
		Lootster_AdjustRec.Reason = reason;

		-- set default DKP value and reason
		Lootster_RaidFrameAdjustFrameDKP:SetNumber(dkp);
		Lootster_RaidFrameAdjustFrameReason:SetText(reason);
		Lootster_RaidFrameAdjustFrameCommentText:SetText("");
	end
	
	-- update roll UI
	Lootster_UpdateRollUI();
end

-- Update Item Prompt using Item Count
function Lootster_UpdateItemPrompt()
	-- how many items we rolling on?
	if (Lootster_ItemCount <= 1) then
		-- item prompt is item text
		Lootster_ItemPrompt = Lootster_ItemLink;
	else
		-- create item prompt using item count
		if (Lootster_ItemLink == nil) then
			-- create an item prompt
			Lootster_ItemPrompt = string.format(LOOTSTER_ECHO_ITEMS, Lootster_ItemCount);
		else
			-- create item text item prompt
			Lootster_ItemPrompt = string.format(LOOTSTER_ECHO_ITEMS_LINK, Lootster_ItemCount, Lootster_ItemLink);
		end
	end
end

-- Has Raid Zone Changed handler
function Lootster_HasRaidZoneChanged()
	local	change, zone;
	
	-- not changed zone yet
	change = false;
	
	-- get the zone name (instance name if appropriate)
	zone = GetRealZoneText();

	-- this a known zone?
	if (Lootster_ZoneDKP[zone] ~= nil) then
		-- is this the currently running raid?
		if (Lootster_Running.RaidId ~= nil) then
			-- have we changed zones?
			change = Lootster_Raid[Lootster_Running.RaidId].Zone ~= zone;
		else
			-- a new zone
			change = true;
		end
	end
	
	return change, zone;
end

-- Has Raid Boss Changed handler
function Lootster_HasRaidBossChanged()
	local	boss, change, dead, newBoss;
	
	-- no boss and no boss change yet
	boss = nil;
	change = false;
	
	-- have we a target?
	if (UnitExists("target") == nil) then
		return false, nil;
	end
	
	-- grab the target name, and attempt to lookup
	boss = UnitName("target");

	-- is this an enemy target?
	if (UnitIsEnemy("target", "player") == nil) then
		return false, nil;
	end

	-- this a known boss?
	if (Lootster_MobsDKP[boss] == nil) then
		-- check for a world boss
		if (UnitClassification("target") ~= "worldboss") then
			-- if our current boss is toast and we have exited boss fight, we have moved on
			if ((Lootster_Running.BossId ~= nil) and (Lootster_Boss[Lootster_Running.BossId].Killed == true) and (Lootster_InBossFight == false)) then
				-- boss TDB
				return true, nil;
			else
				return false, nil;
			end
		end
		
		-- there are 'fake' world bosses out there that we don't want triggering changes - check
		if (LOOTSTER_WORLDBOSS_FAKE[boss] ~= nil) then
			-- fake world bosses are ignored
			return false, nil;
		end
	end

	-- is this the currently running boss?
	if (Lootster_Running.BossId ~= nil) then
		-- is this a new boss?
		if (boss ~= Lootster_Boss[Lootster_Running.BossId].Boss) then
			-- new boss, but make sure previous is dead or we have exited combat (and therefroe started another boss)
			if ((Lootster_Boss[Lootster_Running.BossId].Killed == true) or (Lootster_InBossFight == false)) then
				-- current boss is dead or we have exited combat, so we have started a new guy
				change = true;
			else
				-- effectively no boss
				return false, nil;
			end
		elseif	(UnitIsDead("target") ~= nil) then
			-- dead guy - return false and it he will be marked dead appropriately
			return false, boss;
		end
	else
		-- a new boss
		change = true;
	end
	
	return change, boss;
end

-- Take Attendance handler
function Lootster_TakeAttendance(bossId, attended)
	local	oldAttendee, alt, main, attendId, rosRec;
	
	-- we need a boss
	if (bossId == nil) then
		return;
	end
	
	-- reset old attendee list
	oldAttendee = {};
	
	-- accumulate old attendee list
	for main, attendId in pairs(Lootster_Boss[bossId].AttendSet) do
		-- add this old guy
		oldAttendee[main] = attendId;
	end
	
	-- accumulate new attendee list
	for alt, rosRec in pairs(Lootster_Roster) do
		-- determine the main for this possible alt
		main = Lootster_GetALTMain(alt);

		-- was this guy in the old attendee list?
		if (oldAttendee[main] ~= nil) then
			-- he is still here
			oldAttendee[main] = nil;
		else
			-- insert new guy into boss
			Lootster_InsertAttend(bossId, Lootster_CreateAttend(Lootster_NewAttend(main, alt, attended)));
		end
	end

	-- update each of the remaining old guys with the passed attendance
	for main, attendId in pairs(oldAttendee) do
		-- update current alt, if any
		Lootster_Attend[attendId].Alt = Lootster_GetMainALT(main);
		
		-- make sure we don't upgrade him
		if (Lootster_Attend[attendId].Attended < attended) then
			Lootster_Attend[attendId].Attended = attended;
		end
	end
	
	-- resort raid data using current sort
	Lootster_Raid_Raid_Sort(nil);
	
	-- resort boss data using current sort
	Lootster_Raid_Boss_Sort(nil);
	
	-- resort attend data using current sort
	Lootster_Raid_Attend_Sort(nil);
end

-- Add Restriction to Table handler
function Lootster_AddRestriction(type, list, restriction)
	-- how we add this to the table depends on the NBG type
	if		(type == LOOTSTER_NBG_NEED) then
		local	class;

		-- get the invariant form of the class name
		class = Lootster_ClassPlural[restriction];

		-- is this class unknown or is duplicate?
		if ((class == nil) or (list[class] ~= nil)) then
			return true;
		end

		-- class in plural form - add invariant key
		list[class] = true;

		-- we need to take care of the entry count ourselves
		table.setn(list, table.getn(list) + 1);
	elseif	(type == LOOTSTER_NBG_TIED) then
		-- player in FIFO form
		table.insert(list, restriction);
	end

	return false;
end

-- Synchronise Process handler
function Lootster_Sync_Process(player, msg, payload)
	-- process synchronisation command
	if		(msg == LOOTSTER_SYNC_CMD_SYNCITEM) then
		local	ver, recCount, restrictId;

		-- snarf version.  This is the version the receiver can process
		_, _, ver = string.find(payload, LOOTSTER_SYNC_IMP_SYNCITEM);

		-- validate
		if (ver == nil) then
			-- eep!  Unknown data format
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- convert version to a number
		ver = tonumber(ver);

		-- if this version is greater than ours, make sure we let them know its downgraded
		if (ver > LOOTSTER_SYNC_VERSION) then
			ver = LOOTSTER_SYNC_VERSION;
		end

		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- calculate record count
		recCount = 0;

		for itemId, itemRec in pairs(Lootster_Restrict) do
			recCount = recCount + 1;
		end

		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- begin transaction
		Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_BEGIN, ver, recCount), true);

		-- transmit all items
		for itemId, itemRec in pairs(Lootster_Restrict) do
			-- send this item data
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ITEM, itemId, Lootster_EncodeText(itemRec.Text), table.concat(itemRec.Classes, " ")), true);
		end

		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- commit transaction
		Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_COMMIT, ver), true);	
	elseif	(msg == LOOTSTER_SYNC_CMD_SYNCRAID) then
		local	ver, recCount, raidId, raidRec, raidIx, bossId, bossRec, attendId, attendRec, adjustId, adjustIx, adjustRec, itemSet, itemId, itemIx;
		local	WoWId, dateExp, dateEnd, isTBD, isCombat, isKilled, isML, link;

		-- snarf version.  This is the version the receiver can process
		_, _, ver = string.find(payload, LOOTSTER_SYNC_IMP_SYNCRAID);

		-- validate
		if (ver == nil) then
			-- eep!  Unknown data format
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- convert version to a number
		ver = tonumber(ver);

		-- if this version is greater than ours, make sure we let them know its downgraded
		if (ver > LOOTSTER_SYNC_VERSION) then
			ver = LOOTSTER_SYNC_VERSION;
		end

		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- raid record starts at two for the id and running records
		recCount = 2;

		-- add up raid records
		for raidId, raidRec in pairs(Lootster_Raid) do
			recCount = recCount + 1;
		end

		-- add up boss records
		for bossId, bossRec in pairs(Lootster_Boss) do
			recCount = recCount + 1;
		end

		-- add up attendance records
		for attendId, attendRec in pairs(Lootster_Attend) do
			recCount = recCount + 1;
		end

		-- add up adjustment records
		for adjustId, adjustRec in pairs(Lootster_Adjust) do
			-- transmit our records (not legacy adjustment Lootster records) and that are not total rows
			if ((type(adjustId) == "string") and (adjustRec.DKP ~= nil)) then
				recCount = recCount + 1;
			end
		end

		-- add up legacy adjustment records
		for adjustIx, adjustRec in ipairs(Lootster_Adjust) do
			-- transmit our records legacy adjustment and that are not total rows
			if (adjustRec.DKPAct ~= nil) then
				recCount = recCount + 1;
			end
		end

		-- add up master looted record count
		for raidId, itemSet in pairs(Lootster_MasterLooted) do
			-- accumlate item count in master looted raid table
			for itemId, adjustSet in pairs(itemSet) do
				-- add adjustment count
				recCount = recCount + table.getn(adjustSet);
			end
		end

		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- begin transaction
		Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_BEGIN, ver, recCount), true);

		-- transmit the id
		Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ID, Lootster_Id), true);

		-- transmit all raids
		for raidId, raidRec in pairs(Lootster_Raid) do
			-- do we have a WoWId?
			if (raidRec.WoWId == nil) then
				wowId = "";
			else
				wowId = raidRec.WoWId;
			end

			-- do we have a expiry date?
			if (raidRec.DateExp == nil) then
				dateExp = -1;
			else
				dateExp = raidRec.DateExp;
			end

			-- send this raid data
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_RAID, raidId, Lootster_EncodeText(raidRec.Zone), wowId, raidRec.DateOpn, dateExp, Lootster_EncodeText(raidRec.Comment)), true);
		end
	
		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- transmit all bosse
		for bossId, bossRec in pairs(Lootster_Boss) do
			-- do we have a finish date?
			if (bossRec.DateEnd == nil) then
				dateEnd = -1;
			else
				dateEnd = bossRec.DateEnd;
			end

			-- have we determined Boss name?
			if (bossRec.TBD == false) then
				isTBD = 0;
			else
				isTBD = 1;
			end

			-- have we engaged combat?
			if (bossRec.Combat == false) then
				isCombat = 0;
			else
				isCombat = 1;
			end

			-- have we killed boss?
			if (bossRec.Killed == false) then
				isKilled = 0;
			else
				isKilled = 1;
			end

			-- send this boss data
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_BOSS, bossId, bossRec.RaidId, Lootster_EncodeText(bossRec.Boss), bossRec.DateBeg, dateEnd, isTBD, isCombat, isKilled), true);
		end	
	
		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- transmit all attendances
		for attendId, attendRec in pairs(Lootster_Attend) do
			-- send this attendance data
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ATTEND, attendId, attendRec.BossId, attendRec.Player, attendRec.Alt, attendRec.Attended), true);
		end
	
		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- transmit all adjustments
		for adjustId, adjustRec in pairs(Lootster_Adjust) do
			-- only transmit our records (not old Lootster records) and not a total row
			if ((type(adjustId) == "string") and (adjustRec.DKP ~= nil)) then
				-- was this master looted?
				if (adjustRec.ML == false) then
					isML = 0;
				else
					isML = 1;
				end

				-- do we have an item link?
				if (adjustRec.Link ~= nil) then
					link = adjustRec.Link;
				else
					link = "";
				end

				-- send this adjustment data
				Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ADJUST, adjustId, adjustRec.BossId, adjustRec.Player, adjustRec.Alt, adjustRec.DateAdj, isML, adjustRec.DKP, Lootster_EncodeText(link), Lootster_EncodeText(adjustRec.Reason), Lootster_EncodeText(adjustRec.Comment)), true);
			end
		end

		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- transmit legacy adjustment records
		for adjustIx, adjustRec in ipairs(Lootster_Adjust) do
			-- transmit our records legacy adjustment and that are not total rows
			if (adjustRec.DKPAct ~= nil) then
				-- send this legacy adjustment data
				Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_LEGACY, adjustRec.Player, adjustRec.DKPAct, adjustRec.Epoch, Lootster_EncodeText(adjustRec.Reason), Lootster_EncodeText(adjustRec.Comment)), true);
			end
		end

		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- transmit master looted records
		for raidId, itemSet in pairs(Lootster_MasterLooted) do
			-- transmit items in master looted raid table
			for itemId, adjustSet in pairs(itemSet) do
				-- transmit adjustments in master looted raid item table
				for adjustIx, adjustId in ipairs(adjustSet) do
					-- send this master looted adjustment data
					Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_MASTER, adjustId), true);
				end
			end
		end

		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- do we have a running raid and boss?
		if (Lootster_Running.RaidId == nil) then
			raidId = "";
		else
			raidId = Lootster_Running.RaidId;
		end

		if (Lootster_Running.BossId == nil) then
			bossId = "";
		else
			bossId = Lootster_Running.BossId;
		end

		-- send the running data
		Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_RUNNING, raidId, bossId), true);

		-- send synchronous ack to keep other end alive
		Lootster_SendPrivate(player, LOOTSTER_SYNC_EXP_ACK, true, true);

		-- commit transaction
		Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_COMMIT, ver), true);
	elseif	(msg == LOOTSTER_SYNC_CMD_ABORT) then
		local	count, ix, msgRec;
		local	toWhisperQue;

		-- get queue count so we can process in reverse order
		if (Lootster_ToWhisperQue ~= nil) then
			count = table.getn(Lootster_ToWhisperQue);
		else
			count = 0;
		end

		-- hammer through message queue looking for messages for the player
		for ix=count, 1, -1 do
			-- is this record for our player?
			if (Lootster_ToWhisperQue[ix].To == player) then
				-- is this one of our outbound messages?
				if (string.find(Lootster_ToWhisperQue[ix].Msg, LOOTSTER_SYNC_IMP_PREFIX) ~= nil) then
					-- yup, so toast
					table.remove(Lootster_ToWhisperQue, ix);
				end
			end				
		end

		-- copy whisper items as we need to requeue them so their delivery time is recalculated
		toWhisperQue = Lootster_CopyRecord(Lootster_ToWhisperQue);

		-- smoke the whisper queue so its recreated from scratch
		Lootster_ToWhisperQue = nil;

		-- hammer through the whisper queue copy and reenqueue items
		for ix, msgRec in ipairs(toWhisperQue) do
			-- renqueue this guy
			Lootster_ToWhisper_Enqueue(msgRec.To, msgRec.Msg);
		end
	elseif	(Lootster_SyncType == nil) then
		-- eep!  No synchronise in progress - no message as it can spam
		return false;
	elseif	(Lootster_SyncUser ~= player) then
		-- eep!  Player is not our synchronise target - no message as it can spam
		return false;
	elseif	(msg == LOOTSTER_SYNC_CMD_ACK) then
		-- this is a keep alive message so that we reset the timeout counter
		Lootster_SyncAcks = Lootster_SyncAcks + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_BEGIN) then
		local	ver, recCount;

		-- parse the payload
		_, _, ver, recCount = string.find(payload, LOOTSTER_SYNC_IMP_BEGIN);

		-- validate
		if ((ver == nil) or (recCount == nil)) then
			-- eep!  Unknown data format
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- convert version to a number
		ver = tonumber(ver);

		-- if this version is greater than ours, make sure we let them know its downgraded
		if (ver > LOOTSTER_SYNC_VERSION) then
			-- eep!  We cannot handle record types of this version - bail
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADVERSION, Lootster_SyncTitle, player, ver, LOOTSTER_SYNC_VERSION), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		else			
			ver = LOOTSTER_SYNC_VERSION;
		end

		-- convert record count to a number
		recCount = tonumber(recCount);

		-- reset record counters
		Lootster_SyncCount = 0;
		Lootster_SyncTotal = recCount;

		-- reset synchronise data
		Lootster_SyncData = {};

		-- setup this sync type
		Lootster_SyncData[Lootster_SyncType] = {};
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_COMMIT) then
		-- validate hash totals
		if (Lootster_SyncCount ~= Lootster_SyncTotal) then
			-- bad hash total
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADHASHTOTAL, Lootster_SyncTitle, Lootster_SyncCount, Lootster_SyncTotal), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- normal operation
		Lootster_Sync_StateUpdate();

		-- commit the data
		if		(Lootster_SyncType == LOOTSTER_SYNC_CMD_SYNCITEM) then
			local	update, itemId, itemRec;

			-- retrieve the update flag
			update = (Lootster_ItemSyncFrameOverwrite:GetChecked() ~= nil);

			-- do we have any items?
			if (Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_ITEM] ~= nil) then
				-- smoosh in each item
				for itemId, itemRec in pairs(Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_ITEM]) do
					-- unknown guy or we ar supposed to update?
					if ((Lootster_Restrict[itemId] == nil) or (update == true)) then
						-- hammer it in
						Lootster_Restrict[itemId] = itemRec;
					end
				end
			end

			-- resnarf any existing hyperlink
			Lootster_SetHyperlink(Lootster_ItemLink);

			-- resort item data using current sort
			Lootster_Item_Sort(nil);

			-- let ourselves know
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCHRONISEDITEM, player, Lootster_SyncTotal), true);
		elseif	(Lootster_SyncType == LOOTSTER_SYNC_CMD_SYNCRAID) then
			local	raidId, raidRec, bossId, bossRec, attendId, attendRec, adjustId, adjustRec, adjustIx;

			-- delete all raids
			Lootster_DeleteAllRaid();

			-- reset the current raid id
			Lootster_RaidId = nil;

			-- reset the current boss Id
			Lootster_BossId = nil;

			-- reset the current attend Id
			Lootster_AttendId = nil;

			-- reset the current adjust Id
			Lootster_AdjustId = nil;

			-- reset running raid
			Lootster_Running.RaidId = nil;

			-- reset running boss
			Lootster_Running.BossId = nil;

			-- set id data
			Lootster_Id = Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_ID];

			-- do we have any raids?
			if (Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_RAID] ~= nil) then
				-- add all raids
				for raidId, raidRec in pairs(Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_RAID]) do
					-- create raid
					Lootster_CreateRaid(raidRec, raidId);
				end

				-- do we have any bosses?
				if (Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_BOSS] ~= nil) then
					-- add all bosses
					for bossId, bossRec in pairs(Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_BOSS]) do
						-- create and insert boss
						Lootster_InsertBoss(bossRec.RaidId, Lootster_CreateBoss(bossRec, bossId));
					end

					-- do we have any attendances?
					if (Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_ATTEND] ~= nil) then
						-- add all attendances
						for attendId, attendRec in pairs(Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_ATTEND]) do
							-- create and insert attendance
							Lootster_InsertAttend(attendRec.BossId, Lootster_CreateAttend(attendRec, attendId));
						end
					end

					-- do we have any adjustments?
					if (Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_ADJUST] ~= nil) then
						-- add all adjustments
						for adjustId, adjustRec in pairs(Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_ADJUST]) do
							-- create and insert adjustment
							Lootster_InsertAdjust(adjustRec.BossId, Lootster_CreateAdjust(adjustRec, adjustId));
						end
					end
				end
			end

			-- do we have any legacy adjustments?
			if (Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_LEGACY] ~= nil) then
				-- add all legacy adjustments
				for adjustIx, adjustRec in pairs(Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_LEGACY]) do
					-- insert legacy adjustment
					table.insert(Lootster_Adjust, adjustRec);
				end
			end

			-- do we have any master looted adjustments?
			if (Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_MASTER] ~= nil) then
				-- add all master looted adjustments
				for adjustIx, adjustId in ipairs(Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_MASTER]) do
					-- insert master looted adjustment
					Lootster_InsertMasterLoot(adjustId);
				end
			end

			-- set running data
			Lootster_Running = Lootster_SyncData[Lootster_SyncType][LOOTSTER_SYNC_CMD_RUNNING];

			-- resort DKP data using current sort
			Lootster_Data_DKP_Sort(nil);

			-- resort player data using current sort
			Lootster_Data_Player_Sort(nil);

			-- resort raid data using current sort
			Lootster_Raid_Raid_Sort(nil);

			-- resort boss data using current sort
			Lootster_Raid_Boss_Sort(nil);

			-- resort attendance data using current sort
			Lootster_Raid_Attend_Sort(nil);

			-- resort adjust data using current sort
			Lootster_Raid_Adjust_Sort(nil);

			-- could our DKP change?
			if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
				-- update our roll text
				Lootster_UpdateRoll();
			end

			-- update the raid UI
			Lootster_UpdateRaidUI();

			-- let them know
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_SYNCHRONISEDRAID, player, Lootster_SyncTotal));
		end

		-- successful operation
		Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_SUCCESS);
	elseif	(msg == LOOTSTER_SYNC_CMD_ITEM) then
		local	id, text, classes, class;

		-- parse the payload
		_, _, id, text, classes = string.find(payload, LOOTSTER_SYNC_IMP_ITEM);

		-- validate
		if ((id == nil) or (text == nil) or (classes == nil)) then
			-- eep!  Unknown data format - abort
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- do we have a raid table yet?
		if (Lootster_SyncData[Lootster_SyncType][msg] == nil) then
			Lootster_SyncData[Lootster_SyncType][msg] = {};
		end

		-- create item record
		Lootster_SyncData[Lootster_SyncType][msg][id] = Lootster_NewRestrict(Lootster_DecodeText(text), {});

		-- update the classes
		for class in string.gfind(classes, LOOTSTER_CLASS_PATTERN) do
			-- add this one
			table.insert(Lootster_SyncData[Lootster_SyncType][msg][id].Classes, class);
		end

		-- bump record count
		Lootster_SyncCount = Lootster_SyncCount + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_ID) then
		local	id;

		-- parse the payload
		_, _, id = string.find(payload, LOOTSTER_SYNC_IMP_ID);

		-- validate
		if (id == nil) then
			-- eep!  Unknown data format - abort
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- convert id to a number
		id = tonumber(id);

		-- create id record
		Lootster_SyncData[Lootster_SyncType][msg] = id;

		-- bump record count
		Lootster_SyncCount = Lootster_SyncCount + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_RAID) then
		local	id, zone, wowId, dateOpn, dateExp, comment;

		-- parse the payload
		_, _, id, zone, wowId, dateOpn, dateExp, comment = string.find(payload, LOOTSTER_SYNC_IMP_RAID);

		-- validate
		if ((id == nil) or (zone == nil) or (wowId == nil) or (dateOpn == nil) or (dateExp == nil) or (comment == nil)) then
			-- eep!  Unknown data format - abort
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- translate WoW id
		if (wowId == "") then
			wowId = nil;
		end

		-- convert open date to a number
		dateOpn = tonumber(dateOpn);

		-- convert expiry date to a number
		dateExp = tonumber(dateExp);

		-- translate expiry date
		if (dateExp == -1) then
			dateExp = nil;
		end

		-- do we have a raid table yet?
		if (Lootster_SyncData[Lootster_SyncType][msg] == nil) then
			Lootster_SyncData[Lootster_SyncType][msg] = {};
		end

		-- create raid record
		Lootster_SyncData[Lootster_SyncType][msg][id] = Lootster_NewRaid(Lootster_DecodeText(zone), wowId, dateOpn, dateExp);

		-- update id and comment
		Lootster_SyncData[Lootster_SyncType][msg][id].Id = id;
		Lootster_SyncData[Lootster_SyncType][msg][id].Comment = Lootster_DecodeText(comment);		

		-- bump record count
		Lootster_SyncCount = Lootster_SyncCount + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_BOSS) then
		local	id, raidId, boss, dateBeg, dateEnd, isTBD, isCombat, isKilled;

		-- parse the payload
		_, _, id, raidId, boss, dateBeg, dateEnd, isTBD, isCombat, isKilled = string.find(payload, LOOTSTER_SYNC_IMP_BOSS);

		-- validate
		if ((id == nil) or (raidId == nil) or (boss == nil) or (dateBeg == nil) or (dateEnd == nil) or (isTBD == nil) or (isCombat == nil) or (isKilled == nil)) then
			-- eep!  Unknown data format - abort
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- convert begin date to a number
		dateBeg = tonumber(dateBeg);

		-- convert end date to a number
		dateEnd = tonumber(dateEnd);

		-- translate end date
		if (dateEnd == -1) then
			dateEnd = nil;
		end

		-- convert TBD, combat and killed flags to a number
		isTBD = tonumber(isTBD);
		isCombat = tonumber(isCombat);
		isKilled = tonumber(isKilled);

		-- do we have a boss table yet?
		if (Lootster_SyncData[Lootster_SyncType][msg] == nil) then
			Lootster_SyncData[Lootster_SyncType][msg] = {};
		end

		-- create boss record
		Lootster_SyncData[Lootster_SyncType][msg][id] = Lootster_NewBoss(Lootster_DecodeText(boss), dateBeg);

		-- update id, raid id, end date and combat
		Lootster_SyncData[Lootster_SyncType][msg][id].Id = id;
		Lootster_SyncData[Lootster_SyncType][msg][id].RaidId = raidId;
		Lootster_SyncData[Lootster_SyncType][msg][id].DateEnd = dateEnd;
		Lootster_SyncData[Lootster_SyncType][msg][id].TBD = (isTBD ~= 0);		
		Lootster_SyncData[Lootster_SyncType][msg][id].Combat = (isCombat ~= 0);		
		Lootster_SyncData[Lootster_SyncType][msg][id].Killed = (isKilled ~= 0);		

		-- bump record count
		Lootster_SyncCount = Lootster_SyncCount + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_ATTEND) then
		local	id, bossId, main, alt, attended;

		-- parse the payload
		_, _, id, bossId, main, alt, attended = string.find(payload, LOOTSTER_SYNC_IMP_ATTEND);

		-- validate
		if ((id == nil) or (bossId == nil) or (main == nil) or (attended == nil)) then
			-- eep!  Unknown data format - abort
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- convert attended to a number
		attended = tonumber(attended);

		-- do we have a attendance table yet?
		if (Lootster_SyncData[Lootster_SyncType][msg] == nil) then
			Lootster_SyncData[Lootster_SyncType][msg] = {};
		end

		-- create attendance record
		Lootster_SyncData[Lootster_SyncType][msg][id] = Lootster_NewAttend(main, alt, attended);

		-- update id and boss id
		Lootster_SyncData[Lootster_SyncType][msg][id].Id = id;
		Lootster_SyncData[Lootster_SyncType][msg][id].BossId = bossId;

		-- bump record count
		Lootster_SyncCount = Lootster_SyncCount + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_ADJUST) then
		local	id, bossId, main, dateAdj, isML, dkp, link, reason, comment;

		-- parse the payload
		_, _, id, bossId, main, alt, dateAdj, isML, dkp, link, reason, comment = string.find(payload, LOOTSTER_SYNC_IMP_ADJUST);

		-- validate
		if ((id == nil) or (bossId == nil) or (main == nil) or (alt == nil) or (dateAdj == nil) or (isML == nil) or (dkp == nil) or (link == nil) or (reason == nil) or (comment == nil)) then
			-- eep!  Unknown data format - abort
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- convert date adjustment to a number
		dateAdj = tonumber(dateAdj);

		-- convert is ML flag to a number
		isML = tonumber(isML);

		-- convert dkp to a number
		dkp = tonumber(dkp);

		-- convert link
		if (link == "") then
			link = nil;
		end

		-- do we have a adjustment table yet?
		if (Lootster_SyncData[Lootster_SyncType][msg] == nil) then
			Lootster_SyncData[Lootster_SyncType][msg] = {};
		end

		-- create adjustment record
		Lootster_SyncData[Lootster_SyncType][msg][id] = Lootster_NewAdjust(main, alt, dateAdj, dkp, Lootster_DecodeText(link), Lootster_DecodeText(reason), Lootster_DecodeText(comment));

		-- update id, boss id and master looted flag
		Lootster_SyncData[Lootster_SyncType][msg][id].Id = id;
		Lootster_SyncData[Lootster_SyncType][msg][id].BossId = bossId;
		Lootster_SyncData[Lootster_SyncType][msg][id].ML = (isML ~= 0);

		-- bump record count
		Lootster_SyncCount = Lootster_SyncCount + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_LEGACY) then
		local	main, dkp, epoch, reason, comment;

		-- parse the payload
		_, _, main, dkp, epoch, reason, comment = string.find(payload, LOOTSTER_SYNC_IMP_LEGACY);

		-- validate
		if ((main == nil) or (dkp == nil) or (epoch == nil) or (reason == nil) or (comment == nil)) then
			-- eep!  Unknown data format - abort
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- convert dkp to a number
		dkp = tonumber(dkp);

		-- convert epoch adjustment to a number
		epoch = tonumber(epoch);

		-- do we have a legacy adjustment table yet?
		if (Lootster_SyncData[Lootster_SyncType][msg] == nil) then
			Lootster_SyncData[Lootster_SyncType][msg] = {};
		end

		-- create legacy adjustment record
		Lootster_SyncData[Lootster_SyncType][msg][id] = Lootster_NewLegacy(main, dkp, epoch, Lootster_DecodeText(reason), Lootster_DecodeText(comment));

		-- bump record count
		Lootster_SyncCount = Lootster_SyncCount + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_MASTER) then
		local	adjustId;

		-- parse the payload
		_, _, adjustId = string.find(payload, LOOTSTER_SYNC_IMP_MASTER);

		-- validate
		if (adjustId == nil) then
			-- eep!  Unknown data format - abort
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_SYNCBADRECORD, Lootster_SyncTitle, msg, payload), true);

			-- abort synchronise
			Lootster_SendPrivate(player, string.format(LOOTSTER_SYNC_EXP_ABORT), true, true);

			-- failed operation
			Lootster_Sync_StateUpdate(LOOTSTER_SYNC_STATE_FAILED);
			return false;
		end

		-- do we have a master loot table yet?
		if (Lootster_SyncData[Lootster_SyncType][msg] == nil) then
			Lootster_SyncData[Lootster_SyncType][msg] = {};
		end

		-- create master loot adjustment record
		table.insert(Lootster_SyncData[Lootster_SyncType][msg][id], adjustId);

		-- bump record count
		Lootster_SyncCount = Lootster_SyncCount + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	elseif	(msg == LOOTSTER_SYNC_CMD_RUNNING) then
		local	raidId, bossId;

		-- parse the payload
		_, _, raidId, bossId = string.find(payload, LOOTSTER_SYNC_IMP_RUNNING);

		-- translate special data
		if (raidId == "") then
			raidId = nil;
		end

		-- translate special data
		if (bossId == "") then
			bossId = nil;
		end

		-- create running record
		Lootster_SyncData[Lootster_SyncType][msg] = { RaidId=raidId, BossId=bossId };

		-- bump record count
		Lootster_SyncCount = Lootster_SyncCount + 1;
		
		-- normal operation
		Lootster_Sync_StateUpdate();
	else
		-- unknown sync - ignore
		return false;
	end
	
	return true;
end

-- Synchronise State Update handler
function Lootster_Sync_StateUpdate(terminal)
	-- update synchronise UIs
	if		(Lootster_SyncType == LOOTSTER_SYNC_CMD_SYNCITEM) then
		-- update the item sychronise UI
		Lootster_ItemSyncUpdateUI(terminal);
	elseif	(Lootster_SyncType == LOOTSTER_SYNC_CMD_SYNCRAID) then
		-- update the raid sychronise UI
		Lootster_RaidSyncUpdateUI(terminal);
	end
	
	-- do we have a terminal state?
	if (terminal ~= nil) then		
		-- wack sync user, type and data
		Lootster_SyncUser = nil;
		Lootster_SyncType = nil;
		Lootster_SyncData = {};
		Lootster_SyncAcks = 0;
		Lootster_SyncTitle = "";
		Lootster_SyncCount = 0;
		Lootster_SyncTotal = 0;

		-- reset timeout
		Lootster_Timer.NextSyncTimeoutTime = 0;
	else
		-- not terminal, so maintain timeouts
		Lootster_Timer.LastSyncTimeoutTime = time();	
		Lootster_Timer.NextSyncTimeoutTime = Lootster_Timer.LastSyncTimeoutTime + LOOTSTER_SYNC_TIMEOUT;	
	end		
end

-- Write Full Report handler
function Lootster_WriteReportFull()
	local	txtSumm = "";
	local	txtRaid = "";
	local	raidSort, raidId, raidRec, raidIx;
	local	adjusts = 0;
	local	totalDKP = 0;
	
	-- produce the full summary
	txtSumm = txtSumm..string.format(LOOTSTER_REPORT_SUMMARY);
	txtSumm = txtSumm..string.format(LOOTSTER_REPORT_RAIDS, table.getn(Lootster_RaidSort));
	txtSumm = txtSumm..string.format(LOOTSTER_REPORT_BOSSES, table.getn(Lootster_BossSort));
	
	-- sort the raid data
	raidSort = Lootster_RaidReport_Raid_Sort();
		
	-- dump every raid and gather count of adjustments and total DKP
	for raidIx, raidId in ipairs(raidSort) do
		-- break
		txtRaid = txtRaid..LOOTSTER_REPORT_BREAK;

		-- get the raid report for this guy
		txtRaid = txtRaid..Lootster_WriteReportRaid(raidId);

		-- add in adjustments
		adjusts = adjusts + table.getn(Lootster_Raid[raidId].AdjustSet);

		-- add in DKP
		totalDKP = totalDKP + Lootster_Raid[raidId].DKP;
	end

	txtSumm = txtSumm..string.format(LOOTSTER_REPORT_ADJUSTS, adjusts);

	-- dump DKP in DKP roll mode only
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		txtSumm = txtSumm..string.format(LOOTSTER_REPORT_TOTALDKP, totalDKP);
	end

	-- smoosh report
	return txtSumm..txtRaid;
end

-- Write Raid Report handler
function Lootster_WriteReportRaid(raidId)
	local	txtRaid = "";
	local	txtBoss = "";
	local	bossSort, bossId, bossRec, bossIx;
	
	-- a specfic raid?
	if (raidId == nil) then
		-- no raid selected we are done
		if (Lootster_RaidId == nil) then
			return txtRaid;
		end

		-- use current raid
		raidId = Lootster_RaidId;
	end
	
	-- format raid summary
	txtRaid = txtRaid..Lootster_FormatReportRaid(Lootster_Raid[raidId]);
	
	-- are we reporting consolidated bosses and we have some?
	if ((Lootster_Options.RepConsolidate == true) and (table.getn(Lootster_Raid[raidId].BossSet) > 0)) then	
		-- break
		txtBoss = txtBoss..LOOTSTER_REPORT_BREAK;
	
		-- dump all bosses as one
		txtBoss = txtBoss..Lootster_WriteReportConsolidateBoss(raidId);
	else
		-- sort the boss data
		bossSort = Lootster_RaidReport_Boss_Sort(raidId);
		
		-- dump every boss
		for bossIx, bossId in ipairs(bossSort) do
			-- break
			txtBoss = txtBoss..LOOTSTER_REPORT_BREAK;
	
			-- get the boss report for this guy
			txtBoss = txtBoss..Lootster_WriteReportBoss(bossId);
		end
	end

	-- smoosh report
	return txtRaid..txtBoss;	
end

-- Write Boss Report handler
function Lootster_WriteReportBoss(bossId)
	local	txtBoss = "";
	local	txtAttend = "";
	local	txtAdjust = "";
	local	attendSort, attendId, attendIx;
	local	adjustSort, adjustId, adjustRec, adjustIx;
	
	-- a specfic boss?
	if (bossId == nil) then
		-- no boss selected we are done
		if (Lootster_BossId == nil) then
			return txtBoss;
		end

		-- use current boss
		bossId = Lootster_BossId;
	end
	
	-- produce boss summary
	txtBoss = txtBoss..Lootster_FormatReportBoss(Lootster_Boss[bossId]);
	
	-- are we reporting attendance?
	if (Lootster_Options.RepAttend == true) then
		-- sort the attendance data
		attendSort = Lootster_RaidReport_Attend_Sort(bossId);
				
		-- dump every attendance
		txtAttend = txtAttend..LOOTSTER_REPORT_BREAK;
		txtAttend = txtAttend..string.format(LOOTSTER_REPORT_ATTEND);
		
		for attendIx, attendId in ipairs(attendSort) do
			-- get the attendance report for this guy
			txtAttend = txtAttend..Lootster_FormatReportAttend(Lootster_Attend[attendId]);
		end
	end

	-- are we reporting adjustment?
	if (Lootster_Options.RepAdjust == true) then	
		-- sort the adjustment data
		adjustSort = Lootster_RaidReport_Adjust_Sort(bossId);
						
		-- dump every adjustment
		txtAdjust = txtAdjust..LOOTSTER_REPORT_BREAK;
		txtAdjust = txtAdjust..string.format(LOOTSTER_REPORT_ADJUST);
	
		for adjustIx, adjustId in ipairs(adjustSort) do
			-- get the adjustment report for this guy
			txtAdjust = txtAdjust..Lootster_FormatReportAdjust(Lootster_Adjust[adjustId]);
		end
	end
	
	-- smoosh report
	return txtBoss..txtAttend..txtAdjust;
end

-- Write Consolidated Boss Report handler
function Lootster_WriteReportConsolidateBoss(raidId)
	local	txtBoss = "";
	local	txtAttend = "";
	local	txtAdjust = "";
	local	dateBeg = nil;
	local	dateEnd = nil;
	local	bigBossRec, bossSort, bossId, bossRec, bossIx;
	local	attendTempSort, attendConsSort, player, attendIx, attendId, attendRec;
	local	adjustConsSort, adjustIx, adjustId, adjustRec;
	
	-- we raidId a raid and it's got bosses?
	if ((raidId == nil) or (table.getn(Lootster_Raid[raidId].BossSet) == 0)) then
		-- no raid or bosses so we are done
		return txtBoss;
	end

	-- sort the adjustment data
	bossSort = Lootster_RaidReport_Boss_Sort(raidId);

	-- determine lowest begin date and highest finish date
	for bossIx, bossId in ipairs(bossSort) do
		-- do we have a begin date yet or this is lower than current?
		if ((dateBeg == nil) or (Lootster_Boss[bossSort[bossIx]].DateBeg < dateBeg)) then
			dateBeg = Lootster_Boss[bossSort[bossIx]].DateBeg;
		end
	
		-- do we have a finish date yet or this is higher than current?
		if ((Lootster_Boss[bossSort[bossIx]].DateEnd ~= nil) and ((dateEnd == nil) or (Lootster_Boss[bossSort[bossIx]].DateEnd > dateEnd))) then
			dateEnd = Lootster_Boss[bossSort[bossIx]].DateEnd;
		end
	end
	
	-- create a boss record as the master for the raid
	bigBossRec = Lootster_NewBoss(Lootster_Raid[raidId].Zone, Lootster_CalcServerTime(dateBeg));

	-- use last boss's end time
	bigBossRec.DateEnd = dateEnd;

	-- reset consolidated attendance set and count
	attendConsSort = {};

	-- get temporary consolidated attendances for the raid
	attendTempSort = Lootster_RaidReport_ConsolidateAttend_Sort(bossSort);

	-- smoosh all attendances together into the consolidated set
	for attendIx, attendId in ipairs(attendTempSort) do
		-- get this player
		player = Lootster_Attend[attendId].Player;

		-- is this player already in attendance?
		if		(bigBossRec.AttendSet[player] == nil) then
			-- transfer
			bigBossRec.AttendSet[player] = Lootster_CopyRecord(Lootster_Attend[attendId]);
			
			-- and bookkeep in order
			table.insert(attendConsSort, player);
		elseif	(bigBossRec.AttendSet[player].Attended ~= Lootster_Attend[attendId].Attended) then
			-- no matter which way you cut it they are partial now
			bigBossRec.AttendSet[player].Attended = LOOTSTER_ENUM_ATTENDED.PARTIAL;
		end			
	end

	-- spoof count of attendances
	table.setn(bigBossRec.AttendSet, table.getn(attendConsSort));
	
	-- get consolidated adjustments for the raid
	adjustConsSort = Lootster_RaidReport_ConsolidateAdjust_Sort(bossSort);

	-- spoof count of adjustments
	table.setn(bigBossRec.AdjustSet, table.getn(adjustConsSort));

	-- accumulate total DKP
	for bossIx, bossId in ipairs(bossSort) do
		bigBossRec.DKP = bigBossRec.DKP + Lootster_Boss[bossSort[bossIx]].DKP;
	end

	-- produce boss summary
	txtBoss = txtBoss..Lootster_FormatReportBoss(bigBossRec);

	-- are we reporting attendances?
	if (Lootster_Options.RepAttend == true) then
		-- dump every attendance
		txtAttend = txtAttend..LOOTSTER_REPORT_BREAK;
		txtAttend = txtAttend..string.format(LOOTSTER_REPORT_ATTEND);
		
		for attendIx, player in ipairs(attendConsSort) do
			-- get the attendance report for this guy
			txtAttend = txtAttend..Lootster_FormatReportAttend(bigBossRec.AttendSet[player]);
		end
	end

	-- are we reporting adjustment?
	if (Lootster_Options.RepAdjust == true) then	
		-- dump every adjustment
		txtAdjust = txtAdjust..LOOTSTER_REPORT_BREAK;
		txtAdjust = txtAdjust..string.format(LOOTSTER_REPORT_ADJUST);
	
		for adjustIx, adjustId in ipairs(adjustConsSort) do
			-- get the adjustment report for this guy
			txtAdjust = txtAdjust..Lootster_FormatReportAdjust(Lootster_Adjust[adjustId]);
		end
	end
	
	-- smoosh report
	return txtBoss..txtAttend..txtAdjust;
end

-- Format Raid Report handler
function Lootster_FormatReportRaid(raidRec)
	local	txtRaid = "";
	local	txtBoss = "";
	local	wowId, dateExp;
	
	-- a raid record?
	if (raidRec == nil) then
		-- no raid record so we are done
		return txtRaid;
	end
	
	-- get the WowId, if any
	if (raidRec.WoWId ~= nil) then
		wowId = raidRec.WoWId;
	else
		wowId = LOOTSTER_RAIDRAID_NOWOWID;
	end
	
	-- get the expiry time, if any
	if (raidRec.DateExp ~= nil) then
        dateExp = Lootster_FormatServerTime(raidRec.DateExp);
	else
		dateExp = LOOTSTER_RAIDRAID_NODATEEXP;
	end
	
	-- produce raid summary
	txtRaid = txtRaid..string.format(LOOTSTER_REPORT_RAID, raidRec.Zone);
	txtRaid = txtRaid..string.format(LOOTSTER_REPORT_DATEOPN, Lootster_FormatServerTime(raidRec.DateOpn));
	txtRaid = txtRaid..string.format(LOOTSTER_REPORT_DATEEXP, dateExp, wowId);
	txtRaid = txtRaid..string.format(LOOTSTER_REPORT_BOSSES, table.getn(raidRec.BossSet));
	txtRaid = txtRaid..string.format(LOOTSTER_REPORT_ATTENDS, table.getn(raidRec.AttendSet));
	txtRaid = txtRaid..string.format(LOOTSTER_REPORT_ADJUSTS, table.getn(raidRec.AdjustSet));

	-- dump DKP in DKP roll mode only
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		txtRaid = txtRaid..string.format(LOOTSTER_REPORT_TOTALDKP, raidRec.DKP);
	end

	txtRaid = txtRaid..string.format(LOOTSTER_REPORT_COMMENT, Lootster_RemoveTrailingLineBreak(raidRec.Comment));
	
	-- return raid report
	return txtRaid..txtBoss;	
end

-- Format Boss Report handler
function Lootster_FormatReportBoss(bossRec)
	local	txtBoss = "";
	local	dateEnd;
	
	-- a boss record?
	if (bossRec == nil) then
		-- no boss record so we are done
		return txtBoss;
	end
	
	-- get the end time, if any
	if (bossRec.DateEnd ~= nil) then
        dateEnd = Lootster_FormatServerTime(bossRec.DateEnd);
	else
		dateEnd = LOOTSTER_RAIDBOSS_NODATEEND;
	end
	
	-- produce boss summary
	txtBoss = txtBoss..string.format(LOOTSTER_REPORT_BOSS, bossRec.Boss);
	txtBoss = txtBoss..string.format(LOOTSTER_REPORT_DATEBEG, Lootster_FormatServerTime(bossRec.DateBeg));
	txtBoss = txtBoss..string.format(LOOTSTER_REPORT_DATEEND, dateEnd);
	txtBoss = txtBoss..string.format(LOOTSTER_REPORT_ATTENDS, table.getn(bossRec.AttendSet));
	txtBoss = txtBoss..string.format(LOOTSTER_REPORT_ADJUSTS, table.getn(bossRec.AdjustSet));

	-- dump DKP in DKP roll mode only
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		txtBoss = txtBoss..string.format(LOOTSTER_REPORT_TOTALDKP, bossRec.DKP);
	end

	-- return boss report
	return txtBoss;
end

-- Format Attendance Report handler
function Lootster_FormatReportAttend(attendRec)
	local	txtAttend = "";
	
	-- an attendance record?
	if (attendRec == nil) then
		-- no attendance record so we are done
		return txtAttend;
	end
	
	-- produce attendance record.  Dump DKP in DKP roll mode only
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		-- showing attendance details?
		if (Lootster_Options.RepAttendDetail == true) then
			txtAttend = txtAttend..string.format(LOOTSTER_REPORT_ATTENDANCEDKPDETAIL, attendRec.Player, attendRec.Alt, LOOTSTER_DATA_ATTENDEDLIST[attendRec.Attended], attendRec.DKP);
		else
			txtAttend = txtAttend..string.format(LOOTSTER_REPORT_ATTENDANCEDKPSIMPLE, attendRec.Player);
		end
	else
		-- showing attendance details?
		if (Lootster_Options.RepAttendDetail == true) then
			txtAttend = txtAttend..string.format(LOOTSTER_REPORT_ATTENDANCENODKPDETAIL, attendRec.Player, attendRec.Alt, LOOTSTER_DATA_ATTENDEDLIST[attendRec.Attended]);
		else
			txtAttend = txtAttend..string.format(LOOTSTER_REPORT_ATTENDANCENODKPSIMPLE, attendRec.Player);
		end
	end

	return txtAttend;
end

-- Format Adjustment Report handler
function Lootster_FormatReportAdjust(adjustRec)
	local	txtAdjust = "";
	local	itemId;
	
	-- an adjustment record?
	if (adjustRec == nil) then
		-- no adjustment record so we are done
		return txtAttend;
	end

	-- do we have a link?
	if (adjustRec.Link ~= nil) then
		-- get the item id
		itemId = Lootster_GetItemDetails(adjustRec.Link, true);
	else
		itemId = "";
	end

	-- produce adjustment record.  Dump DKP in DKP roll mode only
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_ROLLMODE.USEDKP) then
		txtAdjust = txtAdjust..string.format(LOOTSTER_REPORT_ADJUSTMENTDKP, adjustRec.Player, adjustRec.Alt, Lootster_FormatServerTime(adjustRec.DateAdj), adjustRec.DKP, itemId, adjustRec.Reason, Lootster_RemoveTrailingLineBreak(adjustRec.Comment));
	else
		txtAdjust = txtAdjust..string.format(LOOTSTER_REPORT_ADJUSTMENTNODKP, adjustRec.Player, adjustRec.Alt, Lootster_FormatServerTime(adjustRec.DateAdj), itemId, adjustRec.Reason, Lootster_RemoveTrailingLineBreak(adjustRec.Comment));
	end

	return txtAdjust;
end

-- Lootster Popup handler
function Lootster_Popup_Show(frame)
	local	ix, name, dialog, OnCancel;
	
	-- if we don't have a frame we are just closing our dialogs
	if (frame == nil) then
		-- go through all static dialogs, closing exclusive ones
		for ix=1, STATICPOPUP_NUMDIALOGS do
			-- get this static dialog
			dialog = getglobal("StaticPopup"..ix);
			
			-- if this guy is exclusive and shown, hide him
			if ((dialog:IsShown() == true) and StaticPopupDialogs[dialog.which].exclusive) then
				-- hide this guy
				dialog:Hide();
				
				-- get the cancel function, if any
				OnCancel = StaticPopupDialogs[dialog.which].OnCancel;
				
				-- cancel function?
				if (OnCancel ~= nil) then
					-- spoof cancel
					OnCancel(dialog.data, "override");
				end
				
				-- done
				break;
			end
		end
	end

	-- hammer through list of dialogs making sure all are closed except passed guy
	for ix, name in ipairs(LOOTSTER_POPUP_FRAME) do
		-- get the dialog
		dialog = getglobal(name);

		-- and hide it regardless if its the one we want 
		dialog:Hide();
	end

	-- if we have a frame show it
	if (frame ~= nil) then
		frame:Show();
	end
end

-- Lootster Static Popup Show handler
function Lootster_StaticPopup_Show(which)
	-- this is our own handler that allows us to close down our own dialogs before
	-- showing the static popup dialog
	Lootster_Popup_Show();

	-- and show static dialog
	return StaticPopup_Show(which);
end

-- Copy Record handler
function Lootster_CopyRecord(srcRec)
	local	desRec = {};
	local	key, val;

	-- hammer through record copying each value
	for key, val in pairs(srcRec) do
		-- if this is an embedded table, recurse copying it
		if (type(val) == "table") then
			-- copy the embedded table
			desRec[key] = Lootster_CopyRecord(val);
		else
			-- simply copy the value
			desRec[key] = val;
		end
	end

	-- set record count as appropriate
	table.setn(desRec, table.getn(srcRec));

	return desRec;
end

-- Set Date & Time handler
function Lootster_SetDateTime(frame, dateSet, callback)
	local	name, dateOut;
	
	-- get the frame name
	name = frame:GetName();
	
	-- make sure we have a date
	if (dateSet ~= nil) then	
		-- break the date into table form
		dateOut = date("*t", dateSet);

		-- and output
		getglobal(name.."Year"):SetText(string.format("%04d", dateOut.year));
		getglobal(name.."Mon"):SetText(string.format("%02d", dateOut.month));
		getglobal(name.."Day"):SetText(string.format("%02d", dateOut.day));

		getglobal(name.."Hour"):SetText(string.format("%02d", dateOut.hour));
		getglobal(name.."Min"):SetText(string.format("%02d", dateOut.min));
		getglobal(name.."Sec"):SetText(string.format("%02d", dateOut.sec));
	else
		-- output empty text
		getglobal(name.."Year"):SetText("");
		getglobal(name.."Mon"):SetText("");
		getglobal(name.."Day"):SetText("");

		getglobal(name.."Hour"):SetText("");
		getglobal(name.."Min"):SetText("");
		getglobal(name.."Sec"):SetText("");
	end

	-- were passed a callback?
	if (callback ~= nil) then
		-- hook the text entered callback, if any
		frame.TextEnteredCB = callback;
	end
end

-- Get Date & Time handler
function Lootster_GetDateTime(frame)
	local	name, dateInp, year, mon, day, hour, min, sec;
	
	-- get the frame name
	name = frame:GetName();
	
	-- get the current date into table form
	dateInp = date("*t", time());

	-- and input
	year = tonumber(getglobal(name.."Year"):GetText());
	mon = tonumber(getglobal(name.."Mon"):GetText());
	day = tonumber(getglobal(name.."Day"):GetText());
	
	hour = tonumber(getglobal(name.."Hour"):GetText());
	min = tonumber(getglobal(name.."Min"):GetText());
	sec = tonumber(getglobal(name.."Sec"):GetText());

	-- if all input is nil, no date set
	if ((year == nil) and (mon == nil) and (day == nil) and (hour == nil) and (min == nil) and (sec == nil)) then
		return nil;
	end
	
	-- update the values that were input
	if (year ~= nil) then
		dateInp.year = year;
	end
	
	if (mon ~= nil) then
		dateInp.month = mon;
	end
	
	if (day ~= nil) then
		dateInp.day = day;
	end
	
	if (hour ~= nil) then
		dateInp.hour = hour;
	end
	
	if (min ~= nil) then
		dateInp.min = min;
	end
	
	if (sec ~= nil) then
		dateInp.sec = sec;
	end
	
	-- and convert
	return time(dateInp);
end

-- Is Date & Time Partial handler
function Lootster_IsDateTimePartial(frame)
	local	name, year, mon, day, hour, min, sec, allT, allF;
	
	-- get the frame name
	name = frame:GetName();
	
	-- and input
	year = tonumber(getglobal(name.."Year"):GetText());
	mon = tonumber(getglobal(name.."Mon"):GetText());
	day = tonumber(getglobal(name.."Day"):GetText());
	
	hour = tonumber(getglobal(name.."Hour"):GetText());
	min = tonumber(getglobal(name.."Min"):GetText());
	sec = tonumber(getglobal(name.."Sec"):GetText());
	
	-- determine entered state
	allT = (year ~= nil) and (mon ~= nil) and (day ~= nil) and (hour ~= nil) and (min ~= nil) and (sec ~= nil);
	allF = (year == nil) and (mon == nil) and (day == nil) and (hour == nil) and (min == nil) and (sec == nil);
	
	-- can be one or the other
	return not (allT or allF), allT, allF;
end

-- Append Trailing New Line handler
function Lootster_AppendTrailingLineBreak(text)
	-- ensure that it has a trailing new line
	if (string.sub(text, -1, -1) ~= "\n") then
		text = text.."\n";
	end

	return text;
end

-- Remove Trailing New Line handler
function Lootster_RemoveTrailingLineBreak(text)
	-- ensure that it has a trailing new line
	if (string.sub(text, -1) == "\n") then
		text = string.sub(text, 1, -2);
	end

	return text;
end

-- Encode Text handler
function Lootster_EncodeText(text)
	-- encode or-bar characters
	text = string.gsub(text, LOOTSTER_ENC_ORBAR_RAW, LOOTSTER_ENC_ORBAR_ENC);

	-- encode encode characters
	text = string.gsub(text, LOOTSTER_ENC_MARKER_RAW, LOOTSTER_ENC_MARKER_ENC);

	-- encode new lines
	text = string.gsub(text, LOOTSTER_ENC_NEWLINE_RAW, LOOTSTER_ENC_NEWLINE_ENC);

	-- encode quote+slash
	text = string.gsub(text, LOOTSTER_ENC_QUOTESLASH_RAW, LOOTSTER_ENC_QUOTESLASH_ENC);

	return text;
end

-- Decode Text handler
function Lootster_DecodeText(text)
	-- decode quote+slash
	text = string.gsub(text, LOOTSTER_ENC_QUOTESLASH_ENC, LOOTSTER_ENC_QUOTESLASH_RAW);

	-- decode new lines
	text = string.gsub(text, LOOTSTER_ENC_NEWLINE_ENC, LOOTSTER_ENC_NEWLINE_RAW);

	-- decode encode characters
	text = string.gsub(text, LOOTSTER_ENC_MARKER_ENC, LOOTSTER_ENC_MARKER_RAW);

	-- decode or-bar characters
	text = string.gsub(text, LOOTSTER_ENC_ORBAR_ENC, LOOTSTER_ENC_ORBAR_RAW);

	return text;
end
